/*
==============================================================================

                                 DOOM Retro
           The classic, refined DOOM source port. For Windows PC.

==============================================================================

    Copyright © 1993-2025 by id Software LLC, a ZeniMax Media company.
    Copyright © 2013-2025 by Brad Harding <mailto:brad@doomretro.com>.

    This file is a part of DOOM Retro.

    DOOM Retro is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation, either version 3 of the license, or (at your
    option) any later version.

    DOOM Retro is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DOOM Retro. If not, see <https://www.gnu.org/licenses/>.

    DOOM is a registered trademark of id Software LLC, a ZeniMax Media
    company, in the US and/or other countries, and is used without
    permission. All other trademarks are the property of their respective
    holders. DOOM Retro is in no way affiliated with nor endorsed by
    id Software.

==============================================================================
*/

#include "c_console.h"

autocomplete_t autocompletelist[] =
{
    { "alias ",                                      DOOM1AND2        },
    { "alwaysrun ",                                  DOOM1AND2        },
    { "alwaysrun off",                               DOOM1AND2        },
    { "alwaysrun on",                                DOOM1AND2        },
    { "+alwaysrun",                                  DOOM1AND2        },
    { "am_allmapcdwallcolor ",                       DOOM1AND2        },
    { "am_allmapcdwallcolor 109",                    DOOM1AND2        },
    { "am_allmapfdwallcolor ",                       DOOM1AND2        },
    { "am_allmapfdwallcolor 110",                    DOOM1AND2        },
    { "am_allmapwallcolor ",                         DOOM1AND2        },
    { "am_allmapwallcolor 108",                      DOOM1AND2        },
    { "am_antialiasing ",                            DOOM1AND2        },
    { "am_antialiasing off",                         DOOM1AND2        },
    { "am_antialiasing on",                          DOOM1AND2        },
    { "am_backcolor ",                               DOOM1AND2        },
    { "am_bloodsplatcolor ",                         DOOM1AND2        },
    { "am_bloodsplatcolor 124",                      DOOM1AND2        },
    { "am_bluedoorcolor ",                           DOOM1AND2        },
    { "am_bluedoorcolor 160",                        DOOM1AND2        },
    { "am_bluekeycolor ",                            DOOM1AND2        },
    { "am_bluekeycolor 112",                         DOOM1AND2        },
    { "am_cdwallcolor ",                             DOOM1AND2        },
    { "am_cdwallcolor 160",                          DOOM1AND2        },
    { "am_corpsecolor ",                             DOOM1AND2        },
    { "am_corpsecolor 116",                          DOOM1AND2        },
    { "am_correctaspectratio ",                      DOOM1AND2        },
    { "am_correctaspectratio off",                   DOOM1AND2        },
    { "am_correctaspectratio on",                    DOOM1AND2        },
    { "am_crosshaircolor ",                          DOOM1AND2        },
    { "am_display ",                                 DOOM1AND2        },
    { "am_dynamic ",                                 DOOM1AND2        },
    { "am_dynamic off",                              DOOM1AND2        },
    { "am_dynamic on",                               DOOM1AND2        },
    { "am_external ",                                DOOM1AND2        },
    { "am_external off",                             DOOM1AND2        },
    { "am_external on",                              DOOM1AND2        },
    { "am_fdwallcolor ",                             DOOM1AND2        },
    { "am_fdwallcolor 64",                           DOOM1AND2        },
    { "am_followmode ",                              DOOM1AND2        },
    { "am_followmode off",                           DOOM1AND2        },
    { "am_followmode on",                            DOOM1AND2        },
    { "am_grid ",                                    DOOM1AND2        },
    { "am_grid off",                                 DOOM1AND2        },
    { "am_grid on",                                  DOOM1AND2        },
    { "am_gridcolor ",                               DOOM1AND2        },
    { "am_gridcolor 111",                            DOOM1AND2        },
    { "am_gridsize ",                                DOOM1AND2        },
    { "am_gridsize 128x128",                         DOOM1AND2        },
    { "am_markcolor ",                               DOOM1AND2        },
    { "am_markcolor 89",                             DOOM1AND2        },
    { "am_path ",                                    DOOM1AND2        },
    { "am_path off",                                 DOOM1AND2        },
    { "am_path on",                                  DOOM1AND2        },
    { "am_pathcolor ",                               DOOM1AND2        },
    { "am_pathcolor 89",                             DOOM1AND2        },
    { "am_playercolor ",                             DOOM1AND2        },
    { "am_playerstats ",                             DOOM1AND2        },
    { "am_playerstats off",                          DOOM1AND2        },
    { "am_playerstats on",                           DOOM1AND2        },
    { "am_playerstatscolor ",                        DOOM1AND2        },
    { "am_reddoorcolor ",                            DOOM1AND2        },
    { "am_reddoorcolor 160",                         DOOM1AND2        },
    { "am_redkeycolor ",                             DOOM1AND2        },
    { "am_redkeycolor 112",                          DOOM1AND2        },
    { "am_rotatemode ",                              DOOM1AND2        },
    { "am_rotatemode off",                           DOOM1AND2        },
    { "am_rotatemode on",                            DOOM1AND2        },
    { "am_teleportercolor ",                         DOOM1AND2        },
    { "am_teleportercolor 184",                      DOOM1AND2        },
    { "am_thingcolor ",                              DOOM1AND2        },
    { "am_thingcolor 112",                           DOOM1AND2        },
    { "am_tswallcolor ",                             DOOM1AND2        },
    { "am_tswallcolor 104",                          DOOM1AND2        },
    { "am_wallcolor ",                               DOOM1AND2        },
    { "am_wallcolor 176",                            DOOM1AND2        },
    { "am_yellowdoorcolor ",                         DOOM1AND2        },
    { "am_yellowdoorcolor 160",                      DOOM1AND2        },
    { "am_yellowkeycolor ",                          DOOM1AND2        },
    { "am_yellowkeycolor 112",                       DOOM1AND2        },
    { "ammo ",                                       DOOM1AND2        },
    { "ammo 100",                                    DOOM1AND2        },
    { "ammo 200",                                    DOOM1AND2        },
    { "ammo 300",                                    DOOM1AND2        },
    { "ammo 400",                                    DOOM1AND2        },
    { "ammo 50",                                     DOOM1AND2        },
    { "ammo 600",                                    DOOM1AND2        },
    { "animatedstats ",                              DOOM1AND2        },
    { "animatedstats off",                           DOOM1AND2        },
    { "animatedstats on",                            DOOM1AND2        },
    { "armor ",                                      DOOM1AND2        },
    { "armor 0%",                                    DOOM1AND2        },
    { "armor 100%",                                  DOOM1AND2        },
    { "armor 200%",                                  DOOM1AND2        },
    { "armortype ",                                  DOOM1AND2        },
    { "armortype blue",                              DOOM1AND2        },
    { "armortype green",                             DOOM1AND2        },
    { "armortype none",                              DOOM1AND2        },
    { "autoaim ",                                    DOOM1AND2        },
    { "autoaim off",                                 DOOM1AND2        },
    { "autoaim on",                                  DOOM1AND2        },
    { "autoload ",                                   DOOM1AND2        },
    { "autoload off",                                DOOM1AND2        },
    { "autoload on",                                 DOOM1AND2        },
    { "+automap",                                    DOOM1AND2        },
    { "autosave ",                                   DOOM1AND2        },
    { "autosave off",                                DOOM1AND2        },
    { "autosave on",                                 DOOM1AND2        },
    { "autotilt ",                                   DOOM1AND2        },
    { "autotilt off",                                DOOM1AND2        },
    { "autotilt on",                                 DOOM1AND2        },
    { "autouse ",                                    DOOM1AND2        },
    { "autouse off",                                 DOOM1AND2        },
    { "autouse on",                                  DOOM1AND2        },
    { "+back",                                       DOOM1AND2        },
    { "bind ",                                       DOOM1AND2        },
    { "bind ' +alwaysrun",                           DOOM1AND2        },
    { "bind ' +automap",                             DOOM1AND2        },
    { "bind ' +back",                                DOOM1AND2        },
    { "bind ' +clearmark",                           DOOM1AND2        },
    { "bind ' +console",                             DOOM1AND2        },
    { "bind ' +fire",                                DOOM1AND2        },
    { "bind ' +followmode",                          DOOM1AND2        },
    { "bind ' +forward",                             DOOM1AND2        },
    { "bind ' +freelook",                            DOOM1AND2        },
    { "bind ' +grid",                                DOOM1AND2        },
    { "bind ' +jump",                                DOOM1AND2        },
    { "bind ' +left",                                DOOM1AND2        },
    { "bind ' +mark",                                DOOM1AND2        },
    { "bind ' +maxzoom",                             DOOM1AND2        },
    { "bind ' +menu",                                DOOM1AND2        },
    { "bind ' +nextweapon",                          DOOM1AND2        },
    { "bind ' +prevweapon",                          DOOM1AND2        },
    { "bind ' +right",                               DOOM1AND2        },
    { "bind ' +rotatemode",                          DOOM1AND2        },
    { "bind ' +run",                                 DOOM1AND2        },
    { "bind ' +screenshot",                          DOOM1AND2        },
    { "bind ' +strafe",                              DOOM1AND2        },
    { "bind ' +strafeleft",                          DOOM1AND2        },
    { "bind ' +straferight",                         DOOM1AND2        },
    { "bind ' +use",                                 DOOM1AND2        },
    { "bind ' +weapon1",                             DOOM1AND2        },
    { "bind ' +weapon2",                             DOOM1AND2        },
    { "bind ' +weapon3",                             DOOM1AND2        },
    { "bind ' +weapon4",                             DOOM1AND2        },
    { "bind ' +weapon5",                             DOOM1AND2        },
    { "bind ' +weapon6",                             DOOM1AND2        },
    { "bind ' +weapon7",                             DOOM1AND2        },
    { "bind ' +zoomin",                              DOOM1AND2        },
    { "bind ' +zoomout",                             DOOM1AND2        },
    { "bind '-' +alwaysrun",                         DOOM1AND2        },
    { "bind '-' +automap",                           DOOM1AND2        },
    { "bind '-' +back",                              DOOM1AND2        },
    { "bind '-' +clearmark",                         DOOM1AND2        },
    { "bind '-' +console",                           DOOM1AND2        },
    { "bind '-' +fire",                              DOOM1AND2        },
    { "bind '-' +followmode",                        DOOM1AND2        },
    { "bind '-' +forward",                           DOOM1AND2        },
    { "bind '-' +freelook",                          DOOM1AND2        },
    { "bind '-' +grid",                              DOOM1AND2        },
    { "bind '-' +jump",                              DOOM1AND2        },
    { "bind '-' +left",                              DOOM1AND2        },
    { "bind '-' +mark",                              DOOM1AND2        },
    { "bind '-' +maxzoom",                           DOOM1AND2        },
    { "bind '-' +menu",                              DOOM1AND2        },
    { "bind '-' +nextweapon",                        DOOM1AND2        },
    { "bind '-' +prevweapon",                        DOOM1AND2        },
    { "bind '-' +right",                             DOOM1AND2        },
    { "bind '-' +rotatemode",                        DOOM1AND2        },
    { "bind '-' +run",                               DOOM1AND2        },
    { "bind '-' +screenshot",                        DOOM1AND2        },
    { "bind '-' +strafe",                            DOOM1AND2        },
    { "bind '-' +strafeleft",                        DOOM1AND2        },
    { "bind '-' +straferight",                       DOOM1AND2        },
    { "bind '-' +use",                               DOOM1AND2        },
    { "bind '-' +weapon1",                           DOOM1AND2        },
    { "bind '-' +weapon2",                           DOOM1AND2        },
    { "bind '-' +weapon3",                           DOOM1AND2        },
    { "bind '-' +weapon4",                           DOOM1AND2        },
    { "bind '-' +weapon5",                           DOOM1AND2        },
    { "bind '-' +weapon6",                           DOOM1AND2        },
    { "bind '-' +weapon7",                           DOOM1AND2        },
    { "bind '-' +zoomin",                            DOOM1AND2        },
    { "bind '-' +zoomout",                           DOOM1AND2        },
    { "bind ',' +alwaysrun",                         DOOM1AND2        },
    { "bind ',' +automap",                           DOOM1AND2        },
    { "bind ',' +back",                              DOOM1AND2        },
    { "bind ',' +clearmark",                         DOOM1AND2        },
    { "bind ',' +console",                           DOOM1AND2        },
    { "bind ',' +fire",                              DOOM1AND2        },
    { "bind ',' +followmode",                        DOOM1AND2        },
    { "bind ',' +forward",                           DOOM1AND2        },
    { "bind ',' +freelook",                          DOOM1AND2        },
    { "bind ',' +grid",                              DOOM1AND2        },
    { "bind ',' +jump",                              DOOM1AND2        },
    { "bind ',' +left",                              DOOM1AND2        },
    { "bind ',' +mark",                              DOOM1AND2        },
    { "bind ',' +maxzoom",                           DOOM1AND2        },
    { "bind ',' +menu",                              DOOM1AND2        },
    { "bind ',' +nextweapon",                        DOOM1AND2        },
    { "bind ',' +prevweapon",                        DOOM1AND2        },
    { "bind ',' +right",                             DOOM1AND2        },
    { "bind ',' +rotatemode",                        DOOM1AND2        },
    { "bind ',' +run",                               DOOM1AND2        },
    { "bind ',' +screenshot",                        DOOM1AND2        },
    { "bind ',' +strafe",                            DOOM1AND2        },
    { "bind ',' +strafeleft",                        DOOM1AND2        },
    { "bind ',' +straferight",                       DOOM1AND2        },
    { "bind ',' +use",                               DOOM1AND2        },
    { "bind ',' +weapon1",                           DOOM1AND2        },
    { "bind ',' +weapon2",                           DOOM1AND2        },
    { "bind ',' +weapon3",                           DOOM1AND2        },
    { "bind ',' +weapon4",                           DOOM1AND2        },
    { "bind ',' +weapon5",                           DOOM1AND2        },
    { "bind ',' +weapon6",                           DOOM1AND2        },
    { "bind ',' +weapon7",                           DOOM1AND2        },
    { "bind ',' +zoomin",                            DOOM1AND2        },
    { "bind ',' +zoomout",                           DOOM1AND2        },
    { "bind '.' +alwaysrun",                         DOOM1AND2        },
    { "bind '.' +automap",                           DOOM1AND2        },
    { "bind '.' +back",                              DOOM1AND2        },
    { "bind '.' +clearmark",                         DOOM1AND2        },
    { "bind '.' +console",                           DOOM1AND2        },
    { "bind '.' +fire",                              DOOM1AND2        },
    { "bind '.' +followmode",                        DOOM1AND2        },
    { "bind '.' +forward",                           DOOM1AND2        },
    { "bind '.' +freelook",                          DOOM1AND2        },
    { "bind '.' +grid",                              DOOM1AND2        },
    { "bind '.' +jump",                              DOOM1AND2        },
    { "bind '.' +left",                              DOOM1AND2        },
    { "bind '.' +mark",                              DOOM1AND2        },
    { "bind '.' +maxzoom",                           DOOM1AND2        },
    { "bind '.' +menu",                              DOOM1AND2        },
    { "bind '.' +nextweapon",                        DOOM1AND2        },
    { "bind '.' +prevweapon",                        DOOM1AND2        },
    { "bind '.' +right",                             DOOM1AND2        },
    { "bind '.' +rotatemode",                        DOOM1AND2        },
    { "bind '.' +run",                               DOOM1AND2        },
    { "bind '.' +screenshot",                        DOOM1AND2        },
    { "bind '.' +strafe",                            DOOM1AND2        },
    { "bind '.' +strafeleft",                        DOOM1AND2        },
    { "bind '.' +straferight",                       DOOM1AND2        },
    { "bind '.' +use",                               DOOM1AND2        },
    { "bind '.' +weapon1",                           DOOM1AND2        },
    { "bind '.' +weapon2",                           DOOM1AND2        },
    { "bind '.' +weapon3",                           DOOM1AND2        },
    { "bind '.' +weapon4",                           DOOM1AND2        },
    { "bind '.' +weapon5",                           DOOM1AND2        },
    { "bind '.' +weapon6",                           DOOM1AND2        },
    { "bind '.' +weapon7",                           DOOM1AND2        },
    { "bind '.' +zoomin",                            DOOM1AND2        },
    { "bind '.' +zoomout",                           DOOM1AND2        },
    { "bind '/' +alwaysrun",                         DOOM1AND2        },
    { "bind '/' +automap",                           DOOM1AND2        },
    { "bind '/' +back",                              DOOM1AND2        },
    { "bind '/' +clearmark",                         DOOM1AND2        },
    { "bind '/' +console",                           DOOM1AND2        },
    { "bind '/' +fire",                              DOOM1AND2        },
    { "bind '/' +followmode",                        DOOM1AND2        },
    { "bind '/' +forward",                           DOOM1AND2        },
    { "bind '/' +freelook",                          DOOM1AND2        },
    { "bind '/' +grid",                              DOOM1AND2        },
    { "bind '/' +jump",                              DOOM1AND2        },
    { "bind '/' +left",                              DOOM1AND2        },
    { "bind '/' +mark",                              DOOM1AND2        },
    { "bind '/' +maxzoom",                           DOOM1AND2        },
    { "bind '/' +menu",                              DOOM1AND2        },
    { "bind '/' +nextweapon",                        DOOM1AND2        },
    { "bind '/' +prevweapon",                        DOOM1AND2        },
    { "bind '/' +right",                             DOOM1AND2        },
    { "bind '/' +rotatemode",                        DOOM1AND2        },
    { "bind '/' +run",                               DOOM1AND2        },
    { "bind '/' +screenshot",                        DOOM1AND2        },
    { "bind '/' +strafe",                            DOOM1AND2        },
    { "bind '/' +strafeleft",                        DOOM1AND2        },
    { "bind '/' +straferight",                       DOOM1AND2        },
    { "bind '/' +use",                               DOOM1AND2        },
    { "bind '/' +weapon1",                           DOOM1AND2        },
    { "bind '/' +weapon2",                           DOOM1AND2        },
    { "bind '/' +weapon3",                           DOOM1AND2        },
    { "bind '/' +weapon4",                           DOOM1AND2        },
    { "bind '/' +weapon5",                           DOOM1AND2        },
    { "bind '/' +weapon6",                           DOOM1AND2        },
    { "bind '/' +weapon7",                           DOOM1AND2        },
    { "bind '/' +zoomin",                            DOOM1AND2        },
    { "bind '/' +zoomout",                           DOOM1AND2        },
    { "bind ';' +alwaysrun",                         DOOM1AND2        },
    { "bind ';' +automap",                           DOOM1AND2        },
    { "bind ';' +back",                              DOOM1AND2        },
    { "bind ';' +clearmark",                         DOOM1AND2        },
    { "bind ';' +console",                           DOOM1AND2        },
    { "bind ';' +fire",                              DOOM1AND2        },
    { "bind ';' +followmode",                        DOOM1AND2        },
    { "bind ';' +forward",                           DOOM1AND2        },
    { "bind ';' +freelook",                          DOOM1AND2        },
    { "bind ';' +grid",                              DOOM1AND2        },
    { "bind ';' +jump",                              DOOM1AND2        },
    { "bind ';' +left",                              DOOM1AND2        },
    { "bind ';' +mark",                              DOOM1AND2        },
    { "bind ';' +maxzoom",                           DOOM1AND2        },
    { "bind ';' +menu",                              DOOM1AND2        },
    { "bind ';' +nextweapon",                        DOOM1AND2        },
    { "bind ';' +prevweapon",                        DOOM1AND2        },
    { "bind ';' +right",                             DOOM1AND2        },
    { "bind ';' +rotatemode",                        DOOM1AND2        },
    { "bind ';' +run",                               DOOM1AND2        },
    { "bind ';' +screenshot",                        DOOM1AND2        },
    { "bind ';' +strafe",                            DOOM1AND2        },
    { "bind ';' +strafeleft",                        DOOM1AND2        },
    { "bind ';' +straferight",                       DOOM1AND2        },
    { "bind ';' +use",                               DOOM1AND2        },
    { "bind ';' +weapon1",                           DOOM1AND2        },
    { "bind ';' +weapon2",                           DOOM1AND2        },
    { "bind ';' +weapon3",                           DOOM1AND2        },
    { "bind ';' +weapon4",                           DOOM1AND2        },
    { "bind ';' +weapon5",                           DOOM1AND2        },
    { "bind ';' +weapon6",                           DOOM1AND2        },
    { "bind ';' +weapon7",                           DOOM1AND2        },
    { "bind ';' +zoomin",                            DOOM1AND2        },
    { "bind ';' +zoomout",                           DOOM1AND2        },
    { "bind '[' +alwaysrun",                         DOOM1AND2        },
    { "bind '[' +automap",                           DOOM1AND2        },
    { "bind '[' +back",                              DOOM1AND2        },
    { "bind '[' +clearmark",                         DOOM1AND2        },
    { "bind '[' +console",                           DOOM1AND2        },
    { "bind '[' +fire",                              DOOM1AND2        },
    { "bind '[' +followmode",                        DOOM1AND2        },
    { "bind '[' +forward",                           DOOM1AND2        },
    { "bind '[' +freelook",                          DOOM1AND2        },
    { "bind '[' +grid",                              DOOM1AND2        },
    { "bind '[' +jump",                              DOOM1AND2        },
    { "bind '[' +left",                              DOOM1AND2        },
    { "bind '[' +mark",                              DOOM1AND2        },
    { "bind '[' +maxzoom",                           DOOM1AND2        },
    { "bind '[' +menu",                              DOOM1AND2        },
    { "bind '[' +nextweapon",                        DOOM1AND2        },
    { "bind '[' +prevweapon",                        DOOM1AND2        },
    { "bind '[' +right",                             DOOM1AND2        },
    { "bind '[' +rotatemode",                        DOOM1AND2        },
    { "bind '[' +run",                               DOOM1AND2        },
    { "bind '[' +screenshot",                        DOOM1AND2        },
    { "bind '[' +strafe",                            DOOM1AND2        },
    { "bind '[' +strafeleft",                        DOOM1AND2        },
    { "bind '[' +straferight",                       DOOM1AND2        },
    { "bind '[' +use",                               DOOM1AND2        },
    { "bind '[' +weapon1",                           DOOM1AND2        },
    { "bind '[' +weapon2",                           DOOM1AND2        },
    { "bind '[' +weapon3",                           DOOM1AND2        },
    { "bind '[' +weapon4",                           DOOM1AND2        },
    { "bind '[' +weapon5",                           DOOM1AND2        },
    { "bind '[' +weapon6",                           DOOM1AND2        },
    { "bind '[' +weapon7",                           DOOM1AND2        },
    { "bind '[' +zoomin",                            DOOM1AND2        },
    { "bind '[' +zoomout",                           DOOM1AND2        },
    { "bind '\\' +alwaysrun",                        DOOM1AND2        },
    { "bind '\\' +automap",                          DOOM1AND2        },
    { "bind '\\' +back",                             DOOM1AND2        },
    { "bind '\\' +clearmark",                        DOOM1AND2        },
    { "bind '\\' +console",                          DOOM1AND2        },
    { "bind '\\' +fire",                             DOOM1AND2        },
    { "bind '\\' +followmode",                       DOOM1AND2        },
    { "bind '\\' +forward",                          DOOM1AND2        },
    { "bind '\\' +freelook",                         DOOM1AND2        },
    { "bind '\\' +grid",                             DOOM1AND2        },
    { "bind '\\' +jump",                             DOOM1AND2        },
    { "bind '\\' +left",                             DOOM1AND2        },
    { "bind '\\' +mark",                             DOOM1AND2        },
    { "bind '\\' +maxzoom",                          DOOM1AND2        },
    { "bind '\\' +menu",                             DOOM1AND2        },
    { "bind '\\' +nextweapon",                       DOOM1AND2        },
    { "bind '\\' +prevweapon",                       DOOM1AND2        },
    { "bind '\\' +right",                            DOOM1AND2        },
    { "bind '\\' +rotatemode",                       DOOM1AND2        },
    { "bind '\\' +run",                              DOOM1AND2        },
    { "bind '\\' +screenshot",                       DOOM1AND2        },
    { "bind '\\' +strafe",                           DOOM1AND2        },
    { "bind '\\' +strafeleft",                       DOOM1AND2        },
    { "bind '\\' +straferight",                      DOOM1AND2        },
    { "bind '\\' +use",                              DOOM1AND2        },
    { "bind '\\' +weapon1",                          DOOM1AND2        },
    { "bind '\\' +weapon2",                          DOOM1AND2        },
    { "bind '\\' +weapon3",                          DOOM1AND2        },
    { "bind '\\' +weapon4",                          DOOM1AND2        },
    { "bind '\\' +weapon5",                          DOOM1AND2        },
    { "bind '\\' +weapon6",                          DOOM1AND2        },
    { "bind '\\' +weapon7",                          DOOM1AND2        },
    { "bind '\\' +zoomin",                           DOOM1AND2        },
    { "bind '\\' +zoomout",                          DOOM1AND2        },
    { "bind ']' +alwaysrun",                         DOOM1AND2        },
    { "bind ']' +automap",                           DOOM1AND2        },
    { "bind ']' +back",                              DOOM1AND2        },
    { "bind ']' +clearmark",                         DOOM1AND2        },
    { "bind ']' +console",                           DOOM1AND2        },
    { "bind ']' +fire",                              DOOM1AND2        },
    { "bind ']' +followmode",                        DOOM1AND2        },
    { "bind ']' +forward",                           DOOM1AND2        },
    { "bind ']' +freelook",                          DOOM1AND2        },
    { "bind ']' +grid",                              DOOM1AND2        },
    { "bind ']' +jump",                              DOOM1AND2        },
    { "bind ']' +left",                              DOOM1AND2        },
    { "bind ']' +mark",                              DOOM1AND2        },
    { "bind ']' +maxzoom",                           DOOM1AND2        },
    { "bind ']' +menu",                              DOOM1AND2        },
    { "bind ']' +nextweapon",                        DOOM1AND2        },
    { "bind ']' +prevweapon",                        DOOM1AND2        },
    { "bind ']' +right",                             DOOM1AND2        },
    { "bind ']' +rotatemode",                        DOOM1AND2        },
    { "bind ']' +run",                               DOOM1AND2        },
    { "bind ']' +screenshot",                        DOOM1AND2        },
    { "bind ']' +strafe",                            DOOM1AND2        },
    { "bind ']' +strafeleft",                        DOOM1AND2        },
    { "bind ']' +straferight",                       DOOM1AND2        },
    { "bind ']' +use",                               DOOM1AND2        },
    { "bind ']' +weapon1",                           DOOM1AND2        },
    { "bind ']' +weapon2",                           DOOM1AND2        },
    { "bind ']' +weapon3",                           DOOM1AND2        },
    { "bind ']' +weapon4",                           DOOM1AND2        },
    { "bind ']' +weapon5",                           DOOM1AND2        },
    { "bind ']' +weapon6",                           DOOM1AND2        },
    { "bind ']' +weapon7",                           DOOM1AND2        },
    { "bind ']' +zoomin",                            DOOM1AND2        },
    { "bind ']' +zoomout",                           DOOM1AND2        },
    { "bind '+' +alwaysrun",                         DOOM1AND2        },
    { "bind '+' +automap",                           DOOM1AND2        },
    { "bind '+' +back",                              DOOM1AND2        },
    { "bind '+' +clearmark",                         DOOM1AND2        },
    { "bind '+' +console",                           DOOM1AND2        },
    { "bind '+' +fire",                              DOOM1AND2        },
    { "bind '+' +followmode",                        DOOM1AND2        },
    { "bind '+' +forward",                           DOOM1AND2        },
    { "bind '+' +freelook",                          DOOM1AND2        },
    { "bind '+' +grid",                              DOOM1AND2        },
    { "bind '+' +jump",                              DOOM1AND2        },
    { "bind '+' +left",                              DOOM1AND2        },
    { "bind '+' +mark",                              DOOM1AND2        },
    { "bind '+' +maxzoom",                           DOOM1AND2        },
    { "bind '+' +menu",                              DOOM1AND2        },
    { "bind '+' +nextweapon",                        DOOM1AND2        },
    { "bind '+' +prevweapon",                        DOOM1AND2        },
    { "bind '+' +right",                             DOOM1AND2        },
    { "bind '+' +rotatemode",                        DOOM1AND2        },
    { "bind '+' +run",                               DOOM1AND2        },
    { "bind '+' +screenshot",                        DOOM1AND2        },
    { "bind '+' +strafe",                            DOOM1AND2        },
    { "bind '+' +strafeleft",                        DOOM1AND2        },
    { "bind '+' +straferight",                       DOOM1AND2        },
    { "bind '+' +use",                               DOOM1AND2        },
    { "bind '+' +weapon1",                           DOOM1AND2        },
    { "bind '+' +weapon2",                           DOOM1AND2        },
    { "bind '+' +weapon3",                           DOOM1AND2        },
    { "bind '+' +weapon4",                           DOOM1AND2        },
    { "bind '+' +weapon5",                           DOOM1AND2        },
    { "bind '+' +weapon6",                           DOOM1AND2        },
    { "bind '+' +weapon7",                           DOOM1AND2        },
    { "bind '+' +zoomin",                            DOOM1AND2        },
    { "bind '+' +zoomout",                           DOOM1AND2        },
    { "bind '0' +alwaysrun",                         DOOM1AND2        },
    { "bind '0' +automap",                           DOOM1AND2        },
    { "bind '0' +back",                              DOOM1AND2        },
    { "bind '0' +clearmark",                         DOOM1AND2        },
    { "bind '0' +console",                           DOOM1AND2        },
    { "bind '0' +fire",                              DOOM1AND2        },
    { "bind '0' +followmode",                        DOOM1AND2        },
    { "bind '0' +forward",                           DOOM1AND2        },
    { "bind '0' +freelook",                          DOOM1AND2        },
    { "bind '0' +grid",                              DOOM1AND2        },
    { "bind '0' +jump",                              DOOM1AND2        },
    { "bind '0' +left",                              DOOM1AND2        },
    { "bind '0' +mark",                              DOOM1AND2        },
    { "bind '0' +maxzoom",                           DOOM1AND2        },
    { "bind '0' +menu",                              DOOM1AND2        },
    { "bind '0' +nextweapon",                        DOOM1AND2        },
    { "bind '0' +prevweapon",                        DOOM1AND2        },
    { "bind '0' +right",                             DOOM1AND2        },
    { "bind '0' +rotatemode",                        DOOM1AND2        },
    { "bind '0' +run",                               DOOM1AND2        },
    { "bind '0' +screenshot",                        DOOM1AND2        },
    { "bind '0' +strafe",                            DOOM1AND2        },
    { "bind '0' +strafeleft",                        DOOM1AND2        },
    { "bind '0' +straferight",                       DOOM1AND2        },
    { "bind '0' +use",                               DOOM1AND2        },
    { "bind '0' +weapon1",                           DOOM1AND2        },
    { "bind '0' +weapon2",                           DOOM1AND2        },
    { "bind '0' +weapon3",                           DOOM1AND2        },
    { "bind '0' +weapon4",                           DOOM1AND2        },
    { "bind '0' +weapon5",                           DOOM1AND2        },
    { "bind '0' +weapon6",                           DOOM1AND2        },
    { "bind '0' +weapon7",                           DOOM1AND2        },
    { "bind '0' +zoomin",                            DOOM1AND2        },
    { "bind '0' +zoomout",                           DOOM1AND2        },
    { "bind '1' +alwaysrun",                         DOOM1AND2        },
    { "bind '1' +automap",                           DOOM1AND2        },
    { "bind '1' +back",                              DOOM1AND2        },
    { "bind '1' +clearmark",                         DOOM1AND2        },
    { "bind '1' +console",                           DOOM1AND2        },
    { "bind '1' +fire",                              DOOM1AND2        },
    { "bind '1' +followmode",                        DOOM1AND2        },
    { "bind '1' +forward",                           DOOM1AND2        },
    { "bind '1' +freelook",                          DOOM1AND2        },
    { "bind '1' +grid",                              DOOM1AND2        },
    { "bind '1' +jump",                              DOOM1AND2        },
    { "bind '1' +left",                              DOOM1AND2        },
    { "bind '1' +mark",                              DOOM1AND2        },
    { "bind '1' +maxzoom",                           DOOM1AND2        },
    { "bind '1' +menu",                              DOOM1AND2        },
    { "bind '1' +nextweapon",                        DOOM1AND2        },
    { "bind '1' +prevweapon",                        DOOM1AND2        },
    { "bind '1' +right",                             DOOM1AND2        },
    { "bind '1' +rotatemode",                        DOOM1AND2        },
    { "bind '1' +run",                               DOOM1AND2        },
    { "bind '1' +screenshot",                        DOOM1AND2        },
    { "bind '1' +strafe",                            DOOM1AND2        },
    { "bind '1' +strafeleft",                        DOOM1AND2        },
    { "bind '1' +straferight",                       DOOM1AND2        },
    { "bind '1' +use",                               DOOM1AND2        },
    { "bind '1' +weapon1",                           DOOM1AND2        },
    { "bind '1' +weapon2",                           DOOM1AND2        },
    { "bind '1' +weapon3",                           DOOM1AND2        },
    { "bind '1' +weapon4",                           DOOM1AND2        },
    { "bind '1' +weapon5",                           DOOM1AND2        },
    { "bind '1' +weapon6",                           DOOM1AND2        },
    { "bind '1' +weapon7",                           DOOM1AND2        },
    { "bind '1' +zoomin",                            DOOM1AND2        },
    { "bind '1' +zoomout",                           DOOM1AND2        },
    { "bind '2' +alwaysrun",                         DOOM1AND2        },
    { "bind '2' +automap",                           DOOM1AND2        },
    { "bind '2' +back",                              DOOM1AND2        },
    { "bind '2' +clearmark",                         DOOM1AND2        },
    { "bind '2' +console",                           DOOM1AND2        },
    { "bind '2' +fire",                              DOOM1AND2        },
    { "bind '2' +followmode",                        DOOM1AND2        },
    { "bind '2' +forward",                           DOOM1AND2        },
    { "bind '2' +freelook",                          DOOM1AND2        },
    { "bind '2' +grid",                              DOOM1AND2        },
    { "bind '2' +jump",                              DOOM1AND2        },
    { "bind '2' +left",                              DOOM1AND2        },
    { "bind '2' +mark",                              DOOM1AND2        },
    { "bind '2' +maxzoom",                           DOOM1AND2        },
    { "bind '2' +menu",                              DOOM1AND2        },
    { "bind '2' +nextweapon",                        DOOM1AND2        },
    { "bind '2' +prevweapon",                        DOOM1AND2        },
    { "bind '2' +right",                             DOOM1AND2        },
    { "bind '2' +rotatemode",                        DOOM1AND2        },
    { "bind '2' +run",                               DOOM1AND2        },
    { "bind '2' +screenshot",                        DOOM1AND2        },
    { "bind '2' +strafe",                            DOOM1AND2        },
    { "bind '2' +strafeleft",                        DOOM1AND2        },
    { "bind '2' +straferight",                       DOOM1AND2        },
    { "bind '2' +use",                               DOOM1AND2        },
    { "bind '2' +weapon1",                           DOOM1AND2        },
    { "bind '2' +weapon2",                           DOOM1AND2        },
    { "bind '2' +weapon3",                           DOOM1AND2        },
    { "bind '2' +weapon4",                           DOOM1AND2        },
    { "bind '2' +weapon5",                           DOOM1AND2        },
    { "bind '2' +weapon6",                           DOOM1AND2        },
    { "bind '2' +weapon7",                           DOOM1AND2        },
    { "bind '2' +zoomin",                            DOOM1AND2        },
    { "bind '2' +zoomout",                           DOOM1AND2        },
    { "bind '3' +alwaysrun",                         DOOM1AND2        },
    { "bind '3' +automap",                           DOOM1AND2        },
    { "bind '3' +back",                              DOOM1AND2        },
    { "bind '3' +clearmark",                         DOOM1AND2        },
    { "bind '3' +console",                           DOOM1AND2        },
    { "bind '3' +fire",                              DOOM1AND2        },
    { "bind '3' +followmode",                        DOOM1AND2        },
    { "bind '3' +forward",                           DOOM1AND2        },
    { "bind '3' +freelook",                          DOOM1AND2        },
    { "bind '3' +grid",                              DOOM1AND2        },
    { "bind '3' +jump",                              DOOM1AND2        },
    { "bind '3' +left",                              DOOM1AND2        },
    { "bind '3' +mark",                              DOOM1AND2        },
    { "bind '3' +maxzoom",                           DOOM1AND2        },
    { "bind '3' +menu",                              DOOM1AND2        },
    { "bind '3' +nextweapon",                        DOOM1AND2        },
    { "bind '3' +prevweapon",                        DOOM1AND2        },
    { "bind '3' +right",                             DOOM1AND2        },
    { "bind '3' +rotatemode",                        DOOM1AND2        },
    { "bind '3' +run",                               DOOM1AND2        },
    { "bind '3' +screenshot",                        DOOM1AND2        },
    { "bind '3' +strafe",                            DOOM1AND2        },
    { "bind '3' +strafeleft",                        DOOM1AND2        },
    { "bind '3' +straferight",                       DOOM1AND2        },
    { "bind '3' +use",                               DOOM1AND2        },
    { "bind '3' +weapon1",                           DOOM1AND2        },
    { "bind '3' +weapon2",                           DOOM1AND2        },
    { "bind '3' +weapon3",                           DOOM1AND2        },
    { "bind '3' +weapon4",                           DOOM1AND2        },
    { "bind '3' +weapon5",                           DOOM1AND2        },
    { "bind '3' +weapon6",                           DOOM1AND2        },
    { "bind '3' +weapon7",                           DOOM1AND2        },
    { "bind '3' +zoomin",                            DOOM1AND2        },
    { "bind '3' +zoomout",                           DOOM1AND2        },
    { "bind '4' +alwaysrun",                         DOOM1AND2        },
    { "bind '4' +automap",                           DOOM1AND2        },
    { "bind '4' +back",                              DOOM1AND2        },
    { "bind '4' +clearmark",                         DOOM1AND2        },
    { "bind '4' +console",                           DOOM1AND2        },
    { "bind '4' +fire",                              DOOM1AND2        },
    { "bind '4' +followmode",                        DOOM1AND2        },
    { "bind '4' +forward",                           DOOM1AND2        },
    { "bind '4' +freelook",                          DOOM1AND2        },
    { "bind '4' +grid",                              DOOM1AND2        },
    { "bind '4' +jump",                              DOOM1AND2        },
    { "bind '4' +left",                              DOOM1AND2        },
    { "bind '4' +mark",                              DOOM1AND2        },
    { "bind '4' +maxzoom",                           DOOM1AND2        },
    { "bind '4' +menu",                              DOOM1AND2        },
    { "bind '4' +nextweapon",                        DOOM1AND2        },
    { "bind '4' +prevweapon",                        DOOM1AND2        },
    { "bind '4' +right",                             DOOM1AND2        },
    { "bind '4' +rotatemode",                        DOOM1AND2        },
    { "bind '4' +run",                               DOOM1AND2        },
    { "bind '4' +screenshot",                        DOOM1AND2        },
    { "bind '4' +strafe",                            DOOM1AND2        },
    { "bind '4' +strafeleft",                        DOOM1AND2        },
    { "bind '4' +straferight",                       DOOM1AND2        },
    { "bind '4' +use",                               DOOM1AND2        },
    { "bind '4' +weapon1",                           DOOM1AND2        },
    { "bind '4' +weapon2",                           DOOM1AND2        },
    { "bind '4' +weapon3",                           DOOM1AND2        },
    { "bind '4' +weapon4",                           DOOM1AND2        },
    { "bind '4' +weapon5",                           DOOM1AND2        },
    { "bind '4' +weapon6",                           DOOM1AND2        },
    { "bind '4' +weapon7",                           DOOM1AND2        },
    { "bind '4' +zoomin",                            DOOM1AND2        },
    { "bind '4' +zoomout",                           DOOM1AND2        },
    { "bind '5' +alwaysrun",                         DOOM1AND2        },
    { "bind '5' +automap",                           DOOM1AND2        },
    { "bind '5' +back",                              DOOM1AND2        },
    { "bind '5' +clearmark",                         DOOM1AND2        },
    { "bind '5' +console",                           DOOM1AND2        },
    { "bind '5' +fire",                              DOOM1AND2        },
    { "bind '5' +followmode",                        DOOM1AND2        },
    { "bind '5' +forward",                           DOOM1AND2        },
    { "bind '5' +freelook",                          DOOM1AND2        },
    { "bind '5' +grid",                              DOOM1AND2        },
    { "bind '5' +jump",                              DOOM1AND2        },
    { "bind '5' +left",                              DOOM1AND2        },
    { "bind '5' +mark",                              DOOM1AND2        },
    { "bind '5' +maxzoom",                           DOOM1AND2        },
    { "bind '5' +menu",                              DOOM1AND2        },
    { "bind '5' +nextweapon",                        DOOM1AND2        },
    { "bind '5' +prevweapon",                        DOOM1AND2        },
    { "bind '5' +right",                             DOOM1AND2        },
    { "bind '5' +rotatemode",                        DOOM1AND2        },
    { "bind '5' +run",                               DOOM1AND2        },
    { "bind '5' +screenshot",                        DOOM1AND2        },
    { "bind '5' +strafe",                            DOOM1AND2        },
    { "bind '5' +strafeleft",                        DOOM1AND2        },
    { "bind '5' +straferight",                       DOOM1AND2        },
    { "bind '5' +use",                               DOOM1AND2        },
    { "bind '5' +weapon1",                           DOOM1AND2        },
    { "bind '5' +weapon2",                           DOOM1AND2        },
    { "bind '5' +weapon3",                           DOOM1AND2        },
    { "bind '5' +weapon4",                           DOOM1AND2        },
    { "bind '5' +weapon5",                           DOOM1AND2        },
    { "bind '5' +weapon6",                           DOOM1AND2        },
    { "bind '5' +weapon7",                           DOOM1AND2        },
    { "bind '5' +zoomin",                            DOOM1AND2        },
    { "bind '5' +zoomout",                           DOOM1AND2        },
    { "bind '6' +alwaysrun",                         DOOM1AND2        },
    { "bind '6' +automap",                           DOOM1AND2        },
    { "bind '6' +back",                              DOOM1AND2        },
    { "bind '6' +clearmark",                         DOOM1AND2        },
    { "bind '6' +console",                           DOOM1AND2        },
    { "bind '6' +fire",                              DOOM1AND2        },
    { "bind '6' +followmode",                        DOOM1AND2        },
    { "bind '6' +forward",                           DOOM1AND2        },
    { "bind '6' +freelook",                          DOOM1AND2        },
    { "bind '6' +grid",                              DOOM1AND2        },
    { "bind '6' +jump",                              DOOM1AND2        },
    { "bind '6' +left",                              DOOM1AND2        },
    { "bind '6' +mark",                              DOOM1AND2        },
    { "bind '6' +maxzoom",                           DOOM1AND2        },
    { "bind '6' +menu",                              DOOM1AND2        },
    { "bind '6' +nextweapon",                        DOOM1AND2        },
    { "bind '6' +prevweapon",                        DOOM1AND2        },
    { "bind '6' +right",                             DOOM1AND2        },
    { "bind '6' +rotatemode",                        DOOM1AND2        },
    { "bind '6' +run",                               DOOM1AND2        },
    { "bind '6' +screenshot",                        DOOM1AND2        },
    { "bind '6' +strafe",                            DOOM1AND2        },
    { "bind '6' +strafeleft",                        DOOM1AND2        },
    { "bind '6' +straferight",                       DOOM1AND2        },
    { "bind '6' +use",                               DOOM1AND2        },
    { "bind '6' +weapon1",                           DOOM1AND2        },
    { "bind '6' +weapon2",                           DOOM1AND2        },
    { "bind '6' +weapon3",                           DOOM1AND2        },
    { "bind '6' +weapon4",                           DOOM1AND2        },
    { "bind '6' +weapon5",                           DOOM1AND2        },
    { "bind '6' +weapon6",                           DOOM1AND2        },
    { "bind '6' +weapon7",                           DOOM1AND2        },
    { "bind '6' +zoomin",                            DOOM1AND2        },
    { "bind '6' +zoomout",                           DOOM1AND2        },
    { "bind '7' +alwaysrun",                         DOOM1AND2        },
    { "bind '7' +automap",                           DOOM1AND2        },
    { "bind '7' +back",                              DOOM1AND2        },
    { "bind '7' +clearmark",                         DOOM1AND2        },
    { "bind '7' +console",                           DOOM1AND2        },
    { "bind '7' +fire",                              DOOM1AND2        },
    { "bind '7' +followmode",                        DOOM1AND2        },
    { "bind '7' +forward",                           DOOM1AND2        },
    { "bind '7' +freelook",                          DOOM1AND2        },
    { "bind '7' +grid",                              DOOM1AND2        },
    { "bind '7' +jump",                              DOOM1AND2        },
    { "bind '7' +left",                              DOOM1AND2        },
    { "bind '7' +mark",                              DOOM1AND2        },
    { "bind '7' +maxzoom",                           DOOM1AND2        },
    { "bind '7' +menu",                              DOOM1AND2        },
    { "bind '7' +nextweapon",                        DOOM1AND2        },
    { "bind '7' +prevweapon",                        DOOM1AND2        },
    { "bind '7' +right",                             DOOM1AND2        },
    { "bind '7' +rotatemode",                        DOOM1AND2        },
    { "bind '7' +run",                               DOOM1AND2        },
    { "bind '7' +screenshot",                        DOOM1AND2        },
    { "bind '7' +strafe",                            DOOM1AND2        },
    { "bind '7' +strafeleft",                        DOOM1AND2        },
    { "bind '7' +straferight",                       DOOM1AND2        },
    { "bind '7' +use",                               DOOM1AND2        },
    { "bind '7' +weapon1",                           DOOM1AND2        },
    { "bind '7' +weapon2",                           DOOM1AND2        },
    { "bind '7' +weapon3",                           DOOM1AND2        },
    { "bind '7' +weapon4",                           DOOM1AND2        },
    { "bind '7' +weapon5",                           DOOM1AND2        },
    { "bind '7' +weapon6",                           DOOM1AND2        },
    { "bind '7' +weapon7",                           DOOM1AND2        },
    { "bind '7' +zoomin",                            DOOM1AND2        },
    { "bind '7' +zoomout",                           DOOM1AND2        },
    { "bind '8' +alwaysrun",                         DOOM1AND2        },
    { "bind '8' +automap",                           DOOM1AND2        },
    { "bind '8' +back",                              DOOM1AND2        },
    { "bind '8' +clearmark",                         DOOM1AND2        },
    { "bind '8' +console",                           DOOM1AND2        },
    { "bind '8' +fire",                              DOOM1AND2        },
    { "bind '8' +followmode",                        DOOM1AND2        },
    { "bind '8' +forward",                           DOOM1AND2        },
    { "bind '8' +freelook",                          DOOM1AND2        },
    { "bind '8' +grid",                              DOOM1AND2        },
    { "bind '8' +jump",                              DOOM1AND2        },
    { "bind '8' +left",                              DOOM1AND2        },
    { "bind '8' +mark",                              DOOM1AND2        },
    { "bind '8' +maxzoom",                           DOOM1AND2        },
    { "bind '8' +menu",                              DOOM1AND2        },
    { "bind '8' +nextweapon",                        DOOM1AND2        },
    { "bind '8' +prevweapon",                        DOOM1AND2        },
    { "bind '8' +right",                             DOOM1AND2        },
    { "bind '8' +rotatemode",                        DOOM1AND2        },
    { "bind '8' +run",                               DOOM1AND2        },
    { "bind '8' +screenshot",                        DOOM1AND2        },
    { "bind '8' +strafe",                            DOOM1AND2        },
    { "bind '8' +strafeleft",                        DOOM1AND2        },
    { "bind '8' +straferight",                       DOOM1AND2        },
    { "bind '8' +use",                               DOOM1AND2        },
    { "bind '8' +weapon1",                           DOOM1AND2        },
    { "bind '8' +weapon2",                           DOOM1AND2        },
    { "bind '8' +weapon3",                           DOOM1AND2        },
    { "bind '8' +weapon4",                           DOOM1AND2        },
    { "bind '8' +weapon5",                           DOOM1AND2        },
    { "bind '8' +weapon6",                           DOOM1AND2        },
    { "bind '8' +weapon7",                           DOOM1AND2        },
    { "bind '8' +zoomin",                            DOOM1AND2        },
    { "bind '8' +zoomout",                           DOOM1AND2        },
    { "bind '9' +alwaysrun",                         DOOM1AND2        },
    { "bind '9' +automap",                           DOOM1AND2        },
    { "bind '9' +back",                              DOOM1AND2        },
    { "bind '9' +clearmark",                         DOOM1AND2        },
    { "bind '9' +console",                           DOOM1AND2        },
    { "bind '9' +fire",                              DOOM1AND2        },
    { "bind '9' +followmode",                        DOOM1AND2        },
    { "bind '9' +forward",                           DOOM1AND2        },
    { "bind '9' +freelook",                          DOOM1AND2        },
    { "bind '9' +grid",                              DOOM1AND2        },
    { "bind '9' +jump",                              DOOM1AND2        },
    { "bind '9' +left",                              DOOM1AND2        },
    { "bind '9' +mark",                              DOOM1AND2        },
    { "bind '9' +maxzoom",                           DOOM1AND2        },
    { "bind '9' +menu",                              DOOM1AND2        },
    { "bind '9' +nextweapon",                        DOOM1AND2        },
    { "bind '9' +prevweapon",                        DOOM1AND2        },
    { "bind '9' +right",                             DOOM1AND2        },
    { "bind '9' +rotatemode",                        DOOM1AND2        },
    { "bind '9' +run",                               DOOM1AND2        },
    { "bind '9' +screenshot",                        DOOM1AND2        },
    { "bind '9' +strafe",                            DOOM1AND2        },
    { "bind '9' +strafeleft",                        DOOM1AND2        },
    { "bind '9' +straferight",                       DOOM1AND2        },
    { "bind '9' +use",                               DOOM1AND2        },
    { "bind '9' +weapon1",                           DOOM1AND2        },
    { "bind '9' +weapon2",                           DOOM1AND2        },
    { "bind '9' +weapon3",                           DOOM1AND2        },
    { "bind '9' +weapon4",                           DOOM1AND2        },
    { "bind '9' +weapon5",                           DOOM1AND2        },
    { "bind '9' +weapon6",                           DOOM1AND2        },
    { "bind '9' +weapon7",                           DOOM1AND2        },
    { "bind '9' +zoomin",                            DOOM1AND2        },
    { "bind '9' +zoomout",                           DOOM1AND2        },
    { "bind 'a' +alwaysrun",                         DOOM1AND2        },
    { "bind 'a' +automap",                           DOOM1AND2        },
    { "bind 'a' +back",                              DOOM1AND2        },
    { "bind 'a' +clearmark",                         DOOM1AND2        },
    { "bind 'a' +console",                           DOOM1AND2        },
    { "bind 'a' +fire",                              DOOM1AND2        },
    { "bind 'a' +followmode",                        DOOM1AND2        },
    { "bind 'a' +forward",                           DOOM1AND2        },
    { "bind 'a' +freelook",                          DOOM1AND2        },
    { "bind 'a' +grid",                              DOOM1AND2        },
    { "bind 'a' +jump",                              DOOM1AND2        },
    { "bind 'a' +left",                              DOOM1AND2        },
    { "bind 'a' +mark",                              DOOM1AND2        },
    { "bind 'a' +maxzoom",                           DOOM1AND2        },
    { "bind 'a' +menu",                              DOOM1AND2        },
    { "bind 'a' +nextweapon",                        DOOM1AND2        },
    { "bind 'a' +prevweapon",                        DOOM1AND2        },
    { "bind 'a' +right",                             DOOM1AND2        },
    { "bind 'a' +rotatemode",                        DOOM1AND2        },
    { "bind 'a' +run",                               DOOM1AND2        },
    { "bind 'a' +screenshot",                        DOOM1AND2        },
    { "bind 'a' +strafe",                            DOOM1AND2        },
    { "bind 'a' +strafeleft",                        DOOM1AND2        },
    { "bind 'a' +straferight",                       DOOM1AND2        },
    { "bind 'a' +use",                               DOOM1AND2        },
    { "bind 'a' +weapon1",                           DOOM1AND2        },
    { "bind 'a' +weapon2",                           DOOM1AND2        },
    { "bind 'a' +weapon3",                           DOOM1AND2        },
    { "bind 'a' +weapon4",                           DOOM1AND2        },
    { "bind 'a' +weapon5",                           DOOM1AND2        },
    { "bind 'a' +weapon6",                           DOOM1AND2        },
    { "bind 'a' +weapon7",                           DOOM1AND2        },
    { "bind 'a' +zoomin",                            DOOM1AND2        },
    { "bind 'a' +zoomout",                           DOOM1AND2        },
    { "bind 'b' +alwaysrun",                         DOOM1AND2        },
    { "bind 'b' +automap",                           DOOM1AND2        },
    { "bind 'b' +back",                              DOOM1AND2        },
    { "bind 'b' +clearmark",                         DOOM1AND2        },
    { "bind 'b' +console",                           DOOM1AND2        },
    { "bind 'b' +fire",                              DOOM1AND2        },
    { "bind 'b' +followmode",                        DOOM1AND2        },
    { "bind 'b' +forward",                           DOOM1AND2        },
    { "bind 'b' +freelook",                          DOOM1AND2        },
    { "bind 'b' +grid",                              DOOM1AND2        },
    { "bind 'b' +jump",                              DOOM1AND2        },
    { "bind 'b' +left",                              DOOM1AND2        },
    { "bind 'b' +mark",                              DOOM1AND2        },
    { "bind 'b' +maxzoom",                           DOOM1AND2        },
    { "bind 'b' +menu",                              DOOM1AND2        },
    { "bind 'b' +nextweapon",                        DOOM1AND2        },
    { "bind 'b' +prevweapon",                        DOOM1AND2        },
    { "bind 'b' +right",                             DOOM1AND2        },
    { "bind 'b' +rotatemode",                        DOOM1AND2        },
    { "bind 'b' +run",                               DOOM1AND2        },
    { "bind 'b' +screenshot",                        DOOM1AND2        },
    { "bind 'b' +strafe",                            DOOM1AND2        },
    { "bind 'b' +strafeleft",                        DOOM1AND2        },
    { "bind 'b' +straferight",                       DOOM1AND2        },
    { "bind 'b' +use",                               DOOM1AND2        },
    { "bind 'b' +weapon1",                           DOOM1AND2        },
    { "bind 'b' +weapon2",                           DOOM1AND2        },
    { "bind 'b' +weapon3",                           DOOM1AND2        },
    { "bind 'b' +weapon4",                           DOOM1AND2        },
    { "bind 'b' +weapon5",                           DOOM1AND2        },
    { "bind 'b' +weapon6",                           DOOM1AND2        },
    { "bind 'b' +weapon7",                           DOOM1AND2        },
    { "bind 'b' +zoomin",                            DOOM1AND2        },
    { "bind 'b' +zoomout",                           DOOM1AND2        },
    { "bind 'c' +alwaysrun",                         DOOM1AND2        },
    { "bind 'c' +automap",                           DOOM1AND2        },
    { "bind 'c' +back",                              DOOM1AND2        },
    { "bind 'c' +clearmark",                         DOOM1AND2        },
    { "bind 'c' +console",                           DOOM1AND2        },
    { "bind 'c' +fire",                              DOOM1AND2        },
    { "bind 'c' +followmode",                        DOOM1AND2        },
    { "bind 'c' +forward",                           DOOM1AND2        },
    { "bind 'c' +freelook",                          DOOM1AND2        },
    { "bind 'c' +grid",                              DOOM1AND2        },
    { "bind 'c' +jump",                              DOOM1AND2        },
    { "bind 'c' +left",                              DOOM1AND2        },
    { "bind 'c' +mark",                              DOOM1AND2        },
    { "bind 'c' +maxzoom",                           DOOM1AND2        },
    { "bind 'c' +menu",                              DOOM1AND2        },
    { "bind 'c' +nextweapon",                        DOOM1AND2        },
    { "bind 'c' +prevweapon",                        DOOM1AND2        },
    { "bind 'c' +right",                             DOOM1AND2        },
    { "bind 'c' +rotatemode",                        DOOM1AND2        },
    { "bind 'c' +run",                               DOOM1AND2        },
    { "bind 'c' +screenshot",                        DOOM1AND2        },
    { "bind 'c' +strafe",                            DOOM1AND2        },
    { "bind 'c' +strafeleft",                        DOOM1AND2        },
    { "bind 'c' +straferight",                       DOOM1AND2        },
    { "bind 'c' +use",                               DOOM1AND2        },
    { "bind 'c' +weapon1",                           DOOM1AND2        },
    { "bind 'c' +weapon2",                           DOOM1AND2        },
    { "bind 'c' +weapon3",                           DOOM1AND2        },
    { "bind 'c' +weapon4",                           DOOM1AND2        },
    { "bind 'c' +weapon5",                           DOOM1AND2        },
    { "bind 'c' +weapon6",                           DOOM1AND2        },
    { "bind 'c' +weapon7",                           DOOM1AND2        },
    { "bind 'c' +zoomin",                            DOOM1AND2        },
    { "bind 'c' +zoomout",                           DOOM1AND2        },
    { "bind 'd' +alwaysrun",                         DOOM1AND2        },
    { "bind 'd' +automap",                           DOOM1AND2        },
    { "bind 'd' +back",                              DOOM1AND2        },
    { "bind 'd' +clearmark",                         DOOM1AND2        },
    { "bind 'd' +console",                           DOOM1AND2        },
    { "bind 'd' +fire",                              DOOM1AND2        },
    { "bind 'd' +followmode",                        DOOM1AND2        },
    { "bind 'd' +forward",                           DOOM1AND2        },
    { "bind 'd' +freelook",                          DOOM1AND2        },
    { "bind 'd' +grid",                              DOOM1AND2        },
    { "bind 'd' +jump",                              DOOM1AND2        },
    { "bind 'd' +left",                              DOOM1AND2        },
    { "bind 'd' +mark",                              DOOM1AND2        },
    { "bind 'd' +maxzoom",                           DOOM1AND2        },
    { "bind 'd' +menu",                              DOOM1AND2        },
    { "bind 'd' +nextweapon",                        DOOM1AND2        },
    { "bind 'd' +prevweapon",                        DOOM1AND2        },
    { "bind 'd' +right",                             DOOM1AND2        },
    { "bind 'd' +rotatemode",                        DOOM1AND2        },
    { "bind 'd' +run",                               DOOM1AND2        },
    { "bind 'd' +screenshot",                        DOOM1AND2        },
    { "bind 'd' +strafe",                            DOOM1AND2        },
    { "bind 'd' +strafeleft",                        DOOM1AND2        },
    { "bind 'd' +straferight",                       DOOM1AND2        },
    { "bind 'd' +use",                               DOOM1AND2        },
    { "bind 'd' +weapon1",                           DOOM1AND2        },
    { "bind 'd' +weapon2",                           DOOM1AND2        },
    { "bind 'd' +weapon3",                           DOOM1AND2        },
    { "bind 'd' +weapon4",                           DOOM1AND2        },
    { "bind 'd' +weapon5",                           DOOM1AND2        },
    { "bind 'd' +weapon6",                           DOOM1AND2        },
    { "bind 'd' +weapon7",                           DOOM1AND2        },
    { "bind 'd' +zoomin",                            DOOM1AND2        },
    { "bind 'd' +zoomout",                           DOOM1AND2        },
    { "bind 'e' +alwaysrun",                         DOOM1AND2        },
    { "bind 'e' +automap",                           DOOM1AND2        },
    { "bind 'e' +back",                              DOOM1AND2        },
    { "bind 'e' +clearmark",                         DOOM1AND2        },
    { "bind 'e' +console",                           DOOM1AND2        },
    { "bind 'e' +fire",                              DOOM1AND2        },
    { "bind 'e' +followmode",                        DOOM1AND2        },
    { "bind 'e' +forward",                           DOOM1AND2        },
    { "bind 'e' +freelook",                          DOOM1AND2        },
    { "bind 'e' +grid",                              DOOM1AND2        },
    { "bind 'e' +jump",                              DOOM1AND2        },
    { "bind 'e' +left",                              DOOM1AND2        },
    { "bind 'e' +mark",                              DOOM1AND2        },
    { "bind 'e' +maxzoom",                           DOOM1AND2        },
    { "bind 'e' +menu",                              DOOM1AND2        },
    { "bind 'e' +nextweapon",                        DOOM1AND2        },
    { "bind 'e' +prevweapon",                        DOOM1AND2        },
    { "bind 'e' +right",                             DOOM1AND2        },
    { "bind 'e' +rotatemode",                        DOOM1AND2        },
    { "bind 'e' +run",                               DOOM1AND2        },
    { "bind 'e' +screenshot",                        DOOM1AND2        },
    { "bind 'e' +strafe",                            DOOM1AND2        },
    { "bind 'e' +strafeleft",                        DOOM1AND2        },
    { "bind 'e' +straferight",                       DOOM1AND2        },
    { "bind 'e' +use",                               DOOM1AND2        },
    { "bind 'e' +weapon1",                           DOOM1AND2        },
    { "bind 'e' +weapon2",                           DOOM1AND2        },
    { "bind 'e' +weapon3",                           DOOM1AND2        },
    { "bind 'e' +weapon4",                           DOOM1AND2        },
    { "bind 'e' +weapon5",                           DOOM1AND2        },
    { "bind 'e' +weapon6",                           DOOM1AND2        },
    { "bind 'e' +weapon7",                           DOOM1AND2        },
    { "bind 'e' +zoomin",                            DOOM1AND2        },
    { "bind 'e' +zoomout",                           DOOM1AND2        },
    { "bind 'f' +alwaysrun",                         DOOM1AND2        },
    { "bind 'f' +automap",                           DOOM1AND2        },
    { "bind 'f' +back",                              DOOM1AND2        },
    { "bind 'f' +clearmark",                         DOOM1AND2        },
    { "bind 'f' +console",                           DOOM1AND2        },
    { "bind 'f' +fire",                              DOOM1AND2        },
    { "bind 'f' +followmode",                        DOOM1AND2        },
    { "bind 'f' +forward",                           DOOM1AND2        },
    { "bind 'f' +freelook",                          DOOM1AND2        },
    { "bind 'f' +grid",                              DOOM1AND2        },
    { "bind 'f' +jump",                              DOOM1AND2        },
    { "bind 'f' +left",                              DOOM1AND2        },
    { "bind 'f' +mark",                              DOOM1AND2        },
    { "bind 'f' +maxzoom",                           DOOM1AND2        },
    { "bind 'f' +menu",                              DOOM1AND2        },
    { "bind 'f' +nextweapon",                        DOOM1AND2        },
    { "bind 'f' +prevweapon",                        DOOM1AND2        },
    { "bind 'f' +right",                             DOOM1AND2        },
    { "bind 'f' +rotatemode",                        DOOM1AND2        },
    { "bind 'f' +run",                               DOOM1AND2        },
    { "bind 'f' +screenshot",                        DOOM1AND2        },
    { "bind 'f' +strafe",                            DOOM1AND2        },
    { "bind 'f' +strafeleft",                        DOOM1AND2        },
    { "bind 'f' +straferight",                       DOOM1AND2        },
    { "bind 'f' +use",                               DOOM1AND2        },
    { "bind 'f' +weapon1",                           DOOM1AND2        },
    { "bind 'f' +weapon2",                           DOOM1AND2        },
    { "bind 'f' +weapon3",                           DOOM1AND2        },
    { "bind 'f' +weapon4",                           DOOM1AND2        },
    { "bind 'f' +weapon5",                           DOOM1AND2        },
    { "bind 'f' +weapon6",                           DOOM1AND2        },
    { "bind 'f' +weapon7",                           DOOM1AND2        },
    { "bind 'f' +zoomin",                            DOOM1AND2        },
    { "bind 'f' +zoomout",                           DOOM1AND2        },
    { "bind 'g' +alwaysrun",                         DOOM1AND2        },
    { "bind 'g' +automap",                           DOOM1AND2        },
    { "bind 'g' +back",                              DOOM1AND2        },
    { "bind 'g' +clearmark",                         DOOM1AND2        },
    { "bind 'g' +console",                           DOOM1AND2        },
    { "bind 'g' +fire",                              DOOM1AND2        },
    { "bind 'g' +followmode",                        DOOM1AND2        },
    { "bind 'g' +forward",                           DOOM1AND2        },
    { "bind 'g' +freelook",                          DOOM1AND2        },
    { "bind 'g' +grid",                              DOOM1AND2        },
    { "bind 'g' +jump",                              DOOM1AND2        },
    { "bind 'g' +left",                              DOOM1AND2        },
    { "bind 'g' +mark",                              DOOM1AND2        },
    { "bind 'g' +maxzoom",                           DOOM1AND2        },
    { "bind 'g' +menu",                              DOOM1AND2        },
    { "bind 'g' +nextweapon",                        DOOM1AND2        },
    { "bind 'g' +prevweapon",                        DOOM1AND2        },
    { "bind 'g' +right",                             DOOM1AND2        },
    { "bind 'g' +rotatemode",                        DOOM1AND2        },
    { "bind 'g' +run",                               DOOM1AND2        },
    { "bind 'g' +screenshot",                        DOOM1AND2        },
    { "bind 'g' +strafe",                            DOOM1AND2        },
    { "bind 'g' +strafeleft",                        DOOM1AND2        },
    { "bind 'g' +straferight",                       DOOM1AND2        },
    { "bind 'g' +use",                               DOOM1AND2        },
    { "bind 'g' +weapon1",                           DOOM1AND2        },
    { "bind 'g' +weapon2",                           DOOM1AND2        },
    { "bind 'g' +weapon3",                           DOOM1AND2        },
    { "bind 'g' +weapon4",                           DOOM1AND2        },
    { "bind 'g' +weapon5",                           DOOM1AND2        },
    { "bind 'g' +weapon6",                           DOOM1AND2        },
    { "bind 'g' +weapon7",                           DOOM1AND2        },
    { "bind 'g' +zoomin",                            DOOM1AND2        },
    { "bind 'g' +zoomout",                           DOOM1AND2        },
    { "bind 'h' +alwaysrun",                         DOOM1AND2        },
    { "bind 'h' +automap",                           DOOM1AND2        },
    { "bind 'h' +back",                              DOOM1AND2        },
    { "bind 'h' +clearmark",                         DOOM1AND2        },
    { "bind 'h' +console",                           DOOM1AND2        },
    { "bind 'h' +fire",                              DOOM1AND2        },
    { "bind 'h' +followmode",                        DOOM1AND2        },
    { "bind 'h' +forward",                           DOOM1AND2        },
    { "bind 'h' +freelook",                          DOOM1AND2        },
    { "bind 'h' +grid",                              DOOM1AND2        },
    { "bind 'h' +jump",                              DOOM1AND2        },
    { "bind 'h' +left",                              DOOM1AND2        },
    { "bind 'h' +mark",                              DOOM1AND2        },
    { "bind 'h' +maxzoom",                           DOOM1AND2        },
    { "bind 'h' +menu",                              DOOM1AND2        },
    { "bind 'h' +nextweapon",                        DOOM1AND2        },
    { "bind 'h' +prevweapon",                        DOOM1AND2        },
    { "bind 'h' +right",                             DOOM1AND2        },
    { "bind 'h' +rotatemode",                        DOOM1AND2        },
    { "bind 'h' +run",                               DOOM1AND2        },
    { "bind 'h' +screenshot",                        DOOM1AND2        },
    { "bind 'h' +strafe",                            DOOM1AND2        },
    { "bind 'h' +strafeleft",                        DOOM1AND2        },
    { "bind 'h' +straferight",                       DOOM1AND2        },
    { "bind 'h' +use",                               DOOM1AND2        },
    { "bind 'h' +weapon1",                           DOOM1AND2        },
    { "bind 'h' +weapon2",                           DOOM1AND2        },
    { "bind 'h' +weapon3",                           DOOM1AND2        },
    { "bind 'h' +weapon4",                           DOOM1AND2        },
    { "bind 'h' +weapon5",                           DOOM1AND2        },
    { "bind 'h' +weapon6",                           DOOM1AND2        },
    { "bind 'h' +weapon7",                           DOOM1AND2        },
    { "bind 'h' +zoomin",                            DOOM1AND2        },
    { "bind 'h' +zoomout",                           DOOM1AND2        },
    { "bind 'i' +alwaysrun",                         DOOM1AND2        },
    { "bind 'i' +automap",                           DOOM1AND2        },
    { "bind 'i' +back",                              DOOM1AND2        },
    { "bind 'i' +clearmark",                         DOOM1AND2        },
    { "bind 'i' +console",                           DOOM1AND2        },
    { "bind 'i' +fire",                              DOOM1AND2        },
    { "bind 'i' +followmode",                        DOOM1AND2        },
    { "bind 'i' +forward",                           DOOM1AND2        },
    { "bind 'i' +freelook",                          DOOM1AND2        },
    { "bind 'i' +grid",                              DOOM1AND2        },
    { "bind 'i' +jump",                              DOOM1AND2        },
    { "bind 'i' +left",                              DOOM1AND2        },
    { "bind 'i' +mark",                              DOOM1AND2        },
    { "bind 'i' +maxzoom",                           DOOM1AND2        },
    { "bind 'i' +menu",                              DOOM1AND2        },
    { "bind 'i' +nextweapon",                        DOOM1AND2        },
    { "bind 'i' +prevweapon",                        DOOM1AND2        },
    { "bind 'i' +right",                             DOOM1AND2        },
    { "bind 'i' +rotatemode",                        DOOM1AND2        },
    { "bind 'i' +run",                               DOOM1AND2        },
    { "bind 'i' +screenshot",                        DOOM1AND2        },
    { "bind 'i' +strafe",                            DOOM1AND2        },
    { "bind 'i' +strafeleft",                        DOOM1AND2        },
    { "bind 'i' +straferight",                       DOOM1AND2        },
    { "bind 'i' +use",                               DOOM1AND2        },
    { "bind 'i' +weapon1",                           DOOM1AND2        },
    { "bind 'i' +weapon2",                           DOOM1AND2        },
    { "bind 'i' +weapon3",                           DOOM1AND2        },
    { "bind 'i' +weapon4",                           DOOM1AND2        },
    { "bind 'i' +weapon5",                           DOOM1AND2        },
    { "bind 'i' +weapon6",                           DOOM1AND2        },
    { "bind 'i' +weapon7",                           DOOM1AND2        },
    { "bind 'i' +zoomin",                            DOOM1AND2        },
    { "bind 'i' +zoomout",                           DOOM1AND2        },
    { "bind 'j' +alwaysrun",                         DOOM1AND2        },
    { "bind 'j' +automap",                           DOOM1AND2        },
    { "bind 'j' +back",                              DOOM1AND2        },
    { "bind 'j' +clearmark",                         DOOM1AND2        },
    { "bind 'j' +console",                           DOOM1AND2        },
    { "bind 'j' +fire",                              DOOM1AND2        },
    { "bind 'j' +followmode",                        DOOM1AND2        },
    { "bind 'j' +forward",                           DOOM1AND2        },
    { "bind 'j' +freelook",                          DOOM1AND2        },
    { "bind 'j' +grid",                              DOOM1AND2        },
    { "bind 'j' +jump",                              DOOM1AND2        },
    { "bind 'j' +left",                              DOOM1AND2        },
    { "bind 'j' +mark",                              DOOM1AND2        },
    { "bind 'j' +maxzoom",                           DOOM1AND2        },
    { "bind 'j' +menu",                              DOOM1AND2        },
    { "bind 'j' +nextweapon",                        DOOM1AND2        },
    { "bind 'j' +prevweapon",                        DOOM1AND2        },
    { "bind 'j' +right",                             DOOM1AND2        },
    { "bind 'j' +rotatemode",                        DOOM1AND2        },
    { "bind 'j' +run",                               DOOM1AND2        },
    { "bind 'j' +screenshot",                        DOOM1AND2        },
    { "bind 'j' +strafe",                            DOOM1AND2        },
    { "bind 'j' +strafeleft",                        DOOM1AND2        },
    { "bind 'j' +straferight",                       DOOM1AND2        },
    { "bind 'j' +use",                               DOOM1AND2        },
    { "bind 'j' +weapon1",                           DOOM1AND2        },
    { "bind 'j' +weapon2",                           DOOM1AND2        },
    { "bind 'j' +weapon3",                           DOOM1AND2        },
    { "bind 'j' +weapon4",                           DOOM1AND2        },
    { "bind 'j' +weapon5",                           DOOM1AND2        },
    { "bind 'j' +weapon6",                           DOOM1AND2        },
    { "bind 'j' +weapon7",                           DOOM1AND2        },
    { "bind 'j' +zoomin",                            DOOM1AND2        },
    { "bind 'j' +zoomout",                           DOOM1AND2        },
    { "bind 'k' +alwaysrun",                         DOOM1AND2        },
    { "bind 'k' +automap",                           DOOM1AND2        },
    { "bind 'k' +back",                              DOOM1AND2        },
    { "bind 'k' +clearmark",                         DOOM1AND2        },
    { "bind 'k' +console",                           DOOM1AND2        },
    { "bind 'k' +fire",                              DOOM1AND2        },
    { "bind 'k' +followmode",                        DOOM1AND2        },
    { "bind 'k' +forward",                           DOOM1AND2        },
    { "bind 'k' +freelook",                          DOOM1AND2        },
    { "bind 'k' +grid",                              DOOM1AND2        },
    { "bind 'k' +jump",                              DOOM1AND2        },
    { "bind 'k' +left",                              DOOM1AND2        },
    { "bind 'k' +mark",                              DOOM1AND2        },
    { "bind 'k' +maxzoom",                           DOOM1AND2        },
    { "bind 'k' +menu",                              DOOM1AND2        },
    { "bind 'k' +nextweapon",                        DOOM1AND2        },
    { "bind 'k' +prevweapon",                        DOOM1AND2        },
    { "bind 'k' +right",                             DOOM1AND2        },
    { "bind 'k' +rotatemode",                        DOOM1AND2        },
    { "bind 'k' +run",                               DOOM1AND2        },
    { "bind 'k' +screenshot",                        DOOM1AND2        },
    { "bind 'k' +strafe",                            DOOM1AND2        },
    { "bind 'k' +strafeleft",                        DOOM1AND2        },
    { "bind 'k' +straferight",                       DOOM1AND2        },
    { "bind 'k' +use",                               DOOM1AND2        },
    { "bind 'k' +weapon1",                           DOOM1AND2        },
    { "bind 'k' +weapon2",                           DOOM1AND2        },
    { "bind 'k' +weapon3",                           DOOM1AND2        },
    { "bind 'k' +weapon4",                           DOOM1AND2        },
    { "bind 'k' +weapon5",                           DOOM1AND2        },
    { "bind 'k' +weapon6",                           DOOM1AND2        },
    { "bind 'k' +weapon7",                           DOOM1AND2        },
    { "bind 'k' +zoomin",                            DOOM1AND2        },
    { "bind 'k' +zoomout",                           DOOM1AND2        },
    { "bind 'l' +alwaysrun",                         DOOM1AND2        },
    { "bind 'l' +automap",                           DOOM1AND2        },
    { "bind 'l' +back",                              DOOM1AND2        },
    { "bind 'l' +clearmark",                         DOOM1AND2        },
    { "bind 'l' +console",                           DOOM1AND2        },
    { "bind 'l' +fire",                              DOOM1AND2        },
    { "bind 'l' +followmode",                        DOOM1AND2        },
    { "bind 'l' +forward",                           DOOM1AND2        },
    { "bind 'l' +freelook",                          DOOM1AND2        },
    { "bind 'l' +grid",                              DOOM1AND2        },
    { "bind 'l' +jump",                              DOOM1AND2        },
    { "bind 'l' +left",                              DOOM1AND2        },
    { "bind 'l' +mark",                              DOOM1AND2        },
    { "bind 'l' +maxzoom",                           DOOM1AND2        },
    { "bind 'l' +menu",                              DOOM1AND2        },
    { "bind 'l' +nextweapon",                        DOOM1AND2        },
    { "bind 'l' +prevweapon",                        DOOM1AND2        },
    { "bind 'l' +right",                             DOOM1AND2        },
    { "bind 'l' +rotatemode",                        DOOM1AND2        },
    { "bind 'l' +run",                               DOOM1AND2        },
    { "bind 'l' +screenshot",                        DOOM1AND2        },
    { "bind 'l' +strafe",                            DOOM1AND2        },
    { "bind 'l' +strafeleft",                        DOOM1AND2        },
    { "bind 'l' +straferight",                       DOOM1AND2        },
    { "bind 'l' +use",                               DOOM1AND2        },
    { "bind 'l' +weapon1",                           DOOM1AND2        },
    { "bind 'l' +weapon2",                           DOOM1AND2        },
    { "bind 'l' +weapon3",                           DOOM1AND2        },
    { "bind 'l' +weapon4",                           DOOM1AND2        },
    { "bind 'l' +weapon5",                           DOOM1AND2        },
    { "bind 'l' +weapon6",                           DOOM1AND2        },
    { "bind 'l' +weapon7",                           DOOM1AND2        },
    { "bind 'l' +zoomin",                            DOOM1AND2        },
    { "bind 'l' +zoomout",                           DOOM1AND2        },
    { "bind 'm' +alwaysrun",                         DOOM1AND2        },
    { "bind 'm' +automap",                           DOOM1AND2        },
    { "bind 'm' +back",                              DOOM1AND2        },
    { "bind 'm' +clearmark",                         DOOM1AND2        },
    { "bind 'm' +console",                           DOOM1AND2        },
    { "bind 'm' +fire",                              DOOM1AND2        },
    { "bind 'm' +followmode",                        DOOM1AND2        },
    { "bind 'm' +forward",                           DOOM1AND2        },
    { "bind 'm' +freelook",                          DOOM1AND2        },
    { "bind 'm' +grid",                              DOOM1AND2        },
    { "bind 'm' +jump",                              DOOM1AND2        },
    { "bind 'm' +left",                              DOOM1AND2        },
    { "bind 'm' +mark",                              DOOM1AND2        },
    { "bind 'm' +maxzoom",                           DOOM1AND2        },
    { "bind 'm' +menu",                              DOOM1AND2        },
    { "bind 'm' +nextweapon",                        DOOM1AND2        },
    { "bind 'm' +prevweapon",                        DOOM1AND2        },
    { "bind 'm' +right",                             DOOM1AND2        },
    { "bind 'm' +rotatemode",                        DOOM1AND2        },
    { "bind 'm' +run",                               DOOM1AND2        },
    { "bind 'm' +screenshot",                        DOOM1AND2        },
    { "bind 'm' +strafe",                            DOOM1AND2        },
    { "bind 'm' +strafeleft",                        DOOM1AND2        },
    { "bind 'm' +straferight",                       DOOM1AND2        },
    { "bind 'm' +use",                               DOOM1AND2        },
    { "bind 'm' +weapon1",                           DOOM1AND2        },
    { "bind 'm' +weapon2",                           DOOM1AND2        },
    { "bind 'm' +weapon3",                           DOOM1AND2        },
    { "bind 'm' +weapon4",                           DOOM1AND2        },
    { "bind 'm' +weapon5",                           DOOM1AND2        },
    { "bind 'm' +weapon6",                           DOOM1AND2        },
    { "bind 'm' +weapon7",                           DOOM1AND2        },
    { "bind 'm' +zoomin",                            DOOM1AND2        },
    { "bind 'm' +zoomout",                           DOOM1AND2        },
    { "bind 'n' +alwaysrun",                         DOOM1AND2        },
    { "bind 'n' +automap",                           DOOM1AND2        },
    { "bind 'n' +back",                              DOOM1AND2        },
    { "bind 'n' +clearmark",                         DOOM1AND2        },
    { "bind 'n' +console",                           DOOM1AND2        },
    { "bind 'n' +fire",                              DOOM1AND2        },
    { "bind 'n' +followmode",                        DOOM1AND2        },
    { "bind 'n' +forward",                           DOOM1AND2        },
    { "bind 'n' +freelook",                          DOOM1AND2        },
    { "bind 'n' +grid",                              DOOM1AND2        },
    { "bind 'n' +jump",                              DOOM1AND2        },
    { "bind 'n' +left",                              DOOM1AND2        },
    { "bind 'n' +mark",                              DOOM1AND2        },
    { "bind 'n' +maxzoom",                           DOOM1AND2        },
    { "bind 'n' +menu",                              DOOM1AND2        },
    { "bind 'n' +nextweapon",                        DOOM1AND2        },
    { "bind 'n' +prevweapon",                        DOOM1AND2        },
    { "bind 'n' +right",                             DOOM1AND2        },
    { "bind 'n' +rotatemode",                        DOOM1AND2        },
    { "bind 'n' +run",                               DOOM1AND2        },
    { "bind 'n' +screenshot",                        DOOM1AND2        },
    { "bind 'n' +strafe",                            DOOM1AND2        },
    { "bind 'n' +strafeleft",                        DOOM1AND2        },
    { "bind 'n' +straferight",                       DOOM1AND2        },
    { "bind 'n' +use",                               DOOM1AND2        },
    { "bind 'n' +weapon1",                           DOOM1AND2        },
    { "bind 'n' +weapon2",                           DOOM1AND2        },
    { "bind 'n' +weapon3",                           DOOM1AND2        },
    { "bind 'n' +weapon4",                           DOOM1AND2        },
    { "bind 'n' +weapon5",                           DOOM1AND2        },
    { "bind 'n' +weapon6",                           DOOM1AND2        },
    { "bind 'n' +weapon7",                           DOOM1AND2        },
    { "bind 'n' +zoomin",                            DOOM1AND2        },
    { "bind 'n' +zoomout",                           DOOM1AND2        },
    { "bind 'o' +alwaysrun",                         DOOM1AND2        },
    { "bind 'o' +automap",                           DOOM1AND2        },
    { "bind 'o' +back",                              DOOM1AND2        },
    { "bind 'o' +clearmark",                         DOOM1AND2        },
    { "bind 'o' +console",                           DOOM1AND2        },
    { "bind 'o' +fire",                              DOOM1AND2        },
    { "bind 'o' +followmode",                        DOOM1AND2        },
    { "bind 'o' +forward",                           DOOM1AND2        },
    { "bind 'o' +freelook",                          DOOM1AND2        },
    { "bind 'o' +grid",                              DOOM1AND2        },
    { "bind 'o' +jump",                              DOOM1AND2        },
    { "bind 'o' +left",                              DOOM1AND2        },
    { "bind 'o' +mark",                              DOOM1AND2        },
    { "bind 'o' +maxzoom",                           DOOM1AND2        },
    { "bind 'o' +menu",                              DOOM1AND2        },
    { "bind 'o' +nextweapon",                        DOOM1AND2        },
    { "bind 'o' +prevweapon",                        DOOM1AND2        },
    { "bind 'o' +right",                             DOOM1AND2        },
    { "bind 'o' +rotatemode",                        DOOM1AND2        },
    { "bind 'o' +run",                               DOOM1AND2        },
    { "bind 'o' +screenshot",                        DOOM1AND2        },
    { "bind 'o' +strafe",                            DOOM1AND2        },
    { "bind 'o' +strafeleft",                        DOOM1AND2        },
    { "bind 'o' +straferight",                       DOOM1AND2        },
    { "bind 'o' +use",                               DOOM1AND2        },
    { "bind 'o' +weapon1",                           DOOM1AND2        },
    { "bind 'o' +weapon2",                           DOOM1AND2        },
    { "bind 'o' +weapon3",                           DOOM1AND2        },
    { "bind 'o' +weapon4",                           DOOM1AND2        },
    { "bind 'o' +weapon5",                           DOOM1AND2        },
    { "bind 'o' +weapon6",                           DOOM1AND2        },
    { "bind 'o' +weapon7",                           DOOM1AND2        },
    { "bind 'o' +zoomin",                            DOOM1AND2        },
    { "bind 'o' +zoomout",                           DOOM1AND2        },
    { "bind 'p' +alwaysrun",                         DOOM1AND2        },
    { "bind 'p' +automap",                           DOOM1AND2        },
    { "bind 'p' +back",                              DOOM1AND2        },
    { "bind 'p' +clearmark",                         DOOM1AND2        },
    { "bind 'p' +console",                           DOOM1AND2        },
    { "bind 'p' +fire",                              DOOM1AND2        },
    { "bind 'p' +followmode",                        DOOM1AND2        },
    { "bind 'p' +forward",                           DOOM1AND2        },
    { "bind 'p' +freelook",                          DOOM1AND2        },
    { "bind 'p' +grid",                              DOOM1AND2        },
    { "bind 'p' +jump",                              DOOM1AND2        },
    { "bind 'p' +left",                              DOOM1AND2        },
    { "bind 'p' +mark",                              DOOM1AND2        },
    { "bind 'p' +maxzoom",                           DOOM1AND2        },
    { "bind 'p' +menu",                              DOOM1AND2        },
    { "bind 'p' +nextweapon",                        DOOM1AND2        },
    { "bind 'p' +prevweapon",                        DOOM1AND2        },
    { "bind 'p' +right",                             DOOM1AND2        },
    { "bind 'p' +rotatemode",                        DOOM1AND2        },
    { "bind 'p' +run",                               DOOM1AND2        },
    { "bind 'p' +screenshot",                        DOOM1AND2        },
    { "bind 'p' +strafe",                            DOOM1AND2        },
    { "bind 'p' +strafeleft",                        DOOM1AND2        },
    { "bind 'p' +straferight",                       DOOM1AND2        },
    { "bind 'p' +use",                               DOOM1AND2        },
    { "bind 'p' +weapon1",                           DOOM1AND2        },
    { "bind 'p' +weapon2",                           DOOM1AND2        },
    { "bind 'p' +weapon3",                           DOOM1AND2        },
    { "bind 'p' +weapon4",                           DOOM1AND2        },
    { "bind 'p' +weapon5",                           DOOM1AND2        },
    { "bind 'p' +weapon6",                           DOOM1AND2        },
    { "bind 'p' +weapon7",                           DOOM1AND2        },
    { "bind 'p' +zoomin",                            DOOM1AND2        },
    { "bind 'p' +zoomout",                           DOOM1AND2        },
    { "bind 'q' +alwaysrun",                         DOOM1AND2        },
    { "bind 'q' +automap",                           DOOM1AND2        },
    { "bind 'q' +back",                              DOOM1AND2        },
    { "bind 'q' +clearmark",                         DOOM1AND2        },
    { "bind 'q' +console",                           DOOM1AND2        },
    { "bind 'q' +fire",                              DOOM1AND2        },
    { "bind 'q' +followmode",                        DOOM1AND2        },
    { "bind 'q' +forward",                           DOOM1AND2        },
    { "bind 'q' +freelook",                          DOOM1AND2        },
    { "bind 'q' +grid",                              DOOM1AND2        },
    { "bind 'q' +jump",                              DOOM1AND2        },
    { "bind 'q' +left",                              DOOM1AND2        },
    { "bind 'q' +mark",                              DOOM1AND2        },
    { "bind 'q' +maxzoom",                           DOOM1AND2        },
    { "bind 'q' +menu",                              DOOM1AND2        },
    { "bind 'q' +nextweapon",                        DOOM1AND2        },
    { "bind 'q' +prevweapon",                        DOOM1AND2        },
    { "bind 'q' +right",                             DOOM1AND2        },
    { "bind 'q' +rotatemode",                        DOOM1AND2        },
    { "bind 'q' +run",                               DOOM1AND2        },
    { "bind 'q' +screenshot",                        DOOM1AND2        },
    { "bind 'q' +strafe",                            DOOM1AND2        },
    { "bind 'q' +strafeleft",                        DOOM1AND2        },
    { "bind 'q' +straferight",                       DOOM1AND2        },
    { "bind 'q' +use",                               DOOM1AND2        },
    { "bind 'q' +weapon1",                           DOOM1AND2        },
    { "bind 'q' +weapon2",                           DOOM1AND2        },
    { "bind 'q' +weapon3",                           DOOM1AND2        },
    { "bind 'q' +weapon4",                           DOOM1AND2        },
    { "bind 'q' +weapon5",                           DOOM1AND2        },
    { "bind 'q' +weapon6",                           DOOM1AND2        },
    { "bind 'q' +weapon7",                           DOOM1AND2        },
    { "bind 'q' +zoomin",                            DOOM1AND2        },
    { "bind 'q' +zoomout",                           DOOM1AND2        },
    { "bind 'r' +alwaysrun",                         DOOM1AND2        },
    { "bind 'r' +automap",                           DOOM1AND2        },
    { "bind 'r' +back",                              DOOM1AND2        },
    { "bind 'r' +clearmark",                         DOOM1AND2        },
    { "bind 'r' +console",                           DOOM1AND2        },
    { "bind 'r' +fire",                              DOOM1AND2        },
    { "bind 'r' +followmode",                        DOOM1AND2        },
    { "bind 'r' +forward",                           DOOM1AND2        },
    { "bind 'r' +freelook",                          DOOM1AND2        },
    { "bind 'r' +grid",                              DOOM1AND2        },
    { "bind 'r' +jump",                              DOOM1AND2        },
    { "bind 'r' +left",                              DOOM1AND2        },
    { "bind 'r' +mark",                              DOOM1AND2        },
    { "bind 'r' +maxzoom",                           DOOM1AND2        },
    { "bind 'r' +menu",                              DOOM1AND2        },
    { "bind 'r' +nextweapon",                        DOOM1AND2        },
    { "bind 'r' +prevweapon",                        DOOM1AND2        },
    { "bind 'r' +right",                             DOOM1AND2        },
    { "bind 'r' +rotatemode",                        DOOM1AND2        },
    { "bind 'r' +run",                               DOOM1AND2        },
    { "bind 'r' +screenshot",                        DOOM1AND2        },
    { "bind 'r' +strafe",                            DOOM1AND2        },
    { "bind 'r' +strafeleft",                        DOOM1AND2        },
    { "bind 'r' +straferight",                       DOOM1AND2        },
    { "bind 'r' +use",                               DOOM1AND2        },
    { "bind 'r' +weapon1",                           DOOM1AND2        },
    { "bind 'r' +weapon2",                           DOOM1AND2        },
    { "bind 'r' +weapon3",                           DOOM1AND2        },
    { "bind 'r' +weapon4",                           DOOM1AND2        },
    { "bind 'r' +weapon5",                           DOOM1AND2        },
    { "bind 'r' +weapon6",                           DOOM1AND2        },
    { "bind 'r' +weapon7",                           DOOM1AND2        },
    { "bind 'r' +zoomin",                            DOOM1AND2        },
    { "bind 'r' +zoomout",                           DOOM1AND2        },
    { "bind 's' +alwaysrun",                         DOOM1AND2        },
    { "bind 's' +automap",                           DOOM1AND2        },
    { "bind 's' +back",                              DOOM1AND2        },
    { "bind 's' +clearmark",                         DOOM1AND2        },
    { "bind 's' +console",                           DOOM1AND2        },
    { "bind 's' +fire",                              DOOM1AND2        },
    { "bind 's' +followmode",                        DOOM1AND2        },
    { "bind 's' +forward",                           DOOM1AND2        },
    { "bind 's' +freelook",                          DOOM1AND2        },
    { "bind 's' +grid",                              DOOM1AND2        },
    { "bind 's' +jump",                              DOOM1AND2        },
    { "bind 's' +left",                              DOOM1AND2        },
    { "bind 's' +mark",                              DOOM1AND2        },
    { "bind 's' +maxzoom",                           DOOM1AND2        },
    { "bind 's' +menu",                              DOOM1AND2        },
    { "bind 's' +nextweapon",                        DOOM1AND2        },
    { "bind 's' +prevweapon",                        DOOM1AND2        },
    { "bind 's' +right",                             DOOM1AND2        },
    { "bind 's' +rotatemode",                        DOOM1AND2        },
    { "bind 's' +run",                               DOOM1AND2        },
    { "bind 's' +screenshot",                        DOOM1AND2        },
    { "bind 's' +strafe",                            DOOM1AND2        },
    { "bind 's' +strafeleft",                        DOOM1AND2        },
    { "bind 's' +straferight",                       DOOM1AND2        },
    { "bind 's' +use",                               DOOM1AND2        },
    { "bind 's' +weapon1",                           DOOM1AND2        },
    { "bind 's' +weapon2",                           DOOM1AND2        },
    { "bind 's' +weapon3",                           DOOM1AND2        },
    { "bind 's' +weapon4",                           DOOM1AND2        },
    { "bind 's' +weapon5",                           DOOM1AND2        },
    { "bind 's' +weapon6",                           DOOM1AND2        },
    { "bind 's' +weapon7",                           DOOM1AND2        },
    { "bind 's' +zoomin",                            DOOM1AND2        },
    { "bind 's' +zoomout",                           DOOM1AND2        },
    { "bind 't' +alwaysrun",                         DOOM1AND2        },
    { "bind 't' +automap",                           DOOM1AND2        },
    { "bind 't' +back",                              DOOM1AND2        },
    { "bind 't' +clearmark",                         DOOM1AND2        },
    { "bind 't' +console",                           DOOM1AND2        },
    { "bind 't' +fire",                              DOOM1AND2        },
    { "bind 't' +followmode",                        DOOM1AND2        },
    { "bind 't' +forward",                           DOOM1AND2        },
    { "bind 't' +freelook",                          DOOM1AND2        },
    { "bind 't' +grid",                              DOOM1AND2        },
    { "bind 't' +jump",                              DOOM1AND2        },
    { "bind 't' +left",                              DOOM1AND2        },
    { "bind 't' +mark",                              DOOM1AND2        },
    { "bind 't' +maxzoom",                           DOOM1AND2        },
    { "bind 't' +menu",                              DOOM1AND2        },
    { "bind 't' +nextweapon",                        DOOM1AND2        },
    { "bind 't' +prevweapon",                        DOOM1AND2        },
    { "bind 't' +right",                             DOOM1AND2        },
    { "bind 't' +rotatemode",                        DOOM1AND2        },
    { "bind 't' +run",                               DOOM1AND2        },
    { "bind 't' +screenshot",                        DOOM1AND2        },
    { "bind 't' +strafe",                            DOOM1AND2        },
    { "bind 't' +strafeleft",                        DOOM1AND2        },
    { "bind 't' +straferight",                       DOOM1AND2        },
    { "bind 't' +use",                               DOOM1AND2        },
    { "bind 't' +weapon1",                           DOOM1AND2        },
    { "bind 't' +weapon2",                           DOOM1AND2        },
    { "bind 't' +weapon3",                           DOOM1AND2        },
    { "bind 't' +weapon4",                           DOOM1AND2        },
    { "bind 't' +weapon5",                           DOOM1AND2        },
    { "bind 't' +weapon6",                           DOOM1AND2        },
    { "bind 't' +weapon7",                           DOOM1AND2        },
    { "bind 't' +zoomin",                            DOOM1AND2        },
    { "bind 't' +zoomout",                           DOOM1AND2        },
    { "bind 'u' +alwaysrun",                         DOOM1AND2        },
    { "bind 'u' +automap",                           DOOM1AND2        },
    { "bind 'u' +back",                              DOOM1AND2        },
    { "bind 'u' +clearmark",                         DOOM1AND2        },
    { "bind 'u' +console",                           DOOM1AND2        },
    { "bind 'u' +fire",                              DOOM1AND2        },
    { "bind 'u' +followmode",                        DOOM1AND2        },
    { "bind 'u' +forward",                           DOOM1AND2        },
    { "bind 'u' +freelook",                          DOOM1AND2        },
    { "bind 'u' +grid",                              DOOM1AND2        },
    { "bind 'u' +jump",                              DOOM1AND2        },
    { "bind 'u' +left",                              DOOM1AND2        },
    { "bind 'u' +mark",                              DOOM1AND2        },
    { "bind 'u' +maxzoom",                           DOOM1AND2        },
    { "bind 'u' +menu",                              DOOM1AND2        },
    { "bind 'u' +nextweapon",                        DOOM1AND2        },
    { "bind 'u' +prevweapon",                        DOOM1AND2        },
    { "bind 'u' +right",                             DOOM1AND2        },
    { "bind 'u' +rotatemode",                        DOOM1AND2        },
    { "bind 'u' +run",                               DOOM1AND2        },
    { "bind 'u' +screenshot",                        DOOM1AND2        },
    { "bind 'u' +strafe",                            DOOM1AND2        },
    { "bind 'u' +strafeleft",                        DOOM1AND2        },
    { "bind 'u' +straferight",                       DOOM1AND2        },
    { "bind 'u' +use",                               DOOM1AND2        },
    { "bind 'u' +weapon1",                           DOOM1AND2        },
    { "bind 'u' +weapon2",                           DOOM1AND2        },
    { "bind 'u' +weapon3",                           DOOM1AND2        },
    { "bind 'u' +weapon4",                           DOOM1AND2        },
    { "bind 'u' +weapon5",                           DOOM1AND2        },
    { "bind 'u' +weapon6",                           DOOM1AND2        },
    { "bind 'u' +weapon7",                           DOOM1AND2        },
    { "bind 'u' +zoomin",                            DOOM1AND2        },
    { "bind 'u' +zoomout",                           DOOM1AND2        },
    { "bind 'v' +alwaysrun",                         DOOM1AND2        },
    { "bind 'v' +automap",                           DOOM1AND2        },
    { "bind 'v' +back",                              DOOM1AND2        },
    { "bind 'v' +clearmark",                         DOOM1AND2        },
    { "bind 'v' +console",                           DOOM1AND2        },
    { "bind 'v' +fire",                              DOOM1AND2        },
    { "bind 'v' +followmode",                        DOOM1AND2        },
    { "bind 'v' +forward",                           DOOM1AND2        },
    { "bind 'v' +freelook",                          DOOM1AND2        },
    { "bind 'v' +grid",                              DOOM1AND2        },
    { "bind 'v' +jump",                              DOOM1AND2        },
    { "bind 'v' +left",                              DOOM1AND2        },
    { "bind 'v' +mark",                              DOOM1AND2        },
    { "bind 'v' +maxzoom",                           DOOM1AND2        },
    { "bind 'v' +menu",                              DOOM1AND2        },
    { "bind 'v' +nextweapon",                        DOOM1AND2        },
    { "bind 'v' +prevweapon",                        DOOM1AND2        },
    { "bind 'v' +right",                             DOOM1AND2        },
    { "bind 'v' +rotatemode",                        DOOM1AND2        },
    { "bind 'v' +run",                               DOOM1AND2        },
    { "bind 'v' +screenshot",                        DOOM1AND2        },
    { "bind 'v' +strafe",                            DOOM1AND2        },
    { "bind 'v' +strafeleft",                        DOOM1AND2        },
    { "bind 'v' +straferight",                       DOOM1AND2        },
    { "bind 'v' +use",                               DOOM1AND2        },
    { "bind 'v' +weapon1",                           DOOM1AND2        },
    { "bind 'v' +weapon2",                           DOOM1AND2        },
    { "bind 'v' +weapon3",                           DOOM1AND2        },
    { "bind 'v' +weapon4",                           DOOM1AND2        },
    { "bind 'v' +weapon5",                           DOOM1AND2        },
    { "bind 'v' +weapon6",                           DOOM1AND2        },
    { "bind 'v' +weapon7",                           DOOM1AND2        },
    { "bind 'v' +zoomin",                            DOOM1AND2        },
    { "bind 'v' +zoomout",                           DOOM1AND2        },
    { "bind 'w' +alwaysrun",                         DOOM1AND2        },
    { "bind 'w' +automap",                           DOOM1AND2        },
    { "bind 'w' +back",                              DOOM1AND2        },
    { "bind 'w' +clearmark",                         DOOM1AND2        },
    { "bind 'w' +console",                           DOOM1AND2        },
    { "bind 'w' +fire",                              DOOM1AND2        },
    { "bind 'w' +followmode",                        DOOM1AND2        },
    { "bind 'w' +forward",                           DOOM1AND2        },
    { "bind 'w' +freelook",                          DOOM1AND2        },
    { "bind 'w' +grid",                              DOOM1AND2        },
    { "bind 'w' +jump",                              DOOM1AND2        },
    { "bind 'w' +left",                              DOOM1AND2        },
    { "bind 'w' +mark",                              DOOM1AND2        },
    { "bind 'w' +maxzoom",                           DOOM1AND2        },
    { "bind 'w' +menu",                              DOOM1AND2        },
    { "bind 'w' +nextweapon",                        DOOM1AND2        },
    { "bind 'w' +prevweapon",                        DOOM1AND2        },
    { "bind 'w' +right",                             DOOM1AND2        },
    { "bind 'w' +rotatemode",                        DOOM1AND2        },
    { "bind 'w' +run",                               DOOM1AND2        },
    { "bind 'w' +screenshot",                        DOOM1AND2        },
    { "bind 'w' +strafe",                            DOOM1AND2        },
    { "bind 'w' +strafeleft",                        DOOM1AND2        },
    { "bind 'w' +straferight",                       DOOM1AND2        },
    { "bind 'w' +use",                               DOOM1AND2        },
    { "bind 'w' +weapon1",                           DOOM1AND2        },
    { "bind 'w' +weapon2",                           DOOM1AND2        },
    { "bind 'w' +weapon3",                           DOOM1AND2        },
    { "bind 'w' +weapon4",                           DOOM1AND2        },
    { "bind 'w' +weapon5",                           DOOM1AND2        },
    { "bind 'w' +weapon6",                           DOOM1AND2        },
    { "bind 'w' +weapon7",                           DOOM1AND2        },
    { "bind 'w' +zoomin",                            DOOM1AND2        },
    { "bind 'w' +zoomout",                           DOOM1AND2        },
    { "bind 'x' +alwaysrun",                         DOOM1AND2        },
    { "bind 'x' +automap",                           DOOM1AND2        },
    { "bind 'x' +back",                              DOOM1AND2        },
    { "bind 'x' +clearmark",                         DOOM1AND2        },
    { "bind 'x' +console",                           DOOM1AND2        },
    { "bind 'x' +fire",                              DOOM1AND2        },
    { "bind 'x' +followmode",                        DOOM1AND2        },
    { "bind 'x' +forward",                           DOOM1AND2        },
    { "bind 'x' +freelook",                          DOOM1AND2        },
    { "bind 'x' +grid",                              DOOM1AND2        },
    { "bind 'x' +jump",                              DOOM1AND2        },
    { "bind 'x' +left",                              DOOM1AND2        },
    { "bind 'x' +mark",                              DOOM1AND2        },
    { "bind 'x' +maxzoom",                           DOOM1AND2        },
    { "bind 'x' +menu",                              DOOM1AND2        },
    { "bind 'x' +nextweapon",                        DOOM1AND2        },
    { "bind 'x' +prevweapon",                        DOOM1AND2        },
    { "bind 'x' +right",                             DOOM1AND2        },
    { "bind 'x' +rotatemode",                        DOOM1AND2        },
    { "bind 'x' +run",                               DOOM1AND2        },
    { "bind 'x' +screenshot",                        DOOM1AND2        },
    { "bind 'x' +strafe",                            DOOM1AND2        },
    { "bind 'x' +strafeleft",                        DOOM1AND2        },
    { "bind 'x' +straferight",                       DOOM1AND2        },
    { "bind 'x' +use",                               DOOM1AND2        },
    { "bind 'x' +weapon1",                           DOOM1AND2        },
    { "bind 'x' +weapon2",                           DOOM1AND2        },
    { "bind 'x' +weapon3",                           DOOM1AND2        },
    { "bind 'x' +weapon4",                           DOOM1AND2        },
    { "bind 'x' +weapon5",                           DOOM1AND2        },
    { "bind 'x' +weapon6",                           DOOM1AND2        },
    { "bind 'x' +weapon7",                           DOOM1AND2        },
    { "bind 'x' +zoomin",                            DOOM1AND2        },
    { "bind 'x' +zoomout",                           DOOM1AND2        },
    { "bind 'y' +alwaysrun",                         DOOM1AND2        },
    { "bind 'y' +automap",                           DOOM1AND2        },
    { "bind 'y' +back",                              DOOM1AND2        },
    { "bind 'y' +clearmark",                         DOOM1AND2        },
    { "bind 'y' +console",                           DOOM1AND2        },
    { "bind 'y' +fire",                              DOOM1AND2        },
    { "bind 'y' +followmode",                        DOOM1AND2        },
    { "bind 'y' +forward",                           DOOM1AND2        },
    { "bind 'y' +freelook",                          DOOM1AND2        },
    { "bind 'y' +grid",                              DOOM1AND2        },
    { "bind 'y' +jump",                              DOOM1AND2        },
    { "bind 'y' +left",                              DOOM1AND2        },
    { "bind 'y' +mark",                              DOOM1AND2        },
    { "bind 'y' +maxzoom",                           DOOM1AND2        },
    { "bind 'y' +menu",                              DOOM1AND2        },
    { "bind 'y' +nextweapon",                        DOOM1AND2        },
    { "bind 'y' +prevweapon",                        DOOM1AND2        },
    { "bind 'y' +right",                             DOOM1AND2        },
    { "bind 'y' +rotatemode",                        DOOM1AND2        },
    { "bind 'y' +run",                               DOOM1AND2        },
    { "bind 'y' +screenshot",                        DOOM1AND2        },
    { "bind 'y' +strafe",                            DOOM1AND2        },
    { "bind 'y' +strafeleft",                        DOOM1AND2        },
    { "bind 'y' +straferight",                       DOOM1AND2        },
    { "bind 'y' +use",                               DOOM1AND2        },
    { "bind 'y' +weapon1",                           DOOM1AND2        },
    { "bind 'y' +weapon2",                           DOOM1AND2        },
    { "bind 'y' +weapon3",                           DOOM1AND2        },
    { "bind 'y' +weapon4",                           DOOM1AND2        },
    { "bind 'y' +weapon5",                           DOOM1AND2        },
    { "bind 'y' +weapon6",                           DOOM1AND2        },
    { "bind 'y' +weapon7",                           DOOM1AND2        },
    { "bind 'y' +zoomin",                            DOOM1AND2        },
    { "bind 'y' +zoomout",                           DOOM1AND2        },
    { "bind 'z' +alwaysrun",                         DOOM1AND2        },
    { "bind 'z' +automap",                           DOOM1AND2        },
    { "bind 'z' +back",                              DOOM1AND2        },
    { "bind 'z' +clearmark",                         DOOM1AND2        },
    { "bind 'z' +console",                           DOOM1AND2        },
    { "bind 'z' +fire",                              DOOM1AND2        },
    { "bind 'z' +followmode",                        DOOM1AND2        },
    { "bind 'z' +forward",                           DOOM1AND2        },
    { "bind 'z' +freelook",                          DOOM1AND2        },
    { "bind 'z' +grid",                              DOOM1AND2        },
    { "bind 'z' +jump",                              DOOM1AND2        },
    { "bind 'z' +left",                              DOOM1AND2        },
    { "bind 'z' +mark",                              DOOM1AND2        },
    { "bind 'z' +maxzoom",                           DOOM1AND2        },
    { "bind 'z' +menu",                              DOOM1AND2        },
    { "bind 'z' +nextweapon",                        DOOM1AND2        },
    { "bind 'z' +prevweapon",                        DOOM1AND2        },
    { "bind 'z' +right",                             DOOM1AND2        },
    { "bind 'z' +rotatemode",                        DOOM1AND2        },
    { "bind 'z' +run",                               DOOM1AND2        },
    { "bind 'z' +screenshot",                        DOOM1AND2        },
    { "bind 'z' +strafe",                            DOOM1AND2        },
    { "bind 'z' +strafeleft",                        DOOM1AND2        },
    { "bind 'z' +straferight",                       DOOM1AND2        },
    { "bind 'z' +use",                               DOOM1AND2        },
    { "bind 'z' +weapon1",                           DOOM1AND2        },
    { "bind 'z' +weapon2",                           DOOM1AND2        },
    { "bind 'z' +weapon3",                           DOOM1AND2        },
    { "bind 'z' +weapon4",                           DOOM1AND2        },
    { "bind 'z' +weapon5",                           DOOM1AND2        },
    { "bind 'z' +weapon6",                           DOOM1AND2        },
    { "bind 'z' +weapon7",                           DOOM1AND2        },
    { "bind 'z' +zoomin",                            DOOM1AND2        },
    { "bind 'z' +zoomout",                           DOOM1AND2        },
    { "bind - +alwaysrun",                           DOOM1AND2        },
    { "bind - +automap",                             DOOM1AND2        },
    { "bind - +back",                                DOOM1AND2        },
    { "bind - +clearmark",                           DOOM1AND2        },
    { "bind - +console",                             DOOM1AND2        },
    { "bind - +fire",                                DOOM1AND2        },
    { "bind - +followmode",                          DOOM1AND2        },
    { "bind - +forward",                             DOOM1AND2        },
    { "bind - +freelook",                            DOOM1AND2        },
    { "bind - +grid",                                DOOM1AND2        },
    { "bind - +jump",                                DOOM1AND2        },
    { "bind - +left",                                DOOM1AND2        },
    { "bind - +mark",                                DOOM1AND2        },
    { "bind - +maxzoom",                             DOOM1AND2        },
    { "bind - +menu",                                DOOM1AND2        },
    { "bind - +nextweapon",                          DOOM1AND2        },
    { "bind - +prevweapon",                          DOOM1AND2        },
    { "bind - +right",                               DOOM1AND2        },
    { "bind - +rotatemode",                          DOOM1AND2        },
    { "bind - +run",                                 DOOM1AND2        },
    { "bind - +screenshot",                          DOOM1AND2        },
    { "bind - +strafe",                              DOOM1AND2        },
    { "bind - +strafeleft",                          DOOM1AND2        },
    { "bind - +straferight",                         DOOM1AND2        },
    { "bind - +use",                                 DOOM1AND2        },
    { "bind - +weapon1",                             DOOM1AND2        },
    { "bind - +weapon2",                             DOOM1AND2        },
    { "bind - +weapon3",                             DOOM1AND2        },
    { "bind - +weapon4",                             DOOM1AND2        },
    { "bind - +weapon5",                             DOOM1AND2        },
    { "bind - +weapon6",                             DOOM1AND2        },
    { "bind - +weapon7",                             DOOM1AND2        },
    { "bind - +zoomin",                              DOOM1AND2        },
    { "bind - +zoomout",                             DOOM1AND2        },
    { "bind , +alwaysrun",                           DOOM1AND2        },
    { "bind , +automap",                             DOOM1AND2        },
    { "bind , +back",                                DOOM1AND2        },
    { "bind , +clearmark",                           DOOM1AND2        },
    { "bind , +console",                             DOOM1AND2        },
    { "bind , +fire",                                DOOM1AND2        },
    { "bind , +followmode",                          DOOM1AND2        },
    { "bind , +forward",                             DOOM1AND2        },
    { "bind , +freelook",                            DOOM1AND2        },
    { "bind , +grid",                                DOOM1AND2        },
    { "bind , +jump",                                DOOM1AND2        },
    { "bind , +left",                                DOOM1AND2        },
    { "bind , +mark",                                DOOM1AND2        },
    { "bind , +maxzoom",                             DOOM1AND2        },
    { "bind , +menu",                                DOOM1AND2        },
    { "bind , +nextweapon",                          DOOM1AND2        },
    { "bind , +prevweapon",                          DOOM1AND2        },
    { "bind , +right",                               DOOM1AND2        },
    { "bind , +rotatemode",                          DOOM1AND2        },
    { "bind , +run",                                 DOOM1AND2        },
    { "bind , +screenshot",                          DOOM1AND2        },
    { "bind , +strafe",                              DOOM1AND2        },
    { "bind , +strafeleft",                          DOOM1AND2        },
    { "bind , +straferight",                         DOOM1AND2        },
    { "bind , +use",                                 DOOM1AND2        },
    { "bind , +weapon1",                             DOOM1AND2        },
    { "bind , +weapon2",                             DOOM1AND2        },
    { "bind , +weapon3",                             DOOM1AND2        },
    { "bind , +weapon4",                             DOOM1AND2        },
    { "bind , +weapon5",                             DOOM1AND2        },
    { "bind , +weapon6",                             DOOM1AND2        },
    { "bind , +weapon7",                             DOOM1AND2        },
    { "bind , +zoomin",                              DOOM1AND2        },
    { "bind , +zoomout",                             DOOM1AND2        },
    { "bind . +alwaysrun",                           DOOM1AND2        },
    { "bind . +automap",                             DOOM1AND2        },
    { "bind . +back",                                DOOM1AND2        },
    { "bind . +clearmark",                           DOOM1AND2        },
    { "bind . +console",                             DOOM1AND2        },
    { "bind . +fire",                                DOOM1AND2        },
    { "bind . +followmode",                          DOOM1AND2        },
    { "bind . +forward",                             DOOM1AND2        },
    { "bind . +freelook",                            DOOM1AND2        },
    { "bind . +grid",                                DOOM1AND2        },
    { "bind . +jump",                                DOOM1AND2        },
    { "bind . +left",                                DOOM1AND2        },
    { "bind . +mark",                                DOOM1AND2        },
    { "bind . +maxzoom",                             DOOM1AND2        },
    { "bind . +menu",                                DOOM1AND2        },
    { "bind . +nextweapon",                          DOOM1AND2        },
    { "bind . +prevweapon",                          DOOM1AND2        },
    { "bind . +right",                               DOOM1AND2        },
    { "bind . +rotatemode",                          DOOM1AND2        },
    { "bind . +run",                                 DOOM1AND2        },
    { "bind . +screenshot",                          DOOM1AND2        },
    { "bind . +strafe",                              DOOM1AND2        },
    { "bind . +strafeleft",                          DOOM1AND2        },
    { "bind . +straferight",                         DOOM1AND2        },
    { "bind . +use",                                 DOOM1AND2        },
    { "bind . +weapon1",                             DOOM1AND2        },
    { "bind . +weapon2",                             DOOM1AND2        },
    { "bind . +weapon3",                             DOOM1AND2        },
    { "bind . +weapon4",                             DOOM1AND2        },
    { "bind . +weapon5",                             DOOM1AND2        },
    { "bind . +weapon6",                             DOOM1AND2        },
    { "bind . +weapon7",                             DOOM1AND2        },
    { "bind . +zoomin",                              DOOM1AND2        },
    { "bind . +zoomout",                             DOOM1AND2        },
    { "bind / +alwaysrun",                           DOOM1AND2        },
    { "bind / +automap",                             DOOM1AND2        },
    { "bind / +back",                                DOOM1AND2        },
    { "bind / +clearmark",                           DOOM1AND2        },
    { "bind / +console",                             DOOM1AND2        },
    { "bind / +fire",                                DOOM1AND2        },
    { "bind / +followmode",                          DOOM1AND2        },
    { "bind / +forward",                             DOOM1AND2        },
    { "bind / +freelook",                            DOOM1AND2        },
    { "bind / +grid",                                DOOM1AND2        },
    { "bind / +jump",                                DOOM1AND2        },
    { "bind / +left",                                DOOM1AND2        },
    { "bind / +mark",                                DOOM1AND2        },
    { "bind / +maxzoom",                             DOOM1AND2        },
    { "bind / +menu",                                DOOM1AND2        },
    { "bind / +nextweapon",                          DOOM1AND2        },
    { "bind / +prevweapon",                          DOOM1AND2        },
    { "bind / +right",                               DOOM1AND2        },
    { "bind / +rotatemode",                          DOOM1AND2        },
    { "bind / +run",                                 DOOM1AND2        },
    { "bind / +screenshot",                          DOOM1AND2        },
    { "bind / +strafe",                              DOOM1AND2        },
    { "bind / +strafeleft",                          DOOM1AND2        },
    { "bind / +straferight",                         DOOM1AND2        },
    { "bind / +use",                                 DOOM1AND2        },
    { "bind / +weapon1",                             DOOM1AND2        },
    { "bind / +weapon2",                             DOOM1AND2        },
    { "bind / +weapon3",                             DOOM1AND2        },
    { "bind / +weapon4",                             DOOM1AND2        },
    { "bind / +weapon5",                             DOOM1AND2        },
    { "bind / +weapon6",                             DOOM1AND2        },
    { "bind / +weapon7",                             DOOM1AND2        },
    { "bind / +zoomin",                              DOOM1AND2        },
    { "bind / +zoomout",                             DOOM1AND2        },
    { "bind ; +alwaysrun",                           DOOM1AND2        },
    { "bind ; +automap",                             DOOM1AND2        },
    { "bind ; +back",                                DOOM1AND2        },
    { "bind ; +clearmark",                           DOOM1AND2        },
    { "bind ; +console",                             DOOM1AND2        },
    { "bind ; +fire",                                DOOM1AND2        },
    { "bind ; +followmode",                          DOOM1AND2        },
    { "bind ; +forward",                             DOOM1AND2        },
    { "bind ; +freelook",                            DOOM1AND2        },
    { "bind ; +grid",                                DOOM1AND2        },
    { "bind ; +jump",                                DOOM1AND2        },
    { "bind ; +left",                                DOOM1AND2        },
    { "bind ; +mark",                                DOOM1AND2        },
    { "bind ; +maxzoom",                             DOOM1AND2        },
    { "bind ; +menu",                                DOOM1AND2        },
    { "bind ; +nextweapon",                          DOOM1AND2        },
    { "bind ; +prevweapon",                          DOOM1AND2        },
    { "bind ; +right",                               DOOM1AND2        },
    { "bind ; +rotatemode",                          DOOM1AND2        },
    { "bind ; +run",                                 DOOM1AND2        },
    { "bind ; +screenshot",                          DOOM1AND2        },
    { "bind ; +strafe",                              DOOM1AND2        },
    { "bind ; +strafeleft",                          DOOM1AND2        },
    { "bind ; +straferight",                         DOOM1AND2        },
    { "bind ; +use",                                 DOOM1AND2        },
    { "bind ; +weapon1",                             DOOM1AND2        },
    { "bind ; +weapon2",                             DOOM1AND2        },
    { "bind ; +weapon3",                             DOOM1AND2        },
    { "bind ; +weapon4",                             DOOM1AND2        },
    { "bind ; +weapon5",                             DOOM1AND2        },
    { "bind ; +weapon6",                             DOOM1AND2        },
    { "bind ; +weapon7",                             DOOM1AND2        },
    { "bind ; +zoomin",                              DOOM1AND2        },
    { "bind ; +zoomout",                             DOOM1AND2        },
    { "bind [ +alwaysrun",                           DOOM1AND2        },
    { "bind [ +automap",                             DOOM1AND2        },
    { "bind [ +back",                                DOOM1AND2        },
    { "bind [ +clearmark",                           DOOM1AND2        },
    { "bind [ +console",                             DOOM1AND2        },
    { "bind [ +fire",                                DOOM1AND2        },
    { "bind [ +followmode",                          DOOM1AND2        },
    { "bind [ +forward",                             DOOM1AND2        },
    { "bind [ +freelook",                            DOOM1AND2        },
    { "bind [ +grid",                                DOOM1AND2        },
    { "bind [ +jump",                                DOOM1AND2        },
    { "bind [ +left",                                DOOM1AND2        },
    { "bind [ +mark",                                DOOM1AND2        },
    { "bind [ +maxzoom",                             DOOM1AND2        },
    { "bind [ +menu",                                DOOM1AND2        },
    { "bind [ +nextweapon",                          DOOM1AND2        },
    { "bind [ +prevweapon",                          DOOM1AND2        },
    { "bind [ +right",                               DOOM1AND2        },
    { "bind [ +rotatemode",                          DOOM1AND2        },
    { "bind [ +run",                                 DOOM1AND2        },
    { "bind [ +screenshot",                          DOOM1AND2        },
    { "bind [ +strafe",                              DOOM1AND2        },
    { "bind [ +strafeleft",                          DOOM1AND2        },
    { "bind [ +straferight",                         DOOM1AND2        },
    { "bind [ +use",                                 DOOM1AND2        },
    { "bind [ +weapon1",                             DOOM1AND2        },
    { "bind [ +weapon2",                             DOOM1AND2        },
    { "bind [ +weapon3",                             DOOM1AND2        },
    { "bind [ +weapon4",                             DOOM1AND2        },
    { "bind [ +weapon5",                             DOOM1AND2        },
    { "bind [ +weapon6",                             DOOM1AND2        },
    { "bind [ +weapon7",                             DOOM1AND2        },
    { "bind [ +zoomin",                              DOOM1AND2        },
    { "bind [ +zoomout",                             DOOM1AND2        },
    { "bind \\ +alwaysrun",                          DOOM1AND2        },
    { "bind \\ +automap",                            DOOM1AND2        },
    { "bind \\ +back",                               DOOM1AND2        },
    { "bind \\ +clearmark",                          DOOM1AND2        },
    { "bind \\ +console",                            DOOM1AND2        },
    { "bind \\ +fire",                               DOOM1AND2        },
    { "bind \\ +followmode",                         DOOM1AND2        },
    { "bind \\ +forward",                            DOOM1AND2        },
    { "bind \\ +freelook",                           DOOM1AND2        },
    { "bind \\ +grid",                               DOOM1AND2        },
    { "bind \\ +jump",                               DOOM1AND2        },
    { "bind \\ +left",                               DOOM1AND2        },
    { "bind \\ +mark",                               DOOM1AND2        },
    { "bind \\ +maxzoom",                            DOOM1AND2        },
    { "bind \\ +menu",                               DOOM1AND2        },
    { "bind \\ +nextweapon",                         DOOM1AND2        },
    { "bind \\ +prevweapon",                         DOOM1AND2        },
    { "bind \\ +right",                              DOOM1AND2        },
    { "bind \\ +rotatemode",                         DOOM1AND2        },
    { "bind \\ +run",                                DOOM1AND2        },
    { "bind \\ +screenshot",                         DOOM1AND2        },
    { "bind \\ +strafe",                             DOOM1AND2        },
    { "bind \\ +strafeleft",                         DOOM1AND2        },
    { "bind \\ +straferight",                        DOOM1AND2        },
    { "bind \\ +use",                                DOOM1AND2        },
    { "bind \\ +weapon1",                            DOOM1AND2        },
    { "bind \\ +weapon2",                            DOOM1AND2        },
    { "bind \\ +weapon3",                            DOOM1AND2        },
    { "bind \\ +weapon4",                            DOOM1AND2        },
    { "bind \\ +weapon5",                            DOOM1AND2        },
    { "bind \\ +weapon6",                            DOOM1AND2        },
    { "bind \\ +weapon7",                            DOOM1AND2        },
    { "bind \\ +zoomin",                             DOOM1AND2        },
    { "bind \\ +zoomout",                            DOOM1AND2        },
    { "bind ] +alwaysrun",                           DOOM1AND2        },
    { "bind ] +automap",                             DOOM1AND2        },
    { "bind ] +back",                                DOOM1AND2        },
    { "bind ] +clearmark",                           DOOM1AND2        },
    { "bind ] +console",                             DOOM1AND2        },
    { "bind ] +fire",                                DOOM1AND2        },
    { "bind ] +followmode",                          DOOM1AND2        },
    { "bind ] +forward",                             DOOM1AND2        },
    { "bind ] +freelook",                            DOOM1AND2        },
    { "bind ] +grid",                                DOOM1AND2        },
    { "bind ] +jump",                                DOOM1AND2        },
    { "bind ] +left",                                DOOM1AND2        },
    { "bind ] +mark",                                DOOM1AND2        },
    { "bind ] +maxzoom",                             DOOM1AND2        },
    { "bind ] +menu",                                DOOM1AND2        },
    { "bind ] +nextweapon",                          DOOM1AND2        },
    { "bind ] +prevweapon",                          DOOM1AND2        },
    { "bind ] +right",                               DOOM1AND2        },
    { "bind ] +rotatemode",                          DOOM1AND2        },
    { "bind ] +run",                                 DOOM1AND2        },
    { "bind ] +screenshot",                          DOOM1AND2        },
    { "bind ] +strafe",                              DOOM1AND2        },
    { "bind ] +strafeleft",                          DOOM1AND2        },
    { "bind ] +straferight",                         DOOM1AND2        },
    { "bind ] +use",                                 DOOM1AND2        },
    { "bind ] +weapon1",                             DOOM1AND2        },
    { "bind ] +weapon2",                             DOOM1AND2        },
    { "bind ] +weapon3",                             DOOM1AND2        },
    { "bind ] +weapon4",                             DOOM1AND2        },
    { "bind ] +weapon5",                             DOOM1AND2        },
    { "bind ] +weapon6",                             DOOM1AND2        },
    { "bind ] +weapon7",                             DOOM1AND2        },
    { "bind ] +zoomin",                              DOOM1AND2        },
    { "bind ] +zoomout",                             DOOM1AND2        },
    { "bind + +alwaysrun",                           DOOM1AND2        },
    { "bind + +automap",                             DOOM1AND2        },
    { "bind + +back",                                DOOM1AND2        },
    { "bind + +clearmark",                           DOOM1AND2        },
    { "bind + +console",                             DOOM1AND2        },
    { "bind + +fire",                                DOOM1AND2        },
    { "bind + +followmode",                          DOOM1AND2        },
    { "bind + +forward",                             DOOM1AND2        },
    { "bind + +freelook",                            DOOM1AND2        },
    { "bind + +grid",                                DOOM1AND2        },
    { "bind + +jump",                                DOOM1AND2        },
    { "bind + +left",                                DOOM1AND2        },
    { "bind + +mark",                                DOOM1AND2        },
    { "bind + +maxzoom",                             DOOM1AND2        },
    { "bind + +menu",                                DOOM1AND2        },
    { "bind + +nextweapon",                          DOOM1AND2        },
    { "bind + +prevweapon",                          DOOM1AND2        },
    { "bind + +right",                               DOOM1AND2        },
    { "bind + +rotatemode",                          DOOM1AND2        },
    { "bind + +run",                                 DOOM1AND2        },
    { "bind + +screenshot",                          DOOM1AND2        },
    { "bind + +strafe",                              DOOM1AND2        },
    { "bind + +strafeleft",                          DOOM1AND2        },
    { "bind + +straferight",                         DOOM1AND2        },
    { "bind + +use",                                 DOOM1AND2        },
    { "bind + +weapon1",                             DOOM1AND2        },
    { "bind + +weapon2",                             DOOM1AND2        },
    { "bind + +weapon3",                             DOOM1AND2        },
    { "bind + +weapon4",                             DOOM1AND2        },
    { "bind + +weapon5",                             DOOM1AND2        },
    { "bind + +weapon6",                             DOOM1AND2        },
    { "bind + +weapon7",                             DOOM1AND2        },
    { "bind + +zoomin",                              DOOM1AND2        },
    { "bind + +zoomout",                             DOOM1AND2        },
    { "bind 0 +alwaysrun",                           DOOM1AND2        },
    { "bind 0 +automap",                             DOOM1AND2        },
    { "bind 0 +back",                                DOOM1AND2        },
    { "bind 0 +clearmark",                           DOOM1AND2        },
    { "bind 0 +console",                             DOOM1AND2        },
    { "bind 0 +fire",                                DOOM1AND2        },
    { "bind 0 +followmode",                          DOOM1AND2        },
    { "bind 0 +forward",                             DOOM1AND2        },
    { "bind 0 +freelook",                            DOOM1AND2        },
    { "bind 0 +grid",                                DOOM1AND2        },
    { "bind 0 +jump",                                DOOM1AND2        },
    { "bind 0 +left",                                DOOM1AND2        },
    { "bind 0 +mark",                                DOOM1AND2        },
    { "bind 0 +maxzoom",                             DOOM1AND2        },
    { "bind 0 +menu",                                DOOM1AND2        },
    { "bind 0 +nextweapon",                          DOOM1AND2        },
    { "bind 0 +prevweapon",                          DOOM1AND2        },
    { "bind 0 +right",                               DOOM1AND2        },
    { "bind 0 +rotatemode",                          DOOM1AND2        },
    { "bind 0 +run",                                 DOOM1AND2        },
    { "bind 0 +screenshot",                          DOOM1AND2        },
    { "bind 0 +strafe",                              DOOM1AND2        },
    { "bind 0 +strafeleft",                          DOOM1AND2        },
    { "bind 0 +straferight",                         DOOM1AND2        },
    { "bind 0 +use",                                 DOOM1AND2        },
    { "bind 0 +weapon1",                             DOOM1AND2        },
    { "bind 0 +weapon2",                             DOOM1AND2        },
    { "bind 0 +weapon3",                             DOOM1AND2        },
    { "bind 0 +weapon4",                             DOOM1AND2        },
    { "bind 0 +weapon5",                             DOOM1AND2        },
    { "bind 0 +weapon6",                             DOOM1AND2        },
    { "bind 0 +weapon7",                             DOOM1AND2        },
    { "bind 0 +zoomin",                              DOOM1AND2        },
    { "bind 0 +zoomout",                             DOOM1AND2        },
    { "bind 1 +alwaysrun",                           DOOM1AND2        },
    { "bind 1 +automap",                             DOOM1AND2        },
    { "bind 1 +back",                                DOOM1AND2        },
    { "bind 1 +clearmark",                           DOOM1AND2        },
    { "bind 1 +console",                             DOOM1AND2        },
    { "bind 1 +fire",                                DOOM1AND2        },
    { "bind 1 +followmode",                          DOOM1AND2        },
    { "bind 1 +forward",                             DOOM1AND2        },
    { "bind 1 +freelook",                            DOOM1AND2        },
    { "bind 1 +grid",                                DOOM1AND2        },
    { "bind 1 +jump",                                DOOM1AND2        },
    { "bind 1 +left",                                DOOM1AND2        },
    { "bind 1 +mark",                                DOOM1AND2        },
    { "bind 1 +maxzoom",                             DOOM1AND2        },
    { "bind 1 +menu",                                DOOM1AND2        },
    { "bind 1 +nextweapon",                          DOOM1AND2        },
    { "bind 1 +prevweapon",                          DOOM1AND2        },
    { "bind 1 +right",                               DOOM1AND2        },
    { "bind 1 +rotatemode",                          DOOM1AND2        },
    { "bind 1 +run",                                 DOOM1AND2        },
    { "bind 1 +screenshot",                          DOOM1AND2        },
    { "bind 1 +strafe",                              DOOM1AND2        },
    { "bind 1 +strafeleft",                          DOOM1AND2        },
    { "bind 1 +straferight",                         DOOM1AND2        },
    { "bind 1 +use",                                 DOOM1AND2        },
    { "bind 1 +weapon1",                             DOOM1AND2        },
    { "bind 1 +weapon2",                             DOOM1AND2        },
    { "bind 1 +weapon3",                             DOOM1AND2        },
    { "bind 1 +weapon4",                             DOOM1AND2        },
    { "bind 1 +weapon5",                             DOOM1AND2        },
    { "bind 1 +weapon6",                             DOOM1AND2        },
    { "bind 1 +weapon7",                             DOOM1AND2        },
    { "bind 1 +zoomin",                              DOOM1AND2        },
    { "bind 1 +zoomout",                             DOOM1AND2        },
    { "bind 2 +alwaysrun",                           DOOM1AND2        },
    { "bind 2 +automap",                             DOOM1AND2        },
    { "bind 2 +back",                                DOOM1AND2        },
    { "bind 2 +clearmark",                           DOOM1AND2        },
    { "bind 2 +console",                             DOOM1AND2        },
    { "bind 2 +fire",                                DOOM1AND2        },
    { "bind 2 +followmode",                          DOOM1AND2        },
    { "bind 2 +forward",                             DOOM1AND2        },
    { "bind 2 +freelook",                            DOOM1AND2        },
    { "bind 2 +grid",                                DOOM1AND2        },
    { "bind 2 +jump",                                DOOM1AND2        },
    { "bind 2 +left",                                DOOM1AND2        },
    { "bind 2 +mark",                                DOOM1AND2        },
    { "bind 2 +maxzoom",                             DOOM1AND2        },
    { "bind 2 +menu",                                DOOM1AND2        },
    { "bind 2 +nextweapon",                          DOOM1AND2        },
    { "bind 2 +prevweapon",                          DOOM1AND2        },
    { "bind 2 +right",                               DOOM1AND2        },
    { "bind 2 +rotatemode",                          DOOM1AND2        },
    { "bind 2 +run",                                 DOOM1AND2        },
    { "bind 2 +screenshot",                          DOOM1AND2        },
    { "bind 2 +strafe",                              DOOM1AND2        },
    { "bind 2 +strafeleft",                          DOOM1AND2        },
    { "bind 2 +straferight",                         DOOM1AND2        },
    { "bind 2 +use",                                 DOOM1AND2        },
    { "bind 2 +weapon1",                             DOOM1AND2        },
    { "bind 2 +weapon2",                             DOOM1AND2        },
    { "bind 2 +weapon3",                             DOOM1AND2        },
    { "bind 2 +weapon4",                             DOOM1AND2        },
    { "bind 2 +weapon5",                             DOOM1AND2        },
    { "bind 2 +weapon6",                             DOOM1AND2        },
    { "bind 2 +weapon7",                             DOOM1AND2        },
    { "bind 2 +zoomin",                              DOOM1AND2        },
    { "bind 2 +zoomout",                             DOOM1AND2        },
    { "bind 3 +alwaysrun",                           DOOM1AND2        },
    { "bind 3 +automap",                             DOOM1AND2        },
    { "bind 3 +back",                                DOOM1AND2        },
    { "bind 3 +clearmark",                           DOOM1AND2        },
    { "bind 3 +console",                             DOOM1AND2        },
    { "bind 3 +fire",                                DOOM1AND2        },
    { "bind 3 +followmode",                          DOOM1AND2        },
    { "bind 3 +forward",                             DOOM1AND2        },
    { "bind 3 +freelook",                            DOOM1AND2        },
    { "bind 3 +grid",                                DOOM1AND2        },
    { "bind 3 +jump",                                DOOM1AND2        },
    { "bind 3 +left",                                DOOM1AND2        },
    { "bind 3 +mark",                                DOOM1AND2        },
    { "bind 3 +maxzoom",                             DOOM1AND2        },
    { "bind 3 +menu",                                DOOM1AND2        },
    { "bind 3 +nextweapon",                          DOOM1AND2        },
    { "bind 3 +prevweapon",                          DOOM1AND2        },
    { "bind 3 +right",                               DOOM1AND2        },
    { "bind 3 +rotatemode",                          DOOM1AND2        },
    { "bind 3 +run",                                 DOOM1AND2        },
    { "bind 3 +screenshot",                          DOOM1AND2        },
    { "bind 3 +strafe",                              DOOM1AND2        },
    { "bind 3 +strafeleft",                          DOOM1AND2        },
    { "bind 3 +straferight",                         DOOM1AND2        },
    { "bind 3 +use",                                 DOOM1AND2        },
    { "bind 3 +weapon1",                             DOOM1AND2        },
    { "bind 3 +weapon2",                             DOOM1AND2        },
    { "bind 3 +weapon3",                             DOOM1AND2        },
    { "bind 3 +weapon4",                             DOOM1AND2        },
    { "bind 3 +weapon5",                             DOOM1AND2        },
    { "bind 3 +weapon6",                             DOOM1AND2        },
    { "bind 3 +weapon7",                             DOOM1AND2        },
    { "bind 3 +zoomin",                              DOOM1AND2        },
    { "bind 3 +zoomout",                             DOOM1AND2        },
    { "bind 4 +alwaysrun",                           DOOM1AND2        },
    { "bind 4 +automap",                             DOOM1AND2        },
    { "bind 4 +back",                                DOOM1AND2        },
    { "bind 4 +clearmark",                           DOOM1AND2        },
    { "bind 4 +console",                             DOOM1AND2        },
    { "bind 4 +fire",                                DOOM1AND2        },
    { "bind 4 +followmode",                          DOOM1AND2        },
    { "bind 4 +forward",                             DOOM1AND2        },
    { "bind 4 +freelook",                            DOOM1AND2        },
    { "bind 4 +grid",                                DOOM1AND2        },
    { "bind 4 +jump",                                DOOM1AND2        },
    { "bind 4 +left",                                DOOM1AND2        },
    { "bind 4 +mark",                                DOOM1AND2        },
    { "bind 4 +maxzoom",                             DOOM1AND2        },
    { "bind 4 +menu",                                DOOM1AND2        },
    { "bind 4 +nextweapon",                          DOOM1AND2        },
    { "bind 4 +prevweapon",                          DOOM1AND2        },
    { "bind 4 +right",                               DOOM1AND2        },
    { "bind 4 +rotatemode",                          DOOM1AND2        },
    { "bind 4 +run",                                 DOOM1AND2        },
    { "bind 4 +screenshot",                          DOOM1AND2        },
    { "bind 4 +strafe",                              DOOM1AND2        },
    { "bind 4 +strafeleft",                          DOOM1AND2        },
    { "bind 4 +straferight",                         DOOM1AND2        },
    { "bind 4 +use",                                 DOOM1AND2        },
    { "bind 4 +weapon1",                             DOOM1AND2        },
    { "bind 4 +weapon2",                             DOOM1AND2        },
    { "bind 4 +weapon3",                             DOOM1AND2        },
    { "bind 4 +weapon4",                             DOOM1AND2        },
    { "bind 4 +weapon5",                             DOOM1AND2        },
    { "bind 4 +weapon6",                             DOOM1AND2        },
    { "bind 4 +weapon7",                             DOOM1AND2        },
    { "bind 4 +zoomin",                              DOOM1AND2        },
    { "bind 4 +zoomout",                             DOOM1AND2        },
    { "bind 5 +alwaysrun",                           DOOM1AND2        },
    { "bind 5 +automap",                             DOOM1AND2        },
    { "bind 5 +back",                                DOOM1AND2        },
    { "bind 5 +clearmark",                           DOOM1AND2        },
    { "bind 5 +console",                             DOOM1AND2        },
    { "bind 5 +fire",                                DOOM1AND2        },
    { "bind 5 +followmode",                          DOOM1AND2        },
    { "bind 5 +forward",                             DOOM1AND2        },
    { "bind 5 +freelook",                            DOOM1AND2        },
    { "bind 5 +grid",                                DOOM1AND2        },
    { "bind 5 +jump",                                DOOM1AND2        },
    { "bind 5 +left",                                DOOM1AND2        },
    { "bind 5 +mark",                                DOOM1AND2        },
    { "bind 5 +maxzoom",                             DOOM1AND2        },
    { "bind 5 +menu",                                DOOM1AND2        },
    { "bind 5 +nextweapon",                          DOOM1AND2        },
    { "bind 5 +prevweapon",                          DOOM1AND2        },
    { "bind 5 +right",                               DOOM1AND2        },
    { "bind 5 +rotatemode",                          DOOM1AND2        },
    { "bind 5 +run",                                 DOOM1AND2        },
    { "bind 5 +screenshot",                          DOOM1AND2        },
    { "bind 5 +strafe",                              DOOM1AND2        },
    { "bind 5 +strafeleft",                          DOOM1AND2        },
    { "bind 5 +straferight",                         DOOM1AND2        },
    { "bind 5 +use",                                 DOOM1AND2        },
    { "bind 5 +weapon1",                             DOOM1AND2        },
    { "bind 5 +weapon2",                             DOOM1AND2        },
    { "bind 5 +weapon3",                             DOOM1AND2        },
    { "bind 5 +weapon4",                             DOOM1AND2        },
    { "bind 5 +weapon5",                             DOOM1AND2        },
    { "bind 5 +weapon6",                             DOOM1AND2        },
    { "bind 5 +weapon7",                             DOOM1AND2        },
    { "bind 5 +zoomin",                              DOOM1AND2        },
    { "bind 5 +zoomout",                             DOOM1AND2        },
    { "bind 6 +alwaysrun",                           DOOM1AND2        },
    { "bind 6 +automap",                             DOOM1AND2        },
    { "bind 6 +back",                                DOOM1AND2        },
    { "bind 6 +clearmark",                           DOOM1AND2        },
    { "bind 6 +console",                             DOOM1AND2        },
    { "bind 6 +fire",                                DOOM1AND2        },
    { "bind 6 +followmode",                          DOOM1AND2        },
    { "bind 6 +forward",                             DOOM1AND2        },
    { "bind 6 +freelook",                            DOOM1AND2        },
    { "bind 6 +grid",                                DOOM1AND2        },
    { "bind 6 +jump",                                DOOM1AND2        },
    { "bind 6 +left",                                DOOM1AND2        },
    { "bind 6 +mark",                                DOOM1AND2        },
    { "bind 6 +maxzoom",                             DOOM1AND2        },
    { "bind 6 +menu",                                DOOM1AND2        },
    { "bind 6 +nextweapon",                          DOOM1AND2        },
    { "bind 6 +prevweapon",                          DOOM1AND2        },
    { "bind 6 +right",                               DOOM1AND2        },
    { "bind 6 +rotatemode",                          DOOM1AND2        },
    { "bind 6 +run",                                 DOOM1AND2        },
    { "bind 6 +screenshot",                          DOOM1AND2        },
    { "bind 6 +strafe",                              DOOM1AND2        },
    { "bind 6 +strafeleft",                          DOOM1AND2        },
    { "bind 6 +straferight",                         DOOM1AND2        },
    { "bind 6 +use",                                 DOOM1AND2        },
    { "bind 6 +weapon1",                             DOOM1AND2        },
    { "bind 6 +weapon2",                             DOOM1AND2        },
    { "bind 6 +weapon3",                             DOOM1AND2        },
    { "bind 6 +weapon4",                             DOOM1AND2        },
    { "bind 6 +weapon5",                             DOOM1AND2        },
    { "bind 6 +weapon6",                             DOOM1AND2        },
    { "bind 6 +weapon7",                             DOOM1AND2        },
    { "bind 6 +zoomin",                              DOOM1AND2        },
    { "bind 6 +zoomout",                             DOOM1AND2        },
    { "bind 7 +alwaysrun",                           DOOM1AND2        },
    { "bind 7 +automap",                             DOOM1AND2        },
    { "bind 7 +back",                                DOOM1AND2        },
    { "bind 7 +clearmark",                           DOOM1AND2        },
    { "bind 7 +console",                             DOOM1AND2        },
    { "bind 7 +fire",                                DOOM1AND2        },
    { "bind 7 +followmode",                          DOOM1AND2        },
    { "bind 7 +forward",                             DOOM1AND2        },
    { "bind 7 +freelook",                            DOOM1AND2        },
    { "bind 7 +grid",                                DOOM1AND2        },
    { "bind 7 +jump",                                DOOM1AND2        },
    { "bind 7 +left",                                DOOM1AND2        },
    { "bind 7 +mark",                                DOOM1AND2        },
    { "bind 7 +maxzoom",                             DOOM1AND2        },
    { "bind 7 +menu",                                DOOM1AND2        },
    { "bind 7 +nextweapon",                          DOOM1AND2        },
    { "bind 7 +prevweapon",                          DOOM1AND2        },
    { "bind 7 +right",                               DOOM1AND2        },
    { "bind 7 +rotatemode",                          DOOM1AND2        },
    { "bind 7 +run",                                 DOOM1AND2        },
    { "bind 7 +screenshot",                          DOOM1AND2        },
    { "bind 7 +strafe",                              DOOM1AND2        },
    { "bind 7 +strafeleft",                          DOOM1AND2        },
    { "bind 7 +straferight",                         DOOM1AND2        },
    { "bind 7 +use",                                 DOOM1AND2        },
    { "bind 7 +weapon1",                             DOOM1AND2        },
    { "bind 7 +weapon2",                             DOOM1AND2        },
    { "bind 7 +weapon3",                             DOOM1AND2        },
    { "bind 7 +weapon4",                             DOOM1AND2        },
    { "bind 7 +weapon5",                             DOOM1AND2        },
    { "bind 7 +weapon6",                             DOOM1AND2        },
    { "bind 7 +weapon7",                             DOOM1AND2        },
    { "bind 7 +zoomin",                              DOOM1AND2        },
    { "bind 7 +zoomout",                             DOOM1AND2        },
    { "bind 8 +alwaysrun",                           DOOM1AND2        },
    { "bind 8 +automap",                             DOOM1AND2        },
    { "bind 8 +back",                                DOOM1AND2        },
    { "bind 8 +clearmark",                           DOOM1AND2        },
    { "bind 8 +console",                             DOOM1AND2        },
    { "bind 8 +fire",                                DOOM1AND2        },
    { "bind 8 +followmode",                          DOOM1AND2        },
    { "bind 8 +forward",                             DOOM1AND2        },
    { "bind 8 +freelook",                            DOOM1AND2        },
    { "bind 8 +grid",                                DOOM1AND2        },
    { "bind 8 +jump",                                DOOM1AND2        },
    { "bind 8 +left",                                DOOM1AND2        },
    { "bind 8 +mark",                                DOOM1AND2        },
    { "bind 8 +maxzoom",                             DOOM1AND2        },
    { "bind 8 +menu",                                DOOM1AND2        },
    { "bind 8 +nextweapon",                          DOOM1AND2        },
    { "bind 8 +prevweapon",                          DOOM1AND2        },
    { "bind 8 +right",                               DOOM1AND2        },
    { "bind 8 +rotatemode",                          DOOM1AND2        },
    { "bind 8 +run",                                 DOOM1AND2        },
    { "bind 8 +screenshot",                          DOOM1AND2        },
    { "bind 8 +strafe",                              DOOM1AND2        },
    { "bind 8 +strafeleft",                          DOOM1AND2        },
    { "bind 8 +straferight",                         DOOM1AND2        },
    { "bind 8 +use",                                 DOOM1AND2        },
    { "bind 8 +weapon1",                             DOOM1AND2        },
    { "bind 8 +weapon2",                             DOOM1AND2        },
    { "bind 8 +weapon3",                             DOOM1AND2        },
    { "bind 8 +weapon4",                             DOOM1AND2        },
    { "bind 8 +weapon5",                             DOOM1AND2        },
    { "bind 8 +weapon6",                             DOOM1AND2        },
    { "bind 8 +weapon7",                             DOOM1AND2        },
    { "bind 8 +zoomin",                              DOOM1AND2        },
    { "bind 8 +zoomout",                             DOOM1AND2        },
    { "bind 9 +alwaysrun",                           DOOM1AND2        },
    { "bind 9 +automap",                             DOOM1AND2        },
    { "bind 9 +back",                                DOOM1AND2        },
    { "bind 9 +clearmark",                           DOOM1AND2        },
    { "bind 9 +console",                             DOOM1AND2        },
    { "bind 9 +fire",                                DOOM1AND2        },
    { "bind 9 +followmode",                          DOOM1AND2        },
    { "bind 9 +forward",                             DOOM1AND2        },
    { "bind 9 +freelook",                            DOOM1AND2        },
    { "bind 9 +grid",                                DOOM1AND2        },
    { "bind 9 +jump",                                DOOM1AND2        },
    { "bind 9 +left",                                DOOM1AND2        },
    { "bind 9 +mark",                                DOOM1AND2        },
    { "bind 9 +maxzoom",                             DOOM1AND2        },
    { "bind 9 +menu",                                DOOM1AND2        },
    { "bind 9 +nextweapon",                          DOOM1AND2        },
    { "bind 9 +prevweapon",                          DOOM1AND2        },
    { "bind 9 +right",                               DOOM1AND2        },
    { "bind 9 +rotatemode",                          DOOM1AND2        },
    { "bind 9 +run",                                 DOOM1AND2        },
    { "bind 9 +screenshot",                          DOOM1AND2        },
    { "bind 9 +strafe",                              DOOM1AND2        },
    { "bind 9 +strafeleft",                          DOOM1AND2        },
    { "bind 9 +straferight",                         DOOM1AND2        },
    { "bind 9 +use",                                 DOOM1AND2        },
    { "bind 9 +weapon1",                             DOOM1AND2        },
    { "bind 9 +weapon2",                             DOOM1AND2        },
    { "bind 9 +weapon3",                             DOOM1AND2        },
    { "bind 9 +weapon4",                             DOOM1AND2        },
    { "bind 9 +weapon5",                             DOOM1AND2        },
    { "bind 9 +weapon6",                             DOOM1AND2        },
    { "bind 9 +weapon7",                             DOOM1AND2        },
    { "bind 9 +zoomin",                              DOOM1AND2        },
    { "bind 9 +zoomout",                             DOOM1AND2        },
    { "bind a +alwaysrun",                           DOOM1AND2        },
    { "bind a +automap",                             DOOM1AND2        },
    { "bind a +back",                                DOOM1AND2        },
    { "bind a +clearmark",                           DOOM1AND2        },
    { "bind a +console",                             DOOM1AND2        },
    { "bind a +fire",                                DOOM1AND2        },
    { "bind a +followmode",                          DOOM1AND2        },
    { "bind a +forward",                             DOOM1AND2        },
    { "bind a +freelook",                            DOOM1AND2        },
    { "bind a +grid",                                DOOM1AND2        },
    { "bind a +jump",                                DOOM1AND2        },
    { "bind a +left",                                DOOM1AND2        },
    { "bind a +mark",                                DOOM1AND2        },
    { "bind a +maxzoom",                             DOOM1AND2        },
    { "bind a +menu",                                DOOM1AND2        },
    { "bind a +nextweapon",                          DOOM1AND2        },
    { "bind a +prevweapon",                          DOOM1AND2        },
    { "bind a +right",                               DOOM1AND2        },
    { "bind a +rotatemode",                          DOOM1AND2        },
    { "bind a +run",                                 DOOM1AND2        },
    { "bind a +screenshot",                          DOOM1AND2        },
    { "bind a +strafe",                              DOOM1AND2        },
    { "bind a +strafeleft",                          DOOM1AND2        },
    { "bind a +straferight",                         DOOM1AND2        },
    { "bind a +use",                                 DOOM1AND2        },
    { "bind a +weapon1",                             DOOM1AND2        },
    { "bind a +weapon2",                             DOOM1AND2        },
    { "bind a +weapon3",                             DOOM1AND2        },
    { "bind a +weapon4",                             DOOM1AND2        },
    { "bind a +weapon5",                             DOOM1AND2        },
    { "bind a +weapon6",                             DOOM1AND2        },
    { "bind a +weapon7",                             DOOM1AND2        },
    { "bind a +zoomin",                              DOOM1AND2        },
    { "bind a +zoomout",                             DOOM1AND2        },
    { "bind alt ",                                   DOOM1AND2        },
    { "bind alt +alwaysrun",                         DOOM1AND2        },
    { "bind alt +automap",                           DOOM1AND2        },
    { "bind alt +back",                              DOOM1AND2        },
    { "bind alt +clearmark",                         DOOM1AND2        },
    { "bind alt +console",                           DOOM1AND2        },
    { "bind alt +fire",                              DOOM1AND2        },
    { "bind alt +followmode",                        DOOM1AND2        },
    { "bind alt +forward",                           DOOM1AND2        },
    { "bind alt +freelook",                          DOOM1AND2        },
    { "bind alt +grid",                              DOOM1AND2        },
    { "bind alt +jump",                              DOOM1AND2        },
    { "bind alt +left",                              DOOM1AND2        },
    { "bind alt +mark",                              DOOM1AND2        },
    { "bind alt +maxzoom",                           DOOM1AND2        },
    { "bind alt +menu",                              DOOM1AND2        },
    { "bind alt +nextweapon",                        DOOM1AND2        },
    { "bind alt +prevweapon",                        DOOM1AND2        },
    { "bind alt +right",                             DOOM1AND2        },
    { "bind alt +rotatemode",                        DOOM1AND2        },
    { "bind alt +run",                               DOOM1AND2        },
    { "bind alt +screenshot",                        DOOM1AND2        },
    { "bind alt +strafe",                            DOOM1AND2        },
    { "bind alt +strafeleft",                        DOOM1AND2        },
    { "bind alt +straferight",                       DOOM1AND2        },
    { "bind alt +use",                               DOOM1AND2        },
    { "bind alt +weapon1",                           DOOM1AND2        },
    { "bind alt +weapon2",                           DOOM1AND2        },
    { "bind alt +weapon3",                           DOOM1AND2        },
    { "bind alt +weapon4",                           DOOM1AND2        },
    { "bind alt +weapon5",                           DOOM1AND2        },
    { "bind alt +weapon6",                           DOOM1AND2        },
    { "bind alt +weapon7",                           DOOM1AND2        },
    { "bind alt +zoomin",                            DOOM1AND2        },
    { "bind alt +zoomout",                           DOOM1AND2        },
    { "bind b +alwaysrun",                           DOOM1AND2        },
    { "bind b +automap",                             DOOM1AND2        },
    { "bind b +back",                                DOOM1AND2        },
    { "bind b +clearmark",                           DOOM1AND2        },
    { "bind b +console",                             DOOM1AND2        },
    { "bind b +fire",                                DOOM1AND2        },
    { "bind b +followmode",                          DOOM1AND2        },
    { "bind b +forward",                             DOOM1AND2        },
    { "bind b +freelook",                            DOOM1AND2        },
    { "bind b +grid",                                DOOM1AND2        },
    { "bind b +jump",                                DOOM1AND2        },
    { "bind b +left",                                DOOM1AND2        },
    { "bind b +mark",                                DOOM1AND2        },
    { "bind b +maxzoom",                             DOOM1AND2        },
    { "bind b +menu",                                DOOM1AND2        },
    { "bind b +nextweapon",                          DOOM1AND2        },
    { "bind b +prevweapon",                          DOOM1AND2        },
    { "bind b +right",                               DOOM1AND2        },
    { "bind b +rotatemode",                          DOOM1AND2        },
    { "bind b +run",                                 DOOM1AND2        },
    { "bind b +screenshot",                          DOOM1AND2        },
    { "bind b +strafe",                              DOOM1AND2        },
    { "bind b +strafeleft",                          DOOM1AND2        },
    { "bind b +straferight",                         DOOM1AND2        },
    { "bind b +use",                                 DOOM1AND2        },
    { "bind b +weapon1",                             DOOM1AND2        },
    { "bind b +weapon2",                             DOOM1AND2        },
    { "bind b +weapon3",                             DOOM1AND2        },
    { "bind b +weapon4",                             DOOM1AND2        },
    { "bind b +weapon5",                             DOOM1AND2        },
    { "bind b +weapon6",                             DOOM1AND2        },
    { "bind b +weapon7",                             DOOM1AND2        },
    { "bind b +zoomin",                              DOOM1AND2        },
    { "bind b +zoomout",                             DOOM1AND2        },
    { "bind back ",                                  DOOM1AND2        },
    { "bind back +alwaysrun",                        DOOM1AND2        },
    { "bind back +automap",                          DOOM1AND2        },
    { "bind back +back",                             DOOM1AND2        },
    { "bind back +clearmark",                        DOOM1AND2        },
    { "bind back +console",                          DOOM1AND2        },
    { "bind back +fire",                             DOOM1AND2        },
    { "bind back +followmode",                       DOOM1AND2        },
    { "bind back +forward",                          DOOM1AND2        },
    { "bind back +freelook",                         DOOM1AND2        },
    { "bind back +grid",                             DOOM1AND2        },
    { "bind back +jump",                             DOOM1AND2        },
    { "bind back +left",                             DOOM1AND2        },
    { "bind back +mark",                             DOOM1AND2        },
    { "bind back +maxzoom",                          DOOM1AND2        },
    { "bind back +menu",                             DOOM1AND2        },
    { "bind back +nextweapon",                       DOOM1AND2        },
    { "bind back +prevweapon",                       DOOM1AND2        },
    { "bind back +right",                            DOOM1AND2        },
    { "bind back +rotatemode",                       DOOM1AND2        },
    { "bind back +run",                              DOOM1AND2        },
    { "bind back +strafe",                           DOOM1AND2        },
    { "bind back +strafeleft",                       DOOM1AND2        },
    { "bind back +straferight",                      DOOM1AND2        },
    { "bind back +use",                              DOOM1AND2        },
    { "bind back +weapon1",                          DOOM1AND2        },
    { "bind back +weapon2",                          DOOM1AND2        },
    { "bind back +weapon3",                          DOOM1AND2        },
    { "bind back +weapon4",                          DOOM1AND2        },
    { "bind back +weapon5",                          DOOM1AND2        },
    { "bind back +weapon6",                          DOOM1AND2        },
    { "bind back +weapon7",                          DOOM1AND2        },
    { "bind back +zoomin",                           DOOM1AND2        },
    { "bind back +zoomout",                          DOOM1AND2        },
    { "bind backspace ",                             DOOM1AND2        },
    { "bind backspace +alwaysrun",                   DOOM1AND2        },
    { "bind backspace +automap",                     DOOM1AND2        },
    { "bind backspace +back",                        DOOM1AND2        },
    { "bind backspace +clearmark",                   DOOM1AND2        },
    { "bind backspace +console",                     DOOM1AND2        },
    { "bind backspace +fire",                        DOOM1AND2        },
    { "bind backspace +followmode",                  DOOM1AND2        },
    { "bind backspace +forward",                     DOOM1AND2        },
    { "bind backspace +freelook",                    DOOM1AND2        },
    { "bind backspace +grid",                        DOOM1AND2        },
    { "bind backspace +jump",                        DOOM1AND2        },
    { "bind backspace +left",                        DOOM1AND2        },
    { "bind backspace +mark",                        DOOM1AND2        },
    { "bind backspace +maxzoom",                     DOOM1AND2        },
    { "bind backspace +menu",                        DOOM1AND2        },
    { "bind backspace +nextweapon",                  DOOM1AND2        },
    { "bind backspace +prevweapon",                  DOOM1AND2        },
    { "bind backspace +right",                       DOOM1AND2        },
    { "bind backspace +rotatemode",                  DOOM1AND2        },
    { "bind backspace +run",                         DOOM1AND2        },
    { "bind backspace +screenshot",                  DOOM1AND2        },
    { "bind backspace +strafe",                      DOOM1AND2        },
    { "bind backspace +strafeleft",                  DOOM1AND2        },
    { "bind backspace +straferight",                 DOOM1AND2        },
    { "bind backspace +use",                         DOOM1AND2        },
    { "bind backspace +weapon1",                     DOOM1AND2        },
    { "bind backspace +weapon2",                     DOOM1AND2        },
    { "bind backspace +weapon3",                     DOOM1AND2        },
    { "bind backspace +weapon4",                     DOOM1AND2        },
    { "bind backspace +weapon5",                     DOOM1AND2        },
    { "bind backspace +weapon6",                     DOOM1AND2        },
    { "bind backspace +weapon7",                     DOOM1AND2        },
    { "bind backspace +zoomin",                      DOOM1AND2        },
    { "bind backspace +zoomout",                     DOOM1AND2        },
    { "bind button1 ",                               DOOM1AND2        },
    { "bind button1 +alwaysrun",                     DOOM1AND2        },
    { "bind button1 +automap",                       DOOM1AND2        },
    { "bind button1 +back",                          DOOM1AND2        },
    { "bind button1 +clearmark",                     DOOM1AND2        },
    { "bind button1 +console",                       DOOM1AND2        },
    { "bind button1 +fire",                          DOOM1AND2        },
    { "bind button1 +followmode",                    DOOM1AND2        },
    { "bind button1 +forward",                       DOOM1AND2        },
    { "bind button1 +freelook",                      DOOM1AND2        },
    { "bind button1 +grid",                          DOOM1AND2        },
    { "bind button1 +jump",                          DOOM1AND2        },
    { "bind button1 +left",                          DOOM1AND2        },
    { "bind button1 +mark",                          DOOM1AND2        },
    { "bind button1 +maxzoom",                       DOOM1AND2        },
    { "bind button1 +menu",                          DOOM1AND2        },
    { "bind button1 +nextweapon",                    DOOM1AND2        },
    { "bind button1 +prevweapon",                    DOOM1AND2        },
    { "bind button1 +right",                         DOOM1AND2        },
    { "bind button1 +rotatemode",                    DOOM1AND2        },
    { "bind button1 +run",                           DOOM1AND2        },
    { "bind button1 +strafe",                        DOOM1AND2        },
    { "bind button1 +strafeleft",                    DOOM1AND2        },
    { "bind button1 +straferight",                   DOOM1AND2        },
    { "bind button1 +use",                           DOOM1AND2        },
    { "bind button1 +weapon1",                       DOOM1AND2        },
    { "bind button1 +weapon2",                       DOOM1AND2        },
    { "bind button1 +weapon3",                       DOOM1AND2        },
    { "bind button1 +weapon4",                       DOOM1AND2        },
    { "bind button1 +weapon5",                       DOOM1AND2        },
    { "bind button1 +weapon6",                       DOOM1AND2        },
    { "bind button1 +weapon7",                       DOOM1AND2        },
    { "bind button1 +zoomin",                        DOOM1AND2        },
    { "bind button1 +zoomout",                       DOOM1AND2        },
    { "bind button2 ",                               DOOM1AND2        },
    { "bind button2 +alwaysrun",                     DOOM1AND2        },
    { "bind button2 +automap",                       DOOM1AND2        },
    { "bind button2 +back",                          DOOM1AND2        },
    { "bind button2 +clearmark",                     DOOM1AND2        },
    { "bind button2 +console",                       DOOM1AND2        },
    { "bind button2 +fire",                          DOOM1AND2        },
    { "bind button2 +followmode",                    DOOM1AND2        },
    { "bind button2 +forward",                       DOOM1AND2        },
    { "bind button2 +freelook",                      DOOM1AND2        },
    { "bind button2 +grid",                          DOOM1AND2        },
    { "bind button2 +jump",                          DOOM1AND2        },
    { "bind button2 +left",                          DOOM1AND2        },
    { "bind button2 +mark",                          DOOM1AND2        },
    { "bind button2 +maxzoom",                       DOOM1AND2        },
    { "bind button2 +menu",                          DOOM1AND2        },
    { "bind button2 +nextweapon",                    DOOM1AND2        },
    { "bind button2 +prevweapon",                    DOOM1AND2        },
    { "bind button2 +right",                         DOOM1AND2        },
    { "bind button2 +rotatemode",                    DOOM1AND2        },
    { "bind button2 +run",                           DOOM1AND2        },
    { "bind button2 +strafe",                        DOOM1AND2        },
    { "bind button2 +strafeleft",                    DOOM1AND2        },
    { "bind button2 +straferight",                   DOOM1AND2        },
    { "bind button2 +use",                           DOOM1AND2        },
    { "bind button2 +weapon1",                       DOOM1AND2        },
    { "bind button2 +weapon2",                       DOOM1AND2        },
    { "bind button2 +weapon3",                       DOOM1AND2        },
    { "bind button2 +weapon4",                       DOOM1AND2        },
    { "bind button2 +weapon5",                       DOOM1AND2        },
    { "bind button2 +weapon6",                       DOOM1AND2        },
    { "bind button2 +weapon7",                       DOOM1AND2        },
    { "bind button2 +zoomin",                        DOOM1AND2        },
    { "bind button2 +zoomout",                       DOOM1AND2        },
    { "bind button3 ",                               DOOM1AND2        },
    { "bind button3 +alwaysrun",                     DOOM1AND2        },
    { "bind button3 +automap",                       DOOM1AND2        },
    { "bind button3 +back",                          DOOM1AND2        },
    { "bind button3 +clearmark",                     DOOM1AND2        },
    { "bind button3 +console",                       DOOM1AND2        },
    { "bind button3 +fire",                          DOOM1AND2        },
    { "bind button3 +followmode",                    DOOM1AND2        },
    { "bind button3 +forward",                       DOOM1AND2        },
    { "bind button3 +freelook",                      DOOM1AND2        },
    { "bind button3 +grid",                          DOOM1AND2        },
    { "bind button3 +jump",                          DOOM1AND2        },
    { "bind button3 +left",                          DOOM1AND2        },
    { "bind button3 +mark",                          DOOM1AND2        },
    { "bind button3 +maxzoom",                       DOOM1AND2        },
    { "bind button3 +menu",                          DOOM1AND2        },
    { "bind button3 +nextweapon",                    DOOM1AND2        },
    { "bind button3 +prevweapon",                    DOOM1AND2        },
    { "bind button3 +right",                         DOOM1AND2        },
    { "bind button3 +rotatemode",                    DOOM1AND2        },
    { "bind button3 +run",                           DOOM1AND2        },
    { "bind button3 +strafe",                        DOOM1AND2        },
    { "bind button3 +strafeleft",                    DOOM1AND2        },
    { "bind button3 +straferight",                   DOOM1AND2        },
    { "bind button3 +use",                           DOOM1AND2        },
    { "bind button3 +weapon1",                       DOOM1AND2        },
    { "bind button3 +weapon2",                       DOOM1AND2        },
    { "bind button3 +weapon3",                       DOOM1AND2        },
    { "bind button3 +weapon4",                       DOOM1AND2        },
    { "bind button3 +weapon5",                       DOOM1AND2        },
    { "bind button3 +weapon6",                       DOOM1AND2        },
    { "bind button3 +weapon7",                       DOOM1AND2        },
    { "bind button3 +zoomin",                        DOOM1AND2        },
    { "bind button3 +zoomout",                       DOOM1AND2        },
    { "bind button4 ",                               DOOM1AND2        },
    { "bind button4 +alwaysrun",                     DOOM1AND2        },
    { "bind button4 +automap",                       DOOM1AND2        },
    { "bind button4 +back",                          DOOM1AND2        },
    { "bind button4 +clearmark",                     DOOM1AND2        },
    { "bind button4 +console",                       DOOM1AND2        },
    { "bind button4 +fire",                          DOOM1AND2        },
    { "bind button4 +followmode",                    DOOM1AND2        },
    { "bind button4 +forward",                       DOOM1AND2        },
    { "bind button4 +freelook",                      DOOM1AND2        },
    { "bind button4 +grid",                          DOOM1AND2        },
    { "bind button4 +jump",                          DOOM1AND2        },
    { "bind button4 +left",                          DOOM1AND2        },
    { "bind button4 +mark",                          DOOM1AND2        },
    { "bind button4 +maxzoom",                       DOOM1AND2        },
    { "bind button4 +menu",                          DOOM1AND2        },
    { "bind button4 +nextweapon",                    DOOM1AND2        },
    { "bind button4 +prevweapon",                    DOOM1AND2        },
    { "bind button4 +right",                         DOOM1AND2        },
    { "bind button4 +rotatemode",                    DOOM1AND2        },
    { "bind button4 +run",                           DOOM1AND2        },
    { "bind button4 +strafe",                        DOOM1AND2        },
    { "bind button4 +strafeleft",                    DOOM1AND2        },
    { "bind button4 +straferight",                   DOOM1AND2        },
    { "bind button4 +use",                           DOOM1AND2        },
    { "bind button4 +weapon1",                       DOOM1AND2        },
    { "bind button4 +weapon2",                       DOOM1AND2        },
    { "bind button4 +weapon3",                       DOOM1AND2        },
    { "bind button4 +weapon4",                       DOOM1AND2        },
    { "bind button4 +weapon5",                       DOOM1AND2        },
    { "bind button4 +weapon6",                       DOOM1AND2        },
    { "bind button4 +weapon7",                       DOOM1AND2        },
    { "bind button4 +zoomin",                        DOOM1AND2        },
    { "bind button4 +zoomout",                       DOOM1AND2        },
    { "bind c +alwaysrun",                           DOOM1AND2        },
    { "bind c +automap",                             DOOM1AND2        },
    { "bind c +back",                                DOOM1AND2        },
    { "bind c +clearmark",                           DOOM1AND2        },
    { "bind c +console",                             DOOM1AND2        },
    { "bind c +fire",                                DOOM1AND2        },
    { "bind c +followmode",                          DOOM1AND2        },
    { "bind c +forward",                             DOOM1AND2        },
    { "bind c +freelook",                            DOOM1AND2        },
    { "bind c +grid",                                DOOM1AND2        },
    { "bind c +jump",                                DOOM1AND2        },
    { "bind c +left",                                DOOM1AND2        },
    { "bind c +mark",                                DOOM1AND2        },
    { "bind c +maxzoom",                             DOOM1AND2        },
    { "bind c +menu",                                DOOM1AND2        },
    { "bind c +nextweapon",                          DOOM1AND2        },
    { "bind c +prevweapon",                          DOOM1AND2        },
    { "bind c +right",                               DOOM1AND2        },
    { "bind c +rotatemode",                          DOOM1AND2        },
    { "bind c +run",                                 DOOM1AND2        },
    { "bind c +screenshot",                          DOOM1AND2        },
    { "bind c +strafe",                              DOOM1AND2        },
    { "bind c +strafeleft",                          DOOM1AND2        },
    { "bind c +straferight",                         DOOM1AND2        },
    { "bind c +use",                                 DOOM1AND2        },
    { "bind c +weapon1",                             DOOM1AND2        },
    { "bind c +weapon2",                             DOOM1AND2        },
    { "bind c +weapon3",                             DOOM1AND2        },
    { "bind c +weapon4",                             DOOM1AND2        },
    { "bind c +weapon5",                             DOOM1AND2        },
    { "bind c +weapon6",                             DOOM1AND2        },
    { "bind c +weapon7",                             DOOM1AND2        },
    { "bind c +zoomin",                              DOOM1AND2        },
    { "bind c +zoomout",                             DOOM1AND2        },
    { "bind capslock ",                              DOOM1AND2        },
    { "bind capslock +alwaysrun",                    DOOM1AND2        },
    { "bind capslock +automap",                      DOOM1AND2        },
    { "bind capslock +back",                         DOOM1AND2        },
    { "bind capslock +clearmark",                    DOOM1AND2        },
    { "bind capslock +console",                      DOOM1AND2        },
    { "bind capslock +fire",                         DOOM1AND2        },
    { "bind capslock +followmode",                   DOOM1AND2        },
    { "bind capslock +forward",                      DOOM1AND2        },
    { "bind capslock +freelook",                     DOOM1AND2        },
    { "bind capslock +grid",                         DOOM1AND2        },
    { "bind capslock +jump",                         DOOM1AND2        },
    { "bind capslock +left",                         DOOM1AND2        },
    { "bind capslock +mark",                         DOOM1AND2        },
    { "bind capslock +maxzoom",                      DOOM1AND2        },
    { "bind capslock +menu",                         DOOM1AND2        },
    { "bind capslock +nextweapon",                   DOOM1AND2        },
    { "bind capslock +prevweapon",                   DOOM1AND2        },
    { "bind capslock +right",                        DOOM1AND2        },
    { "bind capslock +rotatemode",                   DOOM1AND2        },
    { "bind capslock +run",                          DOOM1AND2        },
    { "bind capslock +screenshot",                   DOOM1AND2        },
    { "bind capslock +strafe",                       DOOM1AND2        },
    { "bind capslock +strafeleft",                   DOOM1AND2        },
    { "bind capslock +straferight",                  DOOM1AND2        },
    { "bind capslock +use",                          DOOM1AND2        },
    { "bind capslock +weapon1",                      DOOM1AND2        },
    { "bind capslock +weapon2",                      DOOM1AND2        },
    { "bind capslock +weapon3",                      DOOM1AND2        },
    { "bind capslock +weapon4",                      DOOM1AND2        },
    { "bind capslock +weapon5",                      DOOM1AND2        },
    { "bind capslock +weapon6",                      DOOM1AND2        },
    { "bind capslock +weapon7",                      DOOM1AND2        },
    { "bind capslock +zoomin",                       DOOM1AND2        },
    { "bind capslock +zoomout",                      DOOM1AND2        },
    { "bind ctrl ",                                  DOOM1AND2        },
    { "bind ctrl +alwaysrun",                        DOOM1AND2        },
    { "bind ctrl +automap",                          DOOM1AND2        },
    { "bind ctrl +back",                             DOOM1AND2        },
    { "bind ctrl +clearmark",                        DOOM1AND2        },
    { "bind ctrl +console",                          DOOM1AND2        },
    { "bind ctrl +fire",                             DOOM1AND2        },
    { "bind ctrl +followmode",                       DOOM1AND2        },
    { "bind ctrl +forward",                          DOOM1AND2        },
    { "bind ctrl +freelook",                         DOOM1AND2        },
    { "bind ctrl +grid",                             DOOM1AND2        },
    { "bind ctrl +jump",                             DOOM1AND2        },
    { "bind ctrl +left",                             DOOM1AND2        },
    { "bind ctrl +mark",                             DOOM1AND2        },
    { "bind ctrl +maxzoom",                          DOOM1AND2        },
    { "bind ctrl +menu",                             DOOM1AND2        },
    { "bind ctrl +nextweapon",                       DOOM1AND2        },
    { "bind ctrl +prevweapon",                       DOOM1AND2        },
    { "bind ctrl +right",                            DOOM1AND2        },
    { "bind ctrl +rotatemode",                       DOOM1AND2        },
    { "bind ctrl +run",                              DOOM1AND2        },
    { "bind ctrl +screenshot",                       DOOM1AND2        },
    { "bind ctrl +strafe",                           DOOM1AND2        },
    { "bind ctrl +strafeleft",                       DOOM1AND2        },
    { "bind ctrl +straferight",                      DOOM1AND2        },
    { "bind ctrl +use",                              DOOM1AND2        },
    { "bind ctrl +weapon1",                          DOOM1AND2        },
    { "bind ctrl +weapon2",                          DOOM1AND2        },
    { "bind ctrl +weapon3",                          DOOM1AND2        },
    { "bind ctrl +weapon4",                          DOOM1AND2        },
    { "bind ctrl +weapon5",                          DOOM1AND2        },
    { "bind ctrl +weapon6",                          DOOM1AND2        },
    { "bind ctrl +weapon7",                          DOOM1AND2        },
    { "bind ctrl +zoomin",                           DOOM1AND2        },
    { "bind ctrl +zoomout",                          DOOM1AND2        },
    { "bind d +alwaysrun",                           DOOM1AND2        },
    { "bind d +automap",                             DOOM1AND2        },
    { "bind d +back",                                DOOM1AND2        },
    { "bind d +clearmark",                           DOOM1AND2        },
    { "bind d +console",                             DOOM1AND2        },
    { "bind d +fire",                                DOOM1AND2        },
    { "bind d +followmode",                          DOOM1AND2        },
    { "bind d +forward",                             DOOM1AND2        },
    { "bind d +freelook",                            DOOM1AND2        },
    { "bind d +grid",                                DOOM1AND2        },
    { "bind d +jump",                                DOOM1AND2        },
    { "bind d +left",                                DOOM1AND2        },
    { "bind d +mark",                                DOOM1AND2        },
    { "bind d +maxzoom",                             DOOM1AND2        },
    { "bind d +menu",                                DOOM1AND2        },
    { "bind d +nextweapon",                          DOOM1AND2        },
    { "bind d +prevweapon",                          DOOM1AND2        },
    { "bind d +right",                               DOOM1AND2        },
    { "bind d +rotatemode",                          DOOM1AND2        },
    { "bind d +run",                                 DOOM1AND2        },
    { "bind d +screenshot",                          DOOM1AND2        },
    { "bind d +strafe",                              DOOM1AND2        },
    { "bind d +strafeleft",                          DOOM1AND2        },
    { "bind d +straferight",                         DOOM1AND2        },
    { "bind d +use",                                 DOOM1AND2        },
    { "bind d +weapon1",                             DOOM1AND2        },
    { "bind d +weapon2",                             DOOM1AND2        },
    { "bind d +weapon3",                             DOOM1AND2        },
    { "bind d +weapon4",                             DOOM1AND2        },
    { "bind d +weapon5",                             DOOM1AND2        },
    { "bind d +weapon6",                             DOOM1AND2        },
    { "bind d +weapon7",                             DOOM1AND2        },
    { "bind d +zoomin",                              DOOM1AND2        },
    { "bind d +zoomout",                             DOOM1AND2        },
    { "bind delete ",                                DOOM1AND2        },
    { "bind delete +alwaysrun",                      DOOM1AND2        },
    { "bind delete +automap",                        DOOM1AND2        },
    { "bind delete +back",                           DOOM1AND2        },
    { "bind delete +clearmark",                      DOOM1AND2        },
    { "bind delete +console",                        DOOM1AND2        },
    { "bind delete +fire",                           DOOM1AND2        },
    { "bind delete +followmode",                     DOOM1AND2        },
    { "bind delete +forward",                        DOOM1AND2        },
    { "bind delete +freelook",                       DOOM1AND2        },
    { "bind delete +grid",                           DOOM1AND2        },
    { "bind delete +jump",                           DOOM1AND2        },
    { "bind delete +left",                           DOOM1AND2        },
    { "bind delete +mark",                           DOOM1AND2        },
    { "bind delete +maxzoom",                        DOOM1AND2        },
    { "bind delete +menu",                           DOOM1AND2        },
    { "bind delete +nextweapon",                     DOOM1AND2        },
    { "bind delete +prevweapon",                     DOOM1AND2        },
    { "bind delete +right",                          DOOM1AND2        },
    { "bind delete +rotatemode",                     DOOM1AND2        },
    { "bind delete +run",                            DOOM1AND2        },
    { "bind delete +screenshot",                     DOOM1AND2        },
    { "bind delete +strafe",                         DOOM1AND2        },
    { "bind delete +strafeleft",                     DOOM1AND2        },
    { "bind delete +straferight",                    DOOM1AND2        },
    { "bind delete +use",                            DOOM1AND2        },
    { "bind delete +weapon1",                        DOOM1AND2        },
    { "bind delete +weapon2",                        DOOM1AND2        },
    { "bind delete +weapon3",                        DOOM1AND2        },
    { "bind delete +weapon4",                        DOOM1AND2        },
    { "bind delete +weapon5",                        DOOM1AND2        },
    { "bind delete +weapon6",                        DOOM1AND2        },
    { "bind delete +weapon7",                        DOOM1AND2        },
    { "bind delete +zoomin",                         DOOM1AND2        },
    { "bind delete +zoomout",                        DOOM1AND2        },
    { "bind down ",                                  DOOM1AND2        },
    { "bind down +alwaysrun",                        DOOM1AND2        },
    { "bind down +automap",                          DOOM1AND2        },
    { "bind down +back",                             DOOM1AND2        },
    { "bind down +clearmark",                        DOOM1AND2        },
    { "bind down +console",                          DOOM1AND2        },
    { "bind down +fire",                             DOOM1AND2        },
    { "bind down +followmode",                       DOOM1AND2        },
    { "bind down +forward",                          DOOM1AND2        },
    { "bind down +freelook",                         DOOM1AND2        },
    { "bind down +grid",                             DOOM1AND2        },
    { "bind down +jump",                             DOOM1AND2        },
    { "bind down +left",                             DOOM1AND2        },
    { "bind down +mark",                             DOOM1AND2        },
    { "bind down +maxzoom",                          DOOM1AND2        },
    { "bind down +menu",                             DOOM1AND2        },
    { "bind down +nextweapon",                       DOOM1AND2        },
    { "bind down +prevweapon",                       DOOM1AND2        },
    { "bind down +right",                            DOOM1AND2        },
    { "bind down +rotatemode",                       DOOM1AND2        },
    { "bind down +run",                              DOOM1AND2        },
    { "bind down +screenshot",                       DOOM1AND2        },
    { "bind down +strafe",                           DOOM1AND2        },
    { "bind down +strafeleft",                       DOOM1AND2        },
    { "bind down +straferight",                      DOOM1AND2        },
    { "bind down +use",                              DOOM1AND2        },
    { "bind down +weapon1",                          DOOM1AND2        },
    { "bind down +weapon2",                          DOOM1AND2        },
    { "bind down +weapon3",                          DOOM1AND2        },
    { "bind down +weapon4",                          DOOM1AND2        },
    { "bind down +weapon5",                          DOOM1AND2        },
    { "bind down +weapon6",                          DOOM1AND2        },
    { "bind down +weapon7",                          DOOM1AND2        },
    { "bind down +zoomin",                           DOOM1AND2        },
    { "bind down +zoomout",                          DOOM1AND2        },
    { "bind dpaddown ",                              DOOM1AND2        },
    { "bind dpaddown +alwaysrun",                    DOOM1AND2        },
    { "bind dpaddown +automap",                      DOOM1AND2        },
    { "bind dpaddown +back",                         DOOM1AND2        },
    { "bind dpaddown +clearmark",                    DOOM1AND2        },
    { "bind dpaddown +console",                      DOOM1AND2        },
    { "bind dpaddown +fire",                         DOOM1AND2        },
    { "bind dpaddown +followmode",                   DOOM1AND2        },
    { "bind dpaddown +forward",                      DOOM1AND2        },
    { "bind dpaddown +freelook",                     DOOM1AND2        },
    { "bind dpaddown +grid",                         DOOM1AND2        },
    { "bind dpaddown +jump",                         DOOM1AND2        },
    { "bind dpaddown +left",                         DOOM1AND2        },
    { "bind dpaddown +mark",                         DOOM1AND2        },
    { "bind dpaddown +maxzoom",                      DOOM1AND2        },
    { "bind dpaddown +menu",                         DOOM1AND2        },
    { "bind dpaddown +nextweapon",                   DOOM1AND2        },
    { "bind dpaddown +prevweapon",                   DOOM1AND2        },
    { "bind dpaddown +right",                        DOOM1AND2        },
    { "bind dpaddown +rotatemode",                   DOOM1AND2        },
    { "bind dpaddown +run",                          DOOM1AND2        },
    { "bind dpaddown +strafe",                       DOOM1AND2        },
    { "bind dpaddown +strafeleft",                   DOOM1AND2        },
    { "bind dpaddown +straferight",                  DOOM1AND2        },
    { "bind dpaddown +use",                          DOOM1AND2        },
    { "bind dpaddown +weapon1",                      DOOM1AND2        },
    { "bind dpaddown +weapon2",                      DOOM1AND2        },
    { "bind dpaddown +weapon3",                      DOOM1AND2        },
    { "bind dpaddown +weapon4",                      DOOM1AND2        },
    { "bind dpaddown +weapon5",                      DOOM1AND2        },
    { "bind dpaddown +weapon6",                      DOOM1AND2        },
    { "bind dpaddown +weapon7",                      DOOM1AND2        },
    { "bind dpaddown +zoomin",                       DOOM1AND2        },
    { "bind dpaddown +zoomout",                      DOOM1AND2        },
    { "bind dpadleft ",                              DOOM1AND2        },
    { "bind dpadleft +alwaysrun",                    DOOM1AND2        },
    { "bind dpadleft +automap",                      DOOM1AND2        },
    { "bind dpadleft +back",                         DOOM1AND2        },
    { "bind dpadleft +clearmark",                    DOOM1AND2        },
    { "bind dpadleft +console",                      DOOM1AND2        },
    { "bind dpadleft +fire",                         DOOM1AND2        },
    { "bind dpadleft +followmode",                   DOOM1AND2        },
    { "bind dpadleft +forward",                      DOOM1AND2        },
    { "bind dpadleft +freelook",                     DOOM1AND2        },
    { "bind dpadleft +grid",                         DOOM1AND2        },
    { "bind dpadleft +jump",                         DOOM1AND2        },
    { "bind dpadleft +left",                         DOOM1AND2        },
    { "bind dpadleft +mark",                         DOOM1AND2        },
    { "bind dpadleft +maxzoom",                      DOOM1AND2        },
    { "bind dpadleft +menu",                         DOOM1AND2        },
    { "bind dpadleft +nextweapon",                   DOOM1AND2        },
    { "bind dpadleft +prevweapon",                   DOOM1AND2        },
    { "bind dpadleft +right",                        DOOM1AND2        },
    { "bind dpadleft +rotatemode",                   DOOM1AND2        },
    { "bind dpadleft +run",                          DOOM1AND2        },
    { "bind dpadleft +strafe",                       DOOM1AND2        },
    { "bind dpadleft +strafeleft",                   DOOM1AND2        },
    { "bind dpadleft +straferight",                  DOOM1AND2        },
    { "bind dpadleft +use",                          DOOM1AND2        },
    { "bind dpadleft +weapon1",                      DOOM1AND2        },
    { "bind dpadleft +weapon2",                      DOOM1AND2        },
    { "bind dpadleft +weapon3",                      DOOM1AND2        },
    { "bind dpadleft +weapon4",                      DOOM1AND2        },
    { "bind dpadleft +weapon5",                      DOOM1AND2        },
    { "bind dpadleft +weapon6",                      DOOM1AND2        },
    { "bind dpadleft +weapon7",                      DOOM1AND2        },
    { "bind dpadleft +zoomin",                       DOOM1AND2        },
    { "bind dpadleft +zoomout",                      DOOM1AND2        },
    { "bind dpadright ",                             DOOM1AND2        },
    { "bind dpadright +alwaysrun",                   DOOM1AND2        },
    { "bind dpadright +automap",                     DOOM1AND2        },
    { "bind dpadright +back",                        DOOM1AND2        },
    { "bind dpadright +clearmark",                   DOOM1AND2        },
    { "bind dpadright +console",                     DOOM1AND2        },
    { "bind dpadright +fire",                        DOOM1AND2        },
    { "bind dpadright +followmode",                  DOOM1AND2        },
    { "bind dpadright +forward",                     DOOM1AND2        },
    { "bind dpadright +freelook",                    DOOM1AND2        },
    { "bind dpadright +grid",                        DOOM1AND2        },
    { "bind dpadright +jump",                        DOOM1AND2        },
    { "bind dpadright +left",                        DOOM1AND2        },
    { "bind dpadright +mark",                        DOOM1AND2        },
    { "bind dpadright +maxzoom",                     DOOM1AND2        },
    { "bind dpadright +menu",                        DOOM1AND2        },
    { "bind dpadright +nextweapon",                  DOOM1AND2        },
    { "bind dpadright +prevweapon",                  DOOM1AND2        },
    { "bind dpadright +right",                       DOOM1AND2        },
    { "bind dpadright +rotatemode",                  DOOM1AND2        },
    { "bind dpadright +run",                         DOOM1AND2        },
    { "bind dpadright +strafe",                      DOOM1AND2        },
    { "bind dpadright +strafeleft",                  DOOM1AND2        },
    { "bind dpadright +straferight",                 DOOM1AND2        },
    { "bind dpadright +use",                         DOOM1AND2        },
    { "bind dpadright +weapon1",                     DOOM1AND2        },
    { "bind dpadright +weapon2",                     DOOM1AND2        },
    { "bind dpadright +weapon3",                     DOOM1AND2        },
    { "bind dpadright +weapon4",                     DOOM1AND2        },
    { "bind dpadright +weapon5",                     DOOM1AND2        },
    { "bind dpadright +weapon6",                     DOOM1AND2        },
    { "bind dpadright +weapon7",                     DOOM1AND2        },
    { "bind dpadright +zoomin",                      DOOM1AND2        },
    { "bind dpadright +zoomout",                     DOOM1AND2        },
    { "bind dpadup ",                                DOOM1AND2        },
    { "bind dpadup +alwaysrun",                      DOOM1AND2        },
    { "bind dpadup +automap",                        DOOM1AND2        },
    { "bind dpadup +back",                           DOOM1AND2        },
    { "bind dpadup +clearmark",                      DOOM1AND2        },
    { "bind dpadup +console",                        DOOM1AND2        },
    { "bind dpadup +fire",                           DOOM1AND2        },
    { "bind dpadup +followmode",                     DOOM1AND2        },
    { "bind dpadup +forward",                        DOOM1AND2        },
    { "bind dpadup +freelook",                       DOOM1AND2        },
    { "bind dpadup +grid",                           DOOM1AND2        },
    { "bind dpadup +jump",                           DOOM1AND2        },
    { "bind dpadup +left",                           DOOM1AND2        },
    { "bind dpadup +mark",                           DOOM1AND2        },
    { "bind dpadup +maxzoom",                        DOOM1AND2        },
    { "bind dpadup +menu",                           DOOM1AND2        },
    { "bind dpadup +nextweapon",                     DOOM1AND2        },
    { "bind dpadup +prevweapon",                     DOOM1AND2        },
    { "bind dpadup +right",                          DOOM1AND2        },
    { "bind dpadup +rotatemode",                     DOOM1AND2        },
    { "bind dpadup +run",                            DOOM1AND2        },
    { "bind dpadup +strafe",                         DOOM1AND2        },
    { "bind dpadup +strafeleft",                     DOOM1AND2        },
    { "bind dpadup +straferight",                    DOOM1AND2        },
    { "bind dpadup +use",                            DOOM1AND2        },
    { "bind dpadup +weapon1",                        DOOM1AND2        },
    { "bind dpadup +weapon2",                        DOOM1AND2        },
    { "bind dpadup +weapon3",                        DOOM1AND2        },
    { "bind dpadup +weapon4",                        DOOM1AND2        },
    { "bind dpadup +weapon5",                        DOOM1AND2        },
    { "bind dpadup +weapon6",                        DOOM1AND2        },
    { "bind dpadup +weapon7",                        DOOM1AND2        },
    { "bind dpadup +zoomin",                         DOOM1AND2        },
    { "bind dpadup +zoomout",                        DOOM1AND2        },
    { "bind e +alwaysrun",                           DOOM1AND2        },
    { "bind e +automap",                             DOOM1AND2        },
    { "bind e +back",                                DOOM1AND2        },
    { "bind e +clearmark",                           DOOM1AND2        },
    { "bind e +console",                             DOOM1AND2        },
    { "bind e +fire",                                DOOM1AND2        },
    { "bind e +followmode",                          DOOM1AND2        },
    { "bind e +forward",                             DOOM1AND2        },
    { "bind e +freelook",                            DOOM1AND2        },
    { "bind e +grid",                                DOOM1AND2        },
    { "bind e +jump",                                DOOM1AND2        },
    { "bind e +left",                                DOOM1AND2        },
    { "bind e +mark",                                DOOM1AND2        },
    { "bind e +maxzoom",                             DOOM1AND2        },
    { "bind e +menu",                                DOOM1AND2        },
    { "bind e +nextweapon",                          DOOM1AND2        },
    { "bind e +prevweapon",                          DOOM1AND2        },
    { "bind e +right",                               DOOM1AND2        },
    { "bind e +rotatemode",                          DOOM1AND2        },
    { "bind e +run",                                 DOOM1AND2        },
    { "bind e +screenshot",                          DOOM1AND2        },
    { "bind e +strafe",                              DOOM1AND2        },
    { "bind e +strafeleft",                          DOOM1AND2        },
    { "bind e +straferight",                         DOOM1AND2        },
    { "bind e +use",                                 DOOM1AND2        },
    { "bind e +weapon1",                             DOOM1AND2        },
    { "bind e +weapon2",                             DOOM1AND2        },
    { "bind e +weapon3",                             DOOM1AND2        },
    { "bind e +weapon4",                             DOOM1AND2        },
    { "bind e +weapon5",                             DOOM1AND2        },
    { "bind e +weapon6",                             DOOM1AND2        },
    { "bind e +weapon7",                             DOOM1AND2        },
    { "bind e +zoomin",                              DOOM1AND2        },
    { "bind e +zoomout",                             DOOM1AND2        },
    { "bind end ",                                   DOOM1AND2        },
    { "bind end +alwaysrun",                         DOOM1AND2        },
    { "bind end +automap",                           DOOM1AND2        },
    { "bind end +back",                              DOOM1AND2        },
    { "bind end +clearmark",                         DOOM1AND2        },
    { "bind end +console",                           DOOM1AND2        },
    { "bind end +fire",                              DOOM1AND2        },
    { "bind end +followmode",                        DOOM1AND2        },
    { "bind end +forward",                           DOOM1AND2        },
    { "bind end +freelook",                          DOOM1AND2        },
    { "bind end +grid",                              DOOM1AND2        },
    { "bind end +jump",                              DOOM1AND2        },
    { "bind end +left",                              DOOM1AND2        },
    { "bind end +mark",                              DOOM1AND2        },
    { "bind end +maxzoom",                           DOOM1AND2        },
    { "bind end +menu",                              DOOM1AND2        },
    { "bind end +nextweapon",                        DOOM1AND2        },
    { "bind end +prevweapon",                        DOOM1AND2        },
    { "bind end +right",                             DOOM1AND2        },
    { "bind end +rotatemode",                        DOOM1AND2        },
    { "bind end +run",                               DOOM1AND2        },
    { "bind end +screenshot",                        DOOM1AND2        },
    { "bind end +strafe",                            DOOM1AND2        },
    { "bind end +strafeleft",                        DOOM1AND2        },
    { "bind end +straferight",                       DOOM1AND2        },
    { "bind end +use",                               DOOM1AND2        },
    { "bind end +weapon1",                           DOOM1AND2        },
    { "bind end +weapon2",                           DOOM1AND2        },
    { "bind end +weapon3",                           DOOM1AND2        },
    { "bind end +weapon4",                           DOOM1AND2        },
    { "bind end +weapon5",                           DOOM1AND2        },
    { "bind end +weapon6",                           DOOM1AND2        },
    { "bind end +weapon7",                           DOOM1AND2        },
    { "bind end +zoomin",                            DOOM1AND2        },
    { "bind end +zoomout",                           DOOM1AND2        },
    { "bind enter ",                                 DOOM1AND2        },
    { "bind enter +alwaysrun",                       DOOM1AND2        },
    { "bind enter +automap",                         DOOM1AND2        },
    { "bind enter +back",                            DOOM1AND2        },
    { "bind enter +clearmark",                       DOOM1AND2        },
    { "bind enter +console",                         DOOM1AND2        },
    { "bind enter +fire",                            DOOM1AND2        },
    { "bind enter +followmode",                      DOOM1AND2        },
    { "bind enter +forward",                         DOOM1AND2        },
    { "bind enter +freelook",                        DOOM1AND2        },
    { "bind enter +grid",                            DOOM1AND2        },
    { "bind enter +jump",                            DOOM1AND2        },
    { "bind enter +left",                            DOOM1AND2        },
    { "bind enter +mark",                            DOOM1AND2        },
    { "bind enter +maxzoom",                         DOOM1AND2        },
    { "bind enter +menu",                            DOOM1AND2        },
    { "bind enter +nextweapon",                      DOOM1AND2        },
    { "bind enter +prevweapon",                      DOOM1AND2        },
    { "bind enter +right",                           DOOM1AND2        },
    { "bind enter +rotatemode",                      DOOM1AND2        },
    { "bind enter +run",                             DOOM1AND2        },
    { "bind enter +screenshot",                      DOOM1AND2        },
    { "bind enter +strafe",                          DOOM1AND2        },
    { "bind enter +strafeleft",                      DOOM1AND2        },
    { "bind enter +straferight",                     DOOM1AND2        },
    { "bind enter +use",                             DOOM1AND2        },
    { "bind enter +weapon1",                         DOOM1AND2        },
    { "bind enter +weapon2",                         DOOM1AND2        },
    { "bind enter +weapon3",                         DOOM1AND2        },
    { "bind enter +weapon4",                         DOOM1AND2        },
    { "bind enter +weapon5",                         DOOM1AND2        },
    { "bind enter +weapon6",                         DOOM1AND2        },
    { "bind enter +weapon7",                         DOOM1AND2        },
    { "bind enter +zoomin",                          DOOM1AND2        },
    { "bind enter +zoomout",                         DOOM1AND2        },
    { "bind escape ",                                DOOM1AND2        },
    { "bind escape +alwaysrun",                      DOOM1AND2        },
    { "bind escape +automap",                        DOOM1AND2        },
    { "bind escape +back",                           DOOM1AND2        },
    { "bind escape +clearmark",                      DOOM1AND2        },
    { "bind escape +console",                        DOOM1AND2        },
    { "bind escape +fire",                           DOOM1AND2        },
    { "bind escape +followmode",                     DOOM1AND2        },
    { "bind escape +forward",                        DOOM1AND2        },
    { "bind escape +freelook",                       DOOM1AND2        },
    { "bind escape +grid",                           DOOM1AND2        },
    { "bind escape +jump",                           DOOM1AND2        },
    { "bind escape +left",                           DOOM1AND2        },
    { "bind escape +mark",                           DOOM1AND2        },
    { "bind escape +maxzoom",                        DOOM1AND2        },
    { "bind escape +menu",                           DOOM1AND2        },
    { "bind escape +nextweapon",                     DOOM1AND2        },
    { "bind escape +prevweapon",                     DOOM1AND2        },
    { "bind escape +right",                          DOOM1AND2        },
    { "bind escape +rotatemode",                     DOOM1AND2        },
    { "bind escape +run",                            DOOM1AND2        },
    { "bind escape +screenshot",                     DOOM1AND2        },
    { "bind escape +strafe",                         DOOM1AND2        },
    { "bind escape +strafeleft",                     DOOM1AND2        },
    { "bind escape +straferight",                    DOOM1AND2        },
    { "bind escape +use",                            DOOM1AND2        },
    { "bind escape +weapon1",                        DOOM1AND2        },
    { "bind escape +weapon2",                        DOOM1AND2        },
    { "bind escape +weapon3",                        DOOM1AND2        },
    { "bind escape +weapon4",                        DOOM1AND2        },
    { "bind escape +weapon5",                        DOOM1AND2        },
    { "bind escape +weapon6",                        DOOM1AND2        },
    { "bind escape +weapon7",                        DOOM1AND2        },
    { "bind escape +zoomin",                         DOOM1AND2        },
    { "bind escape +zoomout",                        DOOM1AND2        },
    { "bind f +alwaysrun",                           DOOM1AND2        },
    { "bind f +automap",                             DOOM1AND2        },
    { "bind f +back",                                DOOM1AND2        },
    { "bind f +clearmark",                           DOOM1AND2        },
    { "bind f +console",                             DOOM1AND2        },
    { "bind f +fire",                                DOOM1AND2        },
    { "bind f +followmode",                          DOOM1AND2        },
    { "bind f +forward",                             DOOM1AND2        },
    { "bind f +freelook",                            DOOM1AND2        },
    { "bind f +grid",                                DOOM1AND2        },
    { "bind f +jump",                                DOOM1AND2        },
    { "bind f +left",                                DOOM1AND2        },
    { "bind f +mark",                                DOOM1AND2        },
    { "bind f +maxzoom",                             DOOM1AND2        },
    { "bind f +menu",                                DOOM1AND2        },
    { "bind f +nextweapon",                          DOOM1AND2        },
    { "bind f +prevweapon",                          DOOM1AND2        },
    { "bind f +right",                               DOOM1AND2        },
    { "bind f +rotatemode",                          DOOM1AND2        },
    { "bind f +run",                                 DOOM1AND2        },
    { "bind f +screenshot",                          DOOM1AND2        },
    { "bind f +strafe",                              DOOM1AND2        },
    { "bind f +strafeleft",                          DOOM1AND2        },
    { "bind f +straferight",                         DOOM1AND2        },
    { "bind f +use",                                 DOOM1AND2        },
    { "bind f +weapon1",                             DOOM1AND2        },
    { "bind f +weapon2",                             DOOM1AND2        },
    { "bind f +weapon3",                             DOOM1AND2        },
    { "bind f +weapon4",                             DOOM1AND2        },
    { "bind f +weapon5",                             DOOM1AND2        },
    { "bind f +weapon6",                             DOOM1AND2        },
    { "bind f +weapon7",                             DOOM1AND2        },
    { "bind f +zoomin",                              DOOM1AND2        },
    { "bind f +zoomout",                             DOOM1AND2        },
    { "bind F12 ",                                   DOOM1AND2        },
    { "bind F12 +alwaysrun",                         DOOM1AND2        },
    { "bind F12 +automap",                           DOOM1AND2        },
    { "bind F12 +back",                              DOOM1AND2        },
    { "bind F12 +clearmark",                         DOOM1AND2        },
    { "bind F12 +console",                           DOOM1AND2        },
    { "bind F12 +fire",                              DOOM1AND2        },
    { "bind F12 +followmode",                        DOOM1AND2        },
    { "bind F12 +forward",                           DOOM1AND2        },
    { "bind F12 +freelook",                          DOOM1AND2        },
    { "bind F12 +grid",                              DOOM1AND2        },
    { "bind F12 +jump",                              DOOM1AND2        },
    { "bind F12 +left",                              DOOM1AND2        },
    { "bind F12 +mark",                              DOOM1AND2        },
    { "bind F12 +maxzoom",                           DOOM1AND2        },
    { "bind F12 +menu",                              DOOM1AND2        },
    { "bind F12 +nextweapon",                        DOOM1AND2        },
    { "bind F12 +prevweapon",                        DOOM1AND2        },
    { "bind F12 +right",                             DOOM1AND2        },
    { "bind F12 +rotatemode",                        DOOM1AND2        },
    { "bind F12 +run",                               DOOM1AND2        },
    { "bind F12 +screenshot",                        DOOM1AND2        },
    { "bind F12 +strafe",                            DOOM1AND2        },
    { "bind F12 +strafeleft",                        DOOM1AND2        },
    { "bind F12 +straferight",                       DOOM1AND2        },
    { "bind F12 +use",                               DOOM1AND2        },
    { "bind F12 +weapon1",                           DOOM1AND2        },
    { "bind F12 +weapon2",                           DOOM1AND2        },
    { "bind F12 +weapon3",                           DOOM1AND2        },
    { "bind F12 +weapon4",                           DOOM1AND2        },
    { "bind F12 +weapon5",                           DOOM1AND2        },
    { "bind F12 +weapon6",                           DOOM1AND2        },
    { "bind F12 +weapon7",                           DOOM1AND2        },
    { "bind F12 +zoomin",                            DOOM1AND2        },
    { "bind F12 +zoomout",                           DOOM1AND2        },
    { "bind g +alwaysrun",                           DOOM1AND2        },
    { "bind g +automap",                             DOOM1AND2        },
    { "bind g +back",                                DOOM1AND2        },
    { "bind g +clearmark",                           DOOM1AND2        },
    { "bind g +console",                             DOOM1AND2        },
    { "bind g +fire",                                DOOM1AND2        },
    { "bind g +followmode",                          DOOM1AND2        },
    { "bind g +forward",                             DOOM1AND2        },
    { "bind g +freelook",                            DOOM1AND2        },
    { "bind g +grid",                                DOOM1AND2        },
    { "bind g +jump",                                DOOM1AND2        },
    { "bind g +left",                                DOOM1AND2        },
    { "bind g +mark",                                DOOM1AND2        },
    { "bind g +maxzoom",                             DOOM1AND2        },
    { "bind g +menu",                                DOOM1AND2        },
    { "bind g +nextweapon",                          DOOM1AND2        },
    { "bind g +prevweapon",                          DOOM1AND2        },
    { "bind g +right",                               DOOM1AND2        },
    { "bind g +rotatemode",                          DOOM1AND2        },
    { "bind g +run",                                 DOOM1AND2        },
    { "bind g +screenshot",                          DOOM1AND2        },
    { "bind g +strafe",                              DOOM1AND2        },
    { "bind g +strafeleft",                          DOOM1AND2        },
    { "bind g +straferight",                         DOOM1AND2        },
    { "bind g +use",                                 DOOM1AND2        },
    { "bind g +weapon1",                             DOOM1AND2        },
    { "bind g +weapon2",                             DOOM1AND2        },
    { "bind g +weapon3",                             DOOM1AND2        },
    { "bind g +weapon4",                             DOOM1AND2        },
    { "bind g +weapon5",                             DOOM1AND2        },
    { "bind g +weapon6",                             DOOM1AND2        },
    { "bind g +weapon7",                             DOOM1AND2        },
    { "bind g +zoomin",                              DOOM1AND2        },
    { "bind g +zoomout",                             DOOM1AND2        },
    { "bind guide ",                                 DOOM1AND2        },
    { "bind guide +alwaysrun",                       DOOM1AND2        },
    { "bind guide +automap",                         DOOM1AND2        },
    { "bind guide +back",                            DOOM1AND2        },
    { "bind guide +clearmark",                       DOOM1AND2        },
    { "bind guide +console",                         DOOM1AND2        },
    { "bind guide +fire",                            DOOM1AND2        },
    { "bind guide +followmode",                      DOOM1AND2        },
    { "bind guide +forward",                         DOOM1AND2        },
    { "bind guide +freelook",                        DOOM1AND2        },
    { "bind guide +grid",                            DOOM1AND2        },
    { "bind guide +jump",                            DOOM1AND2        },
    { "bind guide +left",                            DOOM1AND2        },
    { "bind guide +mark",                            DOOM1AND2        },
    { "bind guide +maxzoom",                         DOOM1AND2        },
    { "bind guide +menu",                            DOOM1AND2        },
    { "bind guide +nextweapon",                      DOOM1AND2        },
    { "bind guide +prevweapon",                      DOOM1AND2        },
    { "bind guide +right",                           DOOM1AND2        },
    { "bind guide +rotatemode",                      DOOM1AND2        },
    { "bind guide +run",                             DOOM1AND2        },
    { "bind guide +strafe",                          DOOM1AND2        },
    { "bind guide +strafeleft",                      DOOM1AND2        },
    { "bind guide +straferight",                     DOOM1AND2        },
    { "bind guide +use",                             DOOM1AND2        },
    { "bind guide +weapon1",                         DOOM1AND2        },
    { "bind guide +weapon2",                         DOOM1AND2        },
    { "bind guide +weapon3",                         DOOM1AND2        },
    { "bind guide +weapon4",                         DOOM1AND2        },
    { "bind guide +weapon5",                         DOOM1AND2        },
    { "bind guide +weapon6",                         DOOM1AND2        },
    { "bind guide +weapon7",                         DOOM1AND2        },
    { "bind guide +zoomin",                          DOOM1AND2        },
    { "bind guide +zoomout",                         DOOM1AND2        },
    { "bind h +alwaysrun",                           DOOM1AND2        },
    { "bind h +automap",                             DOOM1AND2        },
    { "bind h +back",                                DOOM1AND2        },
    { "bind h +clearmark",                           DOOM1AND2        },
    { "bind h +console",                             DOOM1AND2        },
    { "bind h +fire",                                DOOM1AND2        },
    { "bind h +followmode",                          DOOM1AND2        },
    { "bind h +forward",                             DOOM1AND2        },
    { "bind h +freelook",                            DOOM1AND2        },
    { "bind h +grid",                                DOOM1AND2        },
    { "bind h +jump",                                DOOM1AND2        },
    { "bind h +left",                                DOOM1AND2        },
    { "bind h +mark",                                DOOM1AND2        },
    { "bind h +maxzoom",                             DOOM1AND2        },
    { "bind h +menu",                                DOOM1AND2        },
    { "bind h +nextweapon",                          DOOM1AND2        },
    { "bind h +prevweapon",                          DOOM1AND2        },
    { "bind h +right",                               DOOM1AND2        },
    { "bind h +rotatemode",                          DOOM1AND2        },
    { "bind h +run",                                 DOOM1AND2        },
    { "bind h +screenshot",                          DOOM1AND2        },
    { "bind h +strafe",                              DOOM1AND2        },
    { "bind h +strafeleft",                          DOOM1AND2        },
    { "bind h +straferight",                         DOOM1AND2        },
    { "bind h +use",                                 DOOM1AND2        },
    { "bind h +weapon1",                             DOOM1AND2        },
    { "bind h +weapon2",                             DOOM1AND2        },
    { "bind h +weapon3",                             DOOM1AND2        },
    { "bind h +weapon4",                             DOOM1AND2        },
    { "bind h +weapon5",                             DOOM1AND2        },
    { "bind h +weapon6",                             DOOM1AND2        },
    { "bind h +weapon7",                             DOOM1AND2        },
    { "bind h +zoomin",                              DOOM1AND2        },
    { "bind h +zoomout",                             DOOM1AND2        },
    { "bind home ",                                  DOOM1AND2        },
    { "bind home +alwaysrun",                        DOOM1AND2        },
    { "bind home +automap",                          DOOM1AND2        },
    { "bind home +back",                             DOOM1AND2        },
    { "bind home +clearmark",                        DOOM1AND2        },
    { "bind home +console",                          DOOM1AND2        },
    { "bind home +fire",                             DOOM1AND2        },
    { "bind home +followmode",                       DOOM1AND2        },
    { "bind home +forward",                          DOOM1AND2        },
    { "bind home +freelook",                         DOOM1AND2        },
    { "bind home +grid",                             DOOM1AND2        },
    { "bind home +jump",                             DOOM1AND2        },
    { "bind home +left",                             DOOM1AND2        },
    { "bind home +mark",                             DOOM1AND2        },
    { "bind home +maxzoom",                          DOOM1AND2        },
    { "bind home +menu",                             DOOM1AND2        },
    { "bind home +nextweapon",                       DOOM1AND2        },
    { "bind home +prevweapon",                       DOOM1AND2        },
    { "bind home +right",                            DOOM1AND2        },
    { "bind home +rotatemode",                       DOOM1AND2        },
    { "bind home +run",                              DOOM1AND2        },
    { "bind home +screenshot",                       DOOM1AND2        },
    { "bind home +strafe",                           DOOM1AND2        },
    { "bind home +strafeleft",                       DOOM1AND2        },
    { "bind home +straferight",                      DOOM1AND2        },
    { "bind home +use",                              DOOM1AND2        },
    { "bind home +weapon1",                          DOOM1AND2        },
    { "bind home +weapon2",                          DOOM1AND2        },
    { "bind home +weapon3",                          DOOM1AND2        },
    { "bind home +weapon4",                          DOOM1AND2        },
    { "bind home +weapon5",                          DOOM1AND2        },
    { "bind home +weapon6",                          DOOM1AND2        },
    { "bind home +weapon7",                          DOOM1AND2        },
    { "bind home +zoomin",                           DOOM1AND2        },
    { "bind home +zoomout",                          DOOM1AND2        },
    { "bind i +alwaysrun",                           DOOM1AND2        },
    { "bind i +automap",                             DOOM1AND2        },
    { "bind i +back",                                DOOM1AND2        },
    { "bind i +clearmark",                           DOOM1AND2        },
    { "bind i +console",                             DOOM1AND2        },
    { "bind i +fire",                                DOOM1AND2        },
    { "bind i +followmode",                          DOOM1AND2        },
    { "bind i +forward",                             DOOM1AND2        },
    { "bind i +freelook",                            DOOM1AND2        },
    { "bind i +grid",                                DOOM1AND2        },
    { "bind i +jump",                                DOOM1AND2        },
    { "bind i +left",                                DOOM1AND2        },
    { "bind i +mark",                                DOOM1AND2        },
    { "bind i +maxzoom",                             DOOM1AND2        },
    { "bind i +menu",                                DOOM1AND2        },
    { "bind i +nextweapon",                          DOOM1AND2        },
    { "bind i +prevweapon",                          DOOM1AND2        },
    { "bind i +right",                               DOOM1AND2        },
    { "bind i +rotatemode",                          DOOM1AND2        },
    { "bind i +run",                                 DOOM1AND2        },
    { "bind i +screenshot",                          DOOM1AND2        },
    { "bind i +strafe",                              DOOM1AND2        },
    { "bind i +strafeleft",                          DOOM1AND2        },
    { "bind i +straferight",                         DOOM1AND2        },
    { "bind i +use",                                 DOOM1AND2        },
    { "bind i +weapon1",                             DOOM1AND2        },
    { "bind i +weapon2",                             DOOM1AND2        },
    { "bind i +weapon3",                             DOOM1AND2        },
    { "bind i +weapon4",                             DOOM1AND2        },
    { "bind i +weapon5",                             DOOM1AND2        },
    { "bind i +weapon6",                             DOOM1AND2        },
    { "bind i +weapon7",                             DOOM1AND2        },
    { "bind i +zoomin",                              DOOM1AND2        },
    { "bind i +zoomout",                             DOOM1AND2        },
    { "bind insert ",                                DOOM1AND2        },
    { "bind insert +alwaysrun",                      DOOM1AND2        },
    { "bind insert +automap",                        DOOM1AND2        },
    { "bind insert +back",                           DOOM1AND2        },
    { "bind insert +clearmark",                      DOOM1AND2        },
    { "bind insert +console",                        DOOM1AND2        },
    { "bind insert +fire",                           DOOM1AND2        },
    { "bind insert +followmode",                     DOOM1AND2        },
    { "bind insert +forward",                        DOOM1AND2        },
    { "bind insert +freelook",                       DOOM1AND2        },
    { "bind insert +grid",                           DOOM1AND2        },
    { "bind insert +jump",                           DOOM1AND2        },
    { "bind insert +left",                           DOOM1AND2        },
    { "bind insert +mark",                           DOOM1AND2        },
    { "bind insert +maxzoom",                        DOOM1AND2        },
    { "bind insert +menu",                           DOOM1AND2        },
    { "bind insert +nextweapon",                     DOOM1AND2        },
    { "bind insert +prevweapon",                     DOOM1AND2        },
    { "bind insert +right",                          DOOM1AND2        },
    { "bind insert +rotatemode",                     DOOM1AND2        },
    { "bind insert +run",                            DOOM1AND2        },
    { "bind insert +screenshot",                     DOOM1AND2        },
    { "bind insert +strafe",                         DOOM1AND2        },
    { "bind insert +strafeleft",                     DOOM1AND2        },
    { "bind insert +straferight",                    DOOM1AND2        },
    { "bind insert +use",                            DOOM1AND2        },
    { "bind insert +weapon1",                        DOOM1AND2        },
    { "bind insert +weapon2",                        DOOM1AND2        },
    { "bind insert +weapon3",                        DOOM1AND2        },
    { "bind insert +weapon4",                        DOOM1AND2        },
    { "bind insert +weapon5",                        DOOM1AND2        },
    { "bind insert +weapon6",                        DOOM1AND2        },
    { "bind insert +weapon7",                        DOOM1AND2        },
    { "bind insert +zoomin",                         DOOM1AND2        },
    { "bind insert +zoomout",                        DOOM1AND2        },
    { "bind j +alwaysrun",                           DOOM1AND2        },
    { "bind j +automap",                             DOOM1AND2        },
    { "bind j +back",                                DOOM1AND2        },
    { "bind j +clearmark",                           DOOM1AND2        },
    { "bind j +console",                             DOOM1AND2        },
    { "bind j +fire",                                DOOM1AND2        },
    { "bind j +followmode",                          DOOM1AND2        },
    { "bind j +forward",                             DOOM1AND2        },
    { "bind j +freelook",                            DOOM1AND2        },
    { "bind j +grid",                                DOOM1AND2        },
    { "bind j +jump",                                DOOM1AND2        },
    { "bind j +left",                                DOOM1AND2        },
    { "bind j +mark",                                DOOM1AND2        },
    { "bind j +maxzoom",                             DOOM1AND2        },
    { "bind j +menu",                                DOOM1AND2        },
    { "bind j +nextweapon",                          DOOM1AND2        },
    { "bind j +prevweapon",                          DOOM1AND2        },
    { "bind j +right",                               DOOM1AND2        },
    { "bind j +rotatemode",                          DOOM1AND2        },
    { "bind j +run",                                 DOOM1AND2        },
    { "bind j +screenshot",                          DOOM1AND2        },
    { "bind j +strafe",                              DOOM1AND2        },
    { "bind j +strafeleft",                          DOOM1AND2        },
    { "bind j +straferight",                         DOOM1AND2        },
    { "bind j +use",                                 DOOM1AND2        },
    { "bind j +weapon1",                             DOOM1AND2        },
    { "bind j +weapon2",                             DOOM1AND2        },
    { "bind j +weapon3",                             DOOM1AND2        },
    { "bind j +weapon4",                             DOOM1AND2        },
    { "bind j +weapon5",                             DOOM1AND2        },
    { "bind j +weapon6",                             DOOM1AND2        },
    { "bind j +weapon7",                             DOOM1AND2        },
    { "bind j +zoomin",                              DOOM1AND2        },
    { "bind j +zoomout",                             DOOM1AND2        },
    { "bind k +alwaysrun",                           DOOM1AND2        },
    { "bind k +automap",                             DOOM1AND2        },
    { "bind k +back",                                DOOM1AND2        },
    { "bind k +clearmark",                           DOOM1AND2        },
    { "bind k +console",                             DOOM1AND2        },
    { "bind k +fire",                                DOOM1AND2        },
    { "bind k +followmode",                          DOOM1AND2        },
    { "bind k +forward",                             DOOM1AND2        },
    { "bind k +freelook",                            DOOM1AND2        },
    { "bind k +grid",                                DOOM1AND2        },
    { "bind k +jump",                                DOOM1AND2        },
    { "bind k +left",                                DOOM1AND2        },
    { "bind k +mark",                                DOOM1AND2        },
    { "bind k +maxzoom",                             DOOM1AND2        },
    { "bind k +menu",                                DOOM1AND2        },
    { "bind k +nextweapon",                          DOOM1AND2        },
    { "bind k +prevweapon",                          DOOM1AND2        },
    { "bind k +right",                               DOOM1AND2        },
    { "bind k +rotatemode",                          DOOM1AND2        },
    { "bind k +run",                                 DOOM1AND2        },
    { "bind k +screenshot",                          DOOM1AND2        },
    { "bind k +strafe",                              DOOM1AND2        },
    { "bind k +strafeleft",                          DOOM1AND2        },
    { "bind k +straferight",                         DOOM1AND2        },
    { "bind k +use",                                 DOOM1AND2        },
    { "bind k +weapon1",                             DOOM1AND2        },
    { "bind k +weapon2",                             DOOM1AND2        },
    { "bind k +weapon3",                             DOOM1AND2        },
    { "bind k +weapon4",                             DOOM1AND2        },
    { "bind k +weapon5",                             DOOM1AND2        },
    { "bind k +weapon6",                             DOOM1AND2        },
    { "bind k +weapon7",                             DOOM1AND2        },
    { "bind k +zoomin",                              DOOM1AND2        },
    { "bind k +zoomout",                             DOOM1AND2        },
    { "bind l +alwaysrun",                           DOOM1AND2        },
    { "bind l +automap",                             DOOM1AND2        },
    { "bind l +back",                                DOOM1AND2        },
    { "bind l +clearmark",                           DOOM1AND2        },
    { "bind l +console",                             DOOM1AND2        },
    { "bind l +fire",                                DOOM1AND2        },
    { "bind l +followmode",                          DOOM1AND2        },
    { "bind l +forward",                             DOOM1AND2        },
    { "bind l +freelook",                            DOOM1AND2        },
    { "bind l +grid",                                DOOM1AND2        },
    { "bind l +jump",                                DOOM1AND2        },
    { "bind l +left",                                DOOM1AND2        },
    { "bind l +mark",                                DOOM1AND2        },
    { "bind l +maxzoom",                             DOOM1AND2        },
    { "bind l +menu",                                DOOM1AND2        },
    { "bind l +nextweapon",                          DOOM1AND2        },
    { "bind l +prevweapon",                          DOOM1AND2        },
    { "bind l +right",                               DOOM1AND2        },
    { "bind l +rotatemode",                          DOOM1AND2        },
    { "bind l +run",                                 DOOM1AND2        },
    { "bind l +screenshot",                          DOOM1AND2        },
    { "bind l +strafe",                              DOOM1AND2        },
    { "bind l +strafeleft",                          DOOM1AND2        },
    { "bind l +straferight",                         DOOM1AND2        },
    { "bind l +use",                                 DOOM1AND2        },
    { "bind l +weapon1",                             DOOM1AND2        },
    { "bind l +weapon2",                             DOOM1AND2        },
    { "bind l +weapon3",                             DOOM1AND2        },
    { "bind l +weapon4",                             DOOM1AND2        },
    { "bind l +weapon5",                             DOOM1AND2        },
    { "bind l +weapon6",                             DOOM1AND2        },
    { "bind l +weapon7",                             DOOM1AND2        },
    { "bind l +zoomin",                              DOOM1AND2        },
    { "bind l +zoomout",                             DOOM1AND2        },
    { "bind left ",                                  DOOM1AND2        },
    { "bind left +alwaysrun",                        DOOM1AND2        },
    { "bind left +automap",                          DOOM1AND2        },
    { "bind left +back",                             DOOM1AND2        },
    { "bind left +clearmark",                        DOOM1AND2        },
    { "bind left +console",                          DOOM1AND2        },
    { "bind left +fire",                             DOOM1AND2        },
    { "bind left +followmode",                       DOOM1AND2        },
    { "bind left +forward",                          DOOM1AND2        },
    { "bind left +freelook",                         DOOM1AND2        },
    { "bind left +grid",                             DOOM1AND2        },
    { "bind left +jump",                             DOOM1AND2        },
    { "bind left +left",                             DOOM1AND2        },
    { "bind left +mark",                             DOOM1AND2        },
    { "bind left +maxzoom",                          DOOM1AND2        },
    { "bind left +menu",                             DOOM1AND2        },
    { "bind left +nextweapon",                       DOOM1AND2        },
    { "bind left +prevweapon",                       DOOM1AND2        },
    { "bind left +right",                            DOOM1AND2        },
    { "bind left +rotatemode",                       DOOM1AND2        },
    { "bind left +run",                              DOOM1AND2        },
    { "bind left +screenshot",                       DOOM1AND2        },
    { "bind left +strafe",                           DOOM1AND2        },
    { "bind left +strafeleft",                       DOOM1AND2        },
    { "bind left +straferight",                      DOOM1AND2        },
    { "bind left +use",                              DOOM1AND2        },
    { "bind left +weapon1",                          DOOM1AND2        },
    { "bind left +weapon2",                          DOOM1AND2        },
    { "bind left +weapon3",                          DOOM1AND2        },
    { "bind left +weapon4",                          DOOM1AND2        },
    { "bind left +weapon5",                          DOOM1AND2        },
    { "bind left +weapon6",                          DOOM1AND2        },
    { "bind left +weapon7",                          DOOM1AND2        },
    { "bind left +zoomin",                           DOOM1AND2        },
    { "bind left +zoomout",                          DOOM1AND2        },
    { "bind leftshoulder ",                          DOOM1AND2        },
    { "bind leftshoulder +alwaysrun",                DOOM1AND2        },
    { "bind leftshoulder +automap",                  DOOM1AND2        },
    { "bind leftshoulder +back",                     DOOM1AND2        },
    { "bind leftshoulder +clearmark",                DOOM1AND2        },
    { "bind leftshoulder +console",                  DOOM1AND2        },
    { "bind leftshoulder +fire",                     DOOM1AND2        },
    { "bind leftshoulder +followmode",               DOOM1AND2        },
    { "bind leftshoulder +forward",                  DOOM1AND2        },
    { "bind leftshoulder +freelook",                 DOOM1AND2        },
    { "bind leftshoulder +grid",                     DOOM1AND2        },
    { "bind leftshoulder +jump",                     DOOM1AND2        },
    { "bind leftshoulder +left",                     DOOM1AND2        },
    { "bind leftshoulder +mark",                     DOOM1AND2        },
    { "bind leftshoulder +maxzoom",                  DOOM1AND2        },
    { "bind leftshoulder +menu",                     DOOM1AND2        },
    { "bind leftshoulder +nextweapon",               DOOM1AND2        },
    { "bind leftshoulder +prevweapon",               DOOM1AND2        },
    { "bind leftshoulder +right",                    DOOM1AND2        },
    { "bind leftshoulder +rotatemode",               DOOM1AND2        },
    { "bind leftshoulder +run",                      DOOM1AND2        },
    { "bind leftshoulder +strafe",                   DOOM1AND2        },
    { "bind leftshoulder +strafeleft",               DOOM1AND2        },
    { "bind leftshoulder +straferight",              DOOM1AND2        },
    { "bind leftshoulder +use",                      DOOM1AND2        },
    { "bind leftshoulder +weapon1",                  DOOM1AND2        },
    { "bind leftshoulder +weapon2",                  DOOM1AND2        },
    { "bind leftshoulder +weapon3",                  DOOM1AND2        },
    { "bind leftshoulder +weapon4",                  DOOM1AND2        },
    { "bind leftshoulder +weapon5",                  DOOM1AND2        },
    { "bind leftshoulder +weapon6",                  DOOM1AND2        },
    { "bind leftshoulder +weapon7",                  DOOM1AND2        },
    { "bind leftshoulder +zoomin",                   DOOM1AND2        },
    { "bind leftshoulder +zoomout",                  DOOM1AND2        },
    { "bind leftthumb ",                             DOOM1AND2        },
    { "bind leftthumb +alwaysrun",                   DOOM1AND2        },
    { "bind leftthumb +automap",                     DOOM1AND2        },
    { "bind leftthumb +back",                        DOOM1AND2        },
    { "bind leftthumb +clearmark",                   DOOM1AND2        },
    { "bind leftthumb +console",                     DOOM1AND2        },
    { "bind leftthumb +fire",                        DOOM1AND2        },
    { "bind leftthumb +followmode",                  DOOM1AND2        },
    { "bind leftthumb +forward",                     DOOM1AND2        },
    { "bind leftthumb +freelook",                    DOOM1AND2        },
    { "bind leftthumb +grid",                        DOOM1AND2        },
    { "bind leftthumb +jump",                        DOOM1AND2        },
    { "bind leftthumb +left",                        DOOM1AND2        },
    { "bind leftthumb +mark",                        DOOM1AND2        },
    { "bind leftthumb +maxzoom",                     DOOM1AND2        },
    { "bind leftthumb +menu",                        DOOM1AND2        },
    { "bind leftthumb +nextweapon",                  DOOM1AND2        },
    { "bind leftthumb +prevweapon",                  DOOM1AND2        },
    { "bind leftthumb +right",                       DOOM1AND2        },
    { "bind leftthumb +rotatemode",                  DOOM1AND2        },
    { "bind leftthumb +run",                         DOOM1AND2        },
    { "bind leftthumb +strafe",                      DOOM1AND2        },
    { "bind leftthumb +strafeleft",                  DOOM1AND2        },
    { "bind leftthumb +straferight",                 DOOM1AND2        },
    { "bind leftthumb +use",                         DOOM1AND2        },
    { "bind leftthumb +weapon1",                     DOOM1AND2        },
    { "bind leftthumb +weapon2",                     DOOM1AND2        },
    { "bind leftthumb +weapon3",                     DOOM1AND2        },
    { "bind leftthumb +weapon4",                     DOOM1AND2        },
    { "bind leftthumb +weapon5",                     DOOM1AND2        },
    { "bind leftthumb +weapon6",                     DOOM1AND2        },
    { "bind leftthumb +weapon7",                     DOOM1AND2        },
    { "bind leftthumb +zoomin",                      DOOM1AND2        },
    { "bind leftthumb +zoomout",                     DOOM1AND2        },
    { "bind lefttrigger ",                           DOOM1AND2        },
    { "bind lefttrigger +alwaysrun",                 DOOM1AND2        },
    { "bind lefttrigger +automap",                   DOOM1AND2        },
    { "bind lefttrigger +back",                      DOOM1AND2        },
    { "bind lefttrigger +clearmark",                 DOOM1AND2        },
    { "bind lefttrigger +console",                   DOOM1AND2        },
    { "bind lefttrigger +fire",                      DOOM1AND2        },
    { "bind lefttrigger +followmode",                DOOM1AND2        },
    { "bind lefttrigger +forward",                   DOOM1AND2        },
    { "bind lefttrigger +freelook",                  DOOM1AND2        },
    { "bind lefttrigger +grid",                      DOOM1AND2        },
    { "bind lefttrigger +jump",                      DOOM1AND2        },
    { "bind lefttrigger +left",                      DOOM1AND2        },
    { "bind lefttrigger +mark",                      DOOM1AND2        },
    { "bind lefttrigger +maxzoom",                   DOOM1AND2        },
    { "bind lefttrigger +menu",                      DOOM1AND2        },
    { "bind lefttrigger +nextweapon",                DOOM1AND2        },
    { "bind lefttrigger +prevweapon",                DOOM1AND2        },
    { "bind lefttrigger +right",                     DOOM1AND2        },
    { "bind lefttrigger +rotatemode",                DOOM1AND2        },
    { "bind lefttrigger +run",                       DOOM1AND2        },
    { "bind lefttrigger +strafe",                    DOOM1AND2        },
    { "bind lefttrigger +strafeleft",                DOOM1AND2        },
    { "bind lefttrigger +straferight",               DOOM1AND2        },
    { "bind lefttrigger +use",                       DOOM1AND2        },
    { "bind lefttrigger +weapon1",                   DOOM1AND2        },
    { "bind lefttrigger +weapon2",                   DOOM1AND2        },
    { "bind lefttrigger +weapon3",                   DOOM1AND2        },
    { "bind lefttrigger +weapon4",                   DOOM1AND2        },
    { "bind lefttrigger +weapon5",                   DOOM1AND2        },
    { "bind lefttrigger +weapon6",                   DOOM1AND2        },
    { "bind lefttrigger +weapon7",                   DOOM1AND2        },
    { "bind lefttrigger +zoomin",                    DOOM1AND2        },
    { "bind lefttrigger +zoomout",                   DOOM1AND2        },
    { "bind m +alwaysrun",                           DOOM1AND2        },
    { "bind m +automap",                             DOOM1AND2        },
    { "bind m +back",                                DOOM1AND2        },
    { "bind m +clearmark",                           DOOM1AND2        },
    { "bind m +console",                             DOOM1AND2        },
    { "bind m +fire",                                DOOM1AND2        },
    { "bind m +followmode",                          DOOM1AND2        },
    { "bind m +forward",                             DOOM1AND2        },
    { "bind m +freelook",                            DOOM1AND2        },
    { "bind m +grid",                                DOOM1AND2        },
    { "bind m +jump",                                DOOM1AND2        },
    { "bind m +left",                                DOOM1AND2        },
    { "bind m +mark",                                DOOM1AND2        },
    { "bind m +maxzoom",                             DOOM1AND2        },
    { "bind m +menu",                                DOOM1AND2        },
    { "bind m +nextweapon",                          DOOM1AND2        },
    { "bind m +prevweapon",                          DOOM1AND2        },
    { "bind m +right",                               DOOM1AND2        },
    { "bind m +rotatemode",                          DOOM1AND2        },
    { "bind m +run",                                 DOOM1AND2        },
    { "bind m +screenshot",                          DOOM1AND2        },
    { "bind m +strafe",                              DOOM1AND2        },
    { "bind m +strafeleft",                          DOOM1AND2        },
    { "bind m +straferight",                         DOOM1AND2        },
    { "bind m +use",                                 DOOM1AND2        },
    { "bind m +weapon1",                             DOOM1AND2        },
    { "bind m +weapon2",                             DOOM1AND2        },
    { "bind m +weapon3",                             DOOM1AND2        },
    { "bind m +weapon4",                             DOOM1AND2        },
    { "bind m +weapon5",                             DOOM1AND2        },
    { "bind m +weapon6",                             DOOM1AND2        },
    { "bind m +weapon7",                             DOOM1AND2        },
    { "bind m +zoomin",                              DOOM1AND2        },
    { "bind m +zoomout",                             DOOM1AND2        },
    { "bind misc1 ",                                 DOOM1AND2        },
    { "bind misc1 +alwaysrun",                       DOOM1AND2        },
    { "bind misc1 +automap",                         DOOM1AND2        },
    { "bind misc1 +back",                            DOOM1AND2        },
    { "bind misc1 +clearmark",                       DOOM1AND2        },
    { "bind misc1 +console",                         DOOM1AND2        },
    { "bind misc1 +fire",                            DOOM1AND2        },
    { "bind misc1 +followmode",                      DOOM1AND2        },
    { "bind misc1 +forward",                         DOOM1AND2        },
    { "bind misc1 +freelook",                        DOOM1AND2        },
    { "bind misc1 +grid",                            DOOM1AND2        },
    { "bind misc1 +jump",                            DOOM1AND2        },
    { "bind misc1 +left",                            DOOM1AND2        },
    { "bind misc1 +mark",                            DOOM1AND2        },
    { "bind misc1 +maxzoom",                         DOOM1AND2        },
    { "bind misc1 +menu",                            DOOM1AND2        },
    { "bind misc1 +nextweapon",                      DOOM1AND2        },
    { "bind misc1 +prevweapon",                      DOOM1AND2        },
    { "bind misc1 +right",                           DOOM1AND2        },
    { "bind misc1 +rotatemode",                      DOOM1AND2        },
    { "bind misc1 +run",                             DOOM1AND2        },
    { "bind misc1 +strafe",                          DOOM1AND2        },
    { "bind misc1 +strafeleft",                      DOOM1AND2        },
    { "bind misc1 +straferight",                     DOOM1AND2        },
    { "bind misc1 +use",                             DOOM1AND2        },
    { "bind misc1 +weapon1",                         DOOM1AND2        },
    { "bind misc1 +weapon2",                         DOOM1AND2        },
    { "bind misc1 +weapon3",                         DOOM1AND2        },
    { "bind misc1 +weapon4",                         DOOM1AND2        },
    { "bind misc1 +weapon5",                         DOOM1AND2        },
    { "bind misc1 +weapon6",                         DOOM1AND2        },
    { "bind misc1 +weapon7",                         DOOM1AND2        },
    { "bind misc1 +zoomin",                          DOOM1AND2        },
    { "bind misc1 +zoomout",                         DOOM1AND2        },
    { "bind mouse1 ",                                DOOM1AND2        },
    { "bind mouse1 +back",                           DOOM1AND2        },
    { "bind mouse1 +fire",                           DOOM1AND2        },
    { "bind mouse1 +forward",                        DOOM1AND2        },
    { "bind mouse1 +freelook",                       DOOM1AND2        },
    { "bind mouse1 +jump",                           DOOM1AND2        },
    { "bind mouse1 +left",                           DOOM1AND2        },
    { "bind mouse1 +nextweapon",                     DOOM1AND2        },
    { "bind mouse1 +prevweapon",                     DOOM1AND2        },
    { "bind mouse1 +right",                          DOOM1AND2        },
    { "bind mouse1 +run",                            DOOM1AND2        },
    { "bind mouse1 +strafe",                         DOOM1AND2        },
    { "bind mouse1 +strafeleft",                     DOOM1AND2        },
    { "bind mouse1 +straferight",                    DOOM1AND2        },
    { "bind mouse1 +use",                            DOOM1AND2        },
    { "bind mouse1 +weapon1",                        DOOM1AND2        },
    { "bind mouse1 +weapon2",                        DOOM1AND2        },
    { "bind mouse1 +weapon3",                        DOOM1AND2        },
    { "bind mouse1 +weapon4",                        DOOM1AND2        },
    { "bind mouse1 +weapon5",                        DOOM1AND2        },
    { "bind mouse1 +weapon6",                        DOOM1AND2        },
    { "bind mouse1 +weapon7",                        DOOM1AND2        },
    { "bind mouse2 ",                                DOOM1AND2        },
    { "bind mouse2 +back",                           DOOM1AND2        },
    { "bind mouse2 +fire",                           DOOM1AND2        },
    { "bind mouse2 +forward",                        DOOM1AND2        },
    { "bind mouse2 +freelook",                       DOOM1AND2        },
    { "bind mouse2 +jump",                           DOOM1AND2        },
    { "bind mouse2 +left",                           DOOM1AND2        },
    { "bind mouse2 +nextweapon",                     DOOM1AND2        },
    { "bind mouse2 +prevweapon",                     DOOM1AND2        },
    { "bind mouse2 +right",                          DOOM1AND2        },
    { "bind mouse2 +run",                            DOOM1AND2        },
    { "bind mouse2 +screenshot",                     DOOM1AND2        },
    { "bind mouse2 +strafe",                         DOOM1AND2        },
    { "bind mouse2 +strafeleft",                     DOOM1AND2        },
    { "bind mouse2 +straferight",                    DOOM1AND2        },
    { "bind mouse2 +use",                            DOOM1AND2        },
    { "bind mouse2 +weapon1",                        DOOM1AND2        },
    { "bind mouse2 +weapon2",                        DOOM1AND2        },
    { "bind mouse2 +weapon3",                        DOOM1AND2        },
    { "bind mouse2 +weapon4",                        DOOM1AND2        },
    { "bind mouse2 +weapon5",                        DOOM1AND2        },
    { "bind mouse2 +weapon6",                        DOOM1AND2        },
    { "bind mouse2 +weapon7",                        DOOM1AND2        },
    { "bind mouse3 ",                                DOOM1AND2        },
    { "bind mouse3 +back",                           DOOM1AND2        },
    { "bind mouse3 +fire",                           DOOM1AND2        },
    { "bind mouse3 +forward",                        DOOM1AND2        },
    { "bind mouse3 +freelook",                       DOOM1AND2        },
    { "bind mouse3 +jump",                           DOOM1AND2        },
    { "bind mouse3 +left",                           DOOM1AND2        },
    { "bind mouse3 +nextweapon",                     DOOM1AND2        },
    { "bind mouse3 +prevweapon",                     DOOM1AND2        },
    { "bind mouse3 +right",                          DOOM1AND2        },
    { "bind mouse3 +run",                            DOOM1AND2        },
    { "bind mouse3 +screenshot",                     DOOM1AND2        },
    { "bind mouse3 +strafe",                         DOOM1AND2        },
    { "bind mouse3 +strafeleft",                     DOOM1AND2        },
    { "bind mouse3 +straferight",                    DOOM1AND2        },
    { "bind mouse3 +use",                            DOOM1AND2        },
    { "bind mouse3 +weapon1",                        DOOM1AND2        },
    { "bind mouse3 +weapon2",                        DOOM1AND2        },
    { "bind mouse3 +weapon3",                        DOOM1AND2        },
    { "bind mouse3 +weapon4",                        DOOM1AND2        },
    { "bind mouse3 +weapon5",                        DOOM1AND2        },
    { "bind mouse3 +weapon6",                        DOOM1AND2        },
    { "bind mouse3 +weapon7",                        DOOM1AND2        },
    { "bind mouse4 ",                                DOOM1AND2        },
    { "bind mouse4 +back",                           DOOM1AND2        },
    { "bind mouse4 +fire",                           DOOM1AND2        },
    { "bind mouse4 +forward",                        DOOM1AND2        },
    { "bind mouse4 +freelook",                       DOOM1AND2        },
    { "bind mouse4 +jump",                           DOOM1AND2        },
    { "bind mouse4 +left",                           DOOM1AND2        },
    { "bind mouse4 +nextweapon",                     DOOM1AND2        },
    { "bind mouse4 +prevweapon",                     DOOM1AND2        },
    { "bind mouse4 +right",                          DOOM1AND2        },
    { "bind mouse4 +run",                            DOOM1AND2        },
    { "bind mouse4 +screenshot",                     DOOM1AND2        },
    { "bind mouse4 +strafe",                         DOOM1AND2        },
    { "bind mouse4 +strafeleft",                     DOOM1AND2        },
    { "bind mouse4 +straferight",                    DOOM1AND2        },
    { "bind mouse4 +use",                            DOOM1AND2        },
    { "bind mouse4 +weapon1",                        DOOM1AND2        },
    { "bind mouse4 +weapon2",                        DOOM1AND2        },
    { "bind mouse4 +weapon3",                        DOOM1AND2        },
    { "bind mouse4 +weapon4",                        DOOM1AND2        },
    { "bind mouse4 +weapon5",                        DOOM1AND2        },
    { "bind mouse4 +weapon6",                        DOOM1AND2        },
    { "bind mouse4 +weapon7",                        DOOM1AND2        },
    { "bind mouse5 ",                                DOOM1AND2        },
    { "bind mouse5 +back",                           DOOM1AND2        },
    { "bind mouse5 +fire",                           DOOM1AND2        },
    { "bind mouse5 +forward",                        DOOM1AND2        },
    { "bind mouse5 +freelook",                       DOOM1AND2        },
    { "bind mouse5 +jump",                           DOOM1AND2        },
    { "bind mouse5 +left",                           DOOM1AND2        },
    { "bind mouse5 +nextweapon",                     DOOM1AND2        },
    { "bind mouse5 +prevweapon",                     DOOM1AND2        },
    { "bind mouse5 +right",                          DOOM1AND2        },
    { "bind mouse5 +run",                            DOOM1AND2        },
    { "bind mouse5 +screenshot",                     DOOM1AND2        },
    { "bind mouse5 +strafe",                         DOOM1AND2        },
    { "bind mouse5 +strafeleft",                     DOOM1AND2        },
    { "bind mouse5 +straferight",                    DOOM1AND2        },
    { "bind mouse5 +use",                            DOOM1AND2        },
    { "bind mouse5 +weapon1",                        DOOM1AND2        },
    { "bind mouse5 +weapon2",                        DOOM1AND2        },
    { "bind mouse5 +weapon3",                        DOOM1AND2        },
    { "bind mouse5 +weapon4",                        DOOM1AND2        },
    { "bind mouse5 +weapon5",                        DOOM1AND2        },
    { "bind mouse5 +weapon6",                        DOOM1AND2        },
    { "bind mouse5 +weapon7",                        DOOM1AND2        },
    { "bind mouse6 ",                                DOOM1AND2        },
    { "bind mouse6 +back",                           DOOM1AND2        },
    { "bind mouse6 +fire",                           DOOM1AND2        },
    { "bind mouse6 +forward",                        DOOM1AND2        },
    { "bind mouse6 +freelook",                       DOOM1AND2        },
    { "bind mouse6 +jump",                           DOOM1AND2        },
    { "bind mouse6 +left",                           DOOM1AND2        },
    { "bind mouse6 +nextweapon",                     DOOM1AND2        },
    { "bind mouse6 +prevweapon",                     DOOM1AND2        },
    { "bind mouse6 +right",                          DOOM1AND2        },
    { "bind mouse6 +run",                            DOOM1AND2        },
    { "bind mouse6 +screenshot",                     DOOM1AND2        },
    { "bind mouse6 +strafe",                         DOOM1AND2        },
    { "bind mouse6 +strafeleft",                     DOOM1AND2        },
    { "bind mouse6 +straferight",                    DOOM1AND2        },
    { "bind mouse6 +use",                            DOOM1AND2        },
    { "bind mouse6 +weapon1",                        DOOM1AND2        },
    { "bind mouse6 +weapon2",                        DOOM1AND2        },
    { "bind mouse6 +weapon3",                        DOOM1AND2        },
    { "bind mouse6 +weapon4",                        DOOM1AND2        },
    { "bind mouse6 +weapon5",                        DOOM1AND2        },
    { "bind mouse6 +weapon6",                        DOOM1AND2        },
    { "bind mouse6 +weapon7",                        DOOM1AND2        },
    { "bind mouse7 ",                                DOOM1AND2        },
    { "bind mouse7 +back",                           DOOM1AND2        },
    { "bind mouse7 +fire",                           DOOM1AND2        },
    { "bind mouse7 +forward",                        DOOM1AND2        },
    { "bind mouse7 +freelook",                       DOOM1AND2        },
    { "bind mouse7 +jump",                           DOOM1AND2        },
    { "bind mouse7 +left",                           DOOM1AND2        },
    { "bind mouse7 +nextweapon",                     DOOM1AND2        },
    { "bind mouse7 +prevweapon",                     DOOM1AND2        },
    { "bind mouse7 +right",                          DOOM1AND2        },
    { "bind mouse7 +run",                            DOOM1AND2        },
    { "bind mouse7 +screenshot",                     DOOM1AND2        },
    { "bind mouse7 +strafe",                         DOOM1AND2        },
    { "bind mouse7 +strafeleft",                     DOOM1AND2        },
    { "bind mouse7 +straferight",                    DOOM1AND2        },
    { "bind mouse7 +use",                            DOOM1AND2        },
    { "bind mouse7 +weapon1",                        DOOM1AND2        },
    { "bind mouse7 +weapon2",                        DOOM1AND2        },
    { "bind mouse7 +weapon3",                        DOOM1AND2        },
    { "bind mouse7 +weapon4",                        DOOM1AND2        },
    { "bind mouse7 +weapon5",                        DOOM1AND2        },
    { "bind mouse7 +weapon6",                        DOOM1AND2        },
    { "bind mouse7 +weapon7",                        DOOM1AND2        },
    { "bind mouse8 ",                                DOOM1AND2        },
    { "bind mouse8 +back",                           DOOM1AND2        },
    { "bind mouse8 +fire",                           DOOM1AND2        },
    { "bind mouse8 +forward",                        DOOM1AND2        },
    { "bind mouse8 +freelook",                       DOOM1AND2        },
    { "bind mouse8 +jump",                           DOOM1AND2        },
    { "bind mouse8 +left",                           DOOM1AND2        },
    { "bind mouse8 +nextweapon",                     DOOM1AND2        },
    { "bind mouse8 +prevweapon",                     DOOM1AND2        },
    { "bind mouse8 +right",                          DOOM1AND2        },
    { "bind mouse8 +run",                            DOOM1AND2        },
    { "bind mouse8 +screenshot",                     DOOM1AND2        },
    { "bind mouse8 +strafe",                         DOOM1AND2        },
    { "bind mouse8 +strafeleft",                     DOOM1AND2        },
    { "bind mouse8 +straferight",                    DOOM1AND2        },
    { "bind mouse8 +use",                            DOOM1AND2        },
    { "bind mouse8 +weapon1",                        DOOM1AND2        },
    { "bind mouse8 +weapon2",                        DOOM1AND2        },
    { "bind mouse8 +weapon3",                        DOOM1AND2        },
    { "bind mouse8 +weapon4",                        DOOM1AND2        },
    { "bind mouse8 +weapon5",                        DOOM1AND2        },
    { "bind mouse8 +weapon6",                        DOOM1AND2        },
    { "bind mouse8 +weapon7",                        DOOM1AND2        },
    { "bind n +alwaysrun",                           DOOM1AND2        },
    { "bind n +automap",                             DOOM1AND2        },
    { "bind n +back",                                DOOM1AND2        },
    { "bind n +clearmark",                           DOOM1AND2        },
    { "bind n +console",                             DOOM1AND2        },
    { "bind n +fire",                                DOOM1AND2        },
    { "bind n +followmode",                          DOOM1AND2        },
    { "bind n +forward",                             DOOM1AND2        },
    { "bind n +freelook",                            DOOM1AND2        },
    { "bind n +grid",                                DOOM1AND2        },
    { "bind n +jump",                                DOOM1AND2        },
    { "bind n +left",                                DOOM1AND2        },
    { "bind n +mark",                                DOOM1AND2        },
    { "bind n +maxzoom",                             DOOM1AND2        },
    { "bind n +menu",                                DOOM1AND2        },
    { "bind n +nextweapon",                          DOOM1AND2        },
    { "bind n +prevweapon",                          DOOM1AND2        },
    { "bind n +right",                               DOOM1AND2        },
    { "bind n +rotatemode",                          DOOM1AND2        },
    { "bind n +run",                                 DOOM1AND2        },
    { "bind n +screenshot",                          DOOM1AND2        },
    { "bind n +strafe",                              DOOM1AND2        },
    { "bind n +strafeleft",                          DOOM1AND2        },
    { "bind n +straferight",                         DOOM1AND2        },
    { "bind n +use",                                 DOOM1AND2        },
    { "bind n +weapon1",                             DOOM1AND2        },
    { "bind n +weapon2",                             DOOM1AND2        },
    { "bind n +weapon3",                             DOOM1AND2        },
    { "bind n +weapon4",                             DOOM1AND2        },
    { "bind n +weapon5",                             DOOM1AND2        },
    { "bind n +weapon6",                             DOOM1AND2        },
    { "bind n +weapon7",                             DOOM1AND2        },
    { "bind n +zoomin",                              DOOM1AND2        },
    { "bind n +zoomout",                             DOOM1AND2        },
    { "bind numlock ",                               DOOM1AND2        },
    { "bind numlock +alwaysrun",                     DOOM1AND2        },
    { "bind numlock +automap",                       DOOM1AND2        },
    { "bind numlock +back",                          DOOM1AND2        },
    { "bind numlock +clearmark",                     DOOM1AND2        },
    { "bind numlock +console",                       DOOM1AND2        },
    { "bind numlock +fire",                          DOOM1AND2        },
    { "bind numlock +followmode",                    DOOM1AND2        },
    { "bind numlock +forward",                       DOOM1AND2        },
    { "bind numlock +freelook",                      DOOM1AND2        },
    { "bind numlock +grid",                          DOOM1AND2        },
    { "bind numlock +jump",                          DOOM1AND2        },
    { "bind numlock +left",                          DOOM1AND2        },
    { "bind numlock +mark",                          DOOM1AND2        },
    { "bind numlock +maxzoom",                       DOOM1AND2        },
    { "bind numlock +menu",                          DOOM1AND2        },
    { "bind numlock +nextweapon",                    DOOM1AND2        },
    { "bind numlock +prevweapon",                    DOOM1AND2        },
    { "bind numlock +right",                         DOOM1AND2        },
    { "bind numlock +rotatemode",                    DOOM1AND2        },
    { "bind numlock +run",                           DOOM1AND2        },
    { "bind numlock +screenshot",                    DOOM1AND2        },
    { "bind numlock +strafe",                        DOOM1AND2        },
    { "bind numlock +strafeleft",                    DOOM1AND2        },
    { "bind numlock +straferight",                   DOOM1AND2        },
    { "bind numlock +use",                           DOOM1AND2        },
    { "bind numlock +weapon1",                       DOOM1AND2        },
    { "bind numlock +weapon2",                       DOOM1AND2        },
    { "bind numlock +weapon3",                       DOOM1AND2        },
    { "bind numlock +weapon4",                       DOOM1AND2        },
    { "bind numlock +weapon5",                       DOOM1AND2        },
    { "bind numlock +weapon6",                       DOOM1AND2        },
    { "bind numlock +weapon7",                       DOOM1AND2        },
    { "bind numlock +zoomin",                        DOOM1AND2        },
    { "bind numlock +zoomout",                       DOOM1AND2        },
    { "bind numpad0 ",                               DOOM1AND2        },
    { "bind numpad0 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad0 +automap",                       DOOM1AND2        },
    { "bind numpad0 +back",                          DOOM1AND2        },
    { "bind numpad0 +clearmark",                     DOOM1AND2        },
    { "bind numpad0 +console",                       DOOM1AND2        },
    { "bind numpad0 +fire",                          DOOM1AND2        },
    { "bind numpad0 +followmode",                    DOOM1AND2        },
    { "bind numpad0 +forward",                       DOOM1AND2        },
    { "bind numpad0 +freelook",                      DOOM1AND2        },
    { "bind numpad0 +grid",                          DOOM1AND2        },
    { "bind numpad0 +jump",                          DOOM1AND2        },
    { "bind numpad0 +left",                          DOOM1AND2        },
    { "bind numpad0 +mark",                          DOOM1AND2        },
    { "bind numpad0 +maxzoom",                       DOOM1AND2        },
    { "bind numpad0 +menu",                          DOOM1AND2        },
    { "bind numpad0 +nextweapon",                    DOOM1AND2        },
    { "bind numpad0 +prevweapon",                    DOOM1AND2        },
    { "bind numpad0 +right",                         DOOM1AND2        },
    { "bind numpad0 +rotatemode",                    DOOM1AND2        },
    { "bind numpad0 +run",                           DOOM1AND2        },
    { "bind numpad0 +screenshot",                    DOOM1AND2        },
    { "bind numpad0 +strafe",                        DOOM1AND2        },
    { "bind numpad0 +strafeleft",                    DOOM1AND2        },
    { "bind numpad0 +straferight",                   DOOM1AND2        },
    { "bind numpad0 +use",                           DOOM1AND2        },
    { "bind numpad0 +weapon1",                       DOOM1AND2        },
    { "bind numpad0 +weapon2",                       DOOM1AND2        },
    { "bind numpad0 +weapon3",                       DOOM1AND2        },
    { "bind numpad0 +weapon4",                       DOOM1AND2        },
    { "bind numpad0 +weapon5",                       DOOM1AND2        },
    { "bind numpad0 +weapon6",                       DOOM1AND2        },
    { "bind numpad0 +weapon7",                       DOOM1AND2        },
    { "bind numpad0 +zoomin",                        DOOM1AND2        },
    { "bind numpad0 +zoomout",                       DOOM1AND2        },
    { "bind numpad1 ",                               DOOM1AND2        },
    { "bind numpad1 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad1 +automap",                       DOOM1AND2        },
    { "bind numpad1 +back",                          DOOM1AND2        },
    { "bind numpad1 +clearmark",                     DOOM1AND2        },
    { "bind numpad1 +console",                       DOOM1AND2        },
    { "bind numpad1 +fire",                          DOOM1AND2        },
    { "bind numpad1 +followmode",                    DOOM1AND2        },
    { "bind numpad1 +forward",                       DOOM1AND2        },
    { "bind numpad1 +freelook",                      DOOM1AND2        },
    { "bind numpad1 +grid",                          DOOM1AND2        },
    { "bind numpad1 +jump",                          DOOM1AND2        },
    { "bind numpad1 +left",                          DOOM1AND2        },
    { "bind numpad1 +mark",                          DOOM1AND2        },
    { "bind numpad1 +maxzoom",                       DOOM1AND2        },
    { "bind numpad1 +menu",                          DOOM1AND2        },
    { "bind numpad1 +nextweapon",                    DOOM1AND2        },
    { "bind numpad1 +prevweapon",                    DOOM1AND2        },
    { "bind numpad1 +right",                         DOOM1AND2        },
    { "bind numpad1 +rotatemode",                    DOOM1AND2        },
    { "bind numpad1 +run",                           DOOM1AND2        },
    { "bind numpad1 +screenshot",                    DOOM1AND2        },
    { "bind numpad1 +strafe",                        DOOM1AND2        },
    { "bind numpad1 +strafeleft",                    DOOM1AND2        },
    { "bind numpad1 +straferight",                   DOOM1AND2        },
    { "bind numpad1 +use",                           DOOM1AND2        },
    { "bind numpad1 +weapon1",                       DOOM1AND2        },
    { "bind numpad1 +weapon2",                       DOOM1AND2        },
    { "bind numpad1 +weapon3",                       DOOM1AND2        },
    { "bind numpad1 +weapon4",                       DOOM1AND2        },
    { "bind numpad1 +weapon5",                       DOOM1AND2        },
    { "bind numpad1 +weapon6",                       DOOM1AND2        },
    { "bind numpad1 +weapon7",                       DOOM1AND2        },
    { "bind numpad1 +zoomin",                        DOOM1AND2        },
    { "bind numpad1 +zoomout",                       DOOM1AND2        },
    { "bind numpad2 ",                               DOOM1AND2        },
    { "bind numpad2 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad2 +automap",                       DOOM1AND2        },
    { "bind numpad2 +back",                          DOOM1AND2        },
    { "bind numpad2 +clearmark",                     DOOM1AND2        },
    { "bind numpad2 +console",                       DOOM1AND2        },
    { "bind numpad2 +fire",                          DOOM1AND2        },
    { "bind numpad2 +followmode",                    DOOM1AND2        },
    { "bind numpad2 +forward",                       DOOM1AND2        },
    { "bind numpad2 +freelook",                      DOOM1AND2        },
    { "bind numpad2 +grid",                          DOOM1AND2        },
    { "bind numpad2 +jump",                          DOOM1AND2        },
    { "bind numpad2 +left",                          DOOM1AND2        },
    { "bind numpad2 +mark",                          DOOM1AND2        },
    { "bind numpad2 +maxzoom",                       DOOM1AND2        },
    { "bind numpad2 +menu",                          DOOM1AND2        },
    { "bind numpad2 +nextweapon",                    DOOM1AND2        },
    { "bind numpad2 +prevweapon",                    DOOM1AND2        },
    { "bind numpad2 +right",                         DOOM1AND2        },
    { "bind numpad2 +rotatemode",                    DOOM1AND2        },
    { "bind numpad2 +run",                           DOOM1AND2        },
    { "bind numpad2 +screenshot",                    DOOM1AND2        },
    { "bind numpad2 +strafe",                        DOOM1AND2        },
    { "bind numpad2 +strafeleft",                    DOOM1AND2        },
    { "bind numpad2 +straferight",                   DOOM1AND2        },
    { "bind numpad2 +use",                           DOOM1AND2        },
    { "bind numpad2 +weapon1",                       DOOM1AND2        },
    { "bind numpad2 +weapon2",                       DOOM1AND2        },
    { "bind numpad2 +weapon3",                       DOOM1AND2        },
    { "bind numpad2 +weapon4",                       DOOM1AND2        },
    { "bind numpad2 +weapon5",                       DOOM1AND2        },
    { "bind numpad2 +weapon6",                       DOOM1AND2        },
    { "bind numpad2 +weapon7",                       DOOM1AND2        },
    { "bind numpad2 +zoomin",                        DOOM1AND2        },
    { "bind numpad2 +zoomout",                       DOOM1AND2        },
    { "bind numpad3 ",                               DOOM1AND2        },
    { "bind numpad3 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad3 +automap",                       DOOM1AND2        },
    { "bind numpad3 +back",                          DOOM1AND2        },
    { "bind numpad3 +clearmark",                     DOOM1AND2        },
    { "bind numpad3 +console",                       DOOM1AND2        },
    { "bind numpad3 +fire",                          DOOM1AND2        },
    { "bind numpad3 +followmode",                    DOOM1AND2        },
    { "bind numpad3 +forward",                       DOOM1AND2        },
    { "bind numpad3 +freelook",                      DOOM1AND2        },
    { "bind numpad3 +grid",                          DOOM1AND2        },
    { "bind numpad3 +jump",                          DOOM1AND2        },
    { "bind numpad3 +left",                          DOOM1AND2        },
    { "bind numpad3 +mark",                          DOOM1AND2        },
    { "bind numpad3 +maxzoom",                       DOOM1AND2        },
    { "bind numpad3 +menu",                          DOOM1AND2        },
    { "bind numpad3 +nextweapon",                    DOOM1AND2        },
    { "bind numpad3 +prevweapon",                    DOOM1AND2        },
    { "bind numpad3 +right",                         DOOM1AND2        },
    { "bind numpad3 +rotatemode",                    DOOM1AND2        },
    { "bind numpad3 +run",                           DOOM1AND2        },
    { "bind numpad3 +screenshot",                    DOOM1AND2        },
    { "bind numpad3 +strafe",                        DOOM1AND2        },
    { "bind numpad3 +strafeleft",                    DOOM1AND2        },
    { "bind numpad3 +straferight",                   DOOM1AND2        },
    { "bind numpad3 +use",                           DOOM1AND2        },
    { "bind numpad3 +weapon1",                       DOOM1AND2        },
    { "bind numpad3 +weapon2",                       DOOM1AND2        },
    { "bind numpad3 +weapon3",                       DOOM1AND2        },
    { "bind numpad3 +weapon4",                       DOOM1AND2        },
    { "bind numpad3 +weapon5",                       DOOM1AND2        },
    { "bind numpad3 +weapon6",                       DOOM1AND2        },
    { "bind numpad3 +weapon7",                       DOOM1AND2        },
    { "bind numpad3 +zoomin",                        DOOM1AND2        },
    { "bind numpad3 +zoomout",                       DOOM1AND2        },
    { "bind numpad4 ",                               DOOM1AND2        },
    { "bind numpad4 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad4 +automap",                       DOOM1AND2        },
    { "bind numpad4 +back",                          DOOM1AND2        },
    { "bind numpad4 +clearmark",                     DOOM1AND2        },
    { "bind numpad4 +console",                       DOOM1AND2        },
    { "bind numpad4 +fire",                          DOOM1AND2        },
    { "bind numpad4 +followmode",                    DOOM1AND2        },
    { "bind numpad4 +forward",                       DOOM1AND2        },
    { "bind numpad4 +freelook",                      DOOM1AND2        },
    { "bind numpad4 +grid",                          DOOM1AND2        },
    { "bind numpad4 +jump",                          DOOM1AND2        },
    { "bind numpad4 +left",                          DOOM1AND2        },
    { "bind numpad4 +mark",                          DOOM1AND2        },
    { "bind numpad4 +maxzoom",                       DOOM1AND2        },
    { "bind numpad4 +menu",                          DOOM1AND2        },
    { "bind numpad4 +nextweapon",                    DOOM1AND2        },
    { "bind numpad4 +prevweapon",                    DOOM1AND2        },
    { "bind numpad4 +right",                         DOOM1AND2        },
    { "bind numpad4 +rotatemode",                    DOOM1AND2        },
    { "bind numpad4 +run",                           DOOM1AND2        },
    { "bind numpad4 +screenshot",                    DOOM1AND2        },
    { "bind numpad4 +strafe",                        DOOM1AND2        },
    { "bind numpad4 +strafeleft",                    DOOM1AND2        },
    { "bind numpad4 +straferight",                   DOOM1AND2        },
    { "bind numpad4 +use",                           DOOM1AND2        },
    { "bind numpad4 +weapon1",                       DOOM1AND2        },
    { "bind numpad4 +weapon2",                       DOOM1AND2        },
    { "bind numpad4 +weapon3",                       DOOM1AND2        },
    { "bind numpad4 +weapon4",                       DOOM1AND2        },
    { "bind numpad4 +weapon5",                       DOOM1AND2        },
    { "bind numpad4 +weapon6",                       DOOM1AND2        },
    { "bind numpad4 +weapon7",                       DOOM1AND2        },
    { "bind numpad4 +zoomin",                        DOOM1AND2        },
    { "bind numpad4 +zoomout",                       DOOM1AND2        },
    { "bind numpad5 ",                               DOOM1AND2        },
    { "bind numpad5 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad5 +automap",                       DOOM1AND2        },
    { "bind numpad5 +back",                          DOOM1AND2        },
    { "bind numpad5 +clearmark",                     DOOM1AND2        },
    { "bind numpad5 +console",                       DOOM1AND2        },
    { "bind numpad5 +fire",                          DOOM1AND2        },
    { "bind numpad5 +followmode",                    DOOM1AND2        },
    { "bind numpad5 +forward",                       DOOM1AND2        },
    { "bind numpad5 +freelook",                      DOOM1AND2        },
    { "bind numpad5 +grid",                          DOOM1AND2        },
    { "bind numpad5 +jump",                          DOOM1AND2        },
    { "bind numpad5 +left",                          DOOM1AND2        },
    { "bind numpad5 +mark",                          DOOM1AND2        },
    { "bind numpad5 +maxzoom",                       DOOM1AND2        },
    { "bind numpad5 +menu",                          DOOM1AND2        },
    { "bind numpad5 +nextweapon",                    DOOM1AND2        },
    { "bind numpad5 +prevweapon",                    DOOM1AND2        },
    { "bind numpad5 +right",                         DOOM1AND2        },
    { "bind numpad5 +rotatemode",                    DOOM1AND2        },
    { "bind numpad5 +run",                           DOOM1AND2        },
    { "bind numpad5 +screenshot",                    DOOM1AND2        },
    { "bind numpad5 +strafe",                        DOOM1AND2        },
    { "bind numpad5 +strafeleft",                    DOOM1AND2        },
    { "bind numpad5 +straferight",                   DOOM1AND2        },
    { "bind numpad5 +use",                           DOOM1AND2        },
    { "bind numpad5 +weapon1",                       DOOM1AND2        },
    { "bind numpad5 +weapon2",                       DOOM1AND2        },
    { "bind numpad5 +weapon3",                       DOOM1AND2        },
    { "bind numpad5 +weapon4",                       DOOM1AND2        },
    { "bind numpad5 +weapon5",                       DOOM1AND2        },
    { "bind numpad5 +weapon6",                       DOOM1AND2        },
    { "bind numpad5 +weapon7",                       DOOM1AND2        },
    { "bind numpad5 +zoomin",                        DOOM1AND2        },
    { "bind numpad5 +zoomout",                       DOOM1AND2        },
    { "bind numpad6 ",                               DOOM1AND2        },
    { "bind numpad6 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad6 +automap",                       DOOM1AND2        },
    { "bind numpad6 +back",                          DOOM1AND2        },
    { "bind numpad6 +clearmark",                     DOOM1AND2        },
    { "bind numpad6 +console",                       DOOM1AND2        },
    { "bind numpad6 +fire",                          DOOM1AND2        },
    { "bind numpad6 +followmode",                    DOOM1AND2        },
    { "bind numpad6 +forward",                       DOOM1AND2        },
    { "bind numpad6 +freelook",                      DOOM1AND2        },
    { "bind numpad6 +grid",                          DOOM1AND2        },
    { "bind numpad6 +jump",                          DOOM1AND2        },
    { "bind numpad6 +left",                          DOOM1AND2        },
    { "bind numpad6 +mark",                          DOOM1AND2        },
    { "bind numpad6 +maxzoom",                       DOOM1AND2        },
    { "bind numpad6 +menu",                          DOOM1AND2        },
    { "bind numpad6 +nextweapon",                    DOOM1AND2        },
    { "bind numpad6 +prevweapon",                    DOOM1AND2        },
    { "bind numpad6 +right",                         DOOM1AND2        },
    { "bind numpad6 +rotatemode",                    DOOM1AND2        },
    { "bind numpad6 +run",                           DOOM1AND2        },
    { "bind numpad6 +screenshot",                    DOOM1AND2        },
    { "bind numpad6 +strafe",                        DOOM1AND2        },
    { "bind numpad6 +strafeleft",                    DOOM1AND2        },
    { "bind numpad6 +straferight",                   DOOM1AND2        },
    { "bind numpad6 +use",                           DOOM1AND2        },
    { "bind numpad6 +weapon1",                       DOOM1AND2        },
    { "bind numpad6 +weapon2",                       DOOM1AND2        },
    { "bind numpad6 +weapon3",                       DOOM1AND2        },
    { "bind numpad6 +weapon4",                       DOOM1AND2        },
    { "bind numpad6 +weapon5",                       DOOM1AND2        },
    { "bind numpad6 +weapon6",                       DOOM1AND2        },
    { "bind numpad6 +weapon7",                       DOOM1AND2        },
    { "bind numpad6 +zoomin",                        DOOM1AND2        },
    { "bind numpad6 +zoomout",                       DOOM1AND2        },
    { "bind numpad7 ",                               DOOM1AND2        },
    { "bind numpad7 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad7 +automap",                       DOOM1AND2        },
    { "bind numpad7 +back",                          DOOM1AND2        },
    { "bind numpad7 +clearmark",                     DOOM1AND2        },
    { "bind numpad7 +console",                       DOOM1AND2        },
    { "bind numpad7 +fire",                          DOOM1AND2        },
    { "bind numpad7 +followmode",                    DOOM1AND2        },
    { "bind numpad7 +forward",                       DOOM1AND2        },
    { "bind numpad7 +freelook",                      DOOM1AND2        },
    { "bind numpad7 +grid",                          DOOM1AND2        },
    { "bind numpad7 +jump",                          DOOM1AND2        },
    { "bind numpad7 +left",                          DOOM1AND2        },
    { "bind numpad7 +mark",                          DOOM1AND2        },
    { "bind numpad7 +maxzoom",                       DOOM1AND2        },
    { "bind numpad7 +menu",                          DOOM1AND2        },
    { "bind numpad7 +nextweapon",                    DOOM1AND2        },
    { "bind numpad7 +prevweapon",                    DOOM1AND2        },
    { "bind numpad7 +right",                         DOOM1AND2        },
    { "bind numpad7 +rotatemode",                    DOOM1AND2        },
    { "bind numpad7 +run",                           DOOM1AND2        },
    { "bind numpad7 +screenshot",                    DOOM1AND2        },
    { "bind numpad7 +strafe",                        DOOM1AND2        },
    { "bind numpad7 +strafeleft",                    DOOM1AND2        },
    { "bind numpad7 +straferight",                   DOOM1AND2        },
    { "bind numpad7 +use",                           DOOM1AND2        },
    { "bind numpad7 +weapon1",                       DOOM1AND2        },
    { "bind numpad7 +weapon2",                       DOOM1AND2        },
    { "bind numpad7 +weapon3",                       DOOM1AND2        },
    { "bind numpad7 +weapon4",                       DOOM1AND2        },
    { "bind numpad7 +weapon5",                       DOOM1AND2        },
    { "bind numpad7 +weapon6",                       DOOM1AND2        },
    { "bind numpad7 +weapon7",                       DOOM1AND2        },
    { "bind numpad7 +zoomin",                        DOOM1AND2        },
    { "bind numpad7 +zoomout",                       DOOM1AND2        },
    { "bind numpad8 ",                               DOOM1AND2        },
    { "bind numpad8 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad8 +automap",                       DOOM1AND2        },
    { "bind numpad8 +back",                          DOOM1AND2        },
    { "bind numpad8 +clearmark",                     DOOM1AND2        },
    { "bind numpad8 +console",                       DOOM1AND2        },
    { "bind numpad8 +fire",                          DOOM1AND2        },
    { "bind numpad8 +followmode",                    DOOM1AND2        },
    { "bind numpad8 +forward",                       DOOM1AND2        },
    { "bind numpad8 +freelook",                      DOOM1AND2        },
    { "bind numpad8 +grid",                          DOOM1AND2        },
    { "bind numpad8 +jump",                          DOOM1AND2        },
    { "bind numpad8 +left",                          DOOM1AND2        },
    { "bind numpad8 +mark",                          DOOM1AND2        },
    { "bind numpad8 +maxzoom",                       DOOM1AND2        },
    { "bind numpad8 +menu",                          DOOM1AND2        },
    { "bind numpad8 +nextweapon",                    DOOM1AND2        },
    { "bind numpad8 +prevweapon",                    DOOM1AND2        },
    { "bind numpad8 +right",                         DOOM1AND2        },
    { "bind numpad8 +rotatemode",                    DOOM1AND2        },
    { "bind numpad8 +run",                           DOOM1AND2        },
    { "bind numpad8 +screenshot",                    DOOM1AND2        },
    { "bind numpad8 +strafe",                        DOOM1AND2        },
    { "bind numpad8 +strafeleft",                    DOOM1AND2        },
    { "bind numpad8 +straferight",                   DOOM1AND2        },
    { "bind numpad8 +use",                           DOOM1AND2        },
    { "bind numpad8 +weapon1",                       DOOM1AND2        },
    { "bind numpad8 +weapon2",                       DOOM1AND2        },
    { "bind numpad8 +weapon3",                       DOOM1AND2        },
    { "bind numpad8 +weapon4",                       DOOM1AND2        },
    { "bind numpad8 +weapon5",                       DOOM1AND2        },
    { "bind numpad8 +weapon6",                       DOOM1AND2        },
    { "bind numpad8 +weapon7",                       DOOM1AND2        },
    { "bind numpad8 +zoomin",                        DOOM1AND2        },
    { "bind numpad8 +zoomout",                       DOOM1AND2        },
    { "bind numpad9 ",                               DOOM1AND2        },
    { "bind numpad9 +alwaysrun",                     DOOM1AND2        },
    { "bind numpad9 +automap",                       DOOM1AND2        },
    { "bind numpad9 +back",                          DOOM1AND2        },
    { "bind numpad9 +clearmark",                     DOOM1AND2        },
    { "bind numpad9 +console",                       DOOM1AND2        },
    { "bind numpad9 +fire",                          DOOM1AND2        },
    { "bind numpad9 +followmode",                    DOOM1AND2        },
    { "bind numpad9 +forward",                       DOOM1AND2        },
    { "bind numpad9 +freelook",                      DOOM1AND2        },
    { "bind numpad9 +grid",                          DOOM1AND2        },
    { "bind numpad9 +jump",                          DOOM1AND2        },
    { "bind numpad9 +left",                          DOOM1AND2        },
    { "bind numpad9 +mark",                          DOOM1AND2        },
    { "bind numpad9 +maxzoom",                       DOOM1AND2        },
    { "bind numpad9 +menu",                          DOOM1AND2        },
    { "bind numpad9 +nextweapon",                    DOOM1AND2        },
    { "bind numpad9 +prevweapon",                    DOOM1AND2        },
    { "bind numpad9 +right",                         DOOM1AND2        },
    { "bind numpad9 +rotatemode",                    DOOM1AND2        },
    { "bind numpad9 +run",                           DOOM1AND2        },
    { "bind numpad9 +screenshot",                    DOOM1AND2        },
    { "bind numpad9 +strafe",                        DOOM1AND2        },
    { "bind numpad9 +strafeleft",                    DOOM1AND2        },
    { "bind numpad9 +straferight",                   DOOM1AND2        },
    { "bind numpad9 +use",                           DOOM1AND2        },
    { "bind numpad9 +weapon1",                       DOOM1AND2        },
    { "bind numpad9 +weapon2",                       DOOM1AND2        },
    { "bind numpad9 +weapon3",                       DOOM1AND2        },
    { "bind numpad9 +weapon4",                       DOOM1AND2        },
    { "bind numpad9 +weapon5",                       DOOM1AND2        },
    { "bind numpad9 +weapon6",                       DOOM1AND2        },
    { "bind numpad9 +weapon7",                       DOOM1AND2        },
    { "bind numpad9 +zoomin",                        DOOM1AND2        },
    { "bind numpad9 +zoomout",                       DOOM1AND2        },
    { "bind o +alwaysrun",                           DOOM1AND2        },
    { "bind o +automap",                             DOOM1AND2        },
    { "bind o +back",                                DOOM1AND2        },
    { "bind o +clearmark",                           DOOM1AND2        },
    { "bind o +console",                             DOOM1AND2        },
    { "bind o +fire",                                DOOM1AND2        },
    { "bind o +followmode",                          DOOM1AND2        },
    { "bind o +forward",                             DOOM1AND2        },
    { "bind o +freelook",                            DOOM1AND2        },
    { "bind o +grid",                                DOOM1AND2        },
    { "bind o +jump",                                DOOM1AND2        },
    { "bind o +left",                                DOOM1AND2        },
    { "bind o +mark",                                DOOM1AND2        },
    { "bind o +maxzoom",                             DOOM1AND2        },
    { "bind o +menu",                                DOOM1AND2        },
    { "bind o +nextweapon",                          DOOM1AND2        },
    { "bind o +prevweapon",                          DOOM1AND2        },
    { "bind o +right",                               DOOM1AND2        },
    { "bind o +rotatemode",                          DOOM1AND2        },
    { "bind o +run",                                 DOOM1AND2        },
    { "bind o +screenshot",                          DOOM1AND2        },
    { "bind o +strafe",                              DOOM1AND2        },
    { "bind o +strafeleft",                          DOOM1AND2        },
    { "bind o +straferight",                         DOOM1AND2        },
    { "bind o +use",                                 DOOM1AND2        },
    { "bind o +weapon1",                             DOOM1AND2        },
    { "bind o +weapon2",                             DOOM1AND2        },
    { "bind o +weapon3",                             DOOM1AND2        },
    { "bind o +weapon4",                             DOOM1AND2        },
    { "bind o +weapon5",                             DOOM1AND2        },
    { "bind o +weapon6",                             DOOM1AND2        },
    { "bind o +weapon7",                             DOOM1AND2        },
    { "bind o +zoomin",                              DOOM1AND2        },
    { "bind o +zoomout",                             DOOM1AND2        },
    { "bind p +alwaysrun",                           DOOM1AND2        },
    { "bind p +automap",                             DOOM1AND2        },
    { "bind p +back",                                DOOM1AND2        },
    { "bind p +clearmark",                           DOOM1AND2        },
    { "bind p +console",                             DOOM1AND2        },
    { "bind p +fire",                                DOOM1AND2        },
    { "bind p +followmode",                          DOOM1AND2        },
    { "bind p +forward",                             DOOM1AND2        },
    { "bind p +freelook",                            DOOM1AND2        },
    { "bind p +grid",                                DOOM1AND2        },
    { "bind p +jump",                                DOOM1AND2        },
    { "bind p +left",                                DOOM1AND2        },
    { "bind p +mark",                                DOOM1AND2        },
    { "bind p +maxzoom",                             DOOM1AND2        },
    { "bind p +menu",                                DOOM1AND2        },
    { "bind p +nextweapon",                          DOOM1AND2        },
    { "bind p +prevweapon",                          DOOM1AND2        },
    { "bind p +right",                               DOOM1AND2        },
    { "bind p +rotatemode",                          DOOM1AND2        },
    { "bind p +run",                                 DOOM1AND2        },
    { "bind p +screenshot",                          DOOM1AND2        },
    { "bind p +strafe",                              DOOM1AND2        },
    { "bind p +strafeleft",                          DOOM1AND2        },
    { "bind p +straferight",                         DOOM1AND2        },
    { "bind p +use",                                 DOOM1AND2        },
    { "bind p +weapon1",                             DOOM1AND2        },
    { "bind p +weapon2",                             DOOM1AND2        },
    { "bind p +weapon3",                             DOOM1AND2        },
    { "bind p +weapon4",                             DOOM1AND2        },
    { "bind p +weapon5",                             DOOM1AND2        },
    { "bind p +weapon6",                             DOOM1AND2        },
    { "bind p +weapon7",                             DOOM1AND2        },
    { "bind p +zoomin",                              DOOM1AND2        },
    { "bind p +zoomout",                             DOOM1AND2        },
    { "bind paddle1 ",                               DOOM1AND2        },
    { "bind paddle1 +alwaysrun",                     DOOM1AND2        },
    { "bind paddle1 +automap",                       DOOM1AND2        },
    { "bind paddle1 +back",                          DOOM1AND2        },
    { "bind paddle1 +clearmark",                     DOOM1AND2        },
    { "bind paddle1 +console",                       DOOM1AND2        },
    { "bind paddle1 +fire",                          DOOM1AND2        },
    { "bind paddle1 +followmode",                    DOOM1AND2        },
    { "bind paddle1 +forward",                       DOOM1AND2        },
    { "bind paddle1 +freelook",                      DOOM1AND2        },
    { "bind paddle1 +grid",                          DOOM1AND2        },
    { "bind paddle1 +jump",                          DOOM1AND2        },
    { "bind paddle1 +left",                          DOOM1AND2        },
    { "bind paddle1 +mark",                          DOOM1AND2        },
    { "bind paddle1 +maxzoom",                       DOOM1AND2        },
    { "bind paddle1 +menu",                          DOOM1AND2        },
    { "bind paddle1 +nextweapon",                    DOOM1AND2        },
    { "bind paddle1 +prevweapon",                    DOOM1AND2        },
    { "bind paddle1 +right",                         DOOM1AND2        },
    { "bind paddle1 +rotatemode",                    DOOM1AND2        },
    { "bind paddle1 +run",                           DOOM1AND2        },
    { "bind paddle1 +strafe",                        DOOM1AND2        },
    { "bind paddle1 +strafeleft",                    DOOM1AND2        },
    { "bind paddle1 +straferight",                   DOOM1AND2        },
    { "bind paddle1 +use",                           DOOM1AND2        },
    { "bind paddle1 +weapon1",                       DOOM1AND2        },
    { "bind paddle1 +weapon2",                       DOOM1AND2        },
    { "bind paddle1 +weapon3",                       DOOM1AND2        },
    { "bind paddle1 +weapon4",                       DOOM1AND2        },
    { "bind paddle1 +weapon5",                       DOOM1AND2        },
    { "bind paddle1 +weapon6",                       DOOM1AND2        },
    { "bind paddle1 +weapon7",                       DOOM1AND2        },
    { "bind paddle1 +zoomin",                        DOOM1AND2        },
    { "bind paddle1 +zoomout",                       DOOM1AND2        },
    { "bind paddle2 ",                               DOOM1AND2        },
    { "bind paddle2 +alwaysrun",                     DOOM1AND2        },
    { "bind paddle2 +automap",                       DOOM1AND2        },
    { "bind paddle2 +back",                          DOOM1AND2        },
    { "bind paddle2 +clearmark",                     DOOM1AND2        },
    { "bind paddle2 +console",                       DOOM1AND2        },
    { "bind paddle2 +fire",                          DOOM1AND2        },
    { "bind paddle2 +followmode",                    DOOM1AND2        },
    { "bind paddle2 +forward",                       DOOM1AND2        },
    { "bind paddle2 +freelook",                      DOOM1AND2        },
    { "bind paddle2 +grid",                          DOOM1AND2        },
    { "bind paddle2 +jump",                          DOOM1AND2        },
    { "bind paddle2 +left",                          DOOM1AND2        },
    { "bind paddle2 +mark",                          DOOM1AND2        },
    { "bind paddle2 +maxzoom",                       DOOM1AND2        },
    { "bind paddle2 +menu",                          DOOM1AND2        },
    { "bind paddle2 +nextweapon",                    DOOM1AND2        },
    { "bind paddle2 +prevweapon",                    DOOM1AND2        },
    { "bind paddle2 +right",                         DOOM1AND2        },
    { "bind paddle2 +rotatemode",                    DOOM1AND2        },
    { "bind paddle2 +run",                           DOOM1AND2        },
    { "bind paddle2 +strafe",                        DOOM1AND2        },
    { "bind paddle2 +strafeleft",                    DOOM1AND2        },
    { "bind paddle2 +straferight",                   DOOM1AND2        },
    { "bind paddle2 +use",                           DOOM1AND2        },
    { "bind paddle2 +weapon1",                       DOOM1AND2        },
    { "bind paddle2 +weapon2",                       DOOM1AND2        },
    { "bind paddle2 +weapon3",                       DOOM1AND2        },
    { "bind paddle2 +weapon4",                       DOOM1AND2        },
    { "bind paddle2 +weapon5",                       DOOM1AND2        },
    { "bind paddle2 +weapon6",                       DOOM1AND2        },
    { "bind paddle2 +weapon7",                       DOOM1AND2        },
    { "bind paddle2 +zoomin",                        DOOM1AND2        },
    { "bind paddle2 +zoomout",                       DOOM1AND2        },
    { "bind paddle3 ",                               DOOM1AND2        },
    { "bind paddle3 +alwaysrun",                     DOOM1AND2        },
    { "bind paddle3 +automap",                       DOOM1AND2        },
    { "bind paddle3 +back",                          DOOM1AND2        },
    { "bind paddle3 +clearmark",                     DOOM1AND2        },
    { "bind paddle3 +console",                       DOOM1AND2        },
    { "bind paddle3 +fire",                          DOOM1AND2        },
    { "bind paddle3 +followmode",                    DOOM1AND2        },
    { "bind paddle3 +forward",                       DOOM1AND2        },
    { "bind paddle3 +freelook",                      DOOM1AND2        },
    { "bind paddle3 +grid",                          DOOM1AND2        },
    { "bind paddle3 +jump",                          DOOM1AND2        },
    { "bind paddle3 +left",                          DOOM1AND2        },
    { "bind paddle3 +mark",                          DOOM1AND2        },
    { "bind paddle3 +maxzoom",                       DOOM1AND2        },
    { "bind paddle3 +menu",                          DOOM1AND2        },
    { "bind paddle3 +nextweapon",                    DOOM1AND2        },
    { "bind paddle3 +prevweapon",                    DOOM1AND2        },
    { "bind paddle3 +right",                         DOOM1AND2        },
    { "bind paddle3 +rotatemode",                    DOOM1AND2        },
    { "bind paddle3 +run",                           DOOM1AND2        },
    { "bind paddle3 +strafe",                        DOOM1AND2        },
    { "bind paddle3 +strafeleft",                    DOOM1AND2        },
    { "bind paddle3 +straferight",                   DOOM1AND2        },
    { "bind paddle3 +use",                           DOOM1AND2        },
    { "bind paddle3 +weapon1",                       DOOM1AND2        },
    { "bind paddle3 +weapon2",                       DOOM1AND2        },
    { "bind paddle3 +weapon3",                       DOOM1AND2        },
    { "bind paddle3 +weapon4",                       DOOM1AND2        },
    { "bind paddle3 +weapon5",                       DOOM1AND2        },
    { "bind paddle3 +weapon6",                       DOOM1AND2        },
    { "bind paddle3 +weapon7",                       DOOM1AND2        },
    { "bind paddle3 +zoomin",                        DOOM1AND2        },
    { "bind paddle3 +zoomout",                       DOOM1AND2        },
    { "bind paddle4 ",                               DOOM1AND2        },
    { "bind paddle4 +alwaysrun",                     DOOM1AND2        },
    { "bind paddle4 +automap",                       DOOM1AND2        },
    { "bind paddle4 +back",                          DOOM1AND2        },
    { "bind paddle4 +clearmark",                     DOOM1AND2        },
    { "bind paddle4 +console",                       DOOM1AND2        },
    { "bind paddle4 +fire",                          DOOM1AND2        },
    { "bind paddle4 +followmode",                    DOOM1AND2        },
    { "bind paddle4 +forward",                       DOOM1AND2        },
    { "bind paddle4 +freelook",                      DOOM1AND2        },
    { "bind paddle4 +grid",                          DOOM1AND2        },
    { "bind paddle4 +jump",                          DOOM1AND2        },
    { "bind paddle4 +left",                          DOOM1AND2        },
    { "bind paddle4 +mark",                          DOOM1AND2        },
    { "bind paddle4 +maxzoom",                       DOOM1AND2        },
    { "bind paddle4 +menu",                          DOOM1AND2        },
    { "bind paddle4 +nextweapon",                    DOOM1AND2        },
    { "bind paddle4 +prevweapon",                    DOOM1AND2        },
    { "bind paddle4 +right",                         DOOM1AND2        },
    { "bind paddle4 +rotatemode",                    DOOM1AND2        },
    { "bind paddle4 +run",                           DOOM1AND2        },
    { "bind paddle4 +strafe",                        DOOM1AND2        },
    { "bind paddle4 +strafeleft",                    DOOM1AND2        },
    { "bind paddle4 +straferight",                   DOOM1AND2        },
    { "bind paddle4 +use",                           DOOM1AND2        },
    { "bind paddle4 +weapon1",                       DOOM1AND2        },
    { "bind paddle4 +weapon2",                       DOOM1AND2        },
    { "bind paddle4 +weapon3",                       DOOM1AND2        },
    { "bind paddle4 +weapon4",                       DOOM1AND2        },
    { "bind paddle4 +weapon5",                       DOOM1AND2        },
    { "bind paddle4 +weapon6",                       DOOM1AND2        },
    { "bind paddle4 +weapon7",                       DOOM1AND2        },
    { "bind paddle4 +zoomin",                        DOOM1AND2        },
    { "bind paddle4 +zoomout",                       DOOM1AND2        },
    { "bind pagedown ",                              DOOM1AND2        },
    { "bind pagedown +alwaysrun",                    DOOM1AND2        },
    { "bind pagedown +automap",                      DOOM1AND2        },
    { "bind pagedown +back",                         DOOM1AND2        },
    { "bind pagedown +clearmark",                    DOOM1AND2        },
    { "bind pagedown +console",                      DOOM1AND2        },
    { "bind pagedown +fire",                         DOOM1AND2        },
    { "bind pagedown +followmode",                   DOOM1AND2        },
    { "bind pagedown +forward",                      DOOM1AND2        },
    { "bind pagedown +freelook",                     DOOM1AND2        },
    { "bind pagedown +grid",                         DOOM1AND2        },
    { "bind pagedown +jump",                         DOOM1AND2        },
    { "bind pagedown +left",                         DOOM1AND2        },
    { "bind pagedown +mark",                         DOOM1AND2        },
    { "bind pagedown +maxzoom",                      DOOM1AND2        },
    { "bind pagedown +menu",                         DOOM1AND2        },
    { "bind pagedown +nextweapon",                   DOOM1AND2        },
    { "bind pagedown +prevweapon",                   DOOM1AND2        },
    { "bind pagedown +right",                        DOOM1AND2        },
    { "bind pagedown +rotatemode",                   DOOM1AND2        },
    { "bind pagedown +run",                          DOOM1AND2        },
    { "bind pagedown +screenshot",                   DOOM1AND2        },
    { "bind pagedown +strafe",                       DOOM1AND2        },
    { "bind pagedown +strafeleft",                   DOOM1AND2        },
    { "bind pagedown +straferight",                  DOOM1AND2        },
    { "bind pagedown +use",                          DOOM1AND2        },
    { "bind pagedown +weapon1",                      DOOM1AND2        },
    { "bind pagedown +weapon2",                      DOOM1AND2        },
    { "bind pagedown +weapon3",                      DOOM1AND2        },
    { "bind pagedown +weapon4",                      DOOM1AND2        },
    { "bind pagedown +weapon5",                      DOOM1AND2        },
    { "bind pagedown +weapon6",                      DOOM1AND2        },
    { "bind pagedown +weapon7",                      DOOM1AND2        },
    { "bind pagedown +zoomin",                       DOOM1AND2        },
    { "bind pagedown +zoomout",                      DOOM1AND2        },
    { "bind pageup ",                                DOOM1AND2        },
    { "bind pageup +alwaysrun",                      DOOM1AND2        },
    { "bind pageup +automap",                        DOOM1AND2        },
    { "bind pageup +back",                           DOOM1AND2        },
    { "bind pageup +clearmark",                      DOOM1AND2        },
    { "bind pageup +console",                        DOOM1AND2        },
    { "bind pageup +fire",                           DOOM1AND2        },
    { "bind pageup +followmode",                     DOOM1AND2        },
    { "bind pageup +forward",                        DOOM1AND2        },
    { "bind pageup +freelook",                       DOOM1AND2        },
    { "bind pageup +grid",                           DOOM1AND2        },
    { "bind pageup +jump",                           DOOM1AND2        },
    { "bind pageup +left",                           DOOM1AND2        },
    { "bind pageup +mark",                           DOOM1AND2        },
    { "bind pageup +maxzoom",                        DOOM1AND2        },
    { "bind pageup +menu",                           DOOM1AND2        },
    { "bind pageup +nextweapon",                     DOOM1AND2        },
    { "bind pageup +prevweapon",                     DOOM1AND2        },
    { "bind pageup +right",                          DOOM1AND2        },
    { "bind pageup +rotatemode",                     DOOM1AND2        },
    { "bind pageup +run",                            DOOM1AND2        },
    { "bind pageup +screenshot",                     DOOM1AND2        },
    { "bind pageup +strafe",                         DOOM1AND2        },
    { "bind pageup +strafeleft",                     DOOM1AND2        },
    { "bind pageup +straferight",                    DOOM1AND2        },
    { "bind pageup +use",                            DOOM1AND2        },
    { "bind pageup +weapon1",                        DOOM1AND2        },
    { "bind pageup +weapon2",                        DOOM1AND2        },
    { "bind pageup +weapon3",                        DOOM1AND2        },
    { "bind pageup +weapon4",                        DOOM1AND2        },
    { "bind pageup +weapon5",                        DOOM1AND2        },
    { "bind pageup +weapon6",                        DOOM1AND2        },
    { "bind pageup +weapon7",                        DOOM1AND2        },
    { "bind pageup +zoomin",                         DOOM1AND2        },
    { "bind pageup +zoomout",                        DOOM1AND2        },
    { "bind printscreen ",                           DOOM1AND2        },
    { "bind printscreen +alwaysrun",                 DOOM1AND2        },
    { "bind printscreen +automap",                   DOOM1AND2        },
    { "bind printscreen +back",                      DOOM1AND2        },
    { "bind printscreen +clearmark",                 DOOM1AND2        },
    { "bind printscreen +console",                   DOOM1AND2        },
    { "bind printscreen +fire",                      DOOM1AND2        },
    { "bind printscreen +followmode",                DOOM1AND2        },
    { "bind printscreen +forward",                   DOOM1AND2        },
    { "bind printscreen +freelook",                  DOOM1AND2        },
    { "bind printscreen +grid",                      DOOM1AND2        },
    { "bind printscreen +jump",                      DOOM1AND2        },
    { "bind printscreen +left",                      DOOM1AND2        },
    { "bind printscreen +mark",                      DOOM1AND2        },
    { "bind printscreen +maxzoom",                   DOOM1AND2        },
    { "bind printscreen +menu",                      DOOM1AND2        },
    { "bind printscreen +nextweapon",                DOOM1AND2        },
    { "bind printscreen +prevweapon",                DOOM1AND2        },
    { "bind printscreen +right",                     DOOM1AND2        },
    { "bind printscreen +rotatemode",                DOOM1AND2        },
    { "bind printscreen +run",                       DOOM1AND2        },
    { "bind printscreen +screenshot",                DOOM1AND2        },
    { "bind printscreen +strafe",                    DOOM1AND2        },
    { "bind printscreen +strafeleft",                DOOM1AND2        },
    { "bind printscreen +straferight",               DOOM1AND2        },
    { "bind printscreen +use",                       DOOM1AND2        },
    { "bind printscreen +weapon1",                   DOOM1AND2        },
    { "bind printscreen +weapon2",                   DOOM1AND2        },
    { "bind printscreen +weapon3",                   DOOM1AND2        },
    { "bind printscreen +weapon4",                   DOOM1AND2        },
    { "bind printscreen +weapon5",                   DOOM1AND2        },
    { "bind printscreen +weapon6",                   DOOM1AND2        },
    { "bind printscreen +weapon7",                   DOOM1AND2        },
    { "bind printscreen +zoomin",                    DOOM1AND2        },
    { "bind printscreen +zoomout",                   DOOM1AND2        },
    { "bind q +alwaysrun",                           DOOM1AND2        },
    { "bind q +automap",                             DOOM1AND2        },
    { "bind q +back",                                DOOM1AND2        },
    { "bind q +clearmark",                           DOOM1AND2        },
    { "bind q +console",                             DOOM1AND2        },
    { "bind q +fire",                                DOOM1AND2        },
    { "bind q +followmode",                          DOOM1AND2        },
    { "bind q +forward",                             DOOM1AND2        },
    { "bind q +freelook",                            DOOM1AND2        },
    { "bind q +grid",                                DOOM1AND2        },
    { "bind q +jump",                                DOOM1AND2        },
    { "bind q +left",                                DOOM1AND2        },
    { "bind q +mark",                                DOOM1AND2        },
    { "bind q +maxzoom",                             DOOM1AND2        },
    { "bind q +menu",                                DOOM1AND2        },
    { "bind q +nextweapon",                          DOOM1AND2        },
    { "bind q +prevweapon",                          DOOM1AND2        },
    { "bind q +right",                               DOOM1AND2        },
    { "bind q +rotatemode",                          DOOM1AND2        },
    { "bind q +run",                                 DOOM1AND2        },
    { "bind q +screenshot",                          DOOM1AND2        },
    { "bind q +strafe",                              DOOM1AND2        },
    { "bind q +strafeleft",                          DOOM1AND2        },
    { "bind q +straferight",                         DOOM1AND2        },
    { "bind q +use",                                 DOOM1AND2        },
    { "bind q +weapon1",                             DOOM1AND2        },
    { "bind q +weapon2",                             DOOM1AND2        },
    { "bind q +weapon3",                             DOOM1AND2        },
    { "bind q +weapon4",                             DOOM1AND2        },
    { "bind q +weapon5",                             DOOM1AND2        },
    { "bind q +weapon6",                             DOOM1AND2        },
    { "bind q +weapon7",                             DOOM1AND2        },
    { "bind q +zoomin",                              DOOM1AND2        },
    { "bind q +zoomout",                             DOOM1AND2        },
    { "bind r +alwaysrun",                           DOOM1AND2        },
    { "bind r +automap",                             DOOM1AND2        },
    { "bind r +back",                                DOOM1AND2        },
    { "bind r +clearmark",                           DOOM1AND2        },
    { "bind r +console",                             DOOM1AND2        },
    { "bind r +fire",                                DOOM1AND2        },
    { "bind r +followmode",                          DOOM1AND2        },
    { "bind r +forward",                             DOOM1AND2        },
    { "bind r +freelook",                            DOOM1AND2        },
    { "bind r +grid",                                DOOM1AND2        },
    { "bind r +jump",                                DOOM1AND2        },
    { "bind r +left",                                DOOM1AND2        },
    { "bind r +mark",                                DOOM1AND2        },
    { "bind r +maxzoom",                             DOOM1AND2        },
    { "bind r +menu",                                DOOM1AND2        },
    { "bind r +nextweapon",                          DOOM1AND2        },
    { "bind r +prevweapon",                          DOOM1AND2        },
    { "bind r +right",                               DOOM1AND2        },
    { "bind r +rotatemode",                          DOOM1AND2        },
    { "bind r +run",                                 DOOM1AND2        },
    { "bind r +screenshot",                          DOOM1AND2        },
    { "bind r +strafe",                              DOOM1AND2        },
    { "bind r +strafeleft",                          DOOM1AND2        },
    { "bind r +straferight",                         DOOM1AND2        },
    { "bind r +use",                                 DOOM1AND2        },
    { "bind r +weapon1",                             DOOM1AND2        },
    { "bind r +weapon2",                             DOOM1AND2        },
    { "bind r +weapon3",                             DOOM1AND2        },
    { "bind r +weapon4",                             DOOM1AND2        },
    { "bind r +weapon5",                             DOOM1AND2        },
    { "bind r +weapon6",                             DOOM1AND2        },
    { "bind r +weapon7",                             DOOM1AND2        },
    { "bind r +zoomin",                              DOOM1AND2        },
    { "bind r +zoomout",                             DOOM1AND2        },
    { "bind right ",                                 DOOM1AND2        },
    { "bind right +alwaysrun",                       DOOM1AND2        },
    { "bind right +automap",                         DOOM1AND2        },
    { "bind right +back",                            DOOM1AND2        },
    { "bind right +clearmark",                       DOOM1AND2        },
    { "bind right +console",                         DOOM1AND2        },
    { "bind right +fire",                            DOOM1AND2        },
    { "bind right +followmode",                      DOOM1AND2        },
    { "bind right +forward",                         DOOM1AND2        },
    { "bind right +freelook",                        DOOM1AND2        },
    { "bind right +grid",                            DOOM1AND2        },
    { "bind right +jump",                            DOOM1AND2        },
    { "bind right +left",                            DOOM1AND2        },
    { "bind right +mark",                            DOOM1AND2        },
    { "bind right +maxzoom",                         DOOM1AND2        },
    { "bind right +menu",                            DOOM1AND2        },
    { "bind right +nextweapon",                      DOOM1AND2        },
    { "bind right +prevweapon",                      DOOM1AND2        },
    { "bind right +right",                           DOOM1AND2        },
    { "bind right +rotatemode",                      DOOM1AND2        },
    { "bind right +run",                             DOOM1AND2        },
    { "bind right +screenshot",                      DOOM1AND2        },
    { "bind right +strafe",                          DOOM1AND2        },
    { "bind right +strafeleft",                      DOOM1AND2        },
    { "bind right +straferight",                     DOOM1AND2        },
    { "bind right +use",                             DOOM1AND2        },
    { "bind right +weapon1",                         DOOM1AND2        },
    { "bind right +weapon2",                         DOOM1AND2        },
    { "bind right +weapon3",                         DOOM1AND2        },
    { "bind right +weapon4",                         DOOM1AND2        },
    { "bind right +weapon5",                         DOOM1AND2        },
    { "bind right +weapon6",                         DOOM1AND2        },
    { "bind right +weapon7",                         DOOM1AND2        },
    { "bind right +zoomin",                          DOOM1AND2        },
    { "bind right +zoomout",                         DOOM1AND2        },
    { "bind rightshoulder ",                         DOOM1AND2        },
    { "bind rightshoulder +alwaysrun",               DOOM1AND2        },
    { "bind rightshoulder +automap",                 DOOM1AND2        },
    { "bind rightshoulder +back",                    DOOM1AND2        },
    { "bind rightshoulder +clearmark",               DOOM1AND2        },
    { "bind rightshoulder +console",                 DOOM1AND2        },
    { "bind rightshoulder +fire",                    DOOM1AND2        },
    { "bind rightshoulder +followmode",              DOOM1AND2        },
    { "bind rightshoulder +forward",                 DOOM1AND2        },
    { "bind rightshoulder +freelook",                DOOM1AND2        },
    { "bind rightshoulder +grid",                    DOOM1AND2        },
    { "bind rightshoulder +jump",                    DOOM1AND2        },
    { "bind rightshoulder +left",                    DOOM1AND2        },
    { "bind rightshoulder +mark",                    DOOM1AND2        },
    { "bind rightshoulder +maxzoom",                 DOOM1AND2        },
    { "bind rightshoulder +menu",                    DOOM1AND2        },
    { "bind rightshoulder +nextweapon",              DOOM1AND2        },
    { "bind rightshoulder +prevweapon",              DOOM1AND2        },
    { "bind rightshoulder +right",                   DOOM1AND2        },
    { "bind rightshoulder +rotatemode",              DOOM1AND2        },
    { "bind rightshoulder +run",                     DOOM1AND2        },
    { "bind rightshoulder +strafe",                  DOOM1AND2        },
    { "bind rightshoulder +strafeleft",              DOOM1AND2        },
    { "bind rightshoulder +straferight",             DOOM1AND2        },
    { "bind rightshoulder +use",                     DOOM1AND2        },
    { "bind rightshoulder +weapon1",                 DOOM1AND2        },
    { "bind rightshoulder +weapon2",                 DOOM1AND2        },
    { "bind rightshoulder +weapon3",                 DOOM1AND2        },
    { "bind rightshoulder +weapon4",                 DOOM1AND2        },
    { "bind rightshoulder +weapon5",                 DOOM1AND2        },
    { "bind rightshoulder +weapon6",                 DOOM1AND2        },
    { "bind rightshoulder +weapon7",                 DOOM1AND2        },
    { "bind rightshoulder +zoomin",                  DOOM1AND2        },
    { "bind rightshoulder +zoomout",                 DOOM1AND2        },
    { "bind rightthumb ",                            DOOM1AND2        },
    { "bind rightthumb +alwaysrun",                  DOOM1AND2        },
    { "bind rightthumb +automap",                    DOOM1AND2        },
    { "bind rightthumb +back",                       DOOM1AND2        },
    { "bind rightthumb +clearmark",                  DOOM1AND2        },
    { "bind rightthumb +console",                    DOOM1AND2        },
    { "bind rightthumb +fire",                       DOOM1AND2        },
    { "bind rightthumb +followmode",                 DOOM1AND2        },
    { "bind rightthumb +forward",                    DOOM1AND2        },
    { "bind rightthumb +freelook",                   DOOM1AND2        },
    { "bind rightthumb +grid",                       DOOM1AND2        },
    { "bind rightthumb +jump",                       DOOM1AND2        },
    { "bind rightthumb +left",                       DOOM1AND2        },
    { "bind rightthumb +mark",                       DOOM1AND2        },
    { "bind rightthumb +maxzoom",                    DOOM1AND2        },
    { "bind rightthumb +menu",                       DOOM1AND2        },
    { "bind rightthumb +nextweapon",                 DOOM1AND2        },
    { "bind rightthumb +prevweapon",                 DOOM1AND2        },
    { "bind rightthumb +right",                      DOOM1AND2        },
    { "bind rightthumb +rotatemode",                 DOOM1AND2        },
    { "bind rightthumb +run",                        DOOM1AND2        },
    { "bind rightthumb +strafe",                     DOOM1AND2        },
    { "bind rightthumb +strafeleft",                 DOOM1AND2        },
    { "bind rightthumb +straferight",                DOOM1AND2        },
    { "bind rightthumb +use",                        DOOM1AND2        },
    { "bind rightthumb +weapon1",                    DOOM1AND2        },
    { "bind rightthumb +weapon2",                    DOOM1AND2        },
    { "bind rightthumb +weapon3",                    DOOM1AND2        },
    { "bind rightthumb +weapon4",                    DOOM1AND2        },
    { "bind rightthumb +weapon5",                    DOOM1AND2        },
    { "bind rightthumb +weapon6",                    DOOM1AND2        },
    { "bind rightthumb +weapon7",                    DOOM1AND2        },
    { "bind rightthumb +zoomin",                     DOOM1AND2        },
    { "bind rightthumb +zoomout",                    DOOM1AND2        },
    { "bind righttrigger ",                          DOOM1AND2        },
    { "bind righttrigger +alwaysrun",                DOOM1AND2        },
    { "bind righttrigger +automap",                  DOOM1AND2        },
    { "bind righttrigger +back",                     DOOM1AND2        },
    { "bind righttrigger +clearmark",                DOOM1AND2        },
    { "bind righttrigger +console",                  DOOM1AND2        },
    { "bind righttrigger +fire",                     DOOM1AND2        },
    { "bind righttrigger +followmode",               DOOM1AND2        },
    { "bind righttrigger +forward",                  DOOM1AND2        },
    { "bind righttrigger +freelook",                 DOOM1AND2        },
    { "bind righttrigger +grid",                     DOOM1AND2        },
    { "bind righttrigger +jump",                     DOOM1AND2        },
    { "bind righttrigger +left",                     DOOM1AND2        },
    { "bind righttrigger +mark",                     DOOM1AND2        },
    { "bind righttrigger +maxzoom",                  DOOM1AND2        },
    { "bind righttrigger +menu",                     DOOM1AND2        },
    { "bind righttrigger +nextweapon",               DOOM1AND2        },
    { "bind righttrigger +prevweapon",               DOOM1AND2        },
    { "bind righttrigger +right",                    DOOM1AND2        },
    { "bind righttrigger +rotatemode",               DOOM1AND2        },
    { "bind righttrigger +run",                      DOOM1AND2        },
    { "bind righttrigger +strafe",                   DOOM1AND2        },
    { "bind righttrigger +strafeleft",               DOOM1AND2        },
    { "bind righttrigger +straferight",              DOOM1AND2        },
    { "bind righttrigger +use",                      DOOM1AND2        },
    { "bind righttrigger +weapon1",                  DOOM1AND2        },
    { "bind righttrigger +weapon2",                  DOOM1AND2        },
    { "bind righttrigger +weapon3",                  DOOM1AND2        },
    { "bind righttrigger +weapon4",                  DOOM1AND2        },
    { "bind righttrigger +weapon5",                  DOOM1AND2        },
    { "bind righttrigger +weapon6",                  DOOM1AND2        },
    { "bind righttrigger +weapon7",                  DOOM1AND2        },
    { "bind righttrigger +zoomin",                   DOOM1AND2        },
    { "bind righttrigger +zoomout",                  DOOM1AND2        },
    { "bind s +alwaysrun",                           DOOM1AND2        },
    { "bind s +automap",                             DOOM1AND2        },
    { "bind s +back",                                DOOM1AND2        },
    { "bind s +clearmark",                           DOOM1AND2        },
    { "bind s +console",                             DOOM1AND2        },
    { "bind s +fire",                                DOOM1AND2        },
    { "bind s +followmode",                          DOOM1AND2        },
    { "bind s +forward",                             DOOM1AND2        },
    { "bind s +freelook",                            DOOM1AND2        },
    { "bind s +grid",                                DOOM1AND2        },
    { "bind s +jump",                                DOOM1AND2        },
    { "bind s +left",                                DOOM1AND2        },
    { "bind s +mark",                                DOOM1AND2        },
    { "bind s +maxzoom",                             DOOM1AND2        },
    { "bind s +menu",                                DOOM1AND2        },
    { "bind s +nextweapon",                          DOOM1AND2        },
    { "bind s +prevweapon",                          DOOM1AND2        },
    { "bind s +right",                               DOOM1AND2        },
    { "bind s +rotatemode",                          DOOM1AND2        },
    { "bind s +run",                                 DOOM1AND2        },
    { "bind s +screenshot",                          DOOM1AND2        },
    { "bind s +strafe",                              DOOM1AND2        },
    { "bind s +strafeleft",                          DOOM1AND2        },
    { "bind s +straferight",                         DOOM1AND2        },
    { "bind s +use",                                 DOOM1AND2        },
    { "bind s +weapon1",                             DOOM1AND2        },
    { "bind s +weapon2",                             DOOM1AND2        },
    { "bind s +weapon3",                             DOOM1AND2        },
    { "bind s +weapon4",                             DOOM1AND2        },
    { "bind s +weapon5",                             DOOM1AND2        },
    { "bind s +weapon6",                             DOOM1AND2        },
    { "bind s +weapon7",                             DOOM1AND2        },
    { "bind s +zoomin",                              DOOM1AND2        },
    { "bind s +zoomout",                             DOOM1AND2        },
    { "bind scrolllock ",                            DOOM1AND2        },
    { "bind scrolllock +alwaysrun",                  DOOM1AND2        },
    { "bind scrolllock +automap",                    DOOM1AND2        },
    { "bind scrolllock +back",                       DOOM1AND2        },
    { "bind scrolllock +clearmark",                  DOOM1AND2        },
    { "bind scrolllock +console",                    DOOM1AND2        },
    { "bind scrolllock +fire",                       DOOM1AND2        },
    { "bind scrolllock +followmode",                 DOOM1AND2        },
    { "bind scrolllock +forward",                    DOOM1AND2        },
    { "bind scrolllock +freelook",                   DOOM1AND2        },
    { "bind scrolllock +grid",                       DOOM1AND2        },
    { "bind scrolllock +jump",                       DOOM1AND2        },
    { "bind scrolllock +left",                       DOOM1AND2        },
    { "bind scrolllock +mark",                       DOOM1AND2        },
    { "bind scrolllock +maxzoom",                    DOOM1AND2        },
    { "bind scrolllock +menu",                       DOOM1AND2        },
    { "bind scrolllock +nextweapon",                 DOOM1AND2        },
    { "bind scrolllock +prevweapon",                 DOOM1AND2        },
    { "bind scrolllock +right",                      DOOM1AND2        },
    { "bind scrolllock +rotatemode",                 DOOM1AND2        },
    { "bind scrolllock +run",                        DOOM1AND2        },
    { "bind scrolllock +screenshot",                 DOOM1AND2        },
    { "bind scrolllock +strafe",                     DOOM1AND2        },
    { "bind scrolllock +strafeleft",                 DOOM1AND2        },
    { "bind scrolllock +straferight",                DOOM1AND2        },
    { "bind scrolllock +use",                        DOOM1AND2        },
    { "bind scrolllock +weapon1",                    DOOM1AND2        },
    { "bind scrolllock +weapon2",                    DOOM1AND2        },
    { "bind scrolllock +weapon3",                    DOOM1AND2        },
    { "bind scrolllock +weapon4",                    DOOM1AND2        },
    { "bind scrolllock +weapon5",                    DOOM1AND2        },
    { "bind scrolllock +weapon6",                    DOOM1AND2        },
    { "bind scrolllock +weapon7",                    DOOM1AND2        },
    { "bind scrolllock +zoomin",                     DOOM1AND2        },
    { "bind scrolllock +zoomout",                    DOOM1AND2        },
    { "bind shift ",                                 DOOM1AND2        },
    { "bind shift +alwaysrun",                       DOOM1AND2        },
    { "bind shift +automap",                         DOOM1AND2        },
    { "bind shift +back",                            DOOM1AND2        },
    { "bind shift +clearmark",                       DOOM1AND2        },
    { "bind shift +console",                         DOOM1AND2        },
    { "bind shift +fire",                            DOOM1AND2        },
    { "bind shift +followmode",                      DOOM1AND2        },
    { "bind shift +forward",                         DOOM1AND2        },
    { "bind shift +freelook",                        DOOM1AND2        },
    { "bind shift +grid",                            DOOM1AND2        },
    { "bind shift +jump",                            DOOM1AND2        },
    { "bind shift +left",                            DOOM1AND2        },
    { "bind shift +mark",                            DOOM1AND2        },
    { "bind shift +maxzoom",                         DOOM1AND2        },
    { "bind shift +menu",                            DOOM1AND2        },
    { "bind shift +nextweapon",                      DOOM1AND2        },
    { "bind shift +prevweapon",                      DOOM1AND2        },
    { "bind shift +right",                           DOOM1AND2        },
    { "bind shift +rotatemode",                      DOOM1AND2        },
    { "bind shift +run",                             DOOM1AND2        },
    { "bind shift +screenshot",                      DOOM1AND2        },
    { "bind shift +strafe",                          DOOM1AND2        },
    { "bind shift +strafeleft",                      DOOM1AND2        },
    { "bind shift +straferight",                     DOOM1AND2        },
    { "bind shift +use",                             DOOM1AND2        },
    { "bind shift +weapon1",                         DOOM1AND2        },
    { "bind shift +weapon2",                         DOOM1AND2        },
    { "bind shift +weapon3",                         DOOM1AND2        },
    { "bind shift +weapon4",                         DOOM1AND2        },
    { "bind shift +weapon5",                         DOOM1AND2        },
    { "bind shift +weapon6",                         DOOM1AND2        },
    { "bind shift +weapon7",                         DOOM1AND2        },
    { "bind shift +zoomin",                          DOOM1AND2        },
    { "bind shift +zoomout",                         DOOM1AND2        },
    { "bind space ",                                 DOOM1AND2        },
    { "bind space +alwaysrun",                       DOOM1AND2        },
    { "bind space +automap",                         DOOM1AND2        },
    { "bind space +back",                            DOOM1AND2        },
    { "bind space +clearmark",                       DOOM1AND2        },
    { "bind space +console",                         DOOM1AND2        },
    { "bind space +fire",                            DOOM1AND2        },
    { "bind space +followmode",                      DOOM1AND2        },
    { "bind space +forward",                         DOOM1AND2        },
    { "bind space +freelook",                        DOOM1AND2        },
    { "bind space +grid",                            DOOM1AND2        },
    { "bind space +jump",                            DOOM1AND2        },
    { "bind space +left",                            DOOM1AND2        },
    { "bind space +mark",                            DOOM1AND2        },
    { "bind space +maxzoom",                         DOOM1AND2        },
    { "bind space +menu",                            DOOM1AND2        },
    { "bind space +nextweapon",                      DOOM1AND2        },
    { "bind space +prevweapon",                      DOOM1AND2        },
    { "bind space +right",                           DOOM1AND2        },
    { "bind space +rotatemode",                      DOOM1AND2        },
    { "bind space +run",                             DOOM1AND2        },
    { "bind space +screenshot",                      DOOM1AND2        },
    { "bind space +strafe",                          DOOM1AND2        },
    { "bind space +strafeleft",                      DOOM1AND2        },
    { "bind space +straferight",                     DOOM1AND2        },
    { "bind space +use",                             DOOM1AND2        },
    { "bind space +weapon1",                         DOOM1AND2        },
    { "bind space +weapon2",                         DOOM1AND2        },
    { "bind space +weapon3",                         DOOM1AND2        },
    { "bind space +weapon4",                         DOOM1AND2        },
    { "bind space +weapon5",                         DOOM1AND2        },
    { "bind space +weapon6",                         DOOM1AND2        },
    { "bind space +weapon7",                         DOOM1AND2        },
    { "bind space +zoomin",                          DOOM1AND2        },
    { "bind space +zoomout",                         DOOM1AND2        },
    { "bind start ",                                 DOOM1AND2        },
    { "bind start +alwaysrun",                       DOOM1AND2        },
    { "bind start +automap",                         DOOM1AND2        },
    { "bind start +back",                            DOOM1AND2        },
    { "bind start +clearmark",                       DOOM1AND2        },
    { "bind start +console",                         DOOM1AND2        },
    { "bind start +fire",                            DOOM1AND2        },
    { "bind start +followmode",                      DOOM1AND2        },
    { "bind start +forward",                         DOOM1AND2        },
    { "bind start +freelook",                        DOOM1AND2        },
    { "bind start +grid",                            DOOM1AND2        },
    { "bind start +jump",                            DOOM1AND2        },
    { "bind start +left",                            DOOM1AND2        },
    { "bind start +mark",                            DOOM1AND2        },
    { "bind start +maxzoom",                         DOOM1AND2        },
    { "bind start +menu",                            DOOM1AND2        },
    { "bind start +nextweapon",                      DOOM1AND2        },
    { "bind start +prevweapon",                      DOOM1AND2        },
    { "bind start +right",                           DOOM1AND2        },
    { "bind start +rotatemode",                      DOOM1AND2        },
    { "bind start +run",                             DOOM1AND2        },
    { "bind start +strafe",                          DOOM1AND2        },
    { "bind start +strafeleft",                      DOOM1AND2        },
    { "bind start +straferight",                     DOOM1AND2        },
    { "bind start +use",                             DOOM1AND2        },
    { "bind start +weapon1",                         DOOM1AND2        },
    { "bind start +weapon2",                         DOOM1AND2        },
    { "bind start +weapon3",                         DOOM1AND2        },
    { "bind start +weapon4",                         DOOM1AND2        },
    { "bind start +weapon5",                         DOOM1AND2        },
    { "bind start +weapon6",                         DOOM1AND2        },
    { "bind start +weapon7",                         DOOM1AND2        },
    { "bind start +zoomin",                          DOOM1AND2        },
    { "bind start +zoomout",                         DOOM1AND2        },
    { "bind t +alwaysrun",                           DOOM1AND2        },
    { "bind t +automap",                             DOOM1AND2        },
    { "bind t +back",                                DOOM1AND2        },
    { "bind t +clearmark",                           DOOM1AND2        },
    { "bind t +console",                             DOOM1AND2        },
    { "bind t +fire",                                DOOM1AND2        },
    { "bind t +followmode",                          DOOM1AND2        },
    { "bind t +forward",                             DOOM1AND2        },
    { "bind t +freelook",                            DOOM1AND2        },
    { "bind t +grid",                                DOOM1AND2        },
    { "bind t +jump",                                DOOM1AND2        },
    { "bind t +left",                                DOOM1AND2        },
    { "bind t +mark",                                DOOM1AND2        },
    { "bind t +maxzoom",                             DOOM1AND2        },
    { "bind t +menu",                                DOOM1AND2        },
    { "bind t +nextweapon",                          DOOM1AND2        },
    { "bind t +prevweapon",                          DOOM1AND2        },
    { "bind t +right",                               DOOM1AND2        },
    { "bind t +rotatemode",                          DOOM1AND2        },
    { "bind t +run",                                 DOOM1AND2        },
    { "bind t +screenshot",                          DOOM1AND2        },
    { "bind t +strafe",                              DOOM1AND2        },
    { "bind t +strafeleft",                          DOOM1AND2        },
    { "bind t +straferight",                         DOOM1AND2        },
    { "bind t +use",                                 DOOM1AND2        },
    { "bind t +weapon1",                             DOOM1AND2        },
    { "bind t +weapon2",                             DOOM1AND2        },
    { "bind t +weapon3",                             DOOM1AND2        },
    { "bind t +weapon4",                             DOOM1AND2        },
    { "bind t +weapon5",                             DOOM1AND2        },
    { "bind t +weapon6",                             DOOM1AND2        },
    { "bind t +weapon7",                             DOOM1AND2        },
    { "bind t +zoomin",                              DOOM1AND2        },
    { "bind t +zoomout",                             DOOM1AND2        },
    { "bind tab ",                                   DOOM1AND2        },
    { "bind tab +alwaysrun",                         DOOM1AND2        },
    { "bind tab +automap",                           DOOM1AND2        },
    { "bind tab +back",                              DOOM1AND2        },
    { "bind tab +clearmark",                         DOOM1AND2        },
    { "bind tab +console",                           DOOM1AND2        },
    { "bind tab +fire",                              DOOM1AND2        },
    { "bind tab +followmode",                        DOOM1AND2        },
    { "bind tab +forward",                           DOOM1AND2        },
    { "bind tab +freelook",                          DOOM1AND2        },
    { "bind tab +grid",                              DOOM1AND2        },
    { "bind tab +jump",                              DOOM1AND2        },
    { "bind tab +left",                              DOOM1AND2        },
    { "bind tab +mark",                              DOOM1AND2        },
    { "bind tab +maxzoom",                           DOOM1AND2        },
    { "bind tab +menu",                              DOOM1AND2        },
    { "bind tab +nextweapon",                        DOOM1AND2        },
    { "bind tab +prevweapon",                        DOOM1AND2        },
    { "bind tab +right",                             DOOM1AND2        },
    { "bind tab +rotatemode",                        DOOM1AND2        },
    { "bind tab +run",                               DOOM1AND2        },
    { "bind tab +screenshot",                        DOOM1AND2        },
    { "bind tab +strafe",                            DOOM1AND2        },
    { "bind tab +strafeleft",                        DOOM1AND2        },
    { "bind tab +straferight",                       DOOM1AND2        },
    { "bind tab +use",                               DOOM1AND2        },
    { "bind tab +weapon1",                           DOOM1AND2        },
    { "bind tab +weapon2",                           DOOM1AND2        },
    { "bind tab +weapon3",                           DOOM1AND2        },
    { "bind tab +weapon4",                           DOOM1AND2        },
    { "bind tab +weapon5",                           DOOM1AND2        },
    { "bind tab +weapon6",                           DOOM1AND2        },
    { "bind tab +weapon7",                           DOOM1AND2        },
    { "bind tab +zoomin",                            DOOM1AND2        },
    { "bind tab +zoomout",                           DOOM1AND2        },
    { "bind tilde ",                                 DOOM1AND2        },
    { "bind tilde +alwaysrun",                       DOOM1AND2        },
    { "bind tilde +automap",                         DOOM1AND2        },
    { "bind tilde +back",                            DOOM1AND2        },
    { "bind tilde +clearmark",                       DOOM1AND2        },
    { "bind tilde +console",                         DOOM1AND2        },
    { "bind tilde +fire",                            DOOM1AND2        },
    { "bind tilde +followmode",                      DOOM1AND2        },
    { "bind tilde +forward",                         DOOM1AND2        },
    { "bind tilde +freelook",                        DOOM1AND2        },
    { "bind tilde +grid",                            DOOM1AND2        },
    { "bind tilde +jump",                            DOOM1AND2        },
    { "bind tilde +left",                            DOOM1AND2        },
    { "bind tilde +mark",                            DOOM1AND2        },
    { "bind tilde +maxzoom",                         DOOM1AND2        },
    { "bind tilde +menu",                            DOOM1AND2        },
    { "bind tilde +nextweapon",                      DOOM1AND2        },
    { "bind tilde +prevweapon",                      DOOM1AND2        },
    { "bind tilde +right",                           DOOM1AND2        },
    { "bind tilde +rotatemode",                      DOOM1AND2        },
    { "bind tilde +run",                             DOOM1AND2        },
    { "bind tilde +screenshot",                      DOOM1AND2        },
    { "bind tilde +strafe",                          DOOM1AND2        },
    { "bind tilde +strafeleft",                      DOOM1AND2        },
    { "bind tilde +straferight",                     DOOM1AND2        },
    { "bind tilde +use",                             DOOM1AND2        },
    { "bind tilde +weapon1",                         DOOM1AND2        },
    { "bind tilde +weapon2",                         DOOM1AND2        },
    { "bind tilde +weapon3",                         DOOM1AND2        },
    { "bind tilde +weapon4",                         DOOM1AND2        },
    { "bind tilde +weapon5",                         DOOM1AND2        },
    { "bind tilde +weapon6",                         DOOM1AND2        },
    { "bind tilde +weapon7",                         DOOM1AND2        },
    { "bind tilde +zoomin",                          DOOM1AND2        },
    { "bind tilde +zoomout",                         DOOM1AND2        },
    { "bind touchpad ",                              DOOM1AND2        },
    { "bind touchpad +alwaysrun",                    DOOM1AND2        },
    { "bind touchpad +automap",                      DOOM1AND2        },
    { "bind touchpad +back",                         DOOM1AND2        },
    { "bind touchpad +clearmark",                    DOOM1AND2        },
    { "bind touchpad +console",                      DOOM1AND2        },
    { "bind touchpad +fire",                         DOOM1AND2        },
    { "bind touchpad +followmode",                   DOOM1AND2        },
    { "bind touchpad +forward",                      DOOM1AND2        },
    { "bind touchpad +freelook",                     DOOM1AND2        },
    { "bind touchpad +grid",                         DOOM1AND2        },
    { "bind touchpad +jump",                         DOOM1AND2        },
    { "bind touchpad +left",                         DOOM1AND2        },
    { "bind touchpad +mark",                         DOOM1AND2        },
    { "bind touchpad +maxzoom",                      DOOM1AND2        },
    { "bind touchpad +menu",                         DOOM1AND2        },
    { "bind touchpad +nextweapon",                   DOOM1AND2        },
    { "bind touchpad +prevweapon",                   DOOM1AND2        },
    { "bind touchpad +right",                        DOOM1AND2        },
    { "bind touchpad +rotatemode",                   DOOM1AND2        },
    { "bind touchpad +run",                          DOOM1AND2        },
    { "bind touchpad +strafe",                       DOOM1AND2        },
    { "bind touchpad +strafeleft",                   DOOM1AND2        },
    { "bind touchpad +straferight",                  DOOM1AND2        },
    { "bind touchpad +use",                          DOOM1AND2        },
    { "bind touchpad +weapon1",                      DOOM1AND2        },
    { "bind touchpad +weapon2",                      DOOM1AND2        },
    { "bind touchpad +weapon3",                      DOOM1AND2        },
    { "bind touchpad +weapon4",                      DOOM1AND2        },
    { "bind touchpad +weapon5",                      DOOM1AND2        },
    { "bind touchpad +weapon6",                      DOOM1AND2        },
    { "bind touchpad +weapon7",                      DOOM1AND2        },
    { "bind touchpad +zoomin",                       DOOM1AND2        },
    { "bind touchpad +zoomout",                      DOOM1AND2        },
    { "bind u +alwaysrun",                           DOOM1AND2        },
    { "bind u +automap",                             DOOM1AND2        },
    { "bind u +back",                                DOOM1AND2        },
    { "bind u +clearmark",                           DOOM1AND2        },
    { "bind u +console",                             DOOM1AND2        },
    { "bind u +fire",                                DOOM1AND2        },
    { "bind u +followmode",                          DOOM1AND2        },
    { "bind u +forward",                             DOOM1AND2        },
    { "bind u +freelook",                            DOOM1AND2        },
    { "bind u +grid",                                DOOM1AND2        },
    { "bind u +jump",                                DOOM1AND2        },
    { "bind u +left",                                DOOM1AND2        },
    { "bind u +mark",                                DOOM1AND2        },
    { "bind u +maxzoom",                             DOOM1AND2        },
    { "bind u +menu",                                DOOM1AND2        },
    { "bind u +nextweapon",                          DOOM1AND2        },
    { "bind u +prevweapon",                          DOOM1AND2        },
    { "bind u +right",                               DOOM1AND2        },
    { "bind u +rotatemode",                          DOOM1AND2        },
    { "bind u +run",                                 DOOM1AND2        },
    { "bind u +screenshot",                          DOOM1AND2        },
    { "bind u +strafe",                              DOOM1AND2        },
    { "bind u +strafeleft",                          DOOM1AND2        },
    { "bind u +straferight",                         DOOM1AND2        },
    { "bind u +use",                                 DOOM1AND2        },
    { "bind u +weapon1",                             DOOM1AND2        },
    { "bind u +weapon2",                             DOOM1AND2        },
    { "bind u +weapon3",                             DOOM1AND2        },
    { "bind u +weapon4",                             DOOM1AND2        },
    { "bind u +weapon5",                             DOOM1AND2        },
    { "bind u +weapon6",                             DOOM1AND2        },
    { "bind u +weapon7",                             DOOM1AND2        },
    { "bind u +zoomin",                              DOOM1AND2        },
    { "bind u +zoomout",                             DOOM1AND2        },
    { "bind up ",                                    DOOM1AND2        },
    { "bind up +alwaysrun",                          DOOM1AND2        },
    { "bind up +automap",                            DOOM1AND2        },
    { "bind up +back",                               DOOM1AND2        },
    { "bind up +clearmark",                          DOOM1AND2        },
    { "bind up +console",                            DOOM1AND2        },
    { "bind up +fire",                               DOOM1AND2        },
    { "bind up +followmode",                         DOOM1AND2        },
    { "bind up +forward",                            DOOM1AND2        },
    { "bind up +freelook",                           DOOM1AND2        },
    { "bind up +grid",                               DOOM1AND2        },
    { "bind up +jump",                               DOOM1AND2        },
    { "bind up +left",                               DOOM1AND2        },
    { "bind up +mark",                               DOOM1AND2        },
    { "bind up +maxzoom",                            DOOM1AND2        },
    { "bind up +menu",                               DOOM1AND2        },
    { "bind up +nextweapon",                         DOOM1AND2        },
    { "bind up +prevweapon",                         DOOM1AND2        },
    { "bind up +right",                              DOOM1AND2        },
    { "bind up +rotatemode",                         DOOM1AND2        },
    { "bind up +run",                                DOOM1AND2        },
    { "bind up +screenshot",                         DOOM1AND2        },
    { "bind up +strafe",                             DOOM1AND2        },
    { "bind up +strafeleft",                         DOOM1AND2        },
    { "bind up +straferight",                        DOOM1AND2        },
    { "bind up +use",                                DOOM1AND2        },
    { "bind up +weapon1",                            DOOM1AND2        },
    { "bind up +weapon2",                            DOOM1AND2        },
    { "bind up +weapon3",                            DOOM1AND2        },
    { "bind up +weapon4",                            DOOM1AND2        },
    { "bind up +weapon5",                            DOOM1AND2        },
    { "bind up +weapon6",                            DOOM1AND2        },
    { "bind up +weapon7",                            DOOM1AND2        },
    { "bind up +zoomin",                             DOOM1AND2        },
    { "bind up +zoomout",                            DOOM1AND2        },
    { "bind v +alwaysrun",                           DOOM1AND2        },
    { "bind v +automap",                             DOOM1AND2        },
    { "bind v +back",                                DOOM1AND2        },
    { "bind v +clearmark",                           DOOM1AND2        },
    { "bind v +console",                             DOOM1AND2        },
    { "bind v +fire",                                DOOM1AND2        },
    { "bind v +followmode",                          DOOM1AND2        },
    { "bind v +forward",                             DOOM1AND2        },
    { "bind v +freelook",                            DOOM1AND2        },
    { "bind v +grid",                                DOOM1AND2        },
    { "bind v +jump",                                DOOM1AND2        },
    { "bind v +left",                                DOOM1AND2        },
    { "bind v +mark",                                DOOM1AND2        },
    { "bind v +maxzoom",                             DOOM1AND2        },
    { "bind v +menu",                                DOOM1AND2        },
    { "bind v +nextweapon",                          DOOM1AND2        },
    { "bind v +prevweapon",                          DOOM1AND2        },
    { "bind v +right",                               DOOM1AND2        },
    { "bind v +rotatemode",                          DOOM1AND2        },
    { "bind v +run",                                 DOOM1AND2        },
    { "bind v +screenshot",                          DOOM1AND2        },
    { "bind v +strafe",                              DOOM1AND2        },
    { "bind v +strafeleft",                          DOOM1AND2        },
    { "bind v +straferight",                         DOOM1AND2        },
    { "bind v +use",                                 DOOM1AND2        },
    { "bind v +weapon1",                             DOOM1AND2        },
    { "bind v +weapon2",                             DOOM1AND2        },
    { "bind v +weapon3",                             DOOM1AND2        },
    { "bind v +weapon4",                             DOOM1AND2        },
    { "bind v +weapon5",                             DOOM1AND2        },
    { "bind v +weapon6",                             DOOM1AND2        },
    { "bind v +weapon7",                             DOOM1AND2        },
    { "bind v +zoomin",                              DOOM1AND2        },
    { "bind v +zoomout",                             DOOM1AND2        },
    { "bind w +alwaysrun",                           DOOM1AND2        },
    { "bind w +automap",                             DOOM1AND2        },
    { "bind w +back",                                DOOM1AND2        },
    { "bind w +clearmark",                           DOOM1AND2        },
    { "bind w +console",                             DOOM1AND2        },
    { "bind w +fire",                                DOOM1AND2        },
    { "bind w +followmode",                          DOOM1AND2        },
    { "bind w +forward",                             DOOM1AND2        },
    { "bind w +freelook",                            DOOM1AND2        },
    { "bind w +grid",                                DOOM1AND2        },
    { "bind w +jump",                                DOOM1AND2        },
    { "bind w +left",                                DOOM1AND2        },
    { "bind w +mark",                                DOOM1AND2        },
    { "bind w +maxzoom",                             DOOM1AND2        },
    { "bind w +menu",                                DOOM1AND2        },
    { "bind w +nextweapon",                          DOOM1AND2        },
    { "bind w +prevweapon",                          DOOM1AND2        },
    { "bind w +right",                               DOOM1AND2        },
    { "bind w +rotatemode",                          DOOM1AND2        },
    { "bind w +run",                                 DOOM1AND2        },
    { "bind w +screenshot",                          DOOM1AND2        },
    { "bind w +strafe",                              DOOM1AND2        },
    { "bind w +strafeleft",                          DOOM1AND2        },
    { "bind w +straferight",                         DOOM1AND2        },
    { "bind w +use",                                 DOOM1AND2        },
    { "bind w +weapon1",                             DOOM1AND2        },
    { "bind w +weapon2",                             DOOM1AND2        },
    { "bind w +weapon3",                             DOOM1AND2        },
    { "bind w +weapon4",                             DOOM1AND2        },
    { "bind w +weapon5",                             DOOM1AND2        },
    { "bind w +weapon6",                             DOOM1AND2        },
    { "bind w +weapon7",                             DOOM1AND2        },
    { "bind w +zoomin",                              DOOM1AND2        },
    { "bind w +zoomout",                             DOOM1AND2        },
    { "bind wheeldown ",                             DOOM1AND2        },
    { "bind wheeldown +nextweapon",                  DOOM1AND2        },
    { "bind wheeldown +prevweapon",                  DOOM1AND2        },
    { "bind wheelup ",                               DOOM1AND2        },
    { "bind wheelup +nextweapon",                    DOOM1AND2        },
    { "bind wheelup +prevweapon",                    DOOM1AND2        },
    { "bind x +alwaysrun",                           DOOM1AND2        },
    { "bind x +automap",                             DOOM1AND2        },
    { "bind x +back",                                DOOM1AND2        },
    { "bind x +clearmark",                           DOOM1AND2        },
    { "bind x +console",                             DOOM1AND2        },
    { "bind x +fire",                                DOOM1AND2        },
    { "bind x +followmode",                          DOOM1AND2        },
    { "bind x +forward",                             DOOM1AND2        },
    { "bind x +freelook",                            DOOM1AND2        },
    { "bind x +grid",                                DOOM1AND2        },
    { "bind x +jump",                                DOOM1AND2        },
    { "bind x +left",                                DOOM1AND2        },
    { "bind x +mark",                                DOOM1AND2        },
    { "bind x +maxzoom",                             DOOM1AND2        },
    { "bind x +menu",                                DOOM1AND2        },
    { "bind x +nextweapon",                          DOOM1AND2        },
    { "bind x +prevweapon",                          DOOM1AND2        },
    { "bind x +right",                               DOOM1AND2        },
    { "bind x +rotatemode",                          DOOM1AND2        },
    { "bind x +run",                                 DOOM1AND2        },
    { "bind x +screenshot",                          DOOM1AND2        },
    { "bind x +strafe",                              DOOM1AND2        },
    { "bind x +strafeleft",                          DOOM1AND2        },
    { "bind x +straferight",                         DOOM1AND2        },
    { "bind x +use",                                 DOOM1AND2        },
    { "bind x +weapon1",                             DOOM1AND2        },
    { "bind x +weapon2",                             DOOM1AND2        },
    { "bind x +weapon3",                             DOOM1AND2        },
    { "bind x +weapon4",                             DOOM1AND2        },
    { "bind x +weapon5",                             DOOM1AND2        },
    { "bind x +weapon6",                             DOOM1AND2        },
    { "bind x +weapon7",                             DOOM1AND2        },
    { "bind x +zoomin",                              DOOM1AND2        },
    { "bind x +zoomout",                             DOOM1AND2        },
    { "bind y +alwaysrun",                           DOOM1AND2        },
    { "bind y +automap",                             DOOM1AND2        },
    { "bind y +back",                                DOOM1AND2        },
    { "bind y +clearmark",                           DOOM1AND2        },
    { "bind y +console",                             DOOM1AND2        },
    { "bind y +fire",                                DOOM1AND2        },
    { "bind y +followmode",                          DOOM1AND2        },
    { "bind y +forward",                             DOOM1AND2        },
    { "bind y +freelook",                            DOOM1AND2        },
    { "bind y +grid",                                DOOM1AND2        },
    { "bind y +jump",                                DOOM1AND2        },
    { "bind y +left",                                DOOM1AND2        },
    { "bind y +mark",                                DOOM1AND2        },
    { "bind y +maxzoom",                             DOOM1AND2        },
    { "bind y +menu",                                DOOM1AND2        },
    { "bind y +nextweapon",                          DOOM1AND2        },
    { "bind y +prevweapon",                          DOOM1AND2        },
    { "bind y +right",                               DOOM1AND2        },
    { "bind y +rotatemode",                          DOOM1AND2        },
    { "bind y +run",                                 DOOM1AND2        },
    { "bind y +screenshot",                          DOOM1AND2        },
    { "bind y +strafe",                              DOOM1AND2        },
    { "bind y +strafeleft",                          DOOM1AND2        },
    { "bind y +straferight",                         DOOM1AND2        },
    { "bind y +use",                                 DOOM1AND2        },
    { "bind y +weapon1",                             DOOM1AND2        },
    { "bind y +weapon2",                             DOOM1AND2        },
    { "bind y +weapon3",                             DOOM1AND2        },
    { "bind y +weapon4",                             DOOM1AND2        },
    { "bind y +weapon5",                             DOOM1AND2        },
    { "bind y +weapon6",                             DOOM1AND2        },
    { "bind y +weapon7",                             DOOM1AND2        },
    { "bind y +zoomin",                              DOOM1AND2        },
    { "bind y +zoomout",                             DOOM1AND2        },
    { "bind z +alwaysrun",                           DOOM1AND2        },
    { "bind z +automap",                             DOOM1AND2        },
    { "bind z +back",                                DOOM1AND2        },
    { "bind z +clearmark",                           DOOM1AND2        },
    { "bind z +console",                             DOOM1AND2        },
    { "bind z +fire",                                DOOM1AND2        },
    { "bind z +followmode",                          DOOM1AND2        },
    { "bind z +forward",                             DOOM1AND2        },
    { "bind z +freelook",                            DOOM1AND2        },
    { "bind z +grid",                                DOOM1AND2        },
    { "bind z +jump",                                DOOM1AND2        },
    { "bind z +left",                                DOOM1AND2        },
    { "bind z +mark",                                DOOM1AND2        },
    { "bind z +maxzoom",                             DOOM1AND2        },
    { "bind z +menu",                                DOOM1AND2        },
    { "bind z +nextweapon",                          DOOM1AND2        },
    { "bind z +prevweapon",                          DOOM1AND2        },
    { "bind z +right",                               DOOM1AND2        },
    { "bind z +rotatemode",                          DOOM1AND2        },
    { "bind z +run",                                 DOOM1AND2        },
    { "bind z +screenshot",                          DOOM1AND2        },
    { "bind z +strafe",                              DOOM1AND2        },
    { "bind z +strafeleft",                          DOOM1AND2        },
    { "bind z +straferight",                         DOOM1AND2        },
    { "bind z +use",                                 DOOM1AND2        },
    { "bind z +weapon1",                             DOOM1AND2        },
    { "bind z +weapon2",                             DOOM1AND2        },
    { "bind z +weapon3",                             DOOM1AND2        },
    { "bind z +weapon4",                             DOOM1AND2        },
    { "bind z +weapon5",                             DOOM1AND2        },
    { "bind z +weapon6",                             DOOM1AND2        },
    { "bind z +weapon7",                             DOOM1AND2        },
    { "bind z +zoomin",                              DOOM1AND2        },
    { "bind z +zoomout",                             DOOM1AND2        },
    { "bindlist",                                    DOOM1AND2        },
    { "centerweapon ",                               DOOM1AND2        },
    { "centerweapon off",                            DOOM1AND2        },
    { "centerweapon on",                             DOOM1AND2        },
    { "clear",                                       DOOM1AND2        },
    { "+clearmark",                                  DOOM1AND2        },
    { "cmdlist ",                                    DOOM1AND2        },
    { "condump ",                                    DOOM1AND2        },
    { "+console",                                    DOOM1AND2        },
    { "crosshair ",                                  DOOM1AND2        },
    { "crosshair cross",                             DOOM1AND2        },
    { "crosshair dot",                               DOOM1AND2        },
    { "crosshair none",                              DOOM1AND2        },
    { "crosshair off",                               DOOM1AND2        },
    { "crosshair on",                                DOOM1AND2        },
    { "crosshaircolor ",                             DOOM1AND2        },
    { "crosshaircolor 112",                          DOOM1AND2        },
    { "cvarlist ",                                   DOOM1AND2        },
    { "cvarlist am_*",                               DOOM1AND2        },
    { "cvarlist am_allmap*",                         DOOM1AND2        },
    { "cvarlist am_blue*",                           DOOM1AND2        },
    { "cvarlist am_grid*",                           DOOM1AND2        },
    { "cvarlist am_path*",                           DOOM1AND2        },
    { "cvarlist am_player*",                         DOOM1AND2        },
    { "cvarlist am_red*",                            DOOM1AND2        },
    { "cvarlist am_yellow*",                         DOOM1AND2        },
    { "cvarlist auto*",                              DOOM1AND2        },
    { "cvarlist joy_*",                              DOOM1AND2        },
    { "cvarlist joy_deadzone_*",                     DOOM1AND2        },
    { "cvarlist joy_rumble_*",                       DOOM1AND2        },
    { "cvarlist joy_sensitivity_*",                  DOOM1AND2        },
    { "cvarlist m_*",                                DOOM1AND2        },
    { "cvarlist player*",                            DOOM1AND2        },
    { "cvarlist r_*",                                DOOM1AND2        },
    { "cvarlist r_blood_*",                          DOOM1AND2        },
    { "cvarlist r_corpses_*",                        DOOM1AND2        },
    { "cvarlist r_fix*",                             DOOM1AND2        },
    { "cvarlist r_liquid_*",                         DOOM1AND2        },
    { "cvarlist r_shake_*",                          DOOM1AND2        },
    { "cvarlist s_*",                                DOOM1AND2        },
    { "cvarlist s_music*",                           DOOM1AND2        },
    { "cvarlist s_random*",                          DOOM1AND2        },
    { "cvarlist vid_*",                              DOOM1AND2        },
    { "cvarlist vid_scale*",                         DOOM1AND2        },
    { "cvarlist vid_window*",                        DOOM1AND2        },
    { "cvarlist weapon*",                            DOOM1AND2        },
    { "endgame",                                     DOOM1AND2        },
    { "english ",                                    DOOM1AND2        },
    { "english american",                            DOOM1AND2        },
    { "english british",                             DOOM1AND2        },
    { "episode ",                                    DOOM1AND2        },
    { "exec ",                                       DOOM1AND2        },
    { "exitmap",                                     DOOM1AND2        },
    { "expansion ",                                  DOOM2ONLY        },
    { "explode ",                                    DOOM1AND2        },
    { "explode barrels",                             DOOM1AND2        },
    { "explode missiles",                            DOOM1AND2        },
    { "facebackcolor ",                              DOOM1AND2        },
    { "fade ",                                       DOOM1AND2        },
    { "fade off",                                    DOOM1AND2        },
    { "fade on",                                     DOOM1AND2        },
    { "fastmonsters ",                               DOOM1AND2        },
    { "fastmonsters off",                            DOOM1AND2        },
    { "fastmonsters on",                             DOOM1AND2        },
    { "+fire",                                       DOOM1AND2        },
    { "+followmode",                                 DOOM1AND2        },
    { "+forward",                                    DOOM1AND2        },
    { "+freelook",                                   DOOM1AND2        },
    { "freelook ",                                   DOOM1AND2        },
    { "freelook off",                                DOOM1AND2        },
    { "freelook on",                                 DOOM1AND2        },
    { "freeze ",                                     DOOM1AND2        },
    { "freeze off",                                  DOOM1AND2        },
    { "freeze on",                                   DOOM1AND2        },
    { "gametime",                                    DOOM1AND2        },
    { "give ",                                       DOOM1AND2        },
    { "give all",                                    DOOM1AND2        },
    { "give ammo",                                   DOOM1AND2        },
    { "give armor",                                  DOOM1AND2        },
    { "give armorbonus",                             DOOM1AND2        },
    { "give backpack",                               DOOM1AND2        },
    { "give berserk",                                DOOM1AND2        },
    { "give bfg9000",                                DOOM1AND2        },
    { "give bluearmor",                              DOOM1AND2        },
    { "give bluekeycard",                            DOOM1AND2        },
    { "give blueskullkey",                           DOOM1AND2        },
    { "give boxofbullets",                           DOOM1AND2        },
    { "give boxofrockets",                           DOOM1AND2        },
    { "give boxofshells",                            DOOM1AND2        },
    { "give calamityblade",                          LEGACYOFRUSTONLY },
    { "give cellpack",                               DOOM1AND2        },
    { "give cells",                                  DOOM1AND2        },
    { "give chaingun",                               DOOM1AND2        },
    { "give chainsaw",                               DOOM1AND2        },
    { "give clip",                                   DOOM1AND2        },
    { "give computerareamap",                        DOOM1AND2        },
    { "give fuelcan",                                LEGACYOFRUSTONLY },
    { "give fueltank",                               LEGACYOFRUSTONLY },
    { "give greenarmor",                             DOOM1AND2        },
    { "give health",                                 DOOM1AND2        },
    { "give healthbonus",                            DOOM1AND2        },
    { "give incinerator",                            LEGACYOFRUSTONLY },
    { "give invulnerability",                        DOOM1AND2        },
    { "give keycards",                               DOOM1AND2        },
    { "give keys",                                   DOOM1AND2        },
    { "give lightamplificationvisor",                DOOM1AND2        },
    { "give medikit",                                DOOM1AND2        },
    { "give megasphere",                             DOOM2ONLY        },
    { "give partialinvisibility",                    DOOM1AND2        },
    { "give pistol",                                 DOOM1AND2        },
    { "give plasmarifle",                            DOOM1AND2        },
    { "give powerups",                               DOOM1AND2        },
    { "give radiationshieldingsuit",                 DOOM1AND2        },
    { "give redkeycard",                             DOOM1AND2        },
    { "give redskullkey",                            DOOM1AND2        },
    { "give rocket",                                 DOOM1AND2        },
    { "give rocketlauncher",                         DOOM1AND2        },
    { "give shells",                                 DOOM1AND2        },
    { "give shotgun",                                DOOM1AND2        },
    { "give skullkeys",                              DOOM1AND2        },
    { "give soulsphere",                             DOOM1AND2        },
    { "give stimpack",                               DOOM1AND2        },
    { "give supershotgun",                           DOOM2ONLY        },
    { "give weapons",                                DOOM1AND2        },
    { "give yellowkeycard",                          DOOM1AND2        },
    { "give yellowskullkey",                         DOOM1AND2        },
    { "god ",                                        DOOM1AND2        },
    { "god off",                                     DOOM1AND2        },
    { "god on",                                      DOOM1AND2        },
    { "+grid",                                       DOOM1AND2        },
    { "groupmessages ",                              DOOM1AND2        },
    { "groupmessages off",                           DOOM1AND2        },
    { "groupmessages on",                            DOOM1AND2        },
    { "health ",                                     DOOM1AND2        },
    { "health -99%",                                 DOOM1AND2        },
    { "health 0%",                                   DOOM1AND2        },
    { "health 100%",                                 DOOM1AND2        },
    { "health 200%",                                 DOOM1AND2        },
    { "if ",                                         DOOM1AND2        },
    { "if alwaysrun ",                               DOOM1AND2        },
    { "if alwaysrun off ",                           DOOM1AND2        },
    { "if alwaysrun off then ",                      DOOM1AND2        },
    { "if alwaysrun on ",                            DOOM1AND2        },
    { "if alwaysrun on then ",                       DOOM1AND2        },
    { "if am_allmapcdwallcolor ",                    DOOM1AND2        },
    { "if am_allmapcdwallcolor 106 ",                DOOM1AND2        },
    { "if am_allmapcdwallcolor 106 then",            DOOM1AND2        },
    { "if am_allmapfdwallcolor ",                    DOOM1AND2        },
    { "if am_allmapfdwallcolor 110 ",                DOOM1AND2        },
    { "if am_allmapfdwallcolor 110 then",            DOOM1AND2        },
    { "if am_allmapwallcolor ",                      DOOM1AND2        },
    { "if am_allmapwallcolor 108 ",                  DOOM1AND2        },
    { "if am_allmapwallcolor 108 then",              DOOM1AND2        },
    { "if am_antialiasing ",                         DOOM1AND2        },
    { "if am_antialiasing off ",                     DOOM1AND2        },
    { "if am_antialiasing off then ",                DOOM1AND2        },
    { "if am_antialiasing on ",                      DOOM1AND2        },
    { "if am_antialiasing on then ",                 DOOM1AND2        },
    { "if am_backcolor ",                            DOOM1AND2        },
    { "if am_backcolor 0 then ",                     DOOM1AND2        },
    { "if am_bloodsplatcolor ",                      DOOM1AND2        },
    { "if am_bloodsplatcolor 124 ",                  DOOM1AND2        },
    { "if am_bloodsplatcolor 124 then ",             DOOM1AND2        },
    { "if am_bluedoorcolor ",                        DOOM1AND2        },
    { "if am_bluedoorcolor 160 ",                    DOOM1AND2        },
    { "if am_bluedoorcolor 160 then",                DOOM1AND2        },
    { "if am_bluekeycolor ",                         DOOM1AND2        },
    { "if am_bluekeycolor 112 ",                     DOOM1AND2        },
    { "if am_bluekeycolor 112 then",                 DOOM1AND2        },
    { "if am_cdwallcolor ",                          DOOM1AND2        },
    { "if am_cdwallcolor 160 ",                      DOOM1AND2        },
    { "if am_cdwallcolor 160 then",                  DOOM1AND2        },
    { "if am_corpsecolor ",                          DOOM1AND2        },
    { "if am_corpsecolor 116 ",                      DOOM1AND2        },
    { "if am_corpsecolor 116 then ",                 DOOM1AND2        },
    { "if am_correctaspectratio ",                   DOOM1AND2        },
    { "if am_correctaspectratio off ",               DOOM1AND2        },
    { "if am_correctaspectratio off then ",          DOOM1AND2        },
    { "if am_correctaspectratio on ",                DOOM1AND2        },
    { "if am_correctaspectratio on then ",           DOOM1AND2        },
    { "if am_crosshaircolor ",                       DOOM1AND2        },
    { "if am_crosshaircolor 4 then ",                DOOM1AND2        },
    { "if am_display ",                              DOOM1AND2        },
    { "if am_display 1 then ",                       DOOM1AND2        },
    { "if am_dynamic ",                              DOOM1AND2        },
    { "if am_dynamic off ",                          DOOM1AND2        },
    { "if am_dynamic off then ",                     DOOM1AND2        },
    { "if am_dynamic on ",                           DOOM1AND2        },
    { "if am_dynamic on then ",                      DOOM1AND2        },
    { "if am_external ",                             DOOM1AND2        },
    { "if am_external off ",                         DOOM1AND2        },
    { "if am_external off then ",                    DOOM1AND2        },
    { "if am_external on ",                          DOOM1AND2        },
    { "if am_external on then ",                     DOOM1AND2        },
    { "if am_fdwallcolor ",                          DOOM1AND2        },
    { "if am_fdwallcolor 64 ",                       DOOM1AND2        },
    { "if am_fdwallcolor 64 then",                   DOOM1AND2        },
    { "if am_followmode ",                           DOOM1AND2        },
    { "if am_followmode off ",                       DOOM1AND2        },
    { "if am_followmode off then ",                  DOOM1AND2        },
    { "if am_followmode on ",                        DOOM1AND2        },
    { "if am_followmode on then ",                   DOOM1AND2        },
    { "if am_grid ",                                 DOOM1AND2        },
    { "if am_grid off ",                             DOOM1AND2        },
    { "if am_grid off then ",                        DOOM1AND2        },
    { "if am_grid on ",                              DOOM1AND2        },
    { "if am_grid on then ",                         DOOM1AND2        },
    { "if am_gridcolor ",                            DOOM1AND2        },
    { "if am_gridcolor 111 ",                        DOOM1AND2        },
    { "if am_gridcolor 111 then",                    DOOM1AND2        },
    { "if am_gridsize ",                             DOOM1AND2        },
    { "if am_gridsize 128x128 ",                     DOOM1AND2        },
    { "if am_gridsize 128x128 then ",                DOOM1AND2        },
    { "if am_markcolor ",                            DOOM1AND2        },
    { "if am_markcolor 89 ",                         DOOM1AND2        },
    { "if am_markcolor 89 then ",                    DOOM1AND2        },
    { "if am_path ",                                 DOOM1AND2        },
    { "if am_path off ",                             DOOM1AND2        },
    { "if am_path off then ",                        DOOM1AND2        },
    { "if am_path on ",                              DOOM1AND2        },
    { "if am_path on then ",                         DOOM1AND2        },
    { "if am_pathcolor ",                            DOOM1AND2        },
    { "if am_pathcolor 89 ",                         DOOM1AND2        },
    { "if am_pathcolor 89 then ",                    DOOM1AND2        },
    { "if am_playercolor ",                          DOOM1AND2        },
    { "if am_playercolor 4 then ",                   DOOM1AND2        },
    { "if am_playerstats ",                          DOOM1AND2        },
    { "if am_playerstats off ",                      DOOM1AND2        },
    { "if am_playerstats off then ",                 DOOM1AND2        },
    { "if am_playerstats on ",                       DOOM1AND2        },
    { "if am_playerstats on then ",                  DOOM1AND2        },
    { "if am_playerstatscolor ",                     DOOM1AND2        },
    { "if am_playerstatscolor 4 ",                   DOOM1AND2        },
    { "if am_playerstatscolor 4 then",               DOOM1AND2        },
    { "if am_reddoorcolor ",                         DOOM1AND2        },
    { "if am_reddoorcolor 160 ",                     DOOM1AND2        },
    { "if am_reddoorcolor 160 then",                 DOOM1AND2        },
    { "if am_redkeycolor ",                          DOOM1AND2        },
    { "if am_redkeycolor 112 ",                      DOOM1AND2        },
    { "if am_redkeycolor 112 then",                  DOOM1AND2        },
    { "if am_rotatemode ",                           DOOM1AND2        },
    { "if am_rotatemode off ",                       DOOM1AND2        },
    { "if am_rotatemode off then ",                  DOOM1AND2        },
    { "if am_rotatemode on ",                        DOOM1AND2        },
    { "if am_rotatemode on then ",                   DOOM1AND2        },
    { "if am_teleportercolor ",                      DOOM1AND2        },
    { "if am_teleportercolor 184 ",                  DOOM1AND2        },
    { "if am_teleportercolor 184 then ",             DOOM1AND2        },
    { "if am_thingcolor ",                           DOOM1AND2        },
    { "if am_thingcolor 112 ",                       DOOM1AND2        },
    { "if am_thingcolor 112 then ",                  DOOM1AND2        },
    { "if am_tswallcolor ",                          DOOM1AND2        },
    { "if am_tswallcolor 104 ",                      DOOM1AND2        },
    { "if am_tswallcolor 104 then ",                 DOOM1AND2        },
    { "if am_wallcolor ",                            DOOM1AND2        },
    { "if am_wallcolor 176 ",                        DOOM1AND2        },
    { "if am_wallcolor 176 then ",                   DOOM1AND2        },
    { "if am_yellowdoorcolor ",                      DOOM1AND2        },
    { "if am_yellowdoorcolor 160 ",                  DOOM1AND2        },
    { "if am_yellowdoorcolor 160 then",              DOOM1AND2        },
    { "if am_yellowkeycolor ",                       DOOM1AND2        },
    { "if am_yellowkeycolor 112 ",                   DOOM1AND2        },
    { "if am_yellowkeycolor 112 then",               DOOM1AND2        },
    { "if ammo ",                                    DOOM1AND2        },
    { "if ammo 50 ",                                 DOOM1AND2        },
    { "if ammo 50 then ",                            DOOM1AND2        },
    { "if animatedstats ",                           DOOM1AND2        },
    { "if animatedstats off ",                       DOOM1AND2        },
    { "if animatedstats off then ",                  DOOM1AND2        },
    { "if animatedstats on ",                        DOOM1AND2        },
    { "if animatedstats on then ",                   DOOM1AND2        },
    { "if armor ",                                   DOOM1AND2        },
    { "if armor 0% ",                                DOOM1AND2        },
    { "if armor 0% then ",                           DOOM1AND2        },
    { "if armor 100% ",                              DOOM1AND2        },
    { "if armor 100% then ",                         DOOM1AND2        },
    { "if armor 200% ",                              DOOM1AND2        },
    { "if armor 200% then ",                         DOOM1AND2        },
    { "if armortype ",                               DOOM1AND2        },
    { "if armortype blue ",                          DOOM1AND2        },
    { "if armortype blue then ",                     DOOM1AND2        },
    { "if armortype green ",                         DOOM1AND2        },
    { "if armortype green then ",                    DOOM1AND2        },
    { "if armortype none ",                          DOOM1AND2        },
    { "if armortype none then ",                     DOOM1AND2        },
    { "if autoaim ",                                 DOOM1AND2        },
    { "if autoaim off ",                             DOOM1AND2        },
    { "if autoaim off then ",                        DOOM1AND2        },
    { "if autoaim on ",                              DOOM1AND2        },
    { "if autoaim on then ",                         DOOM1AND2        },
    { "if autoload ",                                DOOM1AND2        },
    { "if autoload off ",                            DOOM1AND2        },
    { "if autoload off then ",                       DOOM1AND2        },
    { "if autoload on ",                             DOOM1AND2        },
    { "if autoload on then ",                        DOOM1AND2        },
    { "if autosave ",                                DOOM1AND2        },
    { "if autosave off ",                            DOOM1AND2        },
    { "if autosave off then ",                       DOOM1AND2        },
    { "if autosave on ",                             DOOM1AND2        },
    { "if autosave on then ",                        DOOM1AND2        },
    { "if autotilt ",                                DOOM1AND2        },
    { "if autotilt off ",                            DOOM1AND2        },
    { "if autotilt off then ",                       DOOM1AND2        },
    { "if autotilt on ",                             DOOM1AND2        },
    { "if autotilt on then ",                        DOOM1AND2        },
    { "if autouse ",                                 DOOM1AND2        },
    { "if autouse off ",                             DOOM1AND2        },
    { "if autouse off then ",                        DOOM1AND2        },
    { "if autouse on ",                              DOOM1AND2        },
    { "if autouse on then ",                         DOOM1AND2        },
    { "if centerweapon ",                            DOOM1AND2        },
    { "if centerweapon off ",                        DOOM1AND2        },
    { "if centerweapon off then ",                   DOOM1AND2        },
    { "if centerweapon on ",                         DOOM1AND2        },
    { "if centerweapon on then ",                    DOOM1AND2        },
    { "if crosshair ",                               DOOM1AND2        },
    { "if crosshair cross ",                         DOOM1AND2        },
    { "if crosshair cross then ",                    DOOM1AND2        },
    { "if crosshair dot ",                           DOOM1AND2        },
    { "if crosshair dot then ",                      DOOM1AND2        },
    { "if crosshair none ",                          DOOM1AND2        },
    { "if crosshair none then ",                     DOOM1AND2        },
    { "if crosshair off ",                           DOOM1AND2        },
    { "if crosshair off then ",                      DOOM1AND2        },
    { "if crosshair on ",                            DOOM1AND2        },
    { "if crosshair on then ",                       DOOM1AND2        },
    { "if crosshaircolor ",                          DOOM1AND2        },
    { "if crosshaircolor 112 ",                      DOOM1AND2        },
    { "if crosshaircolor 112 then ",                 DOOM1AND2        },
    { "if english ",                                 DOOM1AND2        },
    { "if english american ",                        DOOM1AND2        },
    { "if english american then ",                   DOOM1AND2        },
    { "if english british ",                         DOOM1AND2        },
    { "if english british then ",                    DOOM1AND2        },
    { "if episode ",                                 DOOM1ONLY        },
    { "if episode 1 then ",                          DOOM1ONLY        },
    { "if expansion ",                               DOOM2ONLY        },
    { "if expansion 1 then ",                        DOOM2ONLY        },
    { "if facebackcolor ",                           DOOM1AND2        },
    { "if facebackcolor 5 then ",                    DOOM1AND2        },
    { "if fade ",                                    DOOM1AND2        },
    { "if fade off ",                                DOOM1AND2        },
    { "if fade off then ",                           DOOM1AND2        },
    { "if fade on ",                                 DOOM1AND2        },
    { "if fade on then ",                            DOOM1AND2        },
    { "if fastmonsters ",                            DOOM1AND2        },
    { "if fastmonsters off ",                        DOOM1AND2        },
    { "if fastmonsters off then ",                   DOOM1AND2        },
    { "if fastmonsters on ",                         DOOM1AND2        },
    { "if fastmonsters on then ",                    DOOM1AND2        },
    { "if flashkeys ",                               DOOM1AND2        },
    { "if flashkeys off ",                           DOOM1AND2        },
    { "if flashkeys off then ",                      DOOM1AND2        },
    { "if flashkeys on ",                            DOOM1AND2        },
    { "if flashkeys on then ",                       DOOM1AND2        },
    { "if freelook ",                                DOOM1AND2        },
    { "if freelook off ",                            DOOM1AND2        },
    { "if freelook off then ",                       DOOM1AND2        },
    { "if freelook on ",                             DOOM1AND2        },
    { "if freelook on then ",                        DOOM1AND2        },
    { "if freeze ",                                  DOOM1AND2        },
    { "if freeze off ",                              DOOM1AND2        },
    { "if freeze off then ",                         DOOM1AND2        },
    { "if freeze on ",                               DOOM1AND2        },
    { "if freeze on then ",                          DOOM1AND2        },
    { "if gametime ",                                DOOM1AND2        },
    { "if god ",                                     DOOM1AND2        },
    { "if god off ",                                 DOOM1AND2        },
    { "if god off then ",                            DOOM1AND2        },
    { "if god on ",                                  DOOM1AND2        },
    { "if god on then ",                             DOOM1AND2        },
    { "if groupmessages ",                           DOOM1AND2        },
    { "if groupmessages off ",                       DOOM1AND2        },
    { "if groupmessages off then ",                  DOOM1AND2        },
    { "if groupmessages on ",                        DOOM1AND2        },
    { "if groupmessages on then ",                   DOOM1AND2        },
    { "if health ",                                  DOOM1AND2        },
    { "if health -99% ",                             DOOM1AND2        },
    { "if health -99% then ",                        DOOM1AND2        },
    { "if health 0% ",                               DOOM1AND2        },
    { "if health 0% then ",                          DOOM1AND2        },
    { "if health 100% ",                             DOOM1AND2        },
    { "if health 100% then ",                        DOOM1AND2        },
    { "if health 200% ",                             DOOM1AND2        },
    { "if health 200% then ",                        DOOM1AND2        },
    { "if infighting ",                              DOOM1AND2        },
    { "if infighting off ",                          DOOM1AND2        },
    { "if infighting off then ",                     DOOM1AND2        },
    { "if infighting on ",                           DOOM1AND2        },
    { "if infighting on then ",                      DOOM1AND2        },
    { "if infiniteammo ",                            DOOM1AND2        },
    { "if infiniteammo off ",                        DOOM1AND2        },
    { "if infiniteammo off then ",                   DOOM1AND2        },
    { "if infiniteammo on ",                         DOOM1AND2        },
    { "if infiniteammo on then ",                    DOOM1AND2        },
    { "if infiniteheight ",                          DOOM1AND2        },
    { "if infiniteheight off ",                      DOOM1AND2        },
    { "if infiniteheight off then ",                 DOOM1AND2        },
    { "if infiniteheight on ",                       DOOM1AND2        },
    { "if infiniteheight on then ",                  DOOM1AND2        },
    { "if joy_analog ",                              DOOM1AND2        },
    { "if joy_analog off ",                          DOOM1AND2        },
    { "if joy_analog off then ",                     DOOM1AND2        },
    { "if joy_analog on ",                           DOOM1AND2        },
    { "if joy_analog on then ",                      DOOM1AND2        },
    { "if joy_deadzone_left ",                       DOOM1AND2        },
    { "if joy_deadzone_left 0% ",                    DOOM1AND2        },
    { "if joy_deadzone_left 0% then ",               DOOM1AND2        },
    { "if joy_deadzone_left 15% ",                   DOOM1AND2        },
    { "if joy_deadzone_left 15% then ",              DOOM1AND2        },
    { "if joy_deadzone_left 30% ",                   DOOM1AND2        },
    { "if joy_deadzone_left 30% then ",              DOOM1AND2        },
    { "if joy_deadzone_right ",                      DOOM1AND2        },
    { "if joy_deadzone_right 0% ",                   DOOM1AND2        },
    { "if joy_deadzone_right 0% then ",              DOOM1AND2        },
    { "if joy_deadzone_right 15% ",                  DOOM1AND2        },
    { "if joy_deadzone_right 15% then ",             DOOM1AND2        },
    { "if joy_deadzone_right 30% ",                  DOOM1AND2        },
    { "if joy_deadzone_right 30% then ",             DOOM1AND2        },
    { "if joy_invertyaxis ",                         DOOM1AND2        },
    { "if joy_invertyaxis off ",                     DOOM1AND2        },
    { "if joy_invertyaxis off then ",                DOOM1AND2        },
    { "if joy_invertyaxis on ",                      DOOM1AND2        },
    { "if joy_invertyaxis on then ",                 DOOM1AND2        },
    { "if joy_rumble_barrels ",                      DOOM1AND2        },
    { "if joy_rumble_barrels 0% ",                   DOOM1AND2        },
    { "if joy_rumble_barrels 0% then ",              DOOM1AND2        },
    { "if joy_rumble_barrels 100% ",                 DOOM1AND2        },
    { "if joy_rumble_barrels 100% then ",            DOOM1AND2        },
    { "if joy_rumble_barrels 200% ",                 DOOM1AND2        },
    { "if joy_rumble_barrels 200% then ",            DOOM1AND2        },
    { "if joy_rumble_damage ",                       DOOM1AND2        },
    { "if joy_rumble_damage 0% ",                    DOOM1AND2        },
    { "if joy_rumble_damage 0% then ",               DOOM1AND2        },
    { "if joy_rumble_damage 100% ",                  DOOM1AND2        },
    { "if joy_rumble_damage 100% then ",             DOOM1AND2        },
    { "if joy_rumble_damage 200% ",                  DOOM1AND2        },
    { "if joy_rumble_damage 200% then ",             DOOM1AND2        },
    { "if joy_rumble_fall ",                         DOOM1AND2        },
    { "if joy_rumble_fall off ",                     DOOM1AND2        },
    { "if joy_rumble_fall off then ",                DOOM1AND2        },
    { "if joy_rumble_fall on ",                      DOOM1AND2        },
    { "if joy_rumble_fall on then ",                 DOOM1AND2        },
    { "if joy_rumble_pickup ",                       DOOM1AND2        },
    { "if joy_rumble_pickup off ",                   DOOM1AND2        },
    { "if joy_rumble_pickup off then ",              DOOM1AND2        },
    { "if joy_rumble_pickup on ",                    DOOM1AND2        },
    { "if joy_rumble_pickup on then ",               DOOM1AND2        },
    { "if joy_rumble_weapons ",                      DOOM1AND2        },
    { "if joy_rumble_weapons 0% ",                   DOOM1AND2        },
    { "if joy_rumble_weapons 0% then ",              DOOM1AND2        },
    { "if joy_rumble_weapons 100% ",                 DOOM1AND2        },
    { "if joy_rumble_weapons 100% then ",            DOOM1AND2        },
    { "if joy_rumble_weapons 200% ",                 DOOM1AND2        },
    { "if joy_rumble_weapons 200% then ",            DOOM1AND2        },
    { "if joy_sensitivity_horizontal ",              DOOM1AND2        },
    { "if joy_sensitivity_horizontal 128 ",          DOOM1AND2        },
    { "if joy_sensitivity_horizontal 128 then ",     DOOM1AND2        },
    { "if joy_sensitivity_horizontal 64 ",           DOOM1AND2        },
    { "if joy_sensitivity_horizontal 64 then ",      DOOM1AND2        },
    { "if joy_sensitivity_vertical ",                DOOM1AND2        },
    { "if joy_sensitivity_vertical 128 ",            DOOM1AND2        },
    { "if joy_sensitivity_vertical 128 then ",       DOOM1AND2        },
    { "if joy_sensitivity_vertical 64 ",             DOOM1AND2        },
    { "if joy_sensitivity_vertical 64 then ",        DOOM1AND2        },
    { "if joy_swapthumbsticks ",                     DOOM1AND2        },
    { "if joy_swapthumbsticks off ",                 DOOM1AND2        },
    { "if joy_swapthumbsticks off then ",            DOOM1AND2        },
    { "if joy_swapthumbsticks on ",                  DOOM1AND2        },
    { "if joy_swapthumbsticks on then ",             DOOM1AND2        },
    { "if joy_thumbsticks ",                         DOOM1AND2        },
    { "if joy_thumbsticks 1 ",                       DOOM1AND2        },
    { "if joy_thumbsticks 1 then ",                  DOOM1AND2        },
    { "if joy_thumbsticks 2 ",                       DOOM1AND2        },
    { "if joy_thumbsticks 2 then ",                  DOOM1AND2        },
    { "if m_acceleration ",                          DOOM1AND2        },
    { "if m_acceleration off ",                      DOOM1AND2        },
    { "if m_acceleration off then ",                 DOOM1AND2        },
    { "if m_acceleration on ",                       DOOM1AND2        },
    { "if m_acceleration on then ",                  DOOM1AND2        },
    { "if m_doubleclick_use ",                       DOOM1AND2        },
    { "if m_doubleclick_use off ",                   DOOM1AND2        },
    { "if m_doubleclick_use off then ",              DOOM1AND2        },
    { "if m_doubleclick_use on ",                    DOOM1AND2        },
    { "if m_doubleclick_use on then ",               DOOM1AND2        },
    { "if m_invertyaxis ",                           DOOM1AND2        },
    { "if m_invertyaxis off ",                       DOOM1AND2        },
    { "if m_invertyaxis off then ",                  DOOM1AND2        },
    { "if m_invertyaxis on ",                        DOOM1AND2        },
    { "if m_invertyaxis on then ",                   DOOM1AND2        },
    { "if m_novertical ",                            DOOM1AND2        },
    { "if m_novertical off ",                        DOOM1AND2        },
    { "if m_novertical off then ",                   DOOM1AND2        },
    { "if m_novertical on ",                         DOOM1AND2        },
    { "if m_novertical on then ",                    DOOM1AND2        },
    { "if m_pointer ",                               DOOM1AND2        },
    { "if m_pointer off ",                           DOOM1AND2        },
    { "if m_pointer off then ",                      DOOM1AND2        },
    { "if m_pointer on ",                            DOOM1AND2        },
    { "if m_pointer on then ",                       DOOM1AND2        },
    { "if m_sensitivity ",                           DOOM1AND2        },
    { "if m_sensitivity 128 ",                       DOOM1AND2        },
    { "if m_sensitivity 128 then ",                  DOOM1AND2        },
    { "if m_sensitivity 16 ",                        DOOM1AND2        },
    { "if m_sensitivity 16 then ",                   DOOM1AND2        },
    { "if maptime ",                                 DOOM1AND2        },
    { "if melt ",                                    DOOM1AND2        },
    { "if melt off ",                                DOOM1AND2        },
    { "if melt off then ",                           DOOM1AND2        },
    { "if melt on ",                                 DOOM1AND2        },
    { "if melt on then ",                            DOOM1AND2        },
    { "if menuhighlight ",                           DOOM1AND2        },
    { "if menuhighlight off ",                       DOOM1AND2        },
    { "if menuhighlight off then ",                  DOOM1AND2        },
    { "if menuhighlight on ",                        DOOM1AND2        },
    { "if menuhighlight on then ",                   DOOM1AND2        },
    { "if menushadow ",                              DOOM1AND2        },
    { "if menushadow off ",                          DOOM1AND2        },
    { "if menushadow off then ",                     DOOM1AND2        },
    { "if menushadow on ",                           DOOM1AND2        },
    { "if menushadow on then ",                      DOOM1AND2        },
    { "if menuspin ",                                DOOM1AND2        },
    { "if menuspin off ",                            DOOM1AND2        },
    { "if menuspin off then ",                       DOOM1AND2        },
    { "if menuspin on ",                             DOOM1AND2        },
    { "if menuspin on then ",                        DOOM1AND2        },
    { "if messages ",                                DOOM1AND2        },
    { "if messages off ",                            DOOM1AND2        },
    { "if messages off then ",                       DOOM1AND2        },
    { "if messages on ",                             DOOM1AND2        },
    { "if messages on then ",                        DOOM1AND2        },
    { "if movebob ",                                 DOOM1AND2        },
    { "if movebob 0% ",                              DOOM1AND2        },
    { "if movebob 0% then ",                         DOOM1AND2        },
    { "if movebob 100% ",                            DOOM1AND2        },
    { "if movebob 100% then ",                       DOOM1AND2        },
    { "if movebob 75% ",                             DOOM1AND2        },
    { "if movebob 75% then ",                        DOOM1AND2        },
    { "if negativehealth ",                          DOOM1AND2        },
    { "if negativehealth off ",                      DOOM1AND2        },
    { "if negativehealth off then ",                 DOOM1AND2        },
    { "if negativehealth on ",                       DOOM1AND2        },
    { "if negativehealth on then ",                  DOOM1AND2        },
    { "if noclip ",                                  DOOM1AND2        },
    { "if noclip off ",                              DOOM1AND2        },
    { "if noclip off then ",                         DOOM1AND2        },
    { "if noclip on ",                               DOOM1AND2        },
    { "if noclip on then ",                          DOOM1AND2        },
    { "if nomonsters ",                              DOOM1AND2        },
    { "if nomonsters off ",                          DOOM1AND2        },
    { "if nomonsters off then ",                     DOOM1AND2        },
    { "if nomonsters on ",                           DOOM1AND2        },
    { "if nomonsters on then ",                      DOOM1AND2        },
    { "if notarget ",                                DOOM1AND2        },
    { "if notarget off ",                            DOOM1AND2        },
    { "if notarget off then ",                       DOOM1AND2        },
    { "if notarget on ",                             DOOM1AND2        },
    { "if notarget on then ",                        DOOM1AND2        },
    { "if obituaries ",                              DOOM1AND2        },
    { "if obituaries off ",                          DOOM1AND2        },
    { "if obituaries off then ",                     DOOM1AND2        },
    { "if obituaries on ",                           DOOM1AND2        },
    { "if obituaries on then ",                      DOOM1AND2        },
    { "if pistolstart ",                             DOOM1AND2        },
    { "if pistolstart off ",                         DOOM1AND2        },
    { "if pistolstart off then ",                    DOOM1AND2        },
    { "if pistolstart on ",                          DOOM1AND2        },
    { "if pistolstart on then ",                     DOOM1AND2        },
    { "if playergender ",                            DOOM1AND2        },
    { "if playergender female ",                     DOOM1AND2        },
    { "if playergender female then ",                DOOM1AND2        },
    { "if playergender male ",                       DOOM1AND2        },
    { "if playergender male then ",                  DOOM1AND2        },
    { "if playergender other ",                      DOOM1AND2        },
    { "if playergender other then ",                 DOOM1AND2        },
    { "if playername ",                              DOOM1AND2        },
    { "if playername \"\" ",                         DOOM1AND2        },
    { "if playername \"\" then ",                    DOOM1AND2        },
    { "if r_althud ",                                DOOM1AND2        },
    { "if r_althud off ",                            DOOM1AND2        },
    { "if r_althud off then ",                       DOOM1AND2        },
    { "if r_althud on ",                             DOOM1AND2        },
    { "if r_althud on then ",                        DOOM1AND2        },
    { "if r_antialiasing ",                          DOOM1AND2        },
    { "if r_antialiasing off ",                      DOOM1AND2        },
    { "if r_antialiasing off then ",                 DOOM1AND2        },
    { "if r_antialiasing on ",                       DOOM1AND2        },
    { "if r_antialiasing on then ",                  DOOM1AND2        },
    { "if r_berserkeffect ",                         DOOM1AND2        },
    { "if r_blood ",                                 DOOM1AND2        },
    { "if r_blood all ",                             DOOM1AND2        },
    { "if r_blood all then ",                        DOOM1AND2        },
    { "if r_blood green ",                           DOOM1AND2        },
    { "if r_blood green then ",                      DOOM1AND2        },
    { "if r_blood nofuzz ",                          DOOM1AND2        },
    { "if r_blood nofuzz then ",                     DOOM1AND2        },
    { "if r_blood none ",                            DOOM1AND2        },
    { "if r_blood none then ",                       DOOM1AND2        },
    { "if r_blood off ",                             DOOM1AND2        },
    { "if r_blood off then ",                        DOOM1AND2        },
    { "if r_blood on ",                              DOOM1AND2        },
    { "if r_blood on then ",                         DOOM1AND2        },
    { "if r_blood red ",                             DOOM1AND2        },
    { "if r_blood red then ",                        DOOM1AND2        },
    { "if r_blood_gibs ",                            DOOM1AND2        },
    { "if r_blood_gibs off ",                        DOOM1AND2        },
    { "if r_blood_gibs off then ",                   DOOM1AND2        },
    { "if r_blood_gibs on ",                         DOOM1AND2        },
    { "if r_blood_gibs on then ",                    DOOM1AND2        },
    { "if r_blood_melee ",                           DOOM1AND2        },
    { "if r_blood_melee off ",                       DOOM1AND2        },
    { "if r_blood_melee off then ",                  DOOM1AND2        },
    { "if r_blood_melee on ",                        DOOM1AND2        },
    { "if r_blood_melee on then ",                   DOOM1AND2        },
    { "if r_bloodsplats_max ",                       DOOM1AND2        },
    { "if r_bloodsplats_max 1,048,576 ",             DOOM1AND2        },
    { "if r_bloodsplats_max 1,048,576 then ",        DOOM1AND2        },
    { "if r_bloodsplats_max 131,072 ",               DOOM1AND2        },
    { "if r_bloodsplats_max 131,072 then ",          DOOM1AND2        },
    { "if r_bloodsplats_total ",                     DOOM1AND2        },
    { "if r_bloodsplats_translucency ",              DOOM1AND2        },
    { "if r_bloodsplats_translucency off ",          DOOM1AND2        },
    { "if r_bloodsplats_translucency off then ",     DOOM1AND2        },
    { "if r_bloodsplats_translucency on ",           DOOM1AND2        },
    { "if r_bloodsplats_translucency on then ",      DOOM1AND2        },
    { "if r_brightmaps ",                            DOOM1AND2        },
    { "if r_brightmaps off ",                        DOOM1AND2        },
    { "if r_brightmaps off then ",                   DOOM1AND2        },
    { "if r_brightmaps on ",                         DOOM1AND2        },
    { "if r_brightmaps on then ",                    DOOM1AND2        },
    { "if r_corpses_color ",                         DOOM1AND2        },
    { "if r_corpses_color off ",                     DOOM1AND2        },
    { "if r_corpses_color off then ",                DOOM1AND2        },
    { "if r_corpses_color on ",                      DOOM1AND2        },
    { "if r_corpses_color on then ",                 DOOM1AND2        },
    { "if r_corpses_gib ",                           DOOM1AND2        },
    { "if r_corpses_gib off ",                       DOOM1AND2        },
    { "if r_corpses_gib off then ",                  DOOM1AND2        },
    { "if r_corpses_gib on ",                        DOOM1AND2        },
    { "if r_corpses_gib on then ",                   DOOM1AND2        },
    { "if r_corpses_mirrored ",                      DOOM1AND2        },
    { "if r_corpses_mirrored off ",                  DOOM1AND2        },
    { "if r_corpses_mirrored off then ",             DOOM1AND2        },
    { "if r_corpses_mirrored on ",                   DOOM1AND2        },
    { "if r_corpses_mirrored on then ",              DOOM1AND2        },
    { "if r_corpses_moreblood ",                     DOOM1AND2        },
    { "if r_corpses_moreblood off ",                 DOOM1AND2        },
    { "if r_corpses_moreblood off then ",            DOOM1AND2        },
    { "if r_corpses_moreblood on ",                  DOOM1AND2        },
    { "if r_corpses_moreblood on then ",             DOOM1AND2        },
    { "if r_corpses_nudge ",                         DOOM1AND2        },
    { "if r_corpses_nudge off ",                     DOOM1AND2        },
    { "if r_corpses_nudge off then ",                DOOM1AND2        },
    { "if r_corpses_nudge on ",                      DOOM1AND2        },
    { "if r_corpses_nudge on then ",                 DOOM1AND2        },
    { "if r_corpses_slide ",                         DOOM1AND2        },
    { "if r_corpses_slide off ",                     DOOM1AND2        },
    { "if r_corpses_slide off then ",                DOOM1AND2        },
    { "if r_corpses_slide on ",                      DOOM1AND2        },
    { "if r_corpses_slide on then ",                 DOOM1AND2        },
    { "if r_corpses_smearblood ",                    DOOM1AND2        },
    { "if r_corpses_smearblood off ",                DOOM1AND2        },
    { "if r_corpses_smearblood off then ",           DOOM1AND2        },
    { "if r_corpses_smearblood on ",                 DOOM1AND2        },
    { "if r_corpses_smearblood on then ",            DOOM1AND2        },
    { "if r_damageeffect ",                          DOOM1AND2        },
    { "if r_damageeffect off ",                      DOOM1AND2        },
    { "if r_damageeffect off then ",                 DOOM1AND2        },
    { "if r_damageeffect on ",                       DOOM1AND2        },
    { "if r_damageeffect on then ",                  DOOM1AND2        },
    { "if r_detail ",                                DOOM1AND2        },
    { "if r_detail high ",                           DOOM1AND2        },
    { "if r_detail high then ",                      DOOM1AND2        },
    { "if r_detail low ",                            DOOM1AND2        },
    { "if r_detail low then ",                       DOOM1AND2        },
    { "if r_diskicon ",                              DOOM1AND2        },
    { "if r_diskicon off ",                          DOOM1AND2        },
    { "if r_diskicon off then ",                     DOOM1AND2        },
    { "if r_diskicon on ",                           DOOM1AND2        },
    { "if r_diskicon on then ",                      DOOM1AND2        },
    { "if r_ditheredlighting ",                      DOOM1AND2        },
    { "if r_ditheredlighting off ",                  DOOM1AND2        },
    { "if r_ditheredlighting off then ",             DOOM1AND2        },
    { "if r_ditheredlighting on ",                   DOOM1AND2        },
    { "if r_ditheredlighting on then ",              DOOM1AND2        },
    { "if r_fixmaperrors ",                          DOOM1AND2        },
    { "if r_fixmaperrors off ",                      DOOM1AND2        },
    { "if r_fixmaperrors off then ",                 DOOM1AND2        },
    { "if r_fixmaperrors on ",                       DOOM1AND2        },
    { "if r_fixmaperrors on then ",                  DOOM1AND2        },
    { "if r_fixspriteoffsets ",                      DOOM1AND2        },
    { "if r_fixspriteoffsets off ",                  DOOM1AND2        },
    { "if r_fixspriteoffsets off then ",             DOOM1AND2        },
    { "if r_fixspriteoffsets on ",                   DOOM1AND2        },
    { "if r_fixspriteoffsets on then ",              DOOM1AND2        },
    { "if r_floatbob ",                              DOOM1AND2        },
    { "if r_floatbob off ",                          DOOM1AND2        },
    { "if r_floatbob off then ",                     DOOM1AND2        },
    { "if r_floatbob on ",                           DOOM1AND2        },
    { "if r_floatbob on then ",                      DOOM1AND2        },
    { "if r_fov ",                                   DOOM1AND2        },
    { "if r_fov 135 ",                               DOOM1AND2        },
    { "if r_fov 135 then ",                          DOOM1AND2        },
    { "if r_fov 45 ",                                DOOM1AND2        },
    { "if r_fov 45 then ",                           DOOM1AND2        },
    { "if r_fov 90 ",                                DOOM1AND2        },
    { "if r_fov 90 then ",                           DOOM1AND2        },
    { "if r_gamma ",                                 DOOM1AND2        },
    { "if r_gamma 0.50 ",                            DOOM1AND2        },
    { "if r_gamma 0.50 then ",                       DOOM1AND2        },
    { "if r_gamma 0.55 ",                            DOOM1AND2        },
    { "if r_gamma 0.55 then ",                       DOOM1AND2        },
    { "if r_gamma 0.60 ",                            DOOM1AND2        },
    { "if r_gamma 0.60 then ",                       DOOM1AND2        },
    { "if r_gamma 0.65 ",                            DOOM1AND2        },
    { "if r_gamma 0.65 then ",                       DOOM1AND2        },
    { "if r_gamma 0.70 ",                            DOOM1AND2        },
    { "if r_gamma 0.70 then ",                       DOOM1AND2        },
    { "if r_gamma 0.75 ",                            DOOM1AND2        },
    { "if r_gamma 0.75 then ",                       DOOM1AND2        },
    { "if r_gamma 0.80 ",                            DOOM1AND2        },
    { "if r_gamma 0.80 then ",                       DOOM1AND2        },
    { "if r_gamma 0.85 ",                            DOOM1AND2        },
    { "if r_gamma 0.85 then ",                       DOOM1AND2        },
    { "if r_gamma 0.90 ",                            DOOM1AND2        },
    { "if r_gamma 0.90 then ",                       DOOM1AND2        },
    { "if r_gamma 0.95 ",                            DOOM1AND2        },
    { "if r_gamma 0.95 then ",                       DOOM1AND2        },
    { "if r_gamma 1.0 ",                             DOOM1AND2        },
    { "if r_gamma 1.0 then ",                        DOOM1AND2        },
    { "if r_gamma 1.05 ",                            DOOM1AND2        },
    { "if r_gamma 1.05 then ",                       DOOM1AND2        },
    { "if r_gamma 1.10 ",                            DOOM1AND2        },
    { "if r_gamma 1.10 then ",                       DOOM1AND2        },
    { "if r_gamma 1.15 ",                            DOOM1AND2        },
    { "if r_gamma 1.15 then ",                       DOOM1AND2        },
    { "if r_gamma 1.20 ",                            DOOM1AND2        },
    { "if r_gamma 1.20 then ",                       DOOM1AND2        },
    { "if r_gamma 1.25 ",                            DOOM1AND2        },
    { "if r_gamma 1.25 then ",                       DOOM1AND2        },
    { "if r_gamma 1.30 ",                            DOOM1AND2        },
    { "if r_gamma 1.30 then ",                       DOOM1AND2        },
    { "if r_gamma 1.35 ",                            DOOM1AND2        },
    { "if r_gamma 1.35 then ",                       DOOM1AND2        },
    { "if r_gamma 1.40 ",                            DOOM1AND2        },
    { "if r_gamma 1.40 then ",                       DOOM1AND2        },
    { "if r_gamma 1.45 ",                            DOOM1AND2        },
    { "if r_gamma 1.45 then ",                       DOOM1AND2        },
    { "if r_gamma 1.50 ",                            DOOM1AND2        },
    { "if r_gamma 1.50 then ",                       DOOM1AND2        },
    { "if r_gamma 1.55 ",                            DOOM1AND2        },
    { "if r_gamma 1.55 then ",                       DOOM1AND2        },
    { "if r_gamma 1.60 ",                            DOOM1AND2        },
    { "if r_gamma 1.60 then ",                       DOOM1AND2        },
    { "if r_gamma 1.65 ",                            DOOM1AND2        },
    { "if r_gamma 1.65 then ",                       DOOM1AND2        },
    { "if r_gamma 1.70 ",                            DOOM1AND2        },
    { "if r_gamma 1.70 then ",                       DOOM1AND2        },
    { "if r_gamma 1.75 ",                            DOOM1AND2        },
    { "if r_gamma 1.75 then ",                       DOOM1AND2        },
    { "if r_gamma 1.80 ",                            DOOM1AND2        },
    { "if r_gamma 1.80 then ",                       DOOM1AND2        },
    { "if r_gamma 1.85 ",                            DOOM1AND2        },
    { "if r_gamma 1.85 then ",                       DOOM1AND2        },
    { "if r_gamma 1.90 ",                            DOOM1AND2        },
    { "if r_gamma 1.90 then ",                       DOOM1AND2        },
    { "if r_gamma 1.95 ",                            DOOM1AND2        },
    { "if r_gamma 1.95 then ",                       DOOM1AND2        },
    { "if r_gamma 2.0 ",                             DOOM1AND2        },
    { "if r_gamma 2.0 then ",                        DOOM1AND2        },
    { "if r_gamma off ",                             DOOM1AND2        },
    { "if r_gamma off then ",                        DOOM1AND2        },
    { "if r_graduallighting ",                       DOOM1AND2        },
    { "if r_graduallighting off ",                   DOOM1AND2        },
    { "if r_graduallighting off then ",              DOOM1AND2        },
    { "if r_graduallighting on ",                    DOOM1AND2        },
    { "if r_graduallighting on then ",               DOOM1AND2        },
    { "if r_homindicator ",                          DOOM1AND2        },
    { "if r_homindicator off ",                      DOOM1AND2        },
    { "if r_homindicator off then ",                 DOOM1AND2        },
    { "if r_homindicator on ",                       DOOM1AND2        },
    { "if r_homindicator on then ",                  DOOM1AND2        },
    { "if r_hud ",                                   DOOM1AND2        },
    { "if r_hud off ",                               DOOM1AND2        },
    { "if r_hud off then ",                          DOOM1AND2        },
    { "if r_hud on ",                                DOOM1AND2        },
    { "if r_hud on then ",                           DOOM1AND2        },
    { "if r_hud_translucency ",                      DOOM1AND2        },
    { "if r_hud_translucency off ",                  DOOM1AND2        },
    { "if r_hud_translucency off then ",             DOOM1AND2        },
    { "if r_hud_translucency on ",                   DOOM1AND2        },
    { "if r_hud_translucency on then ",              DOOM1AND2        },
    { "if r_levelbrightness ",                       DOOM1AND2        },
    { "if r_levelbrightness 0% ",                    DOOM1AND2        },
    { "if r_levelbrightness 0% then ",               DOOM1AND2        },
    { "if r_levelbrightness 100% ",                  DOOM1AND2        },
    { "if r_levelbrightness 100% then ",             DOOM1AND2        },
    { "if r_linearskies ",                           DOOM1AND2        },
    { "if r_linearskies off ",                       DOOM1AND2        },
    { "if r_linearskies off then ",                  DOOM1AND2        },
    { "if r_linearskies on ",                        DOOM1AND2        },
    { "if r_linearskies on then ",                   DOOM1AND2        },
    { "if r_liquid_bob ",                            DOOM1AND2        },
    { "if r_liquid_bob off ",                        DOOM1AND2        },
    { "if r_liquid_bob off then ",                   DOOM1AND2        },
    { "if r_liquid_bob on ",                         DOOM1AND2        },
    { "if r_liquid_bob on then ",                    DOOM1AND2        },
    { "if r_liquid_bobsprites ",                     DOOM1AND2        },
    { "if r_liquid_bobsprites off ",                 DOOM1AND2        },
    { "if r_liquid_bobsprites off then ",            DOOM1AND2        },
    { "if r_liquid_bobsprites on ",                  DOOM1AND2        },
    { "if r_liquid_bobsprites on then ",             DOOM1AND2        },
    { "if r_liquid_clipsprites ",                    DOOM1AND2        },
    { "if r_liquid_clipsprites off ",                DOOM1AND2        },
    { "if r_liquid_clipsprites off then ",           DOOM1AND2        },
    { "if r_liquid_clipsprites on ",                 DOOM1AND2        },
    { "if r_liquid_clipsprites on then ",            DOOM1AND2        },
    { "if r_liquid_current ",                        DOOM1AND2        },
    { "if r_liquid_current off ",                    DOOM1AND2        },
    { "if r_liquid_current off then ",               DOOM1AND2        },
    { "if r_liquid_current on ",                     DOOM1AND2        },
    { "if r_liquid_current on then ",                DOOM1AND2        },
    { "if r_liquid_lowerview ",                      DOOM1AND2        },
    { "if r_liquid_lowerview off ",                  DOOM1AND2        },
    { "if r_liquid_lowerview off then ",             DOOM1AND2        },
    { "if r_liquid_lowerview on ",                   DOOM1AND2        },
    { "if r_liquid_lowerview on then ",              DOOM1AND2        },
    { "if r_liquid_swirl ",                          DOOM1AND2        },
    { "if r_liquid_swirl off ",                      DOOM1AND2        },
    { "if r_liquid_swirl off then ",                 DOOM1AND2        },
    { "if r_liquid_swirl on ",                       DOOM1AND2        },
    { "if r_liquid_swirl on then ",                  DOOM1AND2        },
    { "if r_lowpixelsize ",                          DOOM1AND2        },
    { "if r_lowpixelsize 2x2 ",                      DOOM1AND2        },
    { "if r_lowpixelsize 2x2 then ",                 DOOM1AND2        },
    { "if r_lowpixelsize 4x2 ",                      DOOM1AND2        },
    { "if r_lowpixelsize 4x2 then ",                 DOOM1AND2        },
    { "if r_mirroredweapons ",                       DOOM1AND2        },
    { "if r_mirroredweapons off ",                   DOOM1AND2        },
    { "if r_mirroredweapons off then ",              DOOM1AND2        },
    { "if r_mirroredweapons on ",                    DOOM1AND2        },
    { "if r_mirroredweapons on then ",               DOOM1AND2        },
    { "if r_percolumnlighting ",                     DOOM1AND2        },
    { "if r_percolumnlighting off ",                 DOOM1AND2        },
    { "if r_percolumnlighting off then ",            DOOM1AND2        },
    { "if r_percolumnlighting on ",                  DOOM1AND2        },
    { "if r_percolumnlighting on then ",             DOOM1AND2        },
    { "if r_pickupeffect ",                          DOOM1AND2        },
    { "if r_pickupeffect off ",                      DOOM1AND2        },
    { "if r_pickupeffect off then ",                 DOOM1AND2        },
    { "if r_pickupeffect on ",                       DOOM1AND2        },
    { "if r_pickupeffect on then ",                  DOOM1AND2        },
    { "if r_playersprites ",                         DOOM1AND2        },
    { "if r_playersprites off ",                     DOOM1AND2        },
    { "if r_playersprites off then ",                DOOM1AND2        },
    { "if r_playersprites on ",                      DOOM1AND2        },
    { "if r_playersprites on then ",                 DOOM1AND2        },
    { "if r_radsuiteffect ",                         DOOM1AND2        },
    { "if r_radsuiteffect off ",                     DOOM1AND2        },
    { "if r_radsuiteffect off then ",                DOOM1AND2        },
    { "if r_radsuiteffect on ",                      DOOM1AND2        },
    { "if r_radsuiteffect on then ",                 DOOM1AND2        },
    { "if r_randomstartframes ",                     DOOM1AND2        },
    { "if r_randomstartframes off ",                 DOOM1AND2        },
    { "if r_randomstartframes off then ",            DOOM1AND2        },
    { "if r_randomstartframes on ",                  DOOM1AND2        },
    { "if r_randomstartframes on then ",             DOOM1AND2        },
    { "if r_rockettrails ",                          DOOM1AND2        },
    { "if r_rockettrails off ",                      DOOM1AND2        },
    { "if r_rockettrails off then ",                 DOOM1AND2        },
    { "if r_rockettrails on ",                       DOOM1AND2        },
    { "if r_rockettrails on then ",                  DOOM1AND2        },
    { "if r_rockettrails_translucency ",             DOOM1AND2        },
    { "if r_rockettrails_translucency off ",         DOOM1AND2        },
    { "if r_rockettrails_translucency off then ",    DOOM1AND2        },
    { "if r_rockettrails_translucency on ",          DOOM1AND2        },
    { "if r_rockettrails_translucency on then ",     DOOM1AND2        },
    { "if r_screensize ",                            DOOM1AND2        },
    { "if r_shadows ",                               DOOM1AND2        },
    { "if r_shadows off ",                           DOOM1AND2        },
    { "if r_shadows off then ",                      DOOM1AND2        },
    { "if r_shadows on ",                            DOOM1AND2        },
    { "if r_shadows on then ",                       DOOM1AND2        },
    { "if r_shadows_translucency ",                  DOOM1AND2        },
    { "if r_shadows_translucency off ",              DOOM1AND2        },
    { "if r_shadows_translucency off then ",         DOOM1AND2        },
    { "if r_shadows_translucency on ",               DOOM1AND2        },
    { "if r_shadows_translucency on then ",          DOOM1AND2        },
    { "if r_shake_barrels ",                         DOOM1AND2        },
    { "if r_shake_barrels off ",                     DOOM1AND2        },
    { "if r_shake_barrels off then ",                DOOM1AND2        },
    { "if r_shake_barrels on ",                      DOOM1AND2        },
    { "if r_shake_barrels on then ",                 DOOM1AND2        },
    { "if r_shake_berserk ",                         DOOM1AND2        },
    { "if r_shake_berserk off ",                     DOOM1AND2        },
    { "if r_shake_berserk off then ",                DOOM1AND2        },
    { "if r_shake_berserk on ",                      DOOM1AND2        },
    { "if r_shake_berserk on then ",                 DOOM1AND2        },
    { "if r_shake_damage ",                          DOOM1AND2        },
    { "if r_shake_damage off ",                      DOOM1AND2        },
    { "if r_shake_damage off then ",                 DOOM1AND2        },
    { "if r_shake_damage on ",                       DOOM1AND2        },
    { "if r_shake_damage on then ",                  DOOM1AND2        },
    { "if r_sprites_translucency ",                  DOOM1AND2        },
    { "if r_sprites_translucency off ",              DOOM1AND2        },
    { "if r_sprites_translucency off then ",         DOOM1AND2        },
    { "if r_sprites_translucency on ",               DOOM1AND2        },
    { "if r_sprites_translucency on then ",          DOOM1AND2        },
    { "if r_textures ",                              DOOM1AND2        },
    { "if r_textures off ",                          DOOM1AND2        },
    { "if r_textures off then ",                     DOOM1AND2        },
    { "if r_textures on ",                           DOOM1AND2        },
    { "if r_textures on then ",                      DOOM1AND2        },
    { "if r_textures_translucency ",                 DOOM1AND2        },
    { "if r_textures_translucency off ",             DOOM1AND2        },
    { "if r_textures_translucency off then ",        DOOM1AND2        },
    { "if r_textures_translucency on ",              DOOM1AND2        },
    { "if r_textures_translucency on then ",         DOOM1AND2        },
    { "if regenhealth ",                             DOOM1AND2        },
    { "if regenhealth off ",                         DOOM1AND2        },
    { "if regenhealth off then ",                    DOOM1AND2        },
    { "if regenhealth on ",                          DOOM1AND2        },
    { "if regenhealth on then ",                     DOOM1AND2        },
    { "if respawnitems ",                            DOOM1AND2        },
    { "if respawnitems off ",                        DOOM1AND2        },
    { "if respawnitems off then ",                   DOOM1AND2        },
    { "if respawnitems on ",                         DOOM1AND2        },
    { "if respawnitems on then ",                    DOOM1AND2        },
    { "if respawnmonsters ",                         DOOM1AND2        },
    { "if respawnmonsters off ",                     DOOM1AND2        },
    { "if respawnmonsters off then ",                DOOM1AND2        },
    { "if respawnmonsters on ",                      DOOM1AND2        },
    { "if respawnmonsters on then ",                 DOOM1AND2        },
    { "if s_channels ",                              DOOM1AND2        },
    { "if s_channels 32 ",                           DOOM1AND2        },
    { "if s_channels 32 then ",                      DOOM1AND2        },
    { "if s_channels 64 ",                           DOOM1AND2        },
    { "if s_channels 64 then ",                      DOOM1AND2        },
    { "if s_fullsfx ",                               DOOM1AND2        },
    { "if s_fullsfx off ",                           DOOM1AND2        },
    { "if s_fullsfx off then ",                      DOOM1AND2        },
    { "if s_fullsfx on ",                            DOOM1AND2        },
    { "if s_fullsfx on then ",                       DOOM1AND2        },
    { "if s_lowermenumusic ",                        DOOM1AND2        },
    { "if s_lowermenumusic off ",                    DOOM1AND2        },
    { "if s_lowermenumusic off then ",               DOOM1AND2        },
    { "if s_lowermenumusic on ",                     DOOM1AND2        },
    { "if s_lowermenumusic on then ",                DOOM1AND2        },
    { "if s_musicinbackground ",                     DOOM1AND2        },
    { "if s_musicinbackground off ",                 DOOM1AND2        },
    { "if s_musicinbackground off then ",            DOOM1AND2        },
    { "if s_musicinbackground on ",                  DOOM1AND2        },
    { "if s_musicinbackground on then ",             DOOM1AND2        },
    { "if s_musicvolume ",                           DOOM1AND2        },
    { "if s_musicvolume 100% ",                      DOOM1AND2        },
    { "if s_musicvolume 100% then ",                 DOOM1AND2        },
    { "if s_randommusic ",                           DOOM1AND2        },
    { "if s_randommusic off ",                       DOOM1AND2        },
    { "if s_randommusic off then ",                  DOOM1AND2        },
    { "if s_randommusic on ",                        DOOM1AND2        },
    { "if s_randommusic on then ",                   DOOM1AND2        },
    { "if s_randompitch ",                           DOOM1AND2        },
    { "if s_randompitch off ",                       DOOM1AND2        },
    { "if s_randompitch off then ",                  DOOM1AND2        },
    { "if s_randompitch on ",                        DOOM1AND2        },
    { "if s_randompitch on then ",                   DOOM1AND2        },
    { "if s_sfxvolume ",                             DOOM1AND2        },
    { "if s_sfxvolume 0% ",                          DOOM1AND2        },
    { "if s_sfxvolume 0% then ",                     DOOM1AND2        },
    { "if s_sfxvolume 100% ",                        DOOM1AND2        },
    { "if s_sfxvolume 100% then ",                   DOOM1AND2        },
    { "if s_stereo ",                                DOOM1AND2        },
    { "if s_stereo off ",                            DOOM1AND2        },
    { "if s_stereo off then ",                       DOOM1AND2        },
    { "if s_stereo on ",                             DOOM1AND2        },
    { "if s_stereo on then ",                        DOOM1AND2        },
    { "if savegame ",                                DOOM1AND2        },
    { "if secretmessages ",                          DOOM1AND2        },
    { "if secretmessages off ",                      DOOM1AND2        },
    { "if secretmessages off then ",                 DOOM1AND2        },
    { "if secretmessages on ",                       DOOM1AND2        },
    { "if secretmessages on then ",                  DOOM1AND2        },
    { "if skilllevel ",                              DOOM1AND2        },
    { "if stillbob ",                                DOOM1AND2        },
    { "if sucktime ",                                DOOM1AND2        },
    { "if sucktime 1 then ",                         DOOM1AND2        },
    { "if sucktime 24 ",                             DOOM1AND2        },
    { "if sucktime 24 then ",                        DOOM1AND2        },
    { "if sucktime off ",                            DOOM1AND2        },
    { "if sucktime off then ",                       DOOM1AND2        },
    { "if tossdrop ",                                DOOM1AND2        },
    { "if tossdrop off ",                            DOOM1AND2        },
    { "if tossdrop off then ",                       DOOM1AND2        },
    { "if tossdrop on ",                             DOOM1AND2        },
    { "if tossdrop on then ",                        DOOM1AND2        },
    { "if turbo ",                                   DOOM1AND2        },
    { "if turbo 10% ",                               DOOM1AND2        },
    { "if turbo 10% then ",                          DOOM1AND2        },
    { "if turbo 100% ",                              DOOM1AND2        },
    { "if turbo 100% then ",                         DOOM1AND2        },
    { "if turbo 400% ",                              DOOM1AND2        },
    { "if turbo 400% then ",                         DOOM1AND2        },
    { "if units ",                                   DOOM1AND2        },
    { "if units imperial ",                          DOOM1AND2        },
    { "if units imperial then ",                     DOOM1AND2        },
    { "if units metric ",                            DOOM1AND2        },
    { "if units metric then ",                       DOOM1AND2        },
    { "if vanilla ",                                 DOOM1AND2        },
    { "if vanilla off ",                             DOOM1AND2        },
    { "if vanilla off then ",                        DOOM1AND2        },
    { "if vanilla on ",                              DOOM1AND2        },
    { "if vanilla on then ",                         DOOM1AND2        },
    { "if version ",                                 DOOM1AND2        },
    { "if vid_aspectratio ",                         DOOM1AND2        },
    { "if vid_aspectratio 16:10 ",                   DOOM1AND2        },
    { "if vid_aspectratio 16:10 then ",              DOOM1AND2        },
    { "if vid_aspectratio 16:9 ",                    DOOM1AND2        },
    { "if vid_aspectratio 16:9 then ",               DOOM1AND2        },
    { "if vid_aspectratio 21:9 ",                    DOOM1AND2        },
    { "if vid_aspectratio 21:9 then ",               DOOM1AND2        },
    { "if vid_aspectratio 32:9 ",                    DOOM1AND2        },
    { "if vid_aspectratio 32:9 then ",               DOOM1AND2        },
    { "if vid_aspectratio auto ",                    DOOM1AND2        },
    { "if vid_aspectratio auto then ",               DOOM1AND2        },
    { "if vid_blue ",                                DOOM1AND2        },
    { "if vid_blue -100% ",                          DOOM1AND2        },
    { "if vid_blue -100% then ",                     DOOM1AND2        },
    { "if vid_blue 0% ",                             DOOM1AND2        },
    { "if vid_blue 0% then ",                        DOOM1AND2        },
    { "if vid_blue 100% ",                           DOOM1AND2        },
    { "if vid_blue 100% then ",                      DOOM1AND2        },
    { "if vid_brightness ",                          DOOM1AND2        },
    { "if vid_brightness -100% ",                    DOOM1AND2        },
    { "if vid_brightness -100% then ",               DOOM1AND2        },
    { "if vid_brightness 0% ",                       DOOM1AND2        },
    { "if vid_brightness 0% then ",                  DOOM1AND2        },
    { "if vid_brightness 100% ",                     DOOM1AND2        },
    { "if vid_brightness 100% then ",                DOOM1AND2        },
    { "if vid_borderlesswindow ",                    DOOM1AND2        },
    { "if vid_borderlesswindow off ",                DOOM1AND2        },
    { "if vid_borderlesswindow off then ",           DOOM1AND2        },
    { "if vid_borderlesswindow on ",                 DOOM1AND2        },
    { "if vid_borderlesswindow on then ",            DOOM1AND2        },
    { "if vid_capfps ",                              DOOM1AND2        },
    { "if vid_capfps 1,000 ",                        DOOM1AND2        },
    { "if vid_capfps 1,000 then ",                   DOOM1AND2        },
    { "if vid_capfps 1000 ",                         DOOM1AND2        },
    { "if vid_capfps 1000 then ",                    DOOM1AND2        },
    { "if vid_capfps 200 ",                          DOOM1AND2        },
    { "if vid_capfps 200 then ",                     DOOM1AND2        },
    { "if vid_capfps 35 ",                           DOOM1AND2        },
    { "if vid_capfps 35 then ",                      DOOM1AND2        },
    { "if vid_capfps off ",                          DOOM1AND2        },
    { "if vid_capfps off then ",                     DOOM1AND2        },
    { "if vid_contrast ",                            DOOM1AND2        },
    { "if vid_contrast -100% ",                      DOOM1AND2        },
    { "if vid_contrast -100% then ",                 DOOM1AND2        },
    { "if vid_contrast 0% ",                         DOOM1AND2        },
    { "if vid_contrast 0% then ",                    DOOM1AND2        },
    { "if vid_contrast 100% ",                       DOOM1AND2        },
    { "if vid_contrast 100% then ",                  DOOM1AND2        },
    { "if vid_display ",                             DOOM1AND2        },
#if !defined(_WIN32)
    { "if vid_driver ",                              DOOM1AND2        },
#endif
    { "if vid_fullscreen ",                          DOOM1AND2        },
    { "if vid_fullscreen off ",                      DOOM1AND2        },
    { "if vid_fullscreen off then ",                 DOOM1AND2        },
    { "if vid_fullscreen on ",                       DOOM1AND2        },
    { "if vid_fullscreen on then ",                  DOOM1AND2        },
    { "if vid_green ",                               DOOM1AND2        },
    { "if vid_green -100% ",                         DOOM1AND2        },
    { "if vid_green -100% then ",                    DOOM1AND2        },
    { "if vid_green 0% ",                            DOOM1AND2        },
    { "if vid_green 0% then ",                       DOOM1AND2        },
    { "if vid_green 100% ",                          DOOM1AND2        },
    { "if vid_green 100% then ",                     DOOM1AND2        },
    { "if vid_motionblur ",                          DOOM1AND2        },
    { "if vid_motionblur 0% ",                       DOOM1AND2        },
    { "if vid_motionblur 0% then ",                  DOOM1AND2        },
    { "if vid_motionblur 100% ",                     DOOM1AND2        },
    { "if vid_motionblur 100% then ",                DOOM1AND2        },
    { "if vid_pillarboxes ",                         DOOM1AND2        },
    { "if vid_pillarboxes off ",                     DOOM1AND2        },
    { "if vid_pillarboxes off then ",                DOOM1AND2        },
    { "if vid_pillarboxes on ",                      DOOM1AND2        },
    { "if vid_pillarboxes on then ",                 DOOM1AND2        },
    { "if vid_red ",                                 DOOM1AND2        },
    { "if vid_red -100% ",                           DOOM1AND2        },
    { "if vid_red -100% then ",                      DOOM1AND2        },
    { "if vid_red 0% ",                              DOOM1AND2        },
    { "if vid_red 0% then ",                         DOOM1AND2        },
    { "if vid_red 100% ",                            DOOM1AND2        },
    { "if vid_red 100% then ",                       DOOM1AND2        },
    { "if vid_saturation ",                          DOOM1AND2        },
    { "if vid_saturation -100% ",                    DOOM1AND2        },
    { "if vid_saturation -100% then ",               DOOM1AND2        },
    { "if vid_saturation 0% ",                       DOOM1AND2        },
    { "if vid_saturation 0% then ",                  DOOM1AND2        },
    { "if vid_saturation 100% ",                     DOOM1AND2        },
    { "if vid_saturation 100% then ",                DOOM1AND2        },
    { "if vid_scaleapi ",                            DOOM1AND2        },
#if defined(_WIN32)
    { "if vid_scaleapi \"direct3d\" ",               DOOM1AND2        },
    { "if vid_scaleapi \"direct3d\" then ",          DOOM1AND2        },
    { "if vid_scaleapi \"opengl\" ",                 DOOM1AND2        },
    { "if vid_scaleapi \"opengl\" then ",            DOOM1AND2        },
    { "if vid_scaleapi \"software\" ",               DOOM1AND2        },
    { "if vid_scaleapi \"software\" then ",          DOOM1AND2        },
    { "if vid_scaleapi direct3d ",                   DOOM1AND2        },
    { "if vid_scaleapi direct3d then ",              DOOM1AND2        },
    { "if vid_scaleapi opengl ",                     DOOM1AND2        },
    { "if vid_scaleapi opengl then ",                DOOM1AND2        },
    { "if vid_scaleapi software ",                   DOOM1AND2        },
    { "if vid_scaleapi software then ",              DOOM1AND2        },
#else
    { "if vid_scaleapi \"opengl\" ",                 DOOM1AND2        },
    { "if vid_scaleapi \"opengl\" then ",            DOOM1AND2        },
    { "if vid_scaleapi \"opengles\" ",               DOOM1AND2        },
    { "if vid_scaleapi \"opengles\" then ",          DOOM1AND2        },
    { "if vid_scaleapi \"opengles2\" ",              DOOM1AND2        },
    { "if vid_scaleapi \"opengles2\" then ",         DOOM1AND2        },
    { "if vid_scaleapi \"software\" ",               DOOM1AND2        },
    { "if vid_scaleapi \"software\" then ",          DOOM1AND2        },
    { "if vid_scaleapi opengl ",                     DOOM1AND2        },
    { "if vid_scaleapi opengl then ",                DOOM1AND2        },
    { "if vid_scaleapi opengles ",                   DOOM1AND2        },
    { "if vid_scaleapi opengles then ",              DOOM1AND2        },
    { "if vid_scaleapi opengles2 ",                  DOOM1AND2        },
    { "if vid_scaleapi opengles2 then ",             DOOM1AND2        },
    { "if vid_scaleapi software ",                   DOOM1AND2        },
    { "if vid_scaleapi software then ",              DOOM1AND2        },
#endif
    { "if vid_scalefilter ",                         DOOM1AND2        },
    { "if vid_scalefilter \"linear\" ",              DOOM1AND2        },
    { "if vid_scalefilter \"linear\" then ",         DOOM1AND2        },
    { "if vid_scalefilter \"nearest\" ",             DOOM1AND2        },
    { "if vid_scalefilter \"nearest\" then ",        DOOM1AND2        },
    { "if vid_scalefilter \"nearest_linear\" ",      DOOM1AND2        },
    { "if vid_scalefilter \"nearest_linear\" then ", DOOM1AND2        },
    { "if vid_scalefilter linear ",                  DOOM1AND2        },
    { "if vid_scalefilter linear then ",             DOOM1AND2        },
    { "if vid_scalefilter nearest ",                 DOOM1AND2        },
    { "if vid_scalefilter nearest then ",            DOOM1AND2        },
    { "if vid_scalefilter nearest_linear ",          DOOM1AND2        },
    { "if vid_scalefilter nearest_linear then ",     DOOM1AND2        },
    { "if vid_screenresolution ",                    DOOM1AND2        },
    { "if vid_screenresolution desktop ",            DOOM1AND2        },
    { "if vid_screenresolution desktop then ",       DOOM1AND2        },
    { "if vid_showfps ",                             DOOM1AND2        },
    { "if vid_showfps off ",                         DOOM1AND2        },
    { "if vid_showfps off then ",                    DOOM1AND2        },
    { "if vid_showfps on ",                          DOOM1AND2        },
    { "if vid_showfps on then ",                     DOOM1AND2        },
    { "if vid_vsync ",                               DOOM1AND2        },
#if !defined(__APPLE__)
    { "if vid_vsync adaptive ",                      DOOM1AND2        },
    { "if vid_vsync adaptive then ",                 DOOM1AND2        },
#endif
    { "if vid_vsync off ",                           DOOM1AND2        },
    { "if vid_vsync off then ",                      DOOM1AND2        },
    { "if vid_vsync on ",                            DOOM1AND2        },
    { "if vid_vsync on then ",                       DOOM1AND2        },
    { "if vid_widescreen ",                          DOOM1AND2        },
    { "if vid_widescreen off ",                      DOOM1AND2        },
    { "if vid_widescreen off then ",                 DOOM1AND2        },
    { "if vid_widescreen on ",                       DOOM1AND2        },
    { "if vid_widescreen on then ",                  DOOM1AND2        },
    { "if vid_windowpos ",                           DOOM1AND2        },
    { "if vid_windowpos centered ",                  DOOM1AND2        },
    { "if vid_windowpos centered then ",             DOOM1AND2        },
    { "if vid_windowsize ",                          DOOM1AND2        },
    { "if vid_windowsize 854x480 ",                  DOOM1AND2        },
    { "if vid_windowsize 854x480 then ",             DOOM1AND2        },
#if defined(_WIN32)
    { "if wad ",                                     DOOM1AND2        },
#endif
    { "if wadfolder ",                               DOOM1AND2        },
    { "if wadfolder \"C:\\\" ",                      DOOM1AND2        },
    { "if wadfolder \"C:\\\" then ",                 DOOM1AND2        },
    { "if wadfolder C:\\ ",                          DOOM1AND2        },
    { "if wadfolder C:\\ then ",                     DOOM1AND2        },
    { "if warninglevel ",                            DOOM1AND2        },
    { "if warninglevel 0 ",                          DOOM1AND2        },
    { "if warninglevel 0 then ",                     DOOM1AND2        },
    { "if warninglevel 1 ",                          DOOM1AND2        },
    { "if warninglevel 1 then ",                     DOOM1AND2        },
    { "if warninglevel 2 ",                          DOOM1AND2        },
    { "if warninglevel 2 then ",                     DOOM1AND2        },
    { "if weapon ",                                  DOOM1AND2        },
    { "if weapon bfg9000 ",                          DOOM1AND2        },
    { "if weapon bfg9000 then ",                     DOOM1AND2        },
    { "if weapon calamityblade ",                    LEGACYOFRUSTONLY },
    { "if weapon calamityblade then ",               LEGACYOFRUSTONLY },
    { "if weapon chaingun ",                         DOOM1AND2        },
    { "if weapon chaingun then ",                    DOOM1AND2        },
    { "if weapon chainsaw ",                         DOOM1AND2        },
    { "if weapon chainsaw then ",                    DOOM1AND2        },
    { "if weapon fists ",                            DOOM1AND2        },
    { "if weapon fists then ",                       DOOM1AND2        },
    { "if weapon incinerator ",                      LEGACYOFRUSTONLY },
    { "if weapon incinerator then ",                 LEGACYOFRUSTONLY },
    { "if weapon pistol ",                           DOOM1AND2        },
    { "if weapon pistol then ",                      DOOM1AND2        },
    { "if weapon plasmarifle ",                      DOOM1AND2        },
    { "if weapon plasmarifle then ",                 DOOM1AND2        },
    { "if weapon rocketlauncher ",                   DOOM1AND2        },
    { "if weapon rocketlauncher then ",              DOOM1AND2        },
    { "if weapon shotgun ",                          DOOM1AND2        },
    { "if weapon shotgun then ",                     DOOM1AND2        },
    { "if weapon supershotgun ",                     DOOM2ONLY        },
    { "if weapon supershotgun then ",                DOOM2ONLY        },
    { "if weaponbob ",                               DOOM1AND2        },
    { "if weaponbob 100% ",                          DOOM1AND2        },
    { "if weaponbob 100% then ",                     DOOM1AND2        },
    { "if weaponbob 75% ",                           DOOM1AND2        },
    { "if weaponbob 75% then ",                      DOOM1AND2        },
    { "if weaponbounce ",                            DOOM1AND2        },
    { "if weaponbounce off ",                        DOOM1AND2        },
    { "if weaponbounce off then ",                   DOOM1AND2        },
    { "if weaponbounce on ",                         DOOM1AND2        },
    { "if weaponbounce on then ",                    DOOM1AND2        },
    { "if weaponrecoil ",                            DOOM1AND2        },
    { "if weaponrecoil off ",                        DOOM1AND2        },
    { "if weaponrecoil off then ",                   DOOM1AND2        },
    { "if weaponrecoil on ",                         DOOM1AND2        },
    { "if weaponrecoil on then ",                    DOOM1AND2        },
    { "infighting ",                                 DOOM1AND2        },
    { "infighting off",                              DOOM1AND2        },
    { "infighting on",                               DOOM1AND2        },
    { "infiniteammo ",                               DOOM1AND2        },
    { "infiniteammo off",                            DOOM1AND2        },
    { "infiniteammo on",                             DOOM1AND2        },
    { "infiniteheight ",                             DOOM1AND2        },
    { "infiniteheight off",                          DOOM1AND2        },
    { "infiniteheight on",                           DOOM1AND2        },
    { "joy_analog ",                                 DOOM1AND2        },
    { "joy_analog off",                              DOOM1AND2        },
    { "joy_analog on",                               DOOM1AND2        },
    { "joy_deadzone_left ",                          DOOM1AND2        },
    { "joy_deadzone_left 0%",                        DOOM1AND2        },
    { "joy_deadzone_left 15%",                       DOOM1AND2        },
    { "joy_deadzone_left 30%",                       DOOM1AND2        },
    { "joy_deadzone_right ",                         DOOM1AND2        },
    { "joy_deadzone_right 0%",                       DOOM1AND2        },
    { "joy_deadzone_right 15%",                      DOOM1AND2        },
    { "joy_deadzone_right 30%",                      DOOM1AND2        },
    { "joy_invertyaxis ",                            DOOM1AND2        },
    { "joy_invertyaxis off",                         DOOM1AND2        },
    { "joy_invertyaxis on",                          DOOM1AND2        },
    { "joy_rumble_barrels ",                         DOOM1AND2        },
    { "joy_rumble_barrels 0%",                       DOOM1AND2        },
    { "joy_rumble_barrels 100%",                     DOOM1AND2        },
    { "joy_rumble_barrels 200%",                     DOOM1AND2        },
    { "joy_rumble_damage ",                          DOOM1AND2        },
    { "joy_rumble_damage 0%",                        DOOM1AND2        },
    { "joy_rumble_damage 100%",                      DOOM1AND2        },
    { "joy_rumble_damage 200%",                      DOOM1AND2        },
    { "joy_rumble_fall ",                            DOOM1AND2        },
    { "joy_rumble_fall off",                         DOOM1AND2        },
    { "joy_rumble_fall on",                          DOOM1AND2        },
    { "joy_rumble_pickup ",                          DOOM1AND2        },
    { "joy_rumble_pickup off",                       DOOM1AND2        },
    { "joy_rumble_pickup on",                        DOOM1AND2        },
    { "joy_rumble_weapons ",                         DOOM1AND2        },
    { "joy_rumble_weapons 0%",                       DOOM1AND2        },
    { "joy_rumble_weapons 100%",                     DOOM1AND2        },
    { "joy_rumble_weapons 200%",                     DOOM1AND2        },
    { "joy_sensitivity_horizontal ",                 DOOM1AND2        },
    { "joy_sensitivity_horizontal 128",              DOOM1AND2        },
    { "joy_sensitivity_horizontal 64",               DOOM1AND2        },
    { "joy_sensitivity_vertical ",                   DOOM1AND2        },
    { "joy_sensitivity_vertical 128",                DOOM1AND2        },
    { "joy_sensitivity_vertical 64",                 DOOM1AND2        },
    { "joy_swapthumbsticks ",                        DOOM1AND2        },
    { "joy_swapthumbsticks off",                     DOOM1AND2        },
    { "joy_swapthumbsticks on",                      DOOM1AND2        },
    { "joy_thumbsticks ",                            DOOM1AND2        },
    { "+jump",                                       DOOM1AND2        },
    { "kill ",                                       DOOM1AND2        },
    { "kill all",                                    DOOM1AND2        },
    { "kill all arachnotrons",                       DOOM2ONLY        },
    { "kill all archviles",                          DOOM2ONLY        },
    { "kill all baronsofhell",                       DOOM1AND2        },
    { "kill all cacodemons",                         DOOM1AND2        },
    { "kill all chaingunners",                       DOOM2ONLY        },
    { "kill all cyberdemons",                        DOOM1AND2        },
    { "kill all dogs",                               DOOM1AND2        },
    { "kill all friendly ",                          DOOM1AND2        },
    { "kill all friendly arachnotrons",              DOOM2ONLY        },
    { "kill all friendly archviles",                 DOOM2ONLY        },
    { "kill all friendly baronsofhell",              DOOM1AND2        },
    { "kill all friendly cacodemons",                DOOM1AND2        },
    { "kill all friendly chaingunners",              DOOM2ONLY        },
    { "kill all friendly cyberdemons",               DOOM1AND2        },
    { "kill all friendly dogs",                      DOOM1AND2        },
    { "kill all friendly hellknights",               DOOM2ONLY        },
    { "kill all friendly imps",                      DOOM1AND2        },
    { "kill all friendly lostsouls",                 DOOM1AND2        },
    { "kill all friendly mancubi",                   DOOM2ONLY        },
    { "kill all friendly monsters",                  DOOM1AND2        },
    { "kill all friendly painelementals",            DOOM2ONLY        },
    { "kill all friendly pinkydemons",               DOOM1AND2        },
    { "kill all friendly revenants",                 DOOM2ONLY        },
    { "kill all friendly shotgunguys",               DOOM1AND2        },
    { "kill all friendly spectres",                  DOOM1AND2        },
    { "kill all friendly spidermasterminds",         DOOM1AND2        },
    { "kill all friendly wolfensteinss",             DOOM2ONLY        },
    { "kill all friendly zombiemen",                 DOOM1AND2        },
    { "kill all hellknights",                        DOOM2ONLY        },
    { "kill all imps",                               DOOM1AND2        },
    { "kill all lostsouls",                          DOOM1AND2        },
    { "kill all mancubi",                            DOOM2ONLY        },
    { "kill all monsters",                           DOOM1AND2        },
    { "kill all painelementals",                     DOOM2ONLY        },
    { "kill all pinkydemons",                        DOOM1AND2        },
    { "kill all revenants",                          DOOM2ONLY        },
    { "kill all shotgunguys",                        DOOM1AND2        },
    { "kill all spectres",                           DOOM1AND2        },
    { "kill all spidermasterminds",                  DOOM1AND2        },
    { "kill all wolfensteinss",                      DOOM2ONLY        },
    { "kill all zombiemen",                          DOOM1AND2        },
    { "kill arachnotrons",                           DOOM2ONLY        },
    { "kill archviles",                              DOOM2ONLY        },
    { "kill baronsofhell",                           DOOM1AND2        },
    { "kill cacodemons",                             DOOM1AND2        },
    { "kill chaingunners",                           DOOM2ONLY        },
    { "kill cyberdemons",                            DOOM1AND2        },
    { "kill dogs",                                   DOOM1AND2        },
    { "kill friendly ",                              DOOM1AND2        },
    { "kill friendly arachnotrons",                  DOOM2ONLY        },
    { "kill friendly archviles",                     DOOM2ONLY        },
    { "kill friendly baronsofhell",                  DOOM1AND2        },
    { "kill friendly cacodemons",                    DOOM1AND2        },
    { "kill friendly chaingunners",                  DOOM2ONLY        },
    { "kill friendly cyberdemons",                   DOOM1AND2        },
    { "kill friendly dogs",                          DOOM1AND2        },
    { "kill friendly hellknights",                   DOOM2ONLY        },
    { "kill friendly imps",                          DOOM1AND2        },
    { "kill friendly lostsouls",                     DOOM1AND2        },
    { "kill friendly mancubi",                       DOOM2ONLY        },
    { "kill friendly monsters",                      DOOM1AND2        },
    { "kill friendly painelementals",                DOOM2ONLY        },
    { "kill friendly pinkydemons",                   DOOM1AND2        },
    { "kill friendly revenants",                     DOOM2ONLY        },
    { "kill friendly shotgunguys",                   DOOM1AND2        },
    { "kill friendly spectres",                      DOOM1AND2        },
    { "kill friendly spidermasterminds",             DOOM1AND2        },
    { "kill friendly wolfensteinss",                 DOOM2ONLY        },
    { "kill friendly zombiemen",                     DOOM1AND2        },
    { "kill hellknights",                            DOOM2ONLY        },
    { "kill imps",                                   DOOM1AND2        },
    { "kill lostsouls",                              DOOM1AND2        },
    { "kill mancubi",                                DOOM2ONLY        },
    { "kill monsters",                               DOOM1AND2        },
    { "kill painelementals",                         DOOM2ONLY        },
    { "kill pinkydemons",                            DOOM1AND2        },
    { "kill player",                                 DOOM1AND2        },
    { "kill revenants",                              DOOM2ONLY        },
    { "kill shotgunguys",                            DOOM1AND2        },
    { "kill spectres",                               DOOM1AND2        },
    { "kill spidermasterminds",                      DOOM1AND2        },
    { "kill unfriendly ",                            DOOM1AND2        },
    { "kill unfriendly arachnotrons",                DOOM2ONLY        },
    { "kill unfriendly archviles",                   DOOM2ONLY        },
    { "kill unfriendly baronsofhell",                DOOM1AND2        },
    { "kill unfriendly cacodemons",                  DOOM1AND2        },
    { "kill unfriendly chaingunners",                DOOM2ONLY        },
    { "kill unfriendly cyberdemons",                 DOOM1AND2        },
    { "kill unfriendly dogs",                        DOOM1AND2        },
    { "kill unfriendly hellknights",                 DOOM2ONLY        },
    { "kill unfriendly imps",                        DOOM1AND2        },
    { "kill unfriendly lostsouls",                   DOOM1AND2        },
    { "kill unfriendly mancubi",                     DOOM2ONLY        },
    { "kill unfriendly monsters",                    DOOM1AND2        },
    { "kill unfriendly painelementals",              DOOM2ONLY        },
    { "kill unfriendly pinkydemons",                 DOOM1AND2        },
    { "kill unfriendly revenants",                   DOOM2ONLY        },
    { "kill unfriendly shotgunguys",                 DOOM1AND2        },
    { "kill unfriendly spectres",                    DOOM1AND2        },
    { "kill unfriendly spidermasterminds",           DOOM1AND2        },
    { "kill unfriendly wolfensteinss",               DOOM2ONLY        },
    { "kill unfriendly zombiemen",                   DOOM1AND2        },
    { "kill wolfensteinss",                          DOOM2ONLY        },
    { "kill zombiemen",                              DOOM1AND2        },
    { "+left",                                       DOOM1AND2        },
    { "license",                                     DOOM1AND2        },
    { "load ",                                       DOOM1AND2        },
    { "m_acceleration ",                             DOOM1AND2        },
    { "m_acceleration off",                          DOOM1AND2        },
    { "m_acceleration on",                           DOOM1AND2        },
    { "m_doubleclick_use ",                          DOOM1AND2        },
    { "m_doubleclick_use off",                       DOOM1AND2        },
    { "m_doubleclick_use on",                        DOOM1AND2        },
    { "m_invertyaxis ",                              DOOM1AND2        },
    { "m_invertyaxis off",                           DOOM1AND2        },
    { "m_invertyaxis on",                            DOOM1AND2        },
    { "m_novertical ",                               DOOM1AND2        },
    { "m_novertical off",                            DOOM1AND2        },
    { "m_novertical on",                             DOOM1AND2        },
    { "m_pointer ",                                  DOOM1AND2        },
    { "m_pointer off",                               DOOM1AND2        },
    { "m_pointer on",                                DOOM1AND2        },
    { "m_sensitivity ",                              DOOM1AND2        },
    { "m_sensitivity 128",                           DOOM1AND2        },
    { "m_sensitivity 16",                            DOOM1AND2        },
    { "map ",                                        DOOM1AND2        },
    { "map abaddonsvoid",                            DOOM1ONLY        },
    { "map abandonedmines",                          DOOM2ONLY        },
    { "map abattoire",                               PLUTONIAONLY     },
    { "map abyssofdespair",                          DOOM1ONLY        },
    { "map administrationcenter",                    TNTONLY          },
    { "map againsttheewickedly",                     DOOM1ONLY        },
    { "map andhellfollowed",                         DOOM1ONLY        },
    { "map antichrist",                              PLUTONIAONLY     },
    { "map ashmill",                                 LEGACYOFRUSTONLY },
    { "map attack",                                  MASTERLEVELSONLY },
    { "map aztec",                                   PLUTONIAONLY     },
    { "map baddream",                                MASTERLEVELSONLY },
    { "map ballistyx",                               TNTONLY          },
    { "map baphometsdemesne",                        DOOM1ONLY        },
    { "map baronsbanquet",                           NERVEONLY        },
    { "map baronsden",                               TNTONLY          },
    { "map baronslair",                              PLUTONIAONLY     },
    { "map barrelsofun",                             DOOM2ONLY        },
    { "map betray",                                  DOOM2ONLY        },
    { "map blacktower",                              MASTERLEVELSONLY },
    { "map bloodfalls",                              DOOM2ONLY        },
    { "map bloodseakeep",                            MASTERLEVELSONLY },
    { "map brink",                                   LEGACYOFRUSTONLY },
    { "map bunker",                                  PLUTONIAONLY     },
    { "map caged",                                   PLUTONIAONLY     },
    { "map cagesofthedamned",                        DOOM1ONLY        },
    { "map canyon",                                  MASTERLEVELSONLY },
    { "map canyonofthedead",                         NERVEONLY        },
    { "map caribbean",                               TNTONLY          },
    { "map catacombs",                               DOOM2ONLY        },
    { "map caughtyard",                              PLUTONIAONLY     },
    { "map centralprocessing",                       TNTONLY          },
    { "map chasm",                                   DOOM2ONLY        },
    { "map citadel",                                 DOOM2ONLY        },
    { "map commandcenter",                           DOOM1ONLY        },
    { "map commandcontrol",                          DOOM1ONLY        },
    { "map compound",                                PLUTONIAONLY     },
    { "map computerstation",                         DOOM1ONLY        },
    { "map congo",                                   PLUTONIAONLY     },
    { "map containmentarea",                         DOOM1ONLY        },
    { "map courtyard",                               DOOM2ONLY        },
    { "map crater",                                  TNTONLY          },
    { "map creepinghate",                            LEGACYOFRUSTONLY },
    { "map crusher",                                 DOOM2ONLY        },
    { "map crypt",                                   DOOM2ONLY        },
    { "map curseddarkness",                          DOOM1ONLY        },
    { "map cyberden",                                PLUTONIAONLY     },
    { "map deadsimple",                              DOOM2ONLY        },
    { "map deadzone",                                TNTONLY          },
    { "map deathdomain",                             DOOM2ONLY        },
    { "map deepestreaches",                          TNTONLY          },
    { "map deimosanomaly",                           DOOM1ONLY        },
    { "map deimoslab",                               DOOM1ONLY        },
    { "map descendinginferno",                       LEGACYOFRUSTONLY },
    { "map descentintoterror",                       DOOM1ONLY        },
    { "map dis",                                     DOOM1ONLY        },
    { "map disunion",                                LEGACYOFRUSTONLY },
    { "map downtown",                                DOOM2ONLY        },
    { "map E1M1",                                    DOOM1ONLY        },
    { "map E1M1",                                    LEGACYOFRUSTONLY },
    { "map E1M2",                                    DOOM1ONLY        },
    { "map E1M2",                                    LEGACYOFRUSTONLY },
    { "map E1M3",                                    DOOM1ONLY        },
    { "map E1M3",                                    LEGACYOFRUSTONLY },
    { "map E1M4",                                    DOOM1ONLY        },
    { "map E1M4",                                    LEGACYOFRUSTONLY },
    { "map E1M4B",                                   DOOM1ONLY        },
    { "map E1M5",                                    DOOM1ONLY        },
    { "map E1M5",                                    LEGACYOFRUSTONLY },
    { "map E1M6",                                    DOOM1ONLY        },
    { "map E1M6",                                    LEGACYOFRUSTONLY },
    { "map E1M7",                                    DOOM1ONLY        },
    { "map E1M7",                                    LEGACYOFRUSTONLY },
    { "map E1M8",                                    DOOM1ONLY        },
    { "map E1M8",                                    LEGACYOFRUSTONLY },
    { "map E1M8B",                                   DOOM1ONLY        },
    { "map E1M9",                                    DOOM1ONLY        },
    { "map E1M9",                                    DOOM1ONLY        },
    { "map E2M1",                                    DOOM1ONLY        },
    { "map E2M1",                                    LEGACYOFRUSTONLY },
    { "map E2M2",                                    DOOM1ONLY        },
    { "map E2M2",                                    LEGACYOFRUSTONLY },
    { "map E2M3",                                    DOOM1ONLY        },
    { "map E2M3",                                    LEGACYOFRUSTONLY },
    { "map E2M4",                                    DOOM1ONLY        },
    { "map E2M4",                                    LEGACYOFRUSTONLY },
    { "map E2M5",                                    DOOM1ONLY        },
    { "map E2M5",                                    LEGACYOFRUSTONLY },
    { "map E2M6",                                    DOOM1ONLY        },
    { "map E2M6",                                    LEGACYOFRUSTONLY },
    { "map E2M7",                                    DOOM1ONLY        },
    { "map E2M7",                                    LEGACYOFRUSTONLY },
    { "map E2M8",                                    DOOM1ONLY        },
    { "map E2M8",                                    LEGACYOFRUSTONLY },
    { "map E2M9",                                    DOOM1ONLY        },
    { "map E3M1",                                    DOOM1ONLY        },
    { "map E3M2",                                    DOOM1ONLY        },
    { "map E3M3",                                    DOOM1ONLY        },
    { "map E3M4",                                    DOOM1ONLY        },
    { "map E3M5",                                    DOOM1ONLY        },
    { "map E3M6",                                    DOOM1ONLY        },
    { "map E3M7",                                    DOOM1ONLY        },
    { "map E3M8",                                    DOOM1ONLY        },
    { "map E3M9",                                    DOOM1ONLY        },
    { "map E4M1",                                    DOOM1ONLY        },
    { "map E4M2",                                    DOOM1ONLY        },
    { "map E4M3",                                    DOOM1ONLY        },
    { "map E4M4",                                    DOOM1ONLY        },
    { "map E4M5",                                    DOOM1ONLY        },
    { "map E4M6",                                    DOOM1ONLY        },
    { "map E4M7",                                    DOOM1ONLY        },
    { "map E4M8",                                    DOOM1ONLY        },
    { "map E4M9",                                    DOOM1ONLY        },
    { "map E5M1",                                    DOOM1ONLY        },
    { "map E5M2",                                    DOOM1ONLY        },
    { "map E5M3",                                    DOOM1ONLY        },
    { "map E5M4",                                    DOOM1ONLY        },
    { "map E5M5",                                    DOOM1ONLY        },
    { "map E5M6",                                    DOOM1ONLY        },
    { "map E5M7",                                    DOOM1ONLY        },
    { "map E5M8",                                    DOOM1ONLY        },
    { "map E5M9",                                    DOOM1ONLY        },
    { "map E6M1",                                    DOOM1ONLY        },
    { "map E6M2",                                    DOOM1ONLY        },
    { "map E6M3",                                    DOOM1ONLY        },
    { "map E6M4",                                    DOOM1ONLY        },
    { "map E6M5",                                    DOOM1ONLY        },
    { "map E6M6",                                    DOOM1ONLY        },
    { "map E6M7",                                    DOOM1ONLY        },
    { "map E6M8",                                    DOOM1ONLY        },
    { "map E6M9",                                    DOOM1ONLY        },
    { "map earthbase",                               DOOM2ONLY        },
    { "map echoesofpain",                            LEGACYOFRUSTONLY },
    { "map entryway",                                DOOM2ONLY        },
    { "map factory",                                 DOOM2ONLY        },
    { "map falsehood",                               LEGACYOFRUSTONLY },
    { "map fear",                                    DOOM1ONLY        },
    { "map finalfrontier",                           DOOM2ONLY        },
    { "map first",                                   DOOM1AND2        },
    { "map focus",                                   DOOM2ONLY        },
    { "map fortifiedsalvation",                      LEGACYOFRUSTONLY },
    { "map fortressofmystery",                       DOOM1ONLY        },
    { "map fragmentsofsanity",                       DOOM1ONLY        },
    { "map gantlet",                                 DOOM2ONLY        },
    { "map gatetolimbo",                             DOOM1ONLY        },
    { "map gatewayofhell",                           DOOM2ONLY        },
    { "map genesis",                                 PLUTONIAONLY     },
    { "map geryon",                                  MASTERLEVELSONLY },
    { "map ghosttown",                               PLUTONIAONLY     },
    { "map go2it",                                   PLUTONIAONLY     },
    { "map gotcha",                                  DOOM2ONLY        },
    { "map grosse",                                  DOOM2ONLY        },
    { "map habitat",                                 TNTONLY          },
    { "map hallsofperdition",                        DOOM1ONLY        },
    { "map hallsofthedamned",                        DOOM1ONLY        },
    { "map hangar",                                  DOOM1ONLY        },
    { "map hanger",                                  TNTONLY          },
    { "map heck",                                    TNTONLY          },
    { "map hellbeneath",                             DOOM1ONLY        },
    { "map hellkeep",                                DOOM1ONLY        },
    { "map hellmountain",                            NERVEONLY        },
    { "map houseofpain",                             DOOM1ONLY        },
    { "map humanbbq",                                TNTONLY          },
    { "map hunted",                                  PLUTONIAONLY     },
    { "map iconofsin",                               DOOM2ONLY        },
    { "map idkfa",                                   DOOM2ONLY        },
    { "map impossiblemission",                       PLUTONIAONLY     },
    { "map industrialzone",                          DOOM2ONLY        },
    { "map infernoofblood",                          NERVEONLY        },
    { "map inmostdens",                              DOOM2ONLY        },
    { "map keen",                                    DOOM2ONLY        },
    { "map last",                                    DOOM1AND2        },
    { "map lastcall",                                TNTONLY          },
    { "map livingend",                               DOOM2ONLY        },
    { "map lunarminingproject",                      TNTONLY          },
    { "map MAP01",                                   DOOM2ONLY        },
    { "map MAP02",                                   DOOM2ONLY        },
    { "map MAP03",                                   DOOM2ONLY        },
    { "map MAP04",                                   DOOM2ONLY        },
    { "map MAP05",                                   DOOM2ONLY        },
    { "map MAP06",                                   DOOM2ONLY        },
    { "map MAP07",                                   DOOM2ONLY        },
    { "map MAP08",                                   DOOM2ONLY        },
    { "map MAP09",                                   DOOM2ONLY        },
    { "map MAP10",                                   DOOM2ONLY        },
    { "map MAP11",                                   DOOM2ONLY        },
    { "map MAP12",                                   DOOM2ONLY        },
    { "map MAP13",                                   DOOM2ONLY        },
    { "map MAP14",                                   DOOM2ONLY        },
    { "map MAP15",                                   DOOM2ONLY        },
    { "map MAP16",                                   DOOM2ONLY        },
    { "map MAP17",                                   DOOM2ONLY        },
    { "map MAP18",                                   DOOM2ONLY        },
    { "map MAP19",                                   DOOM2ONLY        },
    { "map MAP20",                                   DOOM2ONLY        },
    { "map MAP21",                                   DOOM2ONLY        },
    { "map MAP22",                                   DOOM2ONLY        },
    { "map MAP23",                                   DOOM2ONLY        },
    { "map MAP24",                                   DOOM2ONLY        },
    { "map MAP25",                                   DOOM2ONLY        },
    { "map MAP26",                                   DOOM2ONLY        },
    { "map MAP27",                                   DOOM2ONLY        },
    { "map MAP28",                                   DOOM2ONLY        },
    { "map MAP29",                                   DOOM2ONLY        },
    { "map MAP30",                                   DOOM2ONLY        },
    { "map MAP31",                                   DOOM2ONLY        },
    { "map MAP32",                                   DOOM2ONLY        },
    { "map MAP33",                                   DOOM2ONLY        },
    { "map MAP99",                                   LEGACYOFRUSTONLY },
    { "map marchofthedemons",                        NERVEONLY        },
    { "map mephistosmausoleum",                      MASTERLEVELSONLY },
    { "map metal",                                   TNTONLY          },
    { "map militarybase",                            DOOM1ONLY        },
    { "map mill",                                    TNTONLY          },
    { "map minosjudgement",                          MASTERLEVELSONLY },
    { "map monstercondo",                            DOOM2ONLY        },
    { "map mountpain",                               TNTONLY          },
    { "map mterebus",                                DOOM1ONLY        },
    { "map nessus",                                  MASTERLEVELSONLY },
    { "map neurosphere",                             PLUTONIAONLY     },
    { "map next",                                    DOOM1AND2        },
    { "map nightmareunderworld",                     DOOM1ONLY        },
    { "map nirvana",                                 DOOM2ONLY        },
    { "map nme",                                     PLUTONIAONLY     },
    { "map nuclearplant",                            DOOM1ONLY        },
    { "map nukageprocessing",                        TNTONLY          },
    { "map odysseyofnoises",                         PLUTONIAONLY     },
    { "map omen",                                    DOOM2ONLY        },
    { "map onehumanity",                             DOOM2ONLY        },
    { "map onslaught",                               PLUTONIAONLY     },
    { "map oofdestruction",                          DOOM2ONLY        },
    { "map openseason",                              TNTONLY          },
    { "map painlabs",                                DOOM2ONLY        },
    { "map pandemonium",                             DOOM1ONLY        },
    { "map panopticon",                              LEGACYOFRUSTONLY },
    { "map paradox",                                 MASTERLEVELSONLY },
    { "map pathsofwretchedness",                     DOOM1ONLY        },
    { "map perfecthatred",                           DOOM1ONLY        },
    { "map pharaoh",                                 TNTONLY          },
    { "map phobosanomaly",                           DOOM1ONLY        },
    { "map phoboslab",                               DOOM1ONLY        },
    { "map phobosmissioncontrol",                    DOOM1ONLY        },
    { "map pit",                                     DOOM2ONLY        },
    { "map powercontrol",                            TNTONLY          },
    { "map previous",                                DOOM1AND2        },
    { "map prison",                                  TNTONLY          },
    { "map processingarea",                          TNTONLY          },
    { "map quarry",                                  TNTONLY          },
    { "map random",                                  DOOM1AND2        },
    { "map realm",                                   PLUTONIAONLY     },
    { "map realmofiblis",                            DOOM1ONLY        },
    { "map redemption",                              TNTONLY          },
    { "map refinery",                                DOOM1ONLY        },
    { "map refuelingbase",                           DOOM2ONLY        },
    { "map riverstyx",                               TNTONLY          },
    { "map sanguinewastes",                          LEGACYOFRUSTONLY },
    { "map scargate",                                LEGACYOFRUSTONLY },
    { "map secondcoming",                            LEGACYOFRUSTONLY },
    { "map severthewicked",                          DOOM1ONLY        },
    { "map sewers",                                  DOOM2ONLY        },
    { "map shatteredhomecoming",                     DOOM1ONLY        },
    { "map sheol",                                   DOOM1ONLY        },
    { "map shippingrespawning",                      TNTONLY          },
    { "map slayer",                                  PLUTONIAONLY     },
    { "map sloughofdespair",                         DOOM1ONLY        },
    { "map soulsilo",                                LEGACYOFRUSTONLY },
    { "map spawningvats",                            DOOM1ONLY        },
    { "map speed",                                   PLUTONIAONLY     },
    { "map spiritdrains",                            LEGACYOFRUSTONLY },
    { "map spiritworld",                             DOOM2ONLY        },
    { "map steelworks",                              TNTONLY          },
    { "map storagefacility",                         TNTONLY          },
    { "map stronghold",                              TNTONLY          },
    { "map subspace",                                MASTERLEVELSONLY },
    { "map subterra",                                MASTERLEVELSONLY },
    { "map suburbs",                                 DOOM2ONLY        },
    { "map systemcontrol",                           TNTONLY          },
    { "map techgonebad",                             DOOM1ONLY        },
    { "map templeofdarkness",                        DOOM2ONLY        },
    { "map tenements",                               DOOM2ONLY        },
    { "map theabandonedmines",                       DOOM2ONLY        },
    { "map thecatacombs",                            DOOM2ONLY        },
    { "map thecatwalk",                              MASTERLEVELSONLY },
    { "map thechasm",                                DOOM2ONLY        },
    { "map thecitadel",                              DOOM2ONLY        },
    { "map thecoiledcity",                           LEGACYOFRUSTONLY },
    { "map thecombine",                              MASTERLEVELSONLY },
    { "map thecourtyard",                            DOOM2ONLY        },
    { "map thecrusher",                              DOOM2ONLY        },
    { "map thecrypt",                                PLUTONIAONLY     },
    { "map thedeathdomain",                          PLUTONIAONLY     },
    { "map theearthbase",                            NERVEONLY        },
    { "map theexpresselevatortohell",                MASTERLEVELSONLY },
    { "map thefactory",                              DOOM2ONLY        },
    { "map thefinalfrontier",                        PLUTONIAONLY     },
    { "map thefistula",                              MASTERLEVELSONLY },
    { "map thefocus",                                DOOM2ONLY        },
    { "map thegantlet",                              DOOM2ONLY        },
    { "map thegarrison",                             MASTERLEVELSONLY },
    { "map thegatewayofhell",                        PLUTONIAONLY     },
    { "map theinmostdens",                           DOOM2ONLY        },
    { "map thelivingend",                            DOOM2ONLY        },
    { "map theomen",                                 PLUTONIAONLY     },
    { "map thepainlabs",                             NERVEONLY        },
    { "map thepit",                                  DOOM2ONLY        },
    { "map therack",                                 LEGACYOFRUSTONLY },
    { "map thesewers",                               PLUTONIAONLY     },
    { "map thespiritworld",                          DOOM2ONLY        },
    { "map thetempleofdarkness",                     PLUTONIAONLY     },
    { "map thetwilight",                             PLUTONIAONLY     },
    { "map thewastetunnels",                         DOOM2ONLY        },
    { "map theywillrepent",                          DOOM1ONLY        },
    { "map titanmanor",                              MASTERLEVELSONLY },
    { "map tombofmalevolence",                       NERVEONLY        },
    { "map tombstone",                               PLUTONIAONLY     },
    { "map towerofbabel",                            DOOM1ONLY        },
    { "map toxinrefinery",                           DOOM1ONLY        },
    { "map trappedontitan",                          MASTERLEVELSONLY },
    { "map tricksandtraps",                          DOOM2ONLY        },
    { "map twilight",                                DOOM2ONLY        },
    { "map twilightdesolation",                      DOOM1ONLY        },
    { "map underhalls",                              DOOM2ONLY        },
    { "map unholycathedral",                         DOOM1ONLY        },
    { "map unrulyevil",                              DOOM1ONLY        },
    { "map unspeakablepersecution",                  DOOM1ONLY        },
    { "map untothecruel",                            DOOM1ONLY        },
    { "map vengeanceunleashed",                      DOOM1ONLY        },
    { "map vesperas",                                MASTERLEVELSONLY },
    { "map violenthatred",                           DOOM1ONLY        },
    { "map virgilslead",                             MASTERLEVELSONLY },
    { "map vivisection",                             NERVEONLY        },
    { "map warrens",                                 DOOM1ONLY        },
    { "map wastetunnels",                            DOOM2ONLY        },
    { "map wellofsouls",                             PLUTONIAONLY     },
    { "map wolfenstein",                             DOOM2ONLY        },
    { "map wormhole",                                TNTONLY          },
    { "map wrathfulreckoning",                       DOOM1ONLY        },
    { "maplist",                                     DOOM1AND2        },
    { "mapstats",                                    DOOM1AND2        },
    { "maptime",                                     DOOM1AND2        },
    { "+mark",                                       DOOM1AND2        },
    { "+maxzoom",                                    DOOM1AND2        },
    { "melt ",                                       DOOM1AND2        },
    { "melt off",                                    DOOM1AND2        },
    { "melt on",                                     DOOM1AND2        },
    { "+menu",                                       DOOM1AND2        },
    { "menuhighlight ",                              DOOM1AND2        },
    { "menuhighlight off",                           DOOM1AND2        },
    { "menuhighlight on",                            DOOM1AND2        },
    { "menushadow ",                                 DOOM1AND2        },
    { "menushadow off",                              DOOM1AND2        },
    { "menushadow on",                               DOOM1AND2        },
    { "menuspin ",                                   DOOM1AND2        },
    { "menuspin off",                                DOOM1AND2        },
    { "menuspin on",                                 DOOM1AND2        },
    { "messages ",                                   DOOM1AND2        },
    { "messages off",                                DOOM1AND2        },
    { "messages on",                                 DOOM1AND2        },
    { "movebob ",                                    DOOM1AND2        },
    { "movebob 0%",                                  DOOM1AND2        },
    { "movebob 100%",                                DOOM1AND2        },
    { "movebob 75%",                                 DOOM1AND2        },
    { "name ",                                       DOOM1AND2        },
    { "name arachnotron ",                           DOOM2ONLY        },
    { "name archvile ",                              DOOM2ONLY        },
    { "name baronofhell ",                           DOOM1AND2        },
    { "name cacodemon ",                             DOOM1AND2        },
    { "name chaingunner ",                           DOOM2ONLY        },
    { "name cyberdemon ",                            DOOM1AND2        },
    { "name dog ",                                   DOOM1AND2        },
    { "name friendly ",                              DOOM1AND2        },
    { "name friendly arachnotron ",                  DOOM2ONLY        },
    { "name friendly archvile ",                     DOOM2ONLY        },
    { "name friendly baronofhell ",                  DOOM1AND2        },
    { "name friendly cacodemon ",                    DOOM1AND2        },
    { "name friendly chaingunner ",                  DOOM2ONLY        },
    { "name friendly cyberdemon ",                   DOOM1AND2        },
    { "name friendly dog ",                          DOOM1AND2        },
    { "name friendly hellknight ",                   DOOM2ONLY        },
    { "name friendly imp ",                          DOOM1AND2        },
    { "name friendly lostsoul ",                     DOOM1AND2        },
    { "name friendly mancubus ",                     DOOM2ONLY        },
    { "name friendly monster ",                      DOOM1AND2        },
    { "name friendly painelemental ",                DOOM2ONLY        },
    { "name friendly pinkydemon ",                   DOOM1AND2        },
    { "name friendly revenant ",                     DOOM2ONLY        },
    { "name friendly shotgunguy ",                   DOOM1AND2        },
    { "name friendly spectre ",                      DOOM1AND2        },
    { "name friendly spidermastermind ",             DOOM1AND2        },
    { "name friendly wolfensteinss ",                DOOM2ONLY        },
    { "name friendly zombieman ",                    DOOM1AND2        },
    { "name hellknight ",                            DOOM2ONLY        },
    { "name imp ",                                   DOOM1AND2        },
    { "name lostsoul ",                              DOOM1AND2        },
    { "name mancubus ",                              DOOM2ONLY        },
    { "name monster ",                               DOOM1AND2        },
    { "name painelemental ",                         DOOM2ONLY        },
    { "name pinkydemon ",                            DOOM1AND2        },
    { "name player ",                                DOOM1AND2        },
    { "name revenant ",                              DOOM2ONLY        },
    { "name shotgunguy ",                            DOOM1AND2        },
    { "name spectre ",                               DOOM1AND2        },
    { "name spidermastermind ",                      DOOM1AND2        },
    { "name unfriendly ",                            DOOM1AND2        },
    { "name unfriendly arachnotron ",                DOOM2ONLY        },
    { "name unfriendly archvile ",                   DOOM2ONLY        },
    { "name unfriendly baronofhell ",                DOOM1AND2        },
    { "name unfriendly cacodemon ",                  DOOM1AND2        },
    { "name unfriendly chaingunner ",                DOOM2ONLY        },
    { "name unfriendly cyberdemon ",                 DOOM1AND2        },
    { "name unfriendly dog ",                        DOOM1AND2        },
    { "name unfriendly hellknight ",                 DOOM2ONLY        },
    { "name unfriendly imp ",                        DOOM1AND2        },
    { "name unfriendly lostsoul ",                   DOOM1AND2        },
    { "name unfriendly mancubus ",                   DOOM2ONLY        },
    { "name unfriendly monster ",                    DOOM1AND2        },
    { "name unfriendly painelemental ",              DOOM2ONLY        },
    { "name unfriendly pinkydemon ",                 DOOM1AND2        },
    { "name unfriendly revenant ",                   DOOM2ONLY        },
    { "name unfriendly shotgunguy ",                 DOOM1AND2        },
    { "name unfriendly spectre ",                    DOOM1AND2        },
    { "name unfriendly spidermastermind ",           DOOM1AND2        },
    { "name unfriendly wolfensteinss ",              DOOM2ONLY        },
    { "name unfriendly zombieman ",                  DOOM1AND2        },
    { "name wolfensteinss ",                         DOOM2ONLY        },
    { "name zombieman ",                             DOOM1AND2        },
    { "negativehealth ",                             DOOM1AND2        },
    { "negativehealth off",                          DOOM1AND2        },
    { "negativehealth on",                           DOOM1AND2        },
    { "newgame",                                     DOOM1AND2        },
    { "+nextweapon",                                 DOOM1AND2        },
    { "noclip ",                                     DOOM1AND2        },
    { "noclip off",                                  DOOM1AND2        },
    { "noclip on",                                   DOOM1AND2        },
    { "nomonsters ",                                 DOOM1AND2        },
    { "nomonsters off",                              DOOM1AND2        },
    { "nomonsters on",                               DOOM1AND2        },
    { "notarget ",                                   DOOM1AND2        },
    { "notarget off",                                DOOM1AND2        },
    { "notarget on",                                 DOOM1AND2        },
    { "obituaries ",                                 DOOM1AND2        },
    { "obituaries off",                              DOOM1AND2        },
    { "obituaries on",                               DOOM1AND2        },
    { "pistolstart ",                                DOOM1AND2        },
    { "pistolstart off",                             DOOM1AND2        },
    { "pistolstart on",                              DOOM1AND2        },
    { "play ",                                       DOOM1AND2        },
    { "play 13thfloor",                              DOOM1ONLY        },
    { "play adrenalineintheblood",                   DOOM1ONLY        },
    { "play adriansasleep",                          DOOM2ONLY        },
    { "play alice",                                  DOOM1ONLY        },
    { "play atdoomsgate",                            DOOM1ONLY        },
    { "play besiegedcity",                           DOOM1ONLY        },
    { "play betweenlevels",                          DOOM2ONLY        },
    { "play bilgepunks",                             LEGACYOFRUSTONLY },
    { "play bonk",                                   LEGACYOFRUSTONLY },
    { "play buildorpart2",                           DOOM1ONLY        },
    { "play byebyeamericanpie",                      DOOM2ONLY        },
    { "play callousregard",                          LEGACYOFRUSTONLY },
    { "play cathedralrock",                          DOOM1ONLY        },
    { "play chainsawchorus",                         DOOM1ONLY        },
    { "play cliffdriver",                            LEGACYOFRUSTONLY },
    { "play cloudywithachanceofspiders",             LEGACYOFRUSTONLY },
    { "play coldfrostpart6",                         DOOM1ONLY        },
    { "play countdowntodeath",                       DOOM2ONLY        },
    { "play D_ADRIAN",                               DOOM2ONLY        },
    { "play D_AMPIE",                                DOOM2ONLY        },
    { "play D_BETWEE",                               DOOM2ONLY        },
    { "play D_BILGE",                                LEGACYOFRUSTONLY },
    { "play D_BLANK",                                LEGACYOFRUSTONLY },
    { "play D_BONK",                                 LEGACYOFRUSTONLY },
    { "play D_BUNNY",                                DOOM2ONLY        },
    { "play D_CLOUDY",                               LEGACYOFRUSTONLY },
    { "play D_COUNT2",                               DOOM2ONLY        },
    { "play D_COUNTD",                               DOOM2ONLY        },
    { "play D_DDTBL2",                               DOOM2ONLY        },
    { "play D_DDTBL3",                               DOOM2ONLY        },
    { "play D_DDTBLU",                               DOOM2ONLY        },
    { "play D_DEAD",                                 DOOM2ONLY        },
    { "play D_DEAD2",                                DOOM2ONLY        },
    { "play D_DEJAVU",                               LEGACYOFRUSTONLY },
    { "play D_DISGUS",                               LEGACYOFRUSTONLY },
    { "play D_DM2INT",                               DOOM2ONLY        },
    { "play D_DM2TTL",                               DOOM2ONLY        },
    { "play D_DOOM",                                 DOOM2ONLY        },
    { "play D_DOOM2",                                DOOM2ONLY        },
    { "play D_DRIVER",                               LEGACYOFRUSTONLY },
    { "play D_E1M1",                                 DOOM1ONLY        },
    { "play D_E1M2",                                 DOOM1ONLY        },
    { "play D_E1M3",                                 DOOM1ONLY        },
    { "play D_E1M4",                                 DOOM1ONLY        },
    { "play D_E1M5",                                 DOOM1ONLY        },
    { "play D_E1M6",                                 DOOM1ONLY        },
    { "play D_E1M7",                                 DOOM1ONLY        },
    { "play D_E1M8",                                 DOOM1ONLY        },
    { "play D_E1M9",                                 DOOM1ONLY        },
    { "play D_E2M1",                                 DOOM1ONLY        },
    { "play D_E2M2",                                 DOOM1ONLY        },
    { "play D_E2M3",                                 DOOM1ONLY        },
    { "play D_E2M4",                                 DOOM1ONLY        },
    { "play D_E2M5",                                 DOOM1ONLY        },
    { "play D_E2M6",                                 DOOM1ONLY        },
    { "play D_E2M7",                                 DOOM1ONLY        },
    { "play D_E2M8",                                 DOOM1ONLY        },
    { "play D_E2M9",                                 DOOM1ONLY        },
    { "play D_E3M1",                                 DOOM1ONLY        },
    { "play D_E3M2",                                 DOOM1ONLY        },
    { "play D_E3M3",                                 DOOM1ONLY        },
    { "play D_E3M4",                                 DOOM1ONLY        },
    { "play D_E3M5",                                 DOOM1ONLY        },
    { "play D_E3M6",                                 DOOM1ONLY        },
    { "play D_E3M7",                                 DOOM1ONLY        },
    { "play D_E3M8",                                 DOOM1ONLY        },
    { "play D_E3M9",                                 DOOM1ONLY        },
    { "play D_E5M1",                                 DOOM1ONLY        },
    { "play D_E5M2",                                 DOOM1ONLY        },
    { "play D_E5M3",                                 DOOM1ONLY        },
    { "play D_E5M4",                                 DOOM1ONLY        },
    { "play D_E5M5",                                 DOOM1ONLY        },
    { "play D_E5M6",                                 DOOM1ONLY        },
    { "play D_E5M7",                                 DOOM1ONLY        },
    { "play D_E5M8",                                 DOOM1ONLY        },
    { "play D_E5M9",                                 DOOM1ONLY        },
    { "play D_E6M1",                                 DOOM1ONLY        },
    { "play D_E6M2",                                 DOOM1ONLY        },
    { "play D_E6M3",                                 DOOM1ONLY        },
    { "play D_E6M4",                                 DOOM1ONLY        },
    { "play D_E6M5",                                 DOOM1ONLY        },
    { "play D_E6M6",                                 DOOM1ONLY        },
    { "play D_E6M7",                                 DOOM1ONLY        },
    { "play D_E6M8",                                 DOOM1ONLY        },
    { "play D_E6M9",                                 DOOM1ONLY        },
    { "play D_EVIL",                                 DOOM2ONLY        },
    { "play D_HELFOR",                               LEGACYOFRUSTONLY },
    { "play D_IN_CIT",                               DOOM2ONLY        },
    { "play D_INTER",                                DOOM1ONLY        },
    { "play D_INTRO",                                DOOM1ONLY        },
    { "play D_INTROA",                               DOOM1ONLY        },
    { "play D_LAUGH",                                LEGACYOFRUSTONLY },
    { "play D_MESSAG",                               DOOM2ONLY        },
    { "play D_MESSG2",                               DOOM2ONLY        },
    { "play D_OPENIN",                               DOOM2ONLY        },
    { "play D_READ_M",                               DOOM2ONLY        },
    { "play D_REGARD",                               LEGACYOFRUSTONLY },
    { "play D_ROMER2",                               DOOM2ONLY        },
    { "play D_ROMERO",                               DOOM2ONLY        },
    { "play D_RUNNI2",                               DOOM2ONLY        },
    { "play D_RUNNIN",                               DOOM2ONLY        },
    { "play D_SHAWN",                                DOOM2ONLY        },
    { "play D_SHAWN2",                               DOOM2ONLY        },
    { "play D_SHAWN3",                               DOOM2ONLY        },
    { "play D_SHORES",                               LEGACYOFRUSTONLY },
    { "play D_SKELET",                               LEGACYOFRUSTONLY },
    { "play D_STALKS",                               DOOM2ONLY        },
    { "play D_STLKS2",                               DOOM2ONLY        },
    { "play D_STLKS3",                               DOOM2ONLY        },
    { "play D_TACTIC",                               LEGACYOFRUSTONLY },
    { "play D_TENSE",                                DOOM2ONLY        },
    { "play D_THE_DA",                               DOOM2ONLY        },
    { "play D_THEDA2",                               DOOM2ONLY        },
    { "play D_THEDA3",                               DOOM2ONLY        },
    { "play D_ULTIMA",                               DOOM2ONLY        },
    { "play D_VESPER",                               LEGACYOFRUSTONLY },
    { "play D_VICTOR",                               DOOM1ONLY        },
    { "play D_WELCOM",                               LEGACYOFRUSTONLY },
    { "play D_WIZARD",                               LEGACYOFRUSTONLY },
    { "play darkhalls",                              DOOM1ONLY        },
    { "play deepintothecode",                        DOOM1ONLY        },
    { "play dejavuvuzela",                           LEGACYOFRUSTONLY },
    { "play demonsontheprey",                        DOOM1ONLY        },
    { "play disgusto",                               LEGACYOFRUSTONLY },
    { "play donnatotherescue",                       DOOM1ONLY        },
    { "play doom",                                   DOOM2ONLY        },
    { "play DSBANACT",                               LEGACYOFRUSTONLY },
    { "play DSBANDTH",                               LEGACYOFRUSTONLY },
    { "play DSBANPAI",                               LEGACYOFRUSTONLY },
    { "play DSBAREXP",                               DOOM1AND2        },
    { "play DSBDCLS",                                DOOM1AND2        },
    { "play DSBDOPN",                                DOOM1AND2        },
    { "play DSBFG",                                  DOOM1AND2        },
    { "play DSBGACT",                                DOOM1AND2        },
    { "play DSBGDTH1",                               DOOM1AND2        },
    { "play DSBGDTH2",                               DOOM1AND2        },
    { "play DSBGSIT1",                               DOOM1AND2        },
    { "play DSBGSIT2",                               DOOM1AND2        },
    { "play DSBOSCUB",                               DOOM2ONLY        },
    { "play DSBOSDTH",                               DOOM2ONLY        },
    { "play DSBOSPIT",                               DOOM2ONLY        },
    { "play DSBOSPN",                                DOOM2ONLY        },
    { "play DSBOSSIT",                               DOOM2ONLY        },
    { "play DSBREAK",                                LEGACYOFRUSTONLY },
    { "play DSBRSDTH",                               DOOM1AND2        },
    { "play DSBRSSIT",                               DOOM1AND2        },
    { "play DSBSPACT",                               DOOM2ONLY        },
    { "play DSBSPDTH",                               DOOM2ONLY        },
    { "play DSBSPSIT",                               DOOM2ONLY        },
    { "play DSBSPWLK",                               DOOM2ONLY        },
    { "play DSCACDTH",                               DOOM1AND2        },
    { "play DSCACSIT",                               DOOM1AND2        },
    { "play DSCLAW",                                 DOOM1AND2        },
    { "play DSCONSOL",                               DOOM1AND2        },
    { "play DSCSPACT",                               LEGACYOFRUSTONLY },
    { "play DSCSPDTH",                               LEGACYOFRUSTONLY },
    { "play DSCSPSIT",                               LEGACYOFRUSTONLY },
    { "play DSCSPWLK",                               LEGACYOFRUSTONLY },
    { "play DSCYBDTH",                               DOOM1AND2        },
    { "play DSCYBSIT",                               DOOM1AND2        },
    { "play DSDBCLS",                                DOOM2ONLY        },
    { "play DSDBLOAD",                               DOOM2ONLY        },
    { "play DSDBOPN",                                DOOM2ONLY        },
    { "play DSDGACT",                                DOOM2ONLY        },
    { "play DSDGATK",                                DOOM2ONLY        },
    { "play DSDGDTH",                                DOOM2ONLY        },
    { "play DSDGPAIN",                               DOOM2ONLY        },
    { "play DSDGSIT",                                DOOM2ONLY        },
    { "play DSDMACT",                                DOOM1AND2        },
    { "play DSDMPAIN",                               DOOM1AND2        },
    { "play DSDORCLS",                               DOOM1AND2        },
    { "play DSDOROPN",                               DOOM1AND2        },
    { "play DSDSHTGN",                               DOOM2ONLY        },
    { "play DSFIRSHT",                               DOOM1AND2        },
    { "play DSFIRXPL",                               DOOM1AND2        },
    { "play DSFLAME",                                DOOM2ONLY        },
    { "play DSFLAMST",                               DOOM2ONLY        },
    { "play DSGATCLS",                               LEGACYOFRUSTONLY },
    { "play DSGATLOP",                               LEGACYOFRUSTONLY },
    { "play DSGATOPN",                               LEGACYOFRUSTONLY },
    { "play DSGETPOW",                               DOOM1AND2        },
    { "play DSGHLACT",                               LEGACYOFRUSTONLY },
    { "play DSGHLDT2",                               LEGACYOFRUSTONLY },
    { "play DSGHLDTH",                               LEGACYOFRUSTONLY },
    { "play DSGHLPAI",                               LEGACYOFRUSTONLY },
    { "play DSGHLSIT",                               LEGACYOFRUSTONLY },
    { "play DSHETCHG",                               LEGACYOFRUSTONLY },
    { "play DSHETSHT",                               LEGACYOFRUSTONLY },
    { "play DSHETXPL",                               LEGACYOFRUSTONLY },
    { "play DSHOOF",                                 DOOM1AND2        },
    { "play DSINCBRN",                               LEGACYOFRUSTONLY },
    { "play DSINCFI1",                               LEGACYOFRUSTONLY },
    { "play DSINCFI2",                               LEGACYOFRUSTONLY },
    { "play DSINCHT1",                               LEGACYOFRUSTONLY },
    { "play DSINCHT2",                               LEGACYOFRUSTONLY },
    { "play DSINCHT3",                               LEGACYOFRUSTONLY },
    { "play DSITEMUP",                               DOOM1AND2        },
    { "play DSITMBK",                                DOOM1AND2        },
    { "play DSKEENDT",                               DOOM2ONLY        },
    { "play DSKEENPN",                               DOOM2ONLY        },
    { "play DSKLAXON",                               LEGACYOFRUSTONLY },
    { "play DSKNTDTH",                               DOOM2ONLY        },
    { "play DSKNTSIT",                               DOOM2ONLY        },
    { "play DSMANATK",                               DOOM2ONLY        },
    { "play DSMANDTH",                               DOOM2ONLY        },
    { "play DSMANSIT",                               DOOM2ONLY        },
    { "play DSMETAL",                                DOOM1AND2        },
    { "play DSMNPAIN",                               DOOM2ONLY        },
    { "play DSNOWAY",                                DOOM1AND2        },
    { "play DSOOF",                                  DOOM1AND2        },
    { "play DSPDIEHI",                               DOOM1AND2        },
    { "play DSPEDTH",                                DOOM2ONLY        },
    { "play DSPEPAIN",                               DOOM2ONLY        },
    { "play DSPESIT",                                DOOM2ONLY        },
    { "play DSPISTOL",                               DOOM1AND2        },
    { "play DSPLASMA",                               DOOM1AND2        },
    { "play DSPLDETH",                               DOOM1AND2        },
    { "play DSPLPAIN",                               DOOM1AND2        },
    { "play DSPODTH1",                               DOOM1AND2        },
    { "play DSPODTH2",                               DOOM1AND2        },
    { "play DSPODTH3",                               DOOM1AND2        },
    { "play DSPOPAIN",                               DOOM1AND2        },
    { "play DSPOSACT",                               DOOM1AND2        },
    { "play DSPOSIT1",                               DOOM1AND2        },
    { "play DSPOSIT2",                               DOOM1AND2        },
    { "play DSPOSIT3",                               DOOM1AND2        },
    { "play DSPPOACT",                               LEGACYOFRUSTONLY },
    { "play DSPPODTH",                               LEGACYOFRUSTONLY },
    { "play DSPPOHED",                               LEGACYOFRUSTONLY },
    { "play DSPPOPAI",                               LEGACYOFRUSTONLY },
    { "play DSPSTART",                               DOOM1AND2        },
    { "play DSPSTOP",                                DOOM1AND2        },
    { "play DSPUNCH",                                DOOM1AND2        },
    { "play DSRADIO",                                DOOM2ONLY        },
    { "play DSRLAUNC",                               DOOM1AND2        },
    { "play DSRXPLOD",                               DOOM1AND2        },
    { "play DSSAWFUL",                               DOOM1AND2        },
    { "play DSSAWHIT",                               DOOM1AND2        },
    { "play DSSAWIDL",                               DOOM1AND2        },
    { "play DSSAWUP",                                DOOM1AND2        },
    { "play DSSCRSHT",                               DOOM1AND2        },
    { "play DSSECRET",                               DOOM1AND2        },
    { "play DSSGCOCK",                               DOOM1AND2        },
    { "play DSSGTATK",                               DOOM1AND2        },
    { "play DSSGTDTH",                               DOOM1AND2        },
    { "play DSSGTSIT",                               DOOM1AND2        },
    { "play DSSHOTGN",                               DOOM1AND2        },
    { "play DSSKEACT",                               DOOM2ONLY        },
    { "play DSSKEATK",                               DOOM2ONLY        },
    { "play DSSKEDTH",                               DOOM2ONLY        },
    { "play DSSKEPCH",                               DOOM2ONLY        },
    { "play DSSKESIT",                               DOOM2ONLY        },
    { "play DSSKESWG",                               DOOM2ONLY        },
    { "play DSSKLATK",                               DOOM1AND2        },
    { "play DSSKLDTH",                               DOOM1AND2        },
    { "play DSSLOP",                                 DOOM1AND2        },
    { "play DSSPIDTH",                               DOOM1AND2        },
    { "play DSSPISIT",                               DOOM1AND2        },
    { "play DSSSDTH",                                DOOM2ONLY        },
    { "play DSSSSIT",                                DOOM2ONLY        },
    { "play DSSTNMOV",                               DOOM1AND2        },
    { "play DSSWTCHN",                               DOOM1AND2        },
    { "play DSSWTCHX",                               DOOM1AND2        },
    { "play DSTELEPT",                               DOOM1AND2        },
    { "play DSTINK",                                 DOOM1AND2        },
    { "play DSTYRDTH",                               LEGACYOFRUSTONLY },
    { "play DSTYRSIT",                               LEGACYOFRUSTONLY },
    { "play DSTYRWLK",                               LEGACYOFRUSTONLY },
    { "play DSVASACT",                               LEGACYOFRUSTONLY },
    { "play DSVASATK",                               LEGACYOFRUSTONLY },
    { "play DSVASDTH",                               LEGACYOFRUSTONLY },
    { "play DSVASPAI",                               LEGACYOFRUSTONLY },
    { "play DSVASSIT",                               LEGACYOFRUSTONLY },
    { "play DSVILACT",                               DOOM2ONLY        },
    { "play DSVILATK",                               DOOM2ONLY        },
    { "play DSVILDTH",                               DOOM2ONLY        },
    { "play DSVILSIT",                               DOOM2ONLY        },
    { "play DSVIPAIN",                               DOOM2ONLY        },
    { "play DSWPNUP",                                DOOM1AND2        },
    { "play easel",                                  DOOM1ONLY        },
    { "play evildead",                               DOOM1ONLY        },
    { "play evilincarnate",                          DOOM2ONLY        },
    { "play extirpation",                            DOOM1ONLY        },
    { "play eyeonspiralpart1",                       DOOM2ONLY        },
    { "play facingthespider",                        DOOM1ONLY        },
    { "play far5",                                   DOOM1ONLY        },
    { "play fastpass",                               DOOM1ONLY        },
    { "play finalimpact",                            DOOM1ONLY        },
    { "play fractures",                              DOOM1ONLY        },
    { "play gettingtootense",                        DOOM2ONLY        },
    { "play hatemachine",                            DOOM1ONLY        },
    { "play hellforcefive",                          LEGACYOFRUSTONLY },
    { "play hellspawnhavoc",                         DOOM1ONLY        },
    { "play hexaphobia",                             DOOM1ONLY        },
    { "play hidingthesecrets",                       DOOM1ONLY        },
    { "play immolator",                              DOOM1ONLY        },
    { "play imthedoomguywiththegun",                 DOOM1ONLY        },
    { "play incinerationanthem",                     DOOM1ONLY        },
    { "play intermissionfromdoom",                   DOOM1ONLY        },
    { "play inthedark",                              DOOM2ONLY        },
    { "play intosandyscity",                         DOOM2ONLY        },
    { "play isawedthedemons",                        DOOM2ONLY        },
    { "play kitchenaceandtakingnames",               DOOM1ONLY        },
    { "play marchofthevespers",                      LEGACYOFRUSTONLY },
    { "play meltingmanpart2",                        DOOM1ONLY        },
    { "play messageforthearchvile",                  DOOM2ONLY        },
    { "play nightmareoverture",                      DOOM1ONLY        },
    { "play nobodytoldmeaboutid",                    DOOM1ONLY        },
    { "play onthehunt",                              DOOM1ONLY        },
    { "play openingtohell",                          DOOM2ONLY        },
    { "play pain",                                   DOOM1ONLY        },
    { "play poseidon46",                             DOOM1ONLY        },
    { "play quellthebeast",                          DOOM1ONLY        },
    { "play ragingrevenant",                         DOOM1ONLY        },
    { "play riotsquadron",                           DOOM1ONLY        },
    { "play romeroonemindanyweapon",                 DOOM1ONLY        },
    { "play runningfromevil",                        DOOM2ONLY        },
    { "play shawnsgottheshotgun",                    DOOM2ONLY        },
    { "play signofevil",                             DOOM1ONLY        },
    { "play sinister",                               DOOM1ONLY        },
    { "play sleepofreason",                          DOOM1ONLY        },
    { "play suspense",                               DOOM1ONLY        },
    { "play sweetlittledeadbunny",                   DOOM2ONLY        },
    { "play tacticalblasphemy",                      LEGACYOFRUSTONLY },
    { "play thedavedtaylorblues",                    DOOM2ONLY        },
    { "play thedemonsdead",                          DOOM2ONLY        },
    { "play thedemonsfromadrianspen",                DOOM1ONLY        },
    { "play theendofdoom",                           DOOM2ONLY        },
    { "play thehealerstalks",                        DOOM2ONLY        },
    { "play theimpenetrabledark",                    DOOM1ONLY        },
    { "play theimpssong",                            DOOM1ONLY        },
    { "play thepatrolman",                           DOOM1ONLY        },
    { "play theshoresofheaven",                      LEGACYOFRUSTONLY },
    { "play theskeletonworld",                       LEGACYOFRUSTONLY },
    { "play theultimatechallengeconquest",           DOOM2ONLY        },
    { "play theyreallgoingtolaughatyou",             LEGACYOFRUSTONLY },
    { "play theyregoingtogetyou",                    DOOM1ONLY        },
    { "play triceratoptron",                         DOOM2ONLY        },
    { "play umbraluprising",                         DOOM1ONLY        },
    { "play vitriolicvendetta",                      DOOM1ONLY        },
    { "play waitingforromerotoplay",                 DOOM2ONLY        },
    { "play wallsoftheminotaur",                     DOOM1ONLY        },
    { "play waltzofthedemons",                       DOOM1ONLY        },
    { "play watchingyou",                            DOOM1ONLY        },
    { "play welcometodie",                           LEGACYOFRUSTONLY },
    { "play wickedwarpath",                          DOOM1ONLY        },
    { "play wizardscience",                          LEGACYOFRUSTONLY },
    { "play youaintthebossofme",                     DOOM1ONLY        },
    { "playergender ",                               DOOM1AND2        },
    { "playergender female",                         DOOM1AND2        },
    { "playergender male",                           DOOM1AND2        },
    { "playergender other",                          DOOM1AND2        },
    { "playername ",                                 DOOM1AND2        },
    { "playername \"\"",                             DOOM1AND2        },
    { "playerstats",                                 DOOM1AND2        },
    { "+prevweapon",                                 DOOM1AND2        },
    { "print ",                                      DOOM1AND2        },
    { "quit",                                        DOOM1AND2        },
    { "r_althud ",                                   DOOM1AND2        },
    { "r_althud off",                                DOOM1AND2        },
    { "r_althud on",                                 DOOM1AND2        },
    { "r_antialiasing ",                             DOOM1AND2        },
    { "r_antialiasing off",                          DOOM1AND2        },
    { "r_antialiasing on",                           DOOM1AND2        },
    { "r_berserkeffect ",                            DOOM1AND2        },
    { "r_blood ",                                    DOOM1AND2        },
    { "r_blood all",                                 DOOM1AND2        },
    { "r_blood green",                               DOOM1AND2        },
    { "r_blood nofuzz",                              DOOM1AND2        },
    { "r_blood none",                                DOOM1AND2        },
    { "r_blood off",                                 DOOM1AND2        },
    { "r_blood on",                                  DOOM1AND2        },
    { "r_blood red",                                 DOOM1AND2        },
    { "r_blood_gibs ",                               DOOM1AND2        },
    { "r_blood_gibs off",                            DOOM1AND2        },
    { "r_blood_gibs on",                             DOOM1AND2        },
    { "r_blood_melee ",                              DOOM1AND2        },
    { "r_blood_melee off",                           DOOM1AND2        },
    { "r_blood_melee on",                            DOOM1AND2        },
    { "r_bloodsplats_max ",                          DOOM1AND2        },
    { "r_bloodsplats_max 1,048,576",                 DOOM1AND2        },
    { "r_bloodsplats_max 131,072",                   DOOM1AND2        },
    { "r_bloodsplats_total",                         DOOM1AND2        },
    { "r_bloodsplats_translucency ",                 DOOM1AND2        },
    { "r_bloodsplats_translucency off",              DOOM1AND2        },
    { "r_bloodsplats_translucency on",               DOOM1AND2        },
    { "r_brightmaps ",                               DOOM1AND2        },
    { "r_brightmaps off",                            DOOM1AND2        },
    { "r_brightmaps on",                             DOOM1AND2        },
    { "r_corpses_color ",                            DOOM1AND2        },
    { "r_corpses_color off",                         DOOM1AND2        },
    { "r_corpses_color on",                          DOOM1AND2        },
    { "r_corpses_gib ",                              DOOM1AND2        },
    { "r_corpses_gib off",                           DOOM1AND2        },
    { "r_corpses_gib on",                            DOOM1AND2        },
    { "r_corpses_mirrored ",                         DOOM1AND2        },
    { "r_corpses_mirrored off",                      DOOM1AND2        },
    { "r_corpses_mirrored on",                       DOOM1AND2        },
    { "r_corpses_moreblood ",                        DOOM1AND2        },
    { "r_corpses_moreblood off",                     DOOM1AND2        },
    { "r_corpses_moreblood on",                      DOOM1AND2        },
    { "r_corpses_nudge ",                            DOOM1AND2        },
    { "r_corpses_nudge off",                         DOOM1AND2        },
    { "r_corpses_nudge on",                          DOOM1AND2        },
    { "r_corpses_slide ",                            DOOM1AND2        },
    { "r_corpses_slide off",                         DOOM1AND2        },
    { "r_corpses_slide on",                          DOOM1AND2        },
    { "r_corpses_smearblood ",                       DOOM1AND2        },
    { "r_corpses_smearblood off",                    DOOM1AND2        },
    { "r_corpses_smearblood on",                     DOOM1AND2        },
    { "r_damageeffect ",                             DOOM1AND2        },
    { "r_damageeffect off",                          DOOM1AND2        },
    { "r_damageeffect on",                           DOOM1AND2        },
    { "r_detail ",                                   DOOM1AND2        },
    { "r_detail high",                               DOOM1AND2        },
    { "r_detail low",                                DOOM1AND2        },
    { "r_diskicon ",                                 DOOM1AND2        },
    { "r_diskicon off",                              DOOM1AND2        },
    { "r_diskicon on",                               DOOM1AND2        },
    { "r_ditheredlighting ",                         DOOM1AND2        },
    { "r_ditheredlighting off",                      DOOM1AND2        },
    { "r_ditheredlighting on",                       DOOM1AND2        },
    { "r_fixmaperrors ",                             DOOM1AND2        },
    { "r_fixmaperrors off",                          DOOM1AND2        },
    { "r_fixmaperrors on",                           DOOM1AND2        },
    { "r_fixspriteoffsets ",                         DOOM1AND2        },
    { "r_fixspriteoffsets off",                      DOOM1AND2        },
    { "r_fixspriteoffsets on",                       DOOM1AND2        },
    { "r_floatbob ",                                 DOOM1AND2        },
    { "r_floatbob off",                              DOOM1AND2        },
    { "r_floatbob on",                               DOOM1AND2        },
    { "r_fov ",                                      DOOM1AND2        },
    { "r_fov 135",                                   DOOM1AND2        },
    { "r_fov 45",                                    DOOM1AND2        },
    { "r_fov 90",                                    DOOM1AND2        },
    { "r_gamma ",                                    DOOM1AND2        },
    { "r_gamma 0.50",                                DOOM1AND2        },
    { "r_gamma 0.55",                                DOOM1AND2        },
    { "r_gamma 0.60",                                DOOM1AND2        },
    { "r_gamma 0.65",                                DOOM1AND2        },
    { "r_gamma 0.70",                                DOOM1AND2        },
    { "r_gamma 0.75",                                DOOM1AND2        },
    { "r_gamma 0.80",                                DOOM1AND2        },
    { "r_gamma 0.85",                                DOOM1AND2        },
    { "r_gamma 0.90",                                DOOM1AND2        },
    { "r_gamma 1.0",                                 DOOM1AND2        },
    { "r_gamma 1.05",                                DOOM1AND2        },
    { "r_gamma 1.10",                                DOOM1AND2        },
    { "r_gamma 1.15",                                DOOM1AND2        },
    { "r_gamma 1.20",                                DOOM1AND2        },
    { "r_gamma 1.25",                                DOOM1AND2        },
    { "r_gamma 1.30",                                DOOM1AND2        },
    { "r_gamma 1.35",                                DOOM1AND2        },
    { "r_gamma 1.40",                                DOOM1AND2        },
    { "r_gamma 1.45",                                DOOM1AND2        },
    { "r_gamma 1.50",                                DOOM1AND2        },
    { "r_gamma 1.55",                                DOOM1AND2        },
    { "r_gamma 1.60",                                DOOM1AND2        },
    { "r_gamma 1.65",                                DOOM1AND2        },
    { "r_gamma 1.70",                                DOOM1AND2        },
    { "r_gamma 1.75",                                DOOM1AND2        },
    { "r_gamma 1.80",                                DOOM1AND2        },
    { "r_gamma 1.85",                                DOOM1AND2        },
    { "r_gamma 1.90",                                DOOM1AND2        },
    { "r_gamma 2.0",                                 DOOM1AND2        },
    { "r_gamma off",                                 DOOM1AND2        },
    { "r_graduallighting ",                          DOOM1AND2        },
    { "r_graduallighting off",                       DOOM1AND2        },
    { "r_graduallighting on",                        DOOM1AND2        },
    { "r_homindicator ",                             DOOM1AND2        },
    { "r_homindicator off",                          DOOM1AND2        },
    { "r_homindicator on",                           DOOM1AND2        },
    { "r_hud ",                                      DOOM1AND2        },
    { "r_hud off",                                   DOOM1AND2        },
    { "r_hud on",                                    DOOM1AND2        },
    { "r_hud_translucency ",                         DOOM1AND2        },
    { "r_hud_translucency off",                      DOOM1AND2        },
    { "r_hud_translucency on",                       DOOM1AND2        },
    { "r_levelbrightness ",                          DOOM1AND2        },
    { "r_levelbrightness 0%",                        DOOM1AND2        },
    { "r_levelbrightness 100%",                      DOOM1AND2        },
    { "r_linearskies ",                              DOOM1AND2        },
    { "r_linearskies off",                           DOOM1AND2        },
    { "r_linearskies on",                            DOOM1AND2        },
    { "r_liquid_bob ",                               DOOM1AND2        },
    { "r_liquid_bob off",                            DOOM1AND2        },
    { "r_liquid_bob on",                             DOOM1AND2        },
    { "r_liquid_bobsprites ",                        DOOM1AND2        },
    { "r_liquid_bobsprites off",                     DOOM1AND2        },
    { "r_liquid_bobsprites on",                      DOOM1AND2        },
    { "r_liquid_clipsprites ",                       DOOM1AND2        },
    { "r_liquid_clipsprites off",                    DOOM1AND2        },
    { "r_liquid_clipsprites on",                     DOOM1AND2        },
    { "r_liquid_current ",                           DOOM1AND2        },
    { "r_liquid_current off",                        DOOM1AND2        },
    { "r_liquid_current on",                         DOOM1AND2        },
    { "r_liquid_lowerview ",                         DOOM1AND2        },
    { "r_liquid_lowerview off",                      DOOM1AND2        },
    { "r_liquid_lowerview on",                       DOOM1AND2        },
    { "r_liquid_swirl ",                             DOOM1AND2        },
    { "r_liquid_swirl off",                          DOOM1AND2        },
    { "r_liquid_swirl on",                           DOOM1AND2        },
    { "r_lowpixelsize ",                             DOOM1AND2        },
    { "r_lowpixelsize 2x2",                          DOOM1AND2        },
    { "r_lowpixelsize 4x2",                          DOOM1AND2        },
    { "r_mirroredweapons ",                          DOOM1AND2        },
    { "r_mirroredweapons off",                       DOOM1AND2        },
    { "r_mirroredweapons on",                        DOOM1AND2        },
    { "r_percolumnlighting ",                        DOOM1AND2        },
    { "r_percolumnlighting off",                     DOOM1AND2        },
    { "r_percolumnlighting on",                      DOOM1AND2        },
    { "r_pickupeffect ",                             DOOM1AND2        },
    { "r_pickupeffect off",                          DOOM1AND2        },
    { "r_pickupeffect on",                           DOOM1AND2        },
    { "r_playersprites ",                            DOOM1AND2        },
    { "r_playersprites off",                         DOOM1AND2        },
    { "r_playersprites on",                          DOOM1AND2        },
    { "r_radsuiteffect ",                            DOOM1AND2        },
    { "r_radsuiteffect off",                         DOOM1AND2        },
    { "r_radsuiteffect on",                          DOOM1AND2        },
    { "r_randomstartframes ",                        DOOM1AND2        },
    { "r_randomstartframes off",                     DOOM1AND2        },
    { "r_randomstartframes on",                      DOOM1AND2        },
    { "r_rockettrails ",                             DOOM1AND2        },
    { "r_rockettrails off",                          DOOM1AND2        },
    { "r_rockettrails on",                           DOOM1AND2        },
    { "r_rockettrails_translucency ",                DOOM1AND2        },
    { "r_rockettrails_translucency off",             DOOM1AND2        },
    { "r_rockettrails_translucency on",              DOOM1AND2        },
    { "r_screensize ",                               DOOM1AND2        },
    { "r_shadows ",                                  DOOM1AND2        },
    { "r_shadows off",                               DOOM1AND2        },
    { "r_shadows on",                                DOOM1AND2        },
    { "r_shadows_translucency ",                     DOOM1AND2        },
    { "r_shadows_translucency off",                  DOOM1AND2        },
    { "r_shadows_translucency on",                   DOOM1AND2        },
    { "r_shake_barrels ",                            DOOM1AND2        },
    { "r_shake_barrels off",                         DOOM1AND2        },
    { "r_shake_barrels on",                          DOOM1AND2        },
    { "r_shake_berserk ",                            DOOM1AND2        },
    { "r_shake_berserk off",                         DOOM1AND2        },
    { "r_shake_berserk on",                          DOOM1AND2        },
    { "r_shake_damage ",                             DOOM1AND2        },
    { "r_shake_damage off",                          DOOM1AND2        },
    { "r_shake_damage on",                           DOOM1AND2        },
    { "r_sprites_translucency ",                     DOOM1AND2        },
    { "r_sprites_translucency off",                  DOOM1AND2        },
    { "r_sprites_translucency on",                   DOOM1AND2        },
    { "r_textures ",                                 DOOM1AND2        },
    { "r_textures off",                              DOOM1AND2        },
    { "r_textures on",                               DOOM1AND2        },
    { "r_textures_translucency ",                    DOOM1AND2        },
    { "r_textures_translucency off",                 DOOM1AND2        },
    { "r_textures_translucency on",                  DOOM1AND2        },
    { "readme",                                      DOOM1AND2        },
    { "regenhealth ",                                DOOM1AND2        },
    { "regenhealth off",                             DOOM1AND2        },
    { "regenhealth on",                              DOOM1AND2        },
    { "remove ",                                     DOOM1AND2        },
    { "remove armorbonuses",                         DOOM1AND2        },
    { "remove backpacks",                            DOOM1AND2        },
    { "remove berserks",                             DOOM1AND2        },
    { "remove bfg9000s",                             DOOM1AND2        },
    { "remove bloodsplats",                          DOOM1AND2        },
    { "remove bloodymesses1",                        DOOM1AND2        },
    { "remove bloodymesses2",                        DOOM1AND2        },
    { "remove bluearmor",                            DOOM1AND2        },
    { "remove bluekeycards",                         DOOM1AND2        },
    { "remove blueskullkeys",                        DOOM1AND2        },
    { "remove boxesofbullets",                       DOOM1AND2        },
    { "remove boxesofrockets",                       DOOM1AND2        },
    { "remove boxesofshells",                        DOOM1AND2        },
    { "remove burningbarrels",                       DOOM2ONLY        },
    { "remove candelabras",                          DOOM1AND2        },
    { "remove candlesticks",                         DOOM1AND2        },
    { "remove cellpacks",                            DOOM1AND2        },
    { "remove cells",                                DOOM1AND2        },
    { "remove chainguns",                            DOOM1AND2        },
    { "remove chainsaws",                            DOOM1AND2        },
    { "remove clips",                                DOOM1AND2        },
    { "remove computerareamaps",                     DOOM1AND2        },
    { "remove corpses",                              DOOM1AND2        },
    { "remove deadcacodemons",                       DOOM1AND2        },
    { "remove deadimps",                             DOOM1AND2        },
    { "remove deadpinkydemons",                      DOOM1AND2        },
    { "remove deadplayers",                          DOOM1AND2        },
    { "remove deadshotgunguys",                      DOOM1AND2        },
    { "remove deadzombiemen",                        DOOM1AND2        },
    { "remove decorations",                          DOOM1AND2        },
    { "remove everything",                           DOOM1AND2        },
    { "remove evileyes",                             DOOM1AND2        },
    { "remove evilsceptres",                         DOOM1AND2        },
    { "remove fiveskullsshishkebabs",                DOOM1AND2        },
    { "remove floatingskulls",                       DOOM1AND2        },
    { "remove floorlamps",                           DOOM1AND2        },
    { "remove greenarmor",                           DOOM1AND2        },
    { "remove hanginglegs",                          DOOM1AND2        },
    { "remove hanginglegsblocking",                  DOOM1AND2        },
    { "remove hangingpairsoflegs",                   DOOM1AND2        },
    { "remove hangingpairsoflegsblocking",           DOOM1AND2        },
    { "remove hangingtorsosbrainremoved",            DOOM2ONLY        },
    { "remove hangingtorsoslookingdown",             DOOM2ONLY        },
    { "remove hangingtorsoslookingup",               DOOM2ONLY        },
    { "remove hangingtorsosopenskull",               DOOM2ONLY        },
    { "remove hangingvictimsarmsout",                DOOM1AND2        },
    { "remove hangingvictimsarmsoutblocking",        DOOM1AND2        },
    { "remove hangingvictimsgutsandbrainremoved",    DOOM2ONLY        },
    { "remove hangingvictimsgutsremoved",            DOOM2ONLY        },
    { "remove hangingvictimsonelegged",              DOOM1AND2        },
    { "remove hangingvictimsoneleggedblocking",      DOOM1AND2        },
    { "remove hangingvictimstwitching",              DOOM1AND2        },
    { "remove hangingvictimstwitchingblocking",      DOOM1AND2        },
    { "remove healthbonuses",                        DOOM1AND2        },
    { "remove impaledhumans",                        DOOM1AND2        },
    { "remove invulnerabilities",                    DOOM1AND2        },
    { "remove items",                                DOOM1AND2        },
    { "remove largebrowntrees",                      DOOM1AND2        },
    { "remove lightamplificationvisors",             DOOM1AND2        },
    { "remove medikits",                             DOOM1AND2        },
    { "remove megaspheres",                          DOOM2ONLY        },
    { "remove partialinvisibilities",                DOOM1AND2        },
    { "remove pilesofskullsandcandles",              DOOM1AND2        },
    { "remove plasmarifles",                         DOOM1AND2        },
    { "remove poolsofblood",                         DOOM2ONLY        },
    { "remove poolsofbloodandbones",                 DOOM1AND2        },
    { "remove poolsofbloodandguts",                  DOOM2ONLY        },
    { "remove poolsofbrains",                        DOOM2ONLY        },
    { "remove radiationshieldingsuits",              DOOM1AND2        },
    { "remove redkeycards",                          DOOM1AND2        },
    { "remove redskullkeys",                         DOOM1AND2        },
    { "remove rocketlaunchers",                      DOOM1AND2        },
    { "remove rockets",                              DOOM1AND2        },
    { "remove shells",                               DOOM1AND2        },
    { "remove shortbluefiresticks",                  DOOM1AND2        },
    { "remove shortgreencolumns",                    DOOM1AND2        },
    { "remove shortgreencolumnswithbeatinghearts",   DOOM1AND2        },
    { "remove shortgreenfiresticks",                 DOOM1AND2        },
    { "remove shortredcolumns",                      DOOM1AND2        },
    { "remove shortredcolumnswithskulls",            DOOM1AND2        },
    { "remove shortredfiresticks",                   DOOM1AND2        },
    { "remove shorttechnofloorlamps",                DOOM2ONLY        },
    { "remove shotguns",                             DOOM1AND2        },
    { "remove skullsonpoles",                        DOOM1AND2        },
    { "remove soulspheres",                          DOOM1AND2        },
    { "remove stalagmites",                          DOOM1AND2        },
    { "remove stimpacks",                            DOOM1AND2        },
    { "remove supershotguns",                        DOOM2ONLY        },
    { "remove tallbluefiresticks",                   DOOM1AND2        },
    { "remove tallgreencolumns",                     DOOM1AND2        },
    { "remove tallgreenfiresticks",                  DOOM1AND2        },
    { "remove tallredcolumns",                       DOOM1AND2        },
    { "remove tallredfiresticks",                    DOOM1AND2        },
    { "remove talltechnofloorlamps",                 DOOM2ONLY        },
    { "remove talltechnopillars",                    DOOM1AND2        },
    { "remove torchedtrees",                         DOOM1AND2        },
    { "remove twitchingimpaledhumans",               DOOM1AND2        },
    { "remove yellowkeycards",                       DOOM1AND2        },
    { "remove yellowskullkeys",                      DOOM1AND2        },
    { "reset ",                                      DOOM1AND2        },
    { "reset alwaysrun",                             DOOM1AND2        },
    { "reset am_allmapcdwallcolor",                  DOOM1AND2        },
    { "reset am_allmapfdwallcolor",                  DOOM1AND2        },
    { "reset am_allmapwallcolor",                    DOOM1AND2        },
    { "reset am_antialiasing",                       DOOM1AND2        },
    { "reset am_backcolor",                          DOOM1AND2        },
    { "reset am_bloodsplatcolor",                    DOOM1AND2        },
    { "reset am_bluedoorcolor",                      DOOM1AND2        },
    { "reset am_bluekeycolor",                       DOOM1AND2        },
    { "reset am_cdwallcolor",                        DOOM1AND2        },
    { "reset am_corpsecolor",                        DOOM1AND2        },
    { "reset am_correctaspectratio",                 DOOM1AND2        },
    { "reset am_crosshaircolor",                     DOOM1AND2        },
    { "reset am_display",                            DOOM1AND2        },
    { "reset am_dynamic",                            DOOM1AND2        },
    { "reset am_external",                           DOOM1AND2        },
    { "reset am_fdwallcolor",                        DOOM1AND2        },
    { "reset am_followmode",                         DOOM1AND2        },
    { "reset am_grid",                               DOOM1AND2        },
    { "reset am_gridcolor",                          DOOM1AND2        },
    { "reset am_gridsize",                           DOOM1AND2        },
    { "reset am_markcolor",                          DOOM1AND2        },
    { "reset am_path",                               DOOM1AND2        },
    { "reset am_pathcolor",                          DOOM1AND2        },
    { "reset am_playercolor",                        DOOM1AND2        },
    { "reset am_playerstats",                        DOOM1AND2        },
    { "reset am_playerstatscolor",                   DOOM1AND2        },
    { "reset am_reddoorcolor",                       DOOM1AND2        },
    { "reset am_redkeycolor",                        DOOM1AND2        },
    { "reset am_rotatemode",                         DOOM1AND2        },
    { "reset am_teleportercolor",                    DOOM1AND2        },
    { "reset am_thingcolor",                         DOOM1AND2        },
    { "reset am_tswallcolor",                        DOOM1AND2        },
    { "reset am_wallcolor",                          DOOM1AND2        },
    { "reset am_yellowdoorcolor",                    DOOM1AND2        },
    { "reset am_yellowkeycolor",                     DOOM1AND2        },
    { "reset animatedstats",                         DOOM1AND2        },
    { "reset autoaim",                               DOOM1AND2        },
    { "reset autoload",                              DOOM1AND2        },
    { "reset autosave",                              DOOM1AND2        },
    { "reset autotilt",                              DOOM1AND2        },
    { "reset autouse",                               DOOM1AND2        },
    { "reset centerweapon",                          DOOM1AND2        },
    { "reset crosshair",                             DOOM1AND2        },
    { "reset crosshaircolor",                        DOOM1AND2        },
    { "reset english",                               DOOM1AND2        },
    { "reset episode",                               DOOM1ONLY        },
    { "reset expansion",                             DOOM2ONLY        },
    { "reset facebackcolor",                         DOOM1AND2        },
    { "reset fade",                                  DOOM1AND2        },
    { "reset flashkeys",                             DOOM1AND2        },
    { "reset freelook",                              DOOM1AND2        },
    { "reset groupmessages",                         DOOM1AND2        },
    { "reset infighting",                            DOOM1AND2        },
    { "reset infiniteheight",                        DOOM1AND2        },
    { "reset joy_analog",                            DOOM1AND2        },
    { "reset joy_deadzone_left",                     DOOM1AND2        },
    { "reset joy_deadzone_right",                    DOOM1AND2        },
    { "reset joy_invertyaxis",                       DOOM1AND2        },
    { "reset joy_rumble_barrels",                    DOOM1AND2        },
    { "reset joy_rumble_damage",                     DOOM1AND2        },
    { "reset joy_rumble_fall",                       DOOM1AND2        },
    { "reset joy_rumble_pickup",                     DOOM1AND2        },
    { "reset joy_rumble_weapons",                    DOOM1AND2        },
    { "reset joy_sensitivity_horizontal",            DOOM1AND2        },
    { "reset joy_sensitivity_vertical",              DOOM1AND2        },
    { "reset joy_swapthumbsticks",                   DOOM1AND2        },
    { "reset joy_thumbsticks",                       DOOM1AND2        },
    { "reset m_acceleration",                        DOOM1AND2        },
    { "reset m_doubleclick_use",                     DOOM1AND2        },
    { "reset m_invertyaxis",                         DOOM1AND2        },
    { "reset m_novertical",                          DOOM1AND2        },
    { "reset m_pointer",                             DOOM1AND2        },
    { "reset m_sensitivity",                         DOOM1AND2        },
    { "reset melt",                                  DOOM1AND2        },
    { "reset menuhighlight",                         DOOM1AND2        },
    { "reset menushadow",                            DOOM1AND2        },
    { "reset menuspin",                              DOOM1AND2        },
    { "reset messages",                              DOOM1AND2        },
    { "reset movebob",                               DOOM1AND2        },
    { "reset negativehealth",                        DOOM1AND2        },
    { "reset obituaries",                            DOOM1AND2        },
    { "reset playergender",                          DOOM1AND2        },
    { "reset playername",                            DOOM1AND2        },
    { "reset r_althud",                              DOOM1AND2        },
    { "reset r_antialiasing",                        DOOM1AND2        },
    { "reset r_berserkeffect",                       DOOM1AND2        },
    { "reset r_blood",                               DOOM1AND2        },
    { "reset r_blood_gibs",                          DOOM1AND2        },
    { "reset r_blood_melee",                         DOOM1AND2        },
    { "reset r_bloodsplats_max",                     DOOM1AND2        },
    { "reset r_bloodsplats_translucency",            DOOM1AND2        },
    { "reset r_brightmaps",                          DOOM1AND2        },
    { "reset r_corpses_color",                       DOOM1AND2        },
    { "reset r_corpses_gib",                         DOOM1AND2        },
    { "reset r_corpses_mirrored",                    DOOM1AND2        },
    { "reset r_corpses_moreblood",                   DOOM1AND2        },
    { "reset r_corpses_nudge",                       DOOM1AND2        },
    { "reset r_corpses_slide",                       DOOM1AND2        },
    { "reset r_corpses_smearblood",                  DOOM1AND2        },
    { "reset r_damageeffect",                        DOOM1AND2        },
    { "reset r_detail",                              DOOM1AND2        },
    { "reset r_diskicon",                            DOOM1AND2        },
    { "reset r_ditheredlighting",                    DOOM1AND2        },
    { "reset r_fixmaperrors",                        DOOM1AND2        },
    { "reset r_fixspriteoffsets",                    DOOM1AND2        },
    { "reset r_floatbob",                            DOOM1AND2        },
    { "reset r_fov",                                 DOOM1AND2        },
    { "reset r_gamma",                               DOOM1AND2        },
    { "reset r_graduallighting",                     DOOM1AND2        },
    { "reset r_homindicator",                        DOOM1AND2        },
    { "reset r_hud",                                 DOOM1AND2        },
    { "reset r_hud_translucency",                    DOOM1AND2        },
    { "reset r_levelbrightness",                     DOOM1AND2        },
    { "reset r_linearskies",                         DOOM1AND2        },
    { "reset r_liquid_bob",                          DOOM1AND2        },
    { "reset r_liquid_bobsprites",                   DOOM1AND2        },
    { "reset r_liquid_clipsprites",                  DOOM1AND2        },
    { "reset r_liquid_current",                      DOOM1AND2        },
    { "reset r_liquid_lowerview",                    DOOM1AND2        },
    { "reset r_liquid_swirl",                        DOOM1AND2        },
    { "reset r_lowpixelsize",                        DOOM1AND2        },
    { "reset r_mirroredweapons",                     DOOM1AND2        },
    { "reset r_percolumnlighting",                   DOOM1AND2        },
    { "reset r_pickupeffect",                        DOOM1AND2        },
    { "reset r_playersprites",                       DOOM1AND2        },
    { "reset r_radsuiteffect",                       DOOM1AND2        },
    { "reset r_randomstartframes",                   DOOM1AND2        },
    { "reset r_rockettrails",                        DOOM1AND2        },
    { "reset r_rockettrails_translucency",           DOOM1AND2        },
    { "reset r_screensize",                          DOOM1AND2        },
    { "reset r_shadows",                             DOOM1AND2        },
    { "reset r_shadows_translucency",                DOOM1AND2        },
    { "reset r_shake_barrels",                       DOOM1AND2        },
    { "reset r_shake_berserk",                       DOOM1AND2        },
    { "reset r_shake_damage",                        DOOM1AND2        },
    { "reset r_sprites_translucency",                DOOM1AND2        },
    { "reset r_textures",                            DOOM1AND2        },
    { "reset r_textures_translucency",               DOOM1AND2        },
    { "reset s_channels",                            DOOM1AND2        },
    { "reset s_fullsfx",                             DOOM1AND2        },
    { "reset s_lowermenumusic",                      DOOM1AND2        },
    { "reset s_musicinbackground",                   DOOM1AND2        },
    { "reset s_musicvolume",                         DOOM1AND2        },
    { "reset s_randommusic",                         DOOM1AND2        },
    { "reset s_randompitch",                         DOOM1AND2        },
    { "reset s_sfxvolume",                           DOOM1AND2        },
    { "reset s_stereo",                              DOOM1AND2        },
    { "reset savegame",                              DOOM1AND2        },
    { "reset secretmessages",                        DOOM1AND2        },
    { "reset skilllevel",                            DOOM1AND2        },
    { "reset stillbob",                              DOOM1AND2        },
    { "reset sucktime",                              DOOM1AND2        },
    { "reset tossdrop",                              DOOM1AND2        },
    { "reset turbo",                                 DOOM1AND2        },
    { "reset units",                                 DOOM1AND2        },
    { "reset vid_aspectratio",                       DOOM1AND2        },
    { "reset vid_blue",                              DOOM1AND2        },
    { "reset vid_borderlesswindow",                  DOOM1AND2        },
    { "reset vid_brightness",                        DOOM1AND2        },
    { "reset vid_capfps",                            DOOM1AND2        },
    { "reset vid_contrast",                          DOOM1AND2        },
    { "reset vid_display",                           DOOM1AND2        },
#if !defined(_WIN32)
    { "reset vid_driver",                            DOOM1AND2        },
#endif
    { "reset vid_fullscreen",                        DOOM1AND2        },
    { "reset vid_green",                             DOOM1AND2        },
    { "reset vid_motionblur",                        DOOM1AND2        },
    { "reset vid_pillarboxes",                       DOOM1AND2        },
    { "reset vid_red",                               DOOM1AND2        },
    { "reset vid_saturation",                        DOOM1AND2        },
    { "reset vid_scaleapi",                          DOOM1AND2        },
    { "reset vid_scalefilter",                       DOOM1AND2        },
    { "reset vid_screenresolution",                  DOOM1AND2        },
    { "reset vid_showfps",                           DOOM1AND2        },
    { "reset vid_vsync",                             DOOM1AND2        },
    { "reset vid_widescreen",                        DOOM1AND2        },
    { "reset vid_windowpos",                         DOOM1AND2        },
    { "reset vid_windowsize",                        DOOM1AND2        },
    { "reset wadfolder",                             DOOM1AND2        },
    { "reset warninglevel",                          DOOM1AND2        },
    { "reset weaponbob",                             DOOM1AND2        },
    { "reset weaponbounce",                          DOOM1AND2        },
    { "reset weaponrecoil",                          DOOM1AND2        },
    { "resetall",                                    DOOM1AND2        },
    { "respawnitems ",                               DOOM1AND2        },
    { "respawnitems off",                            DOOM1AND2        },
    { "respawnitems on",                             DOOM1AND2        },
    { "respawnmonsters ",                            DOOM1AND2        },
    { "respawnmonsters off",                         DOOM1AND2        },
    { "respawnmonsters on",                          DOOM1AND2        },
    { "restartmap",                                  DOOM1AND2        },
    { "resurrect ",                                  DOOM1AND2        },
    { "resurrect all",                               DOOM1AND2        },
    { "resurrect arachnotrons",                      DOOM2ONLY        },
    { "resurrect archviles",                         DOOM2ONLY        },
    { "resurrect baronsofhell",                      DOOM1AND2        },
    { "resurrect cacodemons",                        DOOM1AND2        },
    { "resurrect chaingunners",                      DOOM2ONLY        },
    { "resurrect cyberdemons",                       DOOM1AND2        },
    { "resurrect demons",                            DOOM1AND2        },
    { "resurrect dogs",                              DOOM1AND2        },
    { "resurrect friendly ",                         DOOM1AND2        },
    { "resurrect friendly arachnotrons",             DOOM2ONLY        },
    { "resurrect friendly archviles",                DOOM2ONLY        },
    { "resurrect friendly baronsofhell",             DOOM1AND2        },
    { "resurrect friendly cacodemons",               DOOM1AND2        },
    { "resurrect friendly chaingunners",             DOOM2ONLY        },
    { "resurrect friendly cyberdemons",              DOOM1AND2        },
    { "resurrect friendly demons",                   DOOM1AND2        },
    { "resurrect friendly dogs",                     DOOM1AND2        },
    { "resurrect friendly hellknights",              DOOM2ONLY        },
    { "resurrect friendly imps",                     DOOM1AND2        },
    { "resurrect friendly mancubi",                  DOOM2ONLY        },
    { "resurrect friendly revenants",                DOOM2ONLY        },
    { "resurrect friendly shotgunguys",              DOOM1AND2        },
    { "resurrect friendly spectres",                 DOOM1AND2        },
    { "resurrect friendly spidermasterminds",        DOOM1AND2        },
    { "resurrect friendly wolfensteinss",            DOOM2ONLY        },
    { "resurrect friendly zombiemen",                DOOM1AND2        },
    { "resurrect hellknights",                       DOOM2ONLY        },
    { "resurrect imps",                              DOOM1AND2        },
    { "resurrect mancubi",                           DOOM2ONLY        },
    { "resurrect player",                            DOOM1AND2        },
    { "resurrect revenants",                         DOOM2ONLY        },
    { "resurrect shotgunguys",                       DOOM1AND2        },
    { "resurrect spectres",                          DOOM1AND2        },
    { "resurrect spidermasterminds",                 DOOM1AND2        },
    { "resurrect unfriendly ",                       DOOM1AND2        },
    { "resurrect unfriendly arachnotrons",           DOOM2ONLY        },
    { "resurrect unfriendly archviles",              DOOM2ONLY        },
    { "resurrect unfriendly baronsofhell",           DOOM1AND2        },
    { "resurrect unfriendly cacodemons",             DOOM1AND2        },
    { "resurrect unfriendly chaingunners",           DOOM2ONLY        },
    { "resurrect unfriendly cyberdemons",            DOOM1AND2        },
    { "resurrect unfriendly demons",                 DOOM1AND2        },
    { "resurrect unfriendly dogs",                   DOOM1AND2        },
    { "resurrect unfriendly hellknights",            DOOM2ONLY        },
    { "resurrect unfriendly imps",                   DOOM1AND2        },
    { "resurrect unfriendly mancubi",                DOOM2ONLY        },
    { "resurrect unfriendly revenants",              DOOM2ONLY        },
    { "resurrect unfriendly shotgunguys",            DOOM1AND2        },
    { "resurrect unfriendly spectres",               DOOM1AND2        },
    { "resurrect unfriendly spidermasterminds",      DOOM1AND2        },
    { "resurrect unfriendly wolfensteinss",          DOOM2ONLY        },
    { "resurrect unfriendly zombiemen",              DOOM1AND2        },
    { "resurrect wolfensteinss",                     DOOM2ONLY        },
    { "resurrect zombiemen",                         DOOM1AND2        },
    { "+right",                                      DOOM1AND2        },
    { "+rotatemode",                                 DOOM1AND2        },
    { "+run",                                        DOOM1AND2        },
    { "s_channels ",                                 DOOM1AND2        },
    { "s_channels 32",                               DOOM1AND2        },
    { "s_channels 64",                               DOOM1AND2        },
    { "s_fullsfx ",                                  DOOM1AND2        },
    { "s_fullsfx off",                               DOOM1AND2        },
    { "s_fullsfx on",                                DOOM1AND2        },
    { "s_lowermenumusic ",                           DOOM1AND2        },
    { "s_lowermenumusic off",                        DOOM1AND2        },
    { "s_lowermenumusic on",                         DOOM1AND2        },
    { "s_musicinbackground ",                        DOOM1AND2        },
    { "s_musicinbackground off",                     DOOM1AND2        },
    { "s_musicinbackground on",                      DOOM1AND2        },
    { "s_musicvolume ",                              DOOM1AND2        },
    { "s_musicvolume 0%",                            DOOM1AND2        },
    { "s_musicvolume 100%",                          DOOM1AND2        },
    { "s_randommusic ",                              DOOM1AND2        },
    { "s_randommusic off",                           DOOM1AND2        },
    { "s_randommusic on",                            DOOM1AND2        },
    { "s_randompitch ",                              DOOM1AND2        },
    { "s_randompitch off",                           DOOM1AND2        },
    { "s_randompitch on",                            DOOM1AND2        },
    { "s_sfxvolume ",                                DOOM1AND2        },
    { "s_sfxvolume 0%",                              DOOM1AND2        },
    { "s_sfxvolume 100%",                            DOOM1AND2        },
    { "s_stereo ",                                   DOOM1AND2        },
    { "s_stereo off",                                DOOM1AND2        },
    { "s_stereo on",                                 DOOM1AND2        },
    { "save ",                                       DOOM1AND2        },
    { "savegame ",                                   DOOM1AND2        },
    { "+screenshot",                                 DOOM1AND2        },
    { "secretmessages ",                             DOOM1AND2        },
    { "secretmessages off",                          DOOM1AND2        },
    { "secretmessages on",                           DOOM1AND2        },
    { "skilllevel ",                                 DOOM1AND2        },
    { "spawn ",                                      DOOM1AND2        },
    { "spawn ambientklaxon",                         LEGACYOFRUSTONLY },
    { "spawn ambientportalclose",                    LEGACYOFRUSTONLY },
    { "spawn ambientportalloop",                     LEGACYOFRUSTONLY },
    { "spawn ambientportalopen",                     LEGACYOFRUSTONLY },
    { "spawn arachnotron",                           DOOM2ONLY        },
    { "spawn archvile",                              DOOM2ONLY        },
    { "spawn armorbonus",                            DOOM1AND2        },
    { "spawn backpack",                              DOOM1AND2        },
    { "spawn banshee",                               LEGACYOFRUSTONLY },
    { "spawn baronofhell",                           DOOM1AND2        },
    { "spawn barrel",                                DOOM1AND2        },
    { "spawn berserk",                               DOOM1AND2        },
    { "spawn bfg9000",                               DOOM1AND2        },
    { "spawn bloodymess1",                           DOOM1AND2        },
    { "spawn bloodymess2",                           DOOM1AND2        },
    { "spawn bluearmor",                             DOOM1AND2        },
    { "spawn bluekeycard",                           DOOM1AND2        },
    { "spawn blueskullkey",                          DOOM1AND2        },
    { "spawn boxofbullets",                          DOOM1AND2        },
    { "spawn boxofrockets",                          DOOM1AND2        },
    { "spawn boxofshells",                           DOOM1AND2        },
    { "spawn burningbarrel",                         DOOM2ONLY        },
    { "spawn bushshort",                             LEGACYOFRUSTONLY },
    { "spawn bushshortburned1",                      LEGACYOFRUSTONLY },
    { "spawn bushshortburned2",                      LEGACYOFRUSTONLY },
    { "spawn bushtall",                              LEGACYOFRUSTONLY },
    { "spawn bushtallburned1",                       LEGACYOFRUSTONLY },
    { "spawn bushtallburned2",                       LEGACYOFRUSTONLY },
    { "spawn cacodemon",                             DOOM1AND2        },
    { "spawn calamityblade",                         LEGACYOFRUSTONLY },
    { "spawn candelabra",                            DOOM1AND2        },
    { "spawn candelabrashort",                       LEGACYOFRUSTONLY },
    { "spawn candlestick",                           DOOM1AND2        },
    { "spawn caverockcolumn",                        LEGACYOFRUSTONLY },
    { "spawn cavestalactitelarge",                   LEGACYOFRUSTONLY },
    { "spawn cavestalactitelargeblocking",           LEGACYOFRUSTONLY },
    { "spawn cavestalactitemedium",                  LEGACYOFRUSTONLY },
    { "spawn cavestalactitemediumblocking",          LEGACYOFRUSTONLY },
    { "spawn cavestalactitesmall",                   LEGACYOFRUSTONLY },
    { "spawn cavestalactitesmallblocking",           LEGACYOFRUSTONLY },
    { "spawn cavestalagmitelarge",                   LEGACYOFRUSTONLY },
    { "spawn cavestalagmitemedium",                  LEGACYOFRUSTONLY },
    { "spawn cavestalagmitesmall",                   LEGACYOFRUSTONLY },
    { "spawn ceilinglamp",                           LEGACYOFRUSTONLY },
    { "spawn cell",                                  DOOM1AND2        },
    { "spawn cellpack",                              DOOM1AND2        },
    { "spawn chaingun",                              DOOM1AND2        },
    { "spawn chaingunner",                           DOOM2ONLY        },
    { "spawn chainsaw",                              DOOM1AND2        },
    { "spawn clip",                                  DOOM1AND2        },
    { "spawn commanderkeen",                         DOOM2ONLY        },
    { "spawn computerareamap",                       DOOM1AND2        },
    { "spawn cyberdemon",                            DOOM1AND2        },
    { "spawn deadcacodemon",                         DOOM1AND2        },
    { "spawn deadimp",                               DOOM1AND2        },
    { "spawn deadlostsoul",                          DOOM1AND2        },
    { "spawn deadpinkydemon",                        DOOM1AND2        },
    { "spawn deadplayer",                            DOOM1AND2        },
    { "spawn deadshotgunguy",                        DOOM1AND2        },
    { "spawn deadzombieman",                         DOOM1AND2        },
    { "spawn deh_actor_150",                         DOOM1AND2        },
    { "spawn deh_actor_151",                         DOOM1AND2        },
    { "spawn deh_actor_152",                         DOOM1AND2        },
    { "spawn deh_actor_153",                         DOOM1AND2        },
    { "spawn deh_actor_154",                         DOOM1AND2        },
    { "spawn deh_actor_155",                         DOOM1AND2        },
    { "spawn deh_actor_156",                         DOOM1AND2        },
    { "spawn deh_actor_157",                         DOOM1AND2        },
    { "spawn deh_actor_158",                         DOOM1AND2        },
    { "spawn deh_actor_159",                         DOOM1AND2        },
    { "spawn deh_actor_160",                         DOOM1AND2        },
    { "spawn deh_actor_161",                         DOOM1AND2        },
    { "spawn deh_actor_162",                         DOOM1AND2        },
    { "spawn deh_actor_163",                         DOOM1AND2        },
    { "spawn deh_actor_164",                         DOOM1AND2        },
    { "spawn deh_actor_165",                         DOOM1AND2        },
    { "spawn deh_actor_166",                         DOOM1AND2        },
    { "spawn deh_actor_167",                         DOOM1AND2        },
    { "spawn deh_actor_168",                         DOOM1AND2        },
    { "spawn deh_actor_169",                         DOOM1AND2        },
    { "spawn deh_actor_170",                         DOOM1AND2        },
    { "spawn deh_actor_171",                         DOOM1AND2        },
    { "spawn deh_actor_172",                         DOOM1AND2        },
    { "spawn deh_actor_173",                         DOOM1AND2        },
    { "spawn deh_actor_174",                         DOOM1AND2        },
    { "spawn deh_actor_175",                         DOOM1AND2        },
    { "spawn deh_actor_176",                         DOOM1AND2        },
    { "spawn deh_actor_177",                         DOOM1AND2        },
    { "spawn deh_actor_178",                         DOOM1AND2        },
    { "spawn deh_actor_179",                         DOOM1AND2        },
    { "spawn deh_actor_180",                         DOOM1AND2        },
    { "spawn deh_actor_181",                         DOOM1AND2        },
    { "spawn deh_actor_182",                         DOOM1AND2        },
    { "spawn deh_actor_183",                         DOOM1AND2        },
    { "spawn deh_actor_184",                         DOOM1AND2        },
    { "spawn deh_actor_185",                         DOOM1AND2        },
    { "spawn deh_actor_186",                         DOOM1AND2        },
    { "spawn deh_actor_187",                         DOOM1AND2        },
    { "spawn deh_actor_188",                         DOOM1AND2        },
    { "spawn deh_actor_189",                         DOOM1AND2        },
    { "spawn deh_actor_190",                         DOOM1AND2        },
    { "spawn deh_actor_191",                         DOOM1AND2        },
    { "spawn deh_actor_192",                         DOOM1AND2        },
    { "spawn deh_actor_193",                         DOOM1AND2        },
    { "spawn deh_actor_194",                         DOOM1AND2        },
    { "spawn deh_actor_195",                         DOOM1AND2        },
    { "spawn deh_actor_196",                         DOOM1AND2        },
    { "spawn deh_actor_197",                         DOOM1AND2        },
    { "spawn deh_actor_198",                         DOOM1AND2        },
    { "spawn deh_actor_199",                         DOOM1AND2        },
    { "spawn deh_actor_200",                         DOOM1AND2        },
    { "spawn deh_actor_201",                         DOOM1AND2        },
    { "spawn deh_actor_202",                         DOOM1AND2        },
    { "spawn deh_actor_203",                         DOOM1AND2        },
    { "spawn deh_actor_204",                         DOOM1AND2        },
    { "spawn deh_actor_205",                         DOOM1AND2        },
    { "spawn deh_actor_206",                         DOOM1AND2        },
    { "spawn deh_actor_207",                         DOOM1AND2        },
    { "spawn deh_actor_208",                         DOOM1AND2        },
    { "spawn deh_actor_209",                         DOOM1AND2        },
    { "spawn deh_actor_210",                         DOOM1AND2        },
    { "spawn deh_actor_211",                         DOOM1AND2        },
    { "spawn deh_actor_212",                         DOOM1AND2        },
    { "spawn deh_actor_213",                         DOOM1AND2        },
    { "spawn deh_actor_214",                         DOOM1AND2        },
    { "spawn deh_actor_215",                         DOOM1AND2        },
    { "spawn deh_actor_216",                         DOOM1AND2        },
    { "spawn deh_actor_217",                         DOOM1AND2        },
    { "spawn deh_actor_218",                         DOOM1AND2        },
    { "spawn deh_actor_219",                         DOOM1AND2        },
    { "spawn deh_actor_220",                         DOOM1AND2        },
    { "spawn deh_actor_221",                         DOOM1AND2        },
    { "spawn deh_actor_222",                         DOOM1AND2        },
    { "spawn deh_actor_223",                         DOOM1AND2        },
    { "spawn deh_actor_224",                         DOOM1AND2        },
    { "spawn deh_actor_225",                         DOOM1AND2        },
    { "spawn deh_actor_226",                         DOOM1AND2        },
    { "spawn deh_actor_227",                         DOOM1AND2        },
    { "spawn deh_actor_228",                         DOOM1AND2        },
    { "spawn deh_actor_229",                         DOOM1AND2        },
    { "spawn deh_actor_230",                         DOOM1AND2        },
    { "spawn deh_actor_231",                         DOOM1AND2        },
    { "spawn deh_actor_232",                         DOOM1AND2        },
    { "spawn deh_actor_233",                         DOOM1AND2        },
    { "spawn deh_actor_234",                         DOOM1AND2        },
    { "spawn deh_actor_235",                         DOOM1AND2        },
    { "spawn deh_actor_236",                         DOOM1AND2        },
    { "spawn deh_actor_237",                         DOOM1AND2        },
    { "spawn deh_actor_238",                         DOOM1AND2        },
    { "spawn deh_actor_239",                         DOOM1AND2        },
    { "spawn deh_actor_240",                         DOOM1AND2        },
    { "spawn deh_actor_241",                         DOOM1AND2        },
    { "spawn deh_actor_242",                         DOOM1AND2        },
    { "spawn deh_actor_243",                         DOOM1AND2        },
    { "spawn deh_actor_244",                         DOOM1AND2        },
    { "spawn deh_actor_245",                         DOOM1AND2        },
    { "spawn deh_actor_246",                         DOOM1AND2        },
    { "spawn deh_actor_247",                         DOOM1AND2        },
    { "spawn deh_actor_248",                         DOOM1AND2        },
    { "spawn deh_actor_249",                         DOOM1AND2        },
    { "spawn dog",                                   DOOM1AND2        },
    { "spawn evileye",                               DOOM1AND2        },
    { "spawn evilsceptre",                           DOOM1AND2        },
    { "spawn fiveskullsshishkebab",                  DOOM1AND2        },
    { "spawn floatingskull",                         DOOM1AND2        },
    { "spawn floorlamp",                             DOOM1AND2        },
    { "spawn friendly ",                             DOOM1AND2        },
    { "spawn friendly arachnotron",                  DOOM2ONLY        },
    { "spawn friendly archvile",                     DOOM2ONLY        },
    { "spawn friendly banshee",                      LEGACYOFRUSTONLY },
    { "spawn friendly baronofhell",                  DOOM1AND2        },
    { "spawn friendly cacodemon",                    DOOM1AND2        },
    { "spawn friendly chaingunner",                  DOOM2ONLY        },
    { "spawn friendly cyberdemon",                   DOOM1AND2        },
    { "spawn friendly dog",                          DOOM1AND2        },
    { "spawn friendly ghoul",                        LEGACYOFRUSTONLY },
    { "spawn friendly hellknight",                   DOOM2ONLY        },
    { "spawn friendly imp",                          DOOM1AND2        },
    { "spawn friendly lostsoul",                     DOOM1AND2        },
    { "spawn friendly mancubus",                     DOOM2ONLY        },
    { "spawn friendly mindweaver",                   LEGACYOFRUSTONLY },
    { "spawn friendly painelemental",                DOOM2ONLY        },
    { "spawn friendly pinkydemon",                   DOOM1AND2        },
    { "spawn friendly revenant",                     DOOM2ONLY        },
    { "spawn friendly shocktrooper",                 LEGACYOFRUSTONLY },
    { "spawn friendly shotgunguy",                   DOOM1AND2        },
    { "spawn friendly spectre",                      DOOM1AND2        },
    { "spawn friendly spidermastermind",             DOOM1AND2        },
    { "spawn friendly tyrant",                       LEGACYOFRUSTONLY },
    { "spawn friendly vassago",                      LEGACYOFRUSTONLY },
    { "spawn friendly zombieman",                    DOOM1AND2        },
    { "spawn fuelcan",                               LEGACYOFRUSTONLY },
    { "spawn fueltank",                              LEGACYOFRUSTONLY },
    { "spawn ghoul",                                 LEGACYOFRUSTONLY },
    { "spawn greenarmor",                            DOOM1AND2        },
    { "spawn hangingbaronofhell",                    LEGACYOFRUSTONLY },
    { "spawn hangingbaronofhellblocking",            LEGACYOFRUSTONLY },
    { "spawn hangingleg",                            DOOM1AND2        },
    { "spawn hanginglegblocking",                    DOOM1AND2        },
    { "spawn hangingpairoflegs",                     DOOM1AND2        },
    { "spawn hangingpairoflegsblocking",             DOOM1AND2        },
    { "spawn hangingtorsobrainremoved",              DOOM2ONLY        },
    { "spawn hangingtorsochained",                   LEGACYOFRUSTONLY },
    { "spawn hangingtorsochainedblocking",           LEGACYOFRUSTONLY },
    { "spawn hangingtorsolookingdown",               DOOM2ONLY        },
    { "spawn hangingtorsolookingup",                 DOOM2ONLY        },
    { "spawn hangingtorsoopenskull",                 DOOM2ONLY        },
    { "spawn hangingvictimarmsbound",                LEGACYOFRUSTONLY },
    { "spawn hangingvictimarmsboundblocking",        LEGACYOFRUSTONLY },
    { "spawn hangingvictimarmsout",                  DOOM1AND2        },
    { "spawn hangingvictimarmsoutblocking",          DOOM1AND2        },
    { "spawn hangingvictimbothlegs",                 LEGACYOFRUSTONLY },
    { "spawn hangingvictimbothlegsblocking",         LEGACYOFRUSTONLY },
    { "spawn hangingvictimchained",                  LEGACYOFRUSTONLY },
    { "spawn hangingvictimchainedblocking",          LEGACYOFRUSTONLY },
    { "spawn hangingvictimcrucified",                LEGACYOFRUSTONLY },
    { "spawn hangingvictimcrucifiedblocking",        LEGACYOFRUSTONLY },
    { "spawn hangingvictimgutsandbrainremoved",      DOOM2ONLY        },
    { "spawn hangingvictimgutsremoved",              DOOM2ONLY        },
    { "spawn hangingvictimonelegged",                DOOM1AND2        },
    { "spawn hangingvictimoneleggedblocking",        DOOM1AND2        },
    { "spawn hangingvictimtwitching",                DOOM1AND2        },
    { "spawn hangingvictimtwitchingblocking",        DOOM1AND2        },
    { "spawn healthbonus",                           DOOM1AND2        },
    { "spawn hellknight",                            DOOM2ONLY        },
    { "spawn humanbbq1",                             LEGACYOFRUSTONLY },
    { "spawn humanbbq2",                             LEGACYOFRUSTONLY },
    { "spawn iconofsin",                             DOOM1AND2        },
    { "spawn imp",                                   DOOM1AND2        },
    { "spawn impaledhuman",                          DOOM1AND2        },
    { "spawn incinerator",                           LEGACYOFRUSTONLY },
    { "spawn invulnerability",                       DOOM1AND2        },
    { "spawn largebrowntree",                        DOOM1AND2        },
    { "spawn largecorpsepile",                       LEGACYOFRUSTONLY },
    { "spawn lightamplificationvisor",               DOOM1AND2        },
    { "spawn lostsoul",                              DOOM1AND2        },
    { "spawn mancubus",                              DOOM2ONLY        },
    { "spawn medikit",                               DOOM1AND2        },
    { "spawn megasphere",                            DOOM2ONLY        },
    { "spawn mindweaver",                            LEGACYOFRUSTONLY },
    { "spawn officechair",                           LEGACYOFRUSTONLY },
    { "spawn officelampbreakable",                   LEGACYOFRUSTONLY },
    { "spawn painelemental",                         DOOM2ONLY        },
    { "spawn partialinvisibility",                   DOOM1AND2        },
    { "spawn pileofskullsandcandles",                DOOM1AND2        },
    { "spawn pinkydemon",                            DOOM1AND2        },
    { "spawn plasmarifle",                           DOOM1AND2        },
    { "spawn poolofblood",                           DOOM2ONLY        },
    { "spawn poolofbloodandbones",                   DOOM1AND2        },
    { "spawn poolofbloodandguts",                    DOOM2ONLY        },
    { "spawn poolofbrains",                          DOOM2ONLY        },
    { "spawn radiationshieldingsuit",                DOOM1AND2        },
    { "spawn redkeycard",                            DOOM1AND2        },
    { "spawn redskullkey",                           DOOM1AND2        },
    { "spawn revenant",                              DOOM2ONLY        },
    { "spawn rocketlauncher",                        DOOM1AND2        },
    { "spawn rockets",                               DOOM1AND2        },
    { "spawn shell",                                 DOOM1AND2        },
    { "spawn shocktrooper",                          LEGACYOFRUSTONLY },
    { "spawn shortbluefirestick",                    DOOM1AND2        },
    { "spawn shortgreencolumn",                      DOOM1AND2        },
    { "spawn shortgreencolumnwithbeatingheart",      DOOM1AND2        },
    { "spawn shortgreenfirestick",                   DOOM1AND2        },
    { "spawn shortredcolumn",                        DOOM1AND2        },
    { "spawn shortredcolumnwithskull",               DOOM1AND2        },
    { "spawn shortredfirestick",                     DOOM1AND2        },
    { "spawn shorttechnofloorlamp",                  DOOM2ONLY        },
    { "spawn shotgun",                               DOOM1AND2        },
    { "spawn shotgunguy",                            DOOM1AND2        },
    { "spawn skullgibs",                             LEGACYOFRUSTONLY },
    { "spawn skullonapole",                          DOOM1AND2        },
    { "spawn skullpoletrio",                         LEGACYOFRUSTONLY },
    { "spawn soulsphere",                            DOOM1AND2        },
    { "spawn spectre",                               DOOM1AND2        },
    { "spawn spidermastermind",                      DOOM1AND2        },
    { "spawn stalagmite",                            DOOM1AND2        },
    { "spawn stalagmitegray",                        LEGACYOFRUSTONLY },
    { "spawn stimpack",                              DOOM1AND2        },
    { "spawn supershotgun",                          DOOM2ONLY        },
    { "spawn tallbluefirestick",                     DOOM1AND2        },
    { "spawn tallgreencolumn",                       DOOM1AND2        },
    { "spawn tallgreenfirestick",                    DOOM1AND2        },
    { "spawn tallredcolumn",                         DOOM1AND2        },
    { "spawn tallredfirestick",                      DOOM1AND2        },
    { "spawn talltechnofloorlamp",                   DOOM2ONLY        },
    { "spawn talltechnopillar",                      DOOM1AND2        },
    { "spawn teleportdestination",                   DOOM1AND2        },
    { "spawn torchedtree",                           DOOM1AND2        },
    { "spawn twitchingimpaledhuman",                 DOOM1AND2        },
    { "spawn tyrant",                                LEGACYOFRUSTONLY },
    { "spawn unfriendly ",                           DOOM1AND2        },
    { "spawn unfriendly arachnotron",                DOOM2ONLY        },
    { "spawn unfriendly archvile",                   DOOM2ONLY        },
    { "spawn unfriendly banshee",                    LEGACYOFRUSTONLY },
    { "spawn unfriendly baronofhell",                DOOM1AND2        },
    { "spawn unfriendly cacodemon",                  DOOM1AND2        },
    { "spawn unfriendly chaingunner",                DOOM2ONLY        },
    { "spawn unfriendly cyberdemon",                 DOOM1AND2        },
    { "spawn unfriendly dog",                        DOOM1AND2        },
    { "spawn unfriendly ghoul",                      LEGACYOFRUSTONLY },
    { "spawn unfriendly hellknight",                 DOOM2ONLY        },
    { "spawn unfriendly imp",                        DOOM1AND2        },
    { "spawn unfriendly lostsoul",                   DOOM1AND2        },
    { "spawn unfriendly mancubus",                   DOOM2ONLY        },
    { "spawn unfriendly mindweaver",                 LEGACYOFRUSTONLY },
    { "spawn unfriendly painelemental",              DOOM2ONLY        },
    { "spawn unfriendly pinkydemon",                 DOOM1AND2        },
    { "spawn unfriendly revenant",                   DOOM2ONLY        },
    { "spawn unfriendly shocktrooper",               LEGACYOFRUSTONLY },
    { "spawn unfriendly shotgunguy",                 DOOM1AND2        },
    { "spawn unfriendly spectre",                    DOOM1AND2        },
    { "spawn unfriendly spidermastermind",           DOOM1AND2        },
    { "spawn unfriendly tyrant",                     LEGACYOFRUSTONLY },
    { "spawn unfriendly vassago",                    LEGACYOFRUSTONLY },
    { "spawn unfriendly zombieman",                  DOOM1AND2        },
    { "spawn vassago",                               LEGACYOFRUSTONLY },
    { "spawn wolfensteinss",                         DOOM2ONLY        },
    { "spawn yellowkeycard",                         DOOM1AND2        },
    { "spawn yellowskullkey",                        DOOM1AND2        },
    { "spawn zombieman",                             DOOM1AND2        },
    { "stillbob ",                                   DOOM1AND2        },
    { "stillbob 0%",                                 DOOM1AND2        },
    { "stillbob 100%",                               DOOM1AND2        },
    { "+strafe",                                     DOOM1AND2        },
    { "+strafeleft",                                 DOOM1AND2        },
    { "+straferight",                                DOOM1AND2        },
    { "sucktime ",                                   DOOM1AND2        },
    { "sucktime 24",                                 DOOM1AND2        },
    { "sucktime off",                                DOOM1AND2        },
    { "take ",                                       DOOM1AND2        },
    { "take all",                                    DOOM1AND2        },
    { "take ammo",                                   DOOM1AND2        },
    { "take armor",                                  DOOM1AND2        },
    { "take armorbonus",                             DOOM1AND2        },
    { "take backpack",                               DOOM1AND2        },
    { "take berserk",                                DOOM1AND2        },
    { "take bfg9000",                                DOOM1AND2        },
    { "take bluearmor",                              DOOM1AND2        },
    { "take bluekeycard",                            DOOM1AND2        },
    { "take blueskullkey",                           DOOM1AND2        },
    { "take boxofbullets",                           DOOM1AND2        },
    { "take boxofrockets",                           DOOM1AND2        },
    { "take boxofshells",                            DOOM1AND2        },
    { "take calamityblade",                          LEGACYOFRUSTONLY },
    { "take cell",                                   DOOM1AND2        },
    { "take cellpack",                               DOOM1AND2        },
    { "take chaingun",                               DOOM1AND2        },
    { "take chainsaw",                               DOOM1AND2        },
    { "take clip",                                   DOOM1AND2        },
    { "take computerareamap",                        DOOM1AND2        },
    { "take fuelcan",                                LEGACYOFRUSTONLY },
    { "take fueltank",                               LEGACYOFRUSTONLY },
    { "take greenarmor",                             DOOM1AND2        },
    { "take health",                                 DOOM1AND2        },
    { "take healthbonus",                            DOOM1AND2        },
    { "take incinerator",                            LEGACYOFRUSTONLY },
    { "take invulnerability",                        DOOM1AND2        },
    { "take keycards",                               DOOM1AND2        },
    { "take keys",                                   DOOM1AND2        },
    { "take lightamplificationvisor",                DOOM1AND2        },
    { "take medikit",                                DOOM1AND2        },
    { "take megasphere",                             DOOM2ONLY        },
    { "take partialinvisibility",                    DOOM1AND2        },
    { "take pistol",                                 DOOM1AND2        },
    { "take plasmarifle",                            DOOM1AND2        },
    { "take powerups",                               DOOM1AND2        },
    { "take radiationshieldingsuit",                 DOOM1AND2        },
    { "take redkeycard",                             DOOM1AND2        },
    { "take redskullkey",                            DOOM1AND2        },
    { "take rocket",                                 DOOM1AND2        },
    { "take rocketlauncher",                         DOOM1AND2        },
    { "take shell",                                  DOOM1AND2        },
    { "take shotgun",                                DOOM1AND2        },
    { "take skullkeys",                              DOOM1AND2        },
    { "take soulsphere",                             DOOM1AND2        },
    { "take stimpack",                               DOOM1AND2        },
    { "take supershotgun",                           DOOM2ONLY        },
    { "take weapons",                                DOOM1AND2        },
    { "take yellowkeycard",                          DOOM1AND2        },
    { "take yellowskullkey",                         DOOM1AND2        },
    { "teleport ",                                   DOOM1AND2        },
    { "thinglist",                                   DOOM1AND2        },
    { "timer ",                                      DOOM1AND2        },
    { "toggle ",                                     DOOM1AND2        },
    { "toggle alwaysrun",                            DOOM1AND2        },
    { "toggle am_antialiasing",                      DOOM1AND2        },
    { "toggle am_correctaspectratio",                DOOM1AND2        },
    { "toggle am_dynamic",                           DOOM1AND2        },
    { "toggle am_external",                          DOOM1AND2        },
    { "toggle am_followmode",                        DOOM1AND2        },
    { "toggle am_grid",                              DOOM1AND2        },
    { "toggle am_path",                              DOOM1AND2        },
    { "toggle am_playerstats",                       DOOM1AND2        },
    { "toggle am_rotatemode",                        DOOM1AND2        },
    { "toggle animatedstats",                        DOOM1AND2        },
    { "toggle autoaim",                              DOOM1AND2        },
    { "toggle autoload",                             DOOM1AND2        },
    { "toggle autosave",                             DOOM1AND2        },
    { "toggle autotilt",                             DOOM1AND2        },
    { "toggle autouse",                              DOOM1AND2        },
    { "toggle centerweapon",                         DOOM1AND2        },
    { "toggle crosshair",                            DOOM1AND2        },
    { "toggle fade",                                 DOOM1AND2        },
    { "toggle flashkeys",                            DOOM1AND2        },
    { "toggle freelook",                             DOOM1AND2        },
    { "toggle groupmessages",                        DOOM1AND2        },
    { "toggle infighting",                           DOOM1AND2        },
    { "toggle infiniteheight",                       DOOM1AND2        },
    { "toggle joy_analog",                           DOOM1AND2        },
    { "toggle joy_invertyaxis",                      DOOM1AND2        },
    { "toggle joy_rumble_fall",                      DOOM1AND2        },
    { "toggle joy_rumble_pickup",                    DOOM1AND2        },
    { "toggle joy_swapthumbsticks",                  DOOM1AND2        },
    { "toggle m_acceleration",                       DOOM1AND2        },
    { "toggle m_doubleclick_use",                    DOOM1AND2        },
    { "toggle m_invertyaxis",                        DOOM1AND2        },
    { "toggle m_novertical",                         DOOM1AND2        },
    { "toggle m_pointer",                            DOOM1AND2        },
    { "toggle menuhighlight",                        DOOM1AND2        },
    { "toggle menushadow",                           DOOM1AND2        },
    { "toggle menuspin",                             DOOM1AND2        },
    { "toggle melt",                                 DOOM1AND2        },
    { "toggle messages",                             DOOM1AND2        },
    { "toggle negativehealth",                       DOOM1AND2        },
    { "toggle obituaries",                           DOOM1AND2        },
    { "toggle r_althud",                             DOOM1AND2        },
    { "toggle r_antialiasing",                       DOOM1AND2        },
    { "toggle r_blood_gibs",                         DOOM1AND2        },
    { "toggle r_blood_melee",                        DOOM1AND2        },
    { "toggle r_bloodsplats_translucency",           DOOM1AND2        },
    { "toggle r_brightmaps",                         DOOM1AND2        },
    { "toggle r_corpses_color",                      DOOM1AND2        },
    { "toggle r_corpses_gib",                        DOOM1AND2        },
    { "toggle r_corpses_mirrored",                   DOOM1AND2        },
    { "toggle r_corpses_moreblood",                  DOOM1AND2        },
    { "toggle r_corpses_nudge",                      DOOM1AND2        },
    { "toggle r_corpses_slide",                      DOOM1AND2        },
    { "toggle r_corpses_smearblood",                 DOOM1AND2        },
    { "toggle r_damageeffect",                       DOOM1AND2        },
    { "toggle r_diskicon",                           DOOM1AND2        },
    { "toggle r_ditheredlighting",                   DOOM1AND2        },
    { "toggle r_fixmaperrors",                       DOOM1AND2        },
    { "toggle r_fixspriteoffsets",                   DOOM1AND2        },
    { "toggle r_floatbob",                           DOOM1AND2        },
    { "toggle r_graduallighting",                    DOOM1AND2        },
    { "toggle r_homindicator",                       DOOM1AND2        },
    { "toggle r_hud",                                DOOM1AND2        },
    { "toggle r_hud_translucency",                   DOOM1AND2        },
    { "toggle r_linearskies",                        DOOM1AND2        },
    { "toggle r_liquid_bob",                         DOOM1AND2        },
    { "toggle r_liquid_bobsprites",                  DOOM1AND2        },
    { "toggle r_liquid_clipsprites",                 DOOM1AND2        },
    { "toggle r_liquid_current",                     DOOM1AND2        },
    { "toggle r_liquid_lowerview",                   DOOM1AND2        },
    { "toggle r_liquid_swirl",                       DOOM1AND2        },
    { "toggle r_mirroredweapons",                    DOOM1AND2        },
    { "toggle r_percolumnlighting",                  DOOM1AND2        },
    { "toggle r_pickupeffect",                       DOOM1AND2        },
    { "toggle r_playersprites",                      DOOM1AND2        },
    { "toggle r_radsuiteffect",                      DOOM1AND2        },
    { "toggle r_randomstartframes",                  DOOM1AND2        },
    { "toggle r_rockettrails",                       DOOM1AND2        },
    { "toggle r_rockettrails_translucency",          DOOM1AND2        },
    { "toggle r_shadows",                            DOOM1AND2        },
    { "toggle r_shadows_translucency",               DOOM1AND2        },
    { "toggle r_shake_barrels",                      DOOM1AND2        },
    { "toggle r_shake_berserk",                      DOOM1AND2        },
    { "toggle r_shake_damage",                       DOOM1AND2        },
    { "toggle r_sprites_translucency",               DOOM1AND2        },
    { "toggle r_textures",                           DOOM1AND2        },
    { "toggle r_textures_translucency",              DOOM1AND2        },
    { "toggle s_fullsfx",                            DOOM1AND2        },
    { "toggle s_lowermenumusic",                     DOOM1AND2        },
    { "toggle s_musicinbackground",                  DOOM1AND2        },
    { "toggle s_randommusic",                        DOOM1AND2        },
    { "toggle s_randompitch",                        DOOM1AND2        },
    { "toggle s_stereo",                             DOOM1AND2        },
    { "toggle secretmessages",                       DOOM1AND2        },
    { "toggle tossdrop",                             DOOM1AND2        },
    { "toggle vid_borderlesswindow",                 DOOM1AND2        },
    { "toggle vid_fullscreen",                       DOOM1AND2        },
    { "toggle vid_pillarboxes",                      DOOM1AND2        },
    { "toggle vid_showfps",                          DOOM1AND2        },
    { "toggle vid_widescreen",                       DOOM1AND2        },
    { "toggle weaponbounce",                         DOOM1AND2        },
    { "toggle weaponrecoil",                         DOOM1AND2        },
    { "tossdrop ",                                   DOOM1AND2        },
    { "tossdrop off",                                DOOM1AND2        },
    { "tossdrop on",                                 DOOM1AND2        },
    { "turbo ",                                      DOOM1AND2        },
    { "turbo 10%",                                   DOOM1AND2        },
    { "turbo 100%",                                  DOOM1AND2        },
    { "turbo 400%",                                  DOOM1AND2        },
    { "unbind ",                                     DOOM1AND2        },
    { "unbind '''",                                  DOOM1AND2        },
    { "unbind '+'",                                  DOOM1AND2        },
    { "unbind ','",                                  DOOM1AND2        },
    { "unbind '-'",                                  DOOM1AND2        },
    { "unbind '.'",                                  DOOM1AND2        },
    { "unbind '/'",                                  DOOM1AND2        },
    { "unbind '0'",                                  DOOM1AND2        },
    { "unbind '1'",                                  DOOM1AND2        },
    { "unbind '2'",                                  DOOM1AND2        },
    { "unbind '3'",                                  DOOM1AND2        },
    { "unbind '4'",                                  DOOM1AND2        },
    { "unbind '5'",                                  DOOM1AND2        },
    { "unbind '6'",                                  DOOM1AND2        },
    { "unbind '7'",                                  DOOM1AND2        },
    { "unbind '8'",                                  DOOM1AND2        },
    { "unbind '9'",                                  DOOM1AND2        },
    { "unbind ';'",                                  DOOM1AND2        },
    { "unbind '['",                                  DOOM1AND2        },
    { "unbind '\\'",                                 DOOM1AND2        },
    { "unbind ']'",                                  DOOM1AND2        },
    { "unbind 'a'",                                  DOOM1AND2        },
    { "unbind 'b'",                                  DOOM1AND2        },
    { "unbind 'c'",                                  DOOM1AND2        },
    { "unbind 'd'",                                  DOOM1AND2        },
    { "unbind 'e'",                                  DOOM1AND2        },
    { "unbind 'f'",                                  DOOM1AND2        },
    { "unbind 'g'",                                  DOOM1AND2        },
    { "unbind 'h'",                                  DOOM1AND2        },
    { "unbind 'i'",                                  DOOM1AND2        },
    { "unbind 'j'",                                  DOOM1AND2        },
    { "unbind 'k'",                                  DOOM1AND2        },
    { "unbind 'l'",                                  DOOM1AND2        },
    { "unbind 'm'",                                  DOOM1AND2        },
    { "unbind 'n'",                                  DOOM1AND2        },
    { "unbind 'o'",                                  DOOM1AND2        },
    { "unbind 'p'",                                  DOOM1AND2        },
    { "unbind 'q'",                                  DOOM1AND2        },
    { "unbind 'r'",                                  DOOM1AND2        },
    { "unbind 's'",                                  DOOM1AND2        },
    { "unbind 't'",                                  DOOM1AND2        },
    { "unbind 'u'",                                  DOOM1AND2        },
    { "unbind 'v'",                                  DOOM1AND2        },
    { "unbind 'w'",                                  DOOM1AND2        },
    { "unbind 'x'",                                  DOOM1AND2        },
    { "unbind 'y'",                                  DOOM1AND2        },
    { "unbind 'z'",                                  DOOM1AND2        },
    { "unbind alt",                                  DOOM1AND2        },
    { "unbind +alwaysrun",                           DOOM1AND2        },
    { "unbind +automap",                             DOOM1AND2        },
    { "unbind back",                                 DOOM1AND2        },
    { "unbind +back",                                DOOM1AND2        },
    { "unbind backspace",                            DOOM1AND2        },
    { "unbind button1",                              DOOM1AND2        },
    { "unbind button2",                              DOOM1AND2        },
    { "unbind button3",                              DOOM1AND2        },
    { "unbind button4",                              DOOM1AND2        },
    { "unbind capslock",                             DOOM1AND2        },
    { "unbind +clearmark",                           DOOM1AND2        },
    { "unbind +console",                             DOOM1AND2        },
    { "unbind ctrl",                                 DOOM1AND2        },
    { "unbind delete",                               DOOM1AND2        },
    { "unbind down",                                 DOOM1AND2        },
    { "unbind dpaddown",                             DOOM1AND2        },
    { "unbind dpadleft",                             DOOM1AND2        },
    { "unbind dpadright",                            DOOM1AND2        },
    { "unbind dpadup",                               DOOM1AND2        },
    { "unbind end",                                  DOOM1AND2        },
    { "unbind enter",                                DOOM1AND2        },
    { "unbind escape",                               DOOM1AND2        },
    { "unbind F12",                                  DOOM1AND2        },
    { "unbind +fire",                                DOOM1AND2        },
    { "unbind +followmode",                          DOOM1AND2        },
    { "unbind +forward",                             DOOM1AND2        },
    { "unbind +freelook",                            DOOM1AND2        },
    { "unbind +grid",                                DOOM1AND2        },
    { "unbind guide",                                DOOM1AND2        },
    { "unbind home",                                 DOOM1AND2        },
    { "unbind insert",                               DOOM1AND2        },
    { "unbind +jump",                                DOOM1AND2        },
    { "unbind left",                                 DOOM1AND2        },
    { "unbind +left",                                DOOM1AND2        },
    { "unbind leftshoulder",                         DOOM1AND2        },
    { "unbind leftthumb",                            DOOM1AND2        },
    { "unbind lefttrigger",                          DOOM1AND2        },
    { "unbind +mark",                                DOOM1AND2        },
    { "unbind +maxzoom",                             DOOM1AND2        },
    { "unbind +menu",                                DOOM1AND2        },
    { "unbind misc1",                                DOOM1AND2        },
    { "unbind mouse1",                               DOOM1AND2        },
    { "unbind mouse2",                               DOOM1AND2        },
    { "unbind mouse3",                               DOOM1AND2        },
    { "unbind mouse4",                               DOOM1AND2        },
    { "unbind mouse5",                               DOOM1AND2        },
    { "unbind mouse6",                               DOOM1AND2        },
    { "unbind mouse7",                               DOOM1AND2        },
    { "unbind mouse8",                               DOOM1AND2        },
    { "unbind +nextweapon",                          DOOM1AND2        },
    { "unbind numlock",                              DOOM1AND2        },
    { "unbind numpad0",                              DOOM1AND2        },
    { "unbind numpad1",                              DOOM1AND2        },
    { "unbind numpad2",                              DOOM1AND2        },
    { "unbind numpad3",                              DOOM1AND2        },
    { "unbind numpad4",                              DOOM1AND2        },
    { "unbind numpad5",                              DOOM1AND2        },
    { "unbind numpad6",                              DOOM1AND2        },
    { "unbind numpad7",                              DOOM1AND2        },
    { "unbind numpad8",                              DOOM1AND2        },
    { "unbind numpad9",                              DOOM1AND2        },
    { "unbind paddle1",                              DOOM1AND2        },
    { "unbind paddle2",                              DOOM1AND2        },
    { "unbind paddle3",                              DOOM1AND2        },
    { "unbind paddle4",                              DOOM1AND2        },
    { "unbind pagedown",                             DOOM1AND2        },
    { "unbind pageup",                               DOOM1AND2        },
    { "unbind +prevweapon",                          DOOM1AND2        },
    { "unbind printscreen",                          DOOM1AND2        },
    { "unbind right",                                DOOM1AND2        },
    { "unbind +right",                               DOOM1AND2        },
    { "unbind rightshoulder",                        DOOM1AND2        },
    { "unbind rightthumb",                           DOOM1AND2        },
    { "unbind righttrigger",                         DOOM1AND2        },
    { "unbind +rotatemode",                          DOOM1AND2        },
    { "unbind +run",                                 DOOM1AND2        },
    { "unbind +screenshot",                          DOOM1AND2        },
    { "unbind scrolllock",                           DOOM1AND2        },
    { "unbind shift",                                DOOM1AND2        },
    { "unbind space",                                DOOM1AND2        },
    { "unbind start",                                DOOM1AND2        },
    { "unbind +strafe",                              DOOM1AND2        },
    { "unbind +strafeleft",                          DOOM1AND2        },
    { "unbind +straferight",                         DOOM1AND2        },
    { "unbind tab",                                  DOOM1AND2        },
    { "unbind tilde",                                DOOM1AND2        },
    { "unbind touchpad",                             DOOM1AND2        },
    { "unbind up",                                   DOOM1AND2        },
    { "unbind +use",                                 DOOM1AND2        },
    { "unbind +weapon1",                             DOOM1AND2        },
    { "unbind +weapon2",                             DOOM1AND2        },
    { "unbind +weapon3",                             DOOM1AND2        },
    { "unbind +weapon4",                             DOOM1AND2        },
    { "unbind +weapon5",                             DOOM1AND2        },
    { "unbind +weapon6",                             DOOM1AND2        },
    { "unbind +weapon7",                             DOOM1AND2        },
    { "unbind wheeldown",                            DOOM1AND2        },
    { "unbind wheelup",                              DOOM1AND2        },
    { "unbind +zoomin",                              DOOM1AND2        },
    { "unbind +zoomout",                             DOOM1AND2        },
    { "units ",                                      DOOM1AND2        },
    { "units imperial",                              DOOM1AND2        },
    { "units metric",                                DOOM1AND2        },
    { "+use",                                        DOOM1AND2        },
    { "vanilla ",                                    DOOM1AND2        },
    { "vanilla off",                                 DOOM1AND2        },
    { "vanilla on",                                  DOOM1AND2        },
    { "version",                                     DOOM1AND2        },
    { "vid_aspectratio ",                            DOOM1AND2        },
    { "vid_aspectratio 16:10",                       DOOM1AND2        },
    { "vid_aspectratio 16:9",                        DOOM1AND2        },
    { "vid_aspectratio 21:9",                        DOOM1AND2        },
    { "vid_aspectratio 32:9",                        DOOM1AND2        },
    { "vid_aspectratio auto",                        DOOM1AND2        },
    { "vid_blue ",                                   DOOM1AND2        },
    { "vid_blue -100%",                              DOOM1AND2        },
    { "vid_blue 0%",                                 DOOM1AND2        },
    { "vid_blue 100%",                               DOOM1AND2        },
    { "vid_borderlesswindow ",                       DOOM1AND2        },
    { "vid_borderlesswindow off",                    DOOM1AND2        },
    { "vid_borderlesswindow on",                     DOOM1AND2        },
    { "vid_brightness ",                             DOOM1AND2        },
    { "vid_brightness -100%",                        DOOM1AND2        },
    { "vid_brightness 0%",                           DOOM1AND2        },
    { "vid_brightness 100%",                         DOOM1AND2        },
    { "vid_capfps ",                                 DOOM1AND2        },
    { "vid_capfps 1,000",                            DOOM1AND2        },
    { "vid_capfps 1000",                             DOOM1AND2        },
    { "vid_capfps 200",                              DOOM1AND2        },
    { "vid_capfps 35",                               DOOM1AND2        },
    { "vid_capfps off",                              DOOM1AND2        },
    { "vid_contrast ",                               DOOM1AND2        },
    { "vid_contrast -100%",                          DOOM1AND2        },
    { "vid_contrast 0%",                             DOOM1AND2        },
    { "vid_contrast 100%",                           DOOM1AND2        },
    { "vid_display ",                                DOOM1AND2        },
#if !defined(_WIN32)
    { "vid_driver ",                                 DOOM1AND2        },
#endif
    { "vid_fullscreen ",                             DOOM1AND2        },
    { "vid_fullscreen off",                          DOOM1AND2        },
    { "vid_fullscreen on",                           DOOM1AND2        },
    { "vid_green ",                                  DOOM1AND2        },
    { "vid_green -100%",                             DOOM1AND2        },
    { "vid_green 0%",                                DOOM1AND2        },
    { "vid_green 100%",                              DOOM1AND2        },
    { "vid_motionblur ",                             DOOM1AND2        },
    { "vid_motionblur 0%",                           DOOM1AND2        },
    { "vid_motionblur 100%",                         DOOM1AND2        },
    { "vid_pillarboxes ",                            DOOM1AND2        },
    { "vid_pillarboxes off",                         DOOM1AND2        },
    { "vid_pillarboxes on",                          DOOM1AND2        },
    { "vid_red ",                                    DOOM1AND2        },
    { "vid_red -100%",                               DOOM1AND2        },
    { "vid_red 0%",                                  DOOM1AND2        },
    { "vid_red 100%",                                DOOM1AND2        },
    { "vid_saturation ",                             DOOM1AND2        },
    { "vid_saturation -100%",                        DOOM1AND2        },
    { "vid_saturation 0%",                           DOOM1AND2        },
    { "vid_saturation 100%",                         DOOM1AND2        },
    { "vid_scaleapi ",                               DOOM1AND2        },
#if defined(_WIN32)
    { "vid_scaleapi \"direct3d\"",                   DOOM1AND2        },
    { "vid_scaleapi \"opengl\"",                     DOOM1AND2        },
    { "vid_scaleapi \"software\"",                   DOOM1AND2        },
    { "vid_scaleapi direct3d",                       DOOM1AND2        },
    { "vid_scaleapi opengl",                         DOOM1AND2        },
    { "vid_scaleapi software",                       DOOM1AND2        },
#else
    { "vid_scaleapi \"opengl\"",                     DOOM1AND2        },
    { "vid_scaleapi \"opengles\"",                   DOOM1AND2        },
    { "vid_scaleapi \"opengles2\"",                  DOOM1AND2        },
    { "vid_scaleapi \"software\"",                   DOOM1AND2        },
    { "vid_scaleapi opengl",                         DOOM1AND2        },
    { "vid_scaleapi opengles",                       DOOM1AND2        },
    { "vid_scaleapi opengles2",                      DOOM1AND2        },
    { "vid_scaleapi software",                       DOOM1AND2        },
#endif
    { "vid_scalefilter ",                            DOOM1AND2        },
    { "vid_scalefilter \"linear\"",                  DOOM1AND2        },
    { "vid_scalefilter \"nearest\"",                 DOOM1AND2        },
    { "vid_scalefilter \"nearest_linear\"",          DOOM1AND2        },
    { "vid_scalefilter linear",                      DOOM1AND2        },
    { "vid_scalefilter nearest",                     DOOM1AND2        },
    { "vid_scalefilter nearest_linear",              DOOM1AND2        },
    { "vid_screenresolution ",                       DOOM1AND2        },
    { "vid_screenresolution desktop",                DOOM1AND2        },
    { "vid_showfps ",                                DOOM1AND2        },
    { "vid_showfps off",                             DOOM1AND2        },
    { "vid_showfps on",                              DOOM1AND2        },
    { "vid_vsync ",                                  DOOM1AND2        },
#if !defined(__APPLE__)
    { "vid_vsync adaptive",                          DOOM1AND2        },
#endif
    { "vid_vsync off",                               DOOM1AND2        },
    { "vid_vsync on",                                DOOM1AND2        },
    { "vid_widescreen ",                             DOOM1AND2        },
    { "vid_widescreen off",                          DOOM1AND2        },
    { "vid_widescreen on",                           DOOM1AND2        },
    { "vid_windowpos ",                              DOOM1AND2        },
    { "vid_windowpos centered",                      DOOM1AND2        },
    { "vid_windowsize ",                             DOOM1AND2        },
    { "vid_windowsize 854x480",                      DOOM1AND2        },
#if defined(_WIN32)
    { "wad",                                         DOOM1AND2        },
#endif
    { "wadfolder ",                                  DOOM1AND2        },
    { "wadfolder \"C:\\\"",                          DOOM1AND2        },
    { "wadfolder C:\\",                              DOOM1AND2        },
    { "warninglevel ",                               DOOM1AND2        },
    { "weapon ",                                     DOOM1AND2        },
    { "weapon bfg9000",                              DOOM1AND2        },
    { "weapon calamityblade",                        LEGACYOFRUSTONLY },
    { "weapon chaingun",                             DOOM1AND2        },
    { "weapon chainsaw",                             DOOM1AND2        },
    { "weapon fists",                                DOOM1AND2        },
    { "weapon incinerator",                          LEGACYOFRUSTONLY },
    { "weapon pistol",                               DOOM1AND2        },
    { "weapon plasmarifle",                          DOOM1AND2        },
    { "weapon rocketlauncher",                       DOOM1AND2        },
    { "weapon shotgun",                              DOOM1AND2        },
    { "weapon supershotgun",                         DOOM2ONLY        },
    { "+weapon1",                                    DOOM1AND2        },
    { "+weapon2",                                    DOOM1AND2        },
    { "+weapon3",                                    DOOM1AND2        },
    { "+weapon4",                                    DOOM1AND2        },
    { "+weapon5",                                    DOOM1AND2        },
    { "+weapon6",                                    DOOM1AND2        },
    { "+weapon7",                                    DOOM1AND2        },
    { "weaponbob ",                                  DOOM1AND2        },
    { "weaponbob 0%",                                DOOM1AND2        },
    { "weaponbob 100%",                              DOOM1AND2        },
    { "weaponbob 75%",                               DOOM1AND2        },
    { "weaponbounce ",                               DOOM1AND2        },
    { "weaponbounce off",                            DOOM1AND2        },
    { "weaponbounce on",                             DOOM1AND2        },
    { "weaponrecoil ",                               DOOM1AND2        },
    { "weaponrecoil off",                            DOOM1AND2        },
    { "weaponrecoil on",                             DOOM1AND2        },
    { "wiki",                                        DOOM1AND2        },
    { "+zoomin",                                     DOOM1AND2        },
    { "+zoomout",                                    DOOM1AND2        },
    { "",                                            0,               }
};
